<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.currency.inc.php 0.16.1 2005/12/04 C K Wu

    class currency {

//---- Currency Detail Validation Checks

    function currency_validate() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$dt = $ckapi['params_post']['dt'] ;
	$err=""; $error=exapi_lang("Error") ;
	$isocode = $dt['isocode'] ;
	if ($isocode=="")			$err=exapi_lang("Currency ISO Code Missing");
		elseif (strlen($isocode)<>3)	$err=exapi_lang("ISO Code must be 3 chars long");
	    	else {
			$result = $adodb->query("SELECT * from $table WHERE isocode='$isocode'");
			if (exapi_dbrc($result)<>0 and $isocode<>$dt['oldisocode'])
						$err=exapi_lang("ISO Code already exists");
		}
	if ($dt['description']=="")		$err=exapi_lang("Currency Description Missing");
	if ($dt['exrate']=="")			$err=exapi_lang("Currency exchange rate Missing");
	if ($dt['exrate']<=0)			$err=exapi_lang("Exchange rate must be > 0");
	if (!is_numeric($dt['exrate']))		$err=exapi_lang("Exchange rate must be numeric");
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Currency Delete Validation Checks

    function delete_validate() {

	$err=""; $error=exapi_lang('Error') ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Currency Detail

    function currency_write() {
	global $ckapi ;

	$t = &$ckapi['objects']['template'] ;
	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_isocode',exapi_lang('ISO Code'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_exrate',exapi_lang('Exchange Rate'));

	$dt = $ckapi['params_post']['dt'] ;
	$fields = array('id','control','isocode','oldisocode','description','exrate') ;
	foreach ($fields as $field)
		if (isset($dt[$field]))		$t->set_var($field,$dt[$field]);
			else			$t->set_var($field,'') ;
	$t->parse('out','report',True);
	}

    }

?>
