<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// connector.inc.php 0.16.1 2005/12/04 C K Wu
//
// (connector for running CK-ERP atop EGW + LAMP)

	global $ckapi,$exapi,$exapi_info,$exapidir,$adodb ;

	$exapi = &$GLOBALS['egw'] ;
	$exapi_info = &$GLOBALS['egw_info'] ;
	$exapidir = 'phpgwapi' ;
	$exapi_info["flags"]["currentapp"] = $app ;
	if (@$enable_vfs)	$exapi_info["flags"]["enable_vfs_class"] = True ;
	if (@$noheader)		$exapi_info["flags"]["noheader"] = True ;
	if (@$nonavbar)		$exapi_info["flags"]["nonavbar"] = True ;
	$ckapi['hostsys']['th_bg'] = &$exapi_info['theme']['th_bg'] ;
	require_once('../header.inc.php');

	$adodb = &$GLOBALS['egw']->db ;
	$ckapi['hostsys']['username'] = trim($exapi_info["user"]["userid"]);
	$ckapi['hostsys']['dbtype'] = $dbtype = $exapi_info["server"]["db_type"] ;
	if ($dbtype=='mysqli')		$ckapi['hostsys']['dbtype'] = $dbtype = 'mysql' ;
	$ckapi['hostsys']['dbhost'] = $exapi_info["server"]["db_host"] ;
	$ckapi['hostsys']['dbname'] = $exapi_info["server"]["db_name"] ;
	$ckapi['hostsys']['dbuser'] = $exapi_info["server"]["db_user"] ;
	if (strstr('1.2.001,1.0.1.029,..',$exapi_info['server']['versions']['phpgwapi'])) {
		if ($dbtype=='mysql') {
			switch ($exapi_info['server']['system_charset']) :
				case 'utf-8' :	$ckapi['hostsys']['dbcharset'] = 'utf8' ;	break ;
				default :	$ckapi['hostsys']['dbcharset'] = '' ;		break ;
				endswitch ;
			}
		}
	$ckapi['hostsys']['dataarea'] = $exapi_info["server"]["files_dir"] ;
	$ckapi['hostsys']['dataarea'] = $exapi_info["server"]["files_dir"] ;
	switch ($exapi_info['user']['preferences']['common']['lang']) :
		case 'zh' :	$ckapi['hostsys']['guilang'] = 'zh-cn' ;	break ;
		case 'zt' :	$ckapi['hostsys']['guilang'] = 'zh-hk' ;	break ;
		case 'zh-tw' :	$ckapi['hostsys']['guilang'] = 'zh-hk' ;	break ;
		case 'en' :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		case 'fr' :	$ckapi['hostsys']['guilang'] = 'fr-fr' ;	break ;
		case 'de' :	$ckapi['hostsys']['guilang'] = 'de-de' ;	break ;
		default :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		endswitch ;
	$ckapi['hostsys']['guicharset'] = lang('charset') ;
	$ckapi['hostsys']['th_bg'] = $exapi_info['theme']['th_bg'] ;
	$ckapi['hostsys']['tr_color1'] = $exapi_info['theme']['row_on'] ;
	$ckapi['hostsys']['tr_color2'] = $exapi_info['theme']['row_off'] ;
	$ckapi['hostsys']['tr_color3'] = $exapi_info['theme']['bg02'] ;
	$ckapi['hostsys']['tr_color4'] = $exapi_info['theme']['bg03'] ;

    function exapi_tpl($app) {
	global $ckapi;

	require_once('../ck-api/inc/class.ck_Template.inc.php') ;
	$tpl = new ck_Template("../$app/templates/default") ;
	return $tpl ;
	}

    function exapi_link($url,$getstr='')		{return $GLOBALS['egw']->session->link($url,$getstr);}
	
    function exapi_footer()				{	$GLOBALS['egw']->common->phpgw_footer();	}

    function exapi_groups($user='') {
	global $ckapi,$exapi,$exapidir,$adodb ;
	
	return ExecMethod("$exapidir.accounts.membership",$user);
	}

    function exapi_is_group($name) {
	global $adodb ;
	
	$result = $adodb->query("SELECT * from egw_accounts where account_type='g' and account_lid='$name'");
	return $result->RecordCount()>0 ;
	}

    function exapi_lang ($phrase,$z1='',$z2='',$z3='',$z4='') {
	global $exapi_info,$env ;

	$tmp = get_i18n($phrase) ;
	if ($env=='adminins')			$tmp = addslashes($tmp);
	if ($GLOBALS['egw_info']['server']['system_charset']<>'utf-8') {
		switch ($exapi_info['user']['preferences']['common']['lang']) :
			case 'zh' :	$tmp1=iconv('gb18030','utf8',$tmp.'<zz>');
					list($tmp)=explode('<zz>',$tmp1);	break ;
			case 'zt' :	$tmp1=iconv('big5','utf8',$tmp.'<zz>');
					list($tmp)=explode('<zz>',$tmp1);	break ;
			case 'zh-tw' :	$tmp1=iconv('big5','utf8',$tmp.'<zz>');
					list($tmp)=explode('<zz>',$tmp1);	break ;
			endswitch ;
		}
						if ($z1==='') return $tmp ;
	$tmp = str_replace('%1',$z1,$tmp) ;	if ($z2==='') return $tmp ;
	$tmp = str_replace('%2',$z2,$tmp) ;	if ($z3==='') return $tmp ;
	$tmp = str_replace('%3',$z3,$tmp) ;	if ($z4==='') return $tmp ;
	return str_replace('%4',$z4,$tmp);
	}

    function exapi_is_admin($user='') {
	global $ckapi,$exapi,$exapidir,$userdata ;
	
	$admin = False ;
	$groups = ExecMethod("$exapidir.accounts.membership",$user);
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']=="Admins")	$admin = True ;
	return $admin ;
	}

    function exapi_dbrc(&$result)		{	return $result->RecordCount();	}

    function exapi_dbflds(&$result,$field)	{	return $result->fields($field);	}

    function exapi_dbcharset($string,$langcode)		{
	global $ckapi ;

	if (!strstr($ckapi['hostsys']['dbcharset'],'utf8'))	return $string ;
	switch ($langcode) :
		case 'zh-cn' :	return iconv('gb18030','utf8',$string) ;	break ;
		case 'zh-hk' :	return iconv('big5','utf8',$string) ;		break ;
		case 'en-hk' :	return $string ;				break ;
		case 'fr-fr' :	return iconv('ISO-8859-1','utf8',$string) ;	break ;
		case 'de-de' :	return iconv('ISO-8859-1','utf8',$string) ;	break ;
		endswitch ;
	return $string;
	}

?>
