<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// connector.inc.php 0.16.1 2005/12/04 C K Wu
//
// (connector for running CK-ERP atop Horde + LAMP)

	global $ckapi,$adodb,$template,$outstream ;

	@define('AUTH_HANDLER', true);
	require_once $basedir . '/lib/base.php';
	require_once $basedir . '/lib/Horde/Group.php' ;

	require_once 'DB.php' ;
	$adodb = &DB::connect($conf['sql'],array('persistent'=>!empty($conf['sql']['persistent']))) ;
	$adodb->setFetchMode(DB_FETCHMODE_ASSOC);

	switch ($language) :
		case 'zh_CN' :	$ckapi['hostsys']['guilang'] = 'zh-cn' ;	break ;
		case 'zh_TW' :	$ckapi['hostsys']['guilang'] = 'zh-hk' ;	break ;
		case 'fr_FR' :	$ckapi['hostsys']['guilang'] = 'fr-fr' ;	break ;
		case 'de_DE' :	$ckapi['hostsys']['guilang'] = 'de-de' ;	break ;
		default :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		endswitch ;

	$ckapi['hostsys']['username'] = trim(Auth::getBareAuth());
	$ckapi['hostsys']['dbtype'] = $dbtype = $conf['sql']['phptype'] ;
	$ckapi['hostsys']['dbhost'] = $conf['sql']['hostspec'] ;
	$ckapi['hostsys']['dbname'] = $conf['sql']['database'] ;
	$ckapi['hostsys']['dbuser'] = $conf['sql']['username'] ;
	$ckapi['hostsys']['dataarea'] = Horde::getTempDir() ;
	$ckapi['hostsys']['th_bg'] = '#e9e9ff' ;
	$ckapi['hostsys']['tr_color1'] = '#DDDDDD' ;
	$ckapi['hostsys']['tr_color2'] = '#EEEEEE' ;
	$ckapi['hostsys']['tr_color3'] = 'grey' ;
	$ckapi['hostsys']['tr_color4'] = 'red' ;

	$outstream = '' ;
	require_once('../ck-api/inc/class.ck_Template.inc.php') ;
	class tw_ck_Template extends ck_Template {
		function set_file($handle,$filename='')	 	{parent::set_file($handle,$filename) ;	}
		function set_block($parent,$handle,$name='')	{parent::set_block($parent,$handle,$name) ; }
		function set_var($varname,$value='')		{parent::set_var($varname,$value) ;	}
		function parse($target,$handle,$append=false)	{return parent::parse($target,$handle,$append) ; }
		function pparse($target,$handle,$append=false)	{
			global $outstream ;	$outstream.= $this->parse($target, $handle, $append) ;
			}
		}

	$group = new Group ;
	if (!isset($noheader)) {
		require_once $basedir . '/ck-api/horde/navbar.php' ;
		$outstream = $navcode ;
		require_once('inc/header.inc.php') ;
		}

	if (!Auth::getAuth())	die(exapi_lang("You must be logged in to access CK-ERP"));

    function exapi_tpl($app)	{$tpl = new tw_ck_Template("../$app/templates/default") ; return $tpl ;	}

    function exapi_link($url,$getstr='') {	
	if (strlen($getstr)<2)			return Horde::url('..'.$url) ;
	$hordeurl = Horde::url('..'.$url) ;
	if (substr($hordeurl,-4)=='.php')	return $hordeurl.'?'.$getstr ;
	  else					return $hordeurl.'&'.$getstr ;
	}
	
    function exapi_footer() {
	global $registry,$outstream;

	echo $outstream ;
	require $registry->get('templates', 'horde') . '/common-footer.inc';
	}

    function exapi_groups($user='') {
	global $group,$ckapi ;

	$user = ($user<>'') ? $user : $ckapi['hostsys']['username'] ;
	$groups = $group->getGroupMemberships($user) ;
	foreach($groups as $key=>$value)	$usergroups[$key]['account_name'] = $value ;
	return isset($usergroups) ? $usergroups : '' ;
	}

    function exapi_is_group($name)		{global $group ;	return $group->exists($name) ;	}

    function exapi_lang ($phrase,$z1='',$z2='',$z3='',$z4='') {
	global $ckapi,$env ;

	$tmp = get_i18n($phrase) ;
	if ($env=='adminins')			$tmp = addslashes($tmp);
	switch ($ckapi['hostsys']['guilang']) :
		case 'zh-hk' :	$tmp1=iconv('big5','utf8',$tmp.'<zz>');
				list($tmp)=explode('<zz>',$tmp1);	break ;
		case 'zh-cn' :	$tmp1=iconv('gb18030','utf8',$tmp.'<zz>');
				list($tmp)=explode('<zz>',$tmp1);	break ;
		endswitch ;
						if ($z1==='') return $tmp ;
	$tmp = str_replace('%1',$z1,$tmp) ;	if ($z2==='') return $tmp ;
	$tmp = str_replace('%2',$z2,$tmp) ;	if ($z3==='') return $tmp ;
	$tmp = str_replace('%3',$z3,$tmp) ;	if ($z4==='') return $tmp ;
	return str_replace('%4',$z4,$tmp);
	}

    function exapi_is_admin($user='')		{return Auth::isAdmin($user) ;	}

    function exapi_dbrc(&$result)		{return (is_a($result,'PEAR_Error')?false:$result->numRows() ) ;}

    function exapi_dbflds(&$result,$field)	{$rs=$result->fetchRow(DB_FETCHMODE_ASSOC,0); return $rs[$field]; }

    function exapi_dbcharset($string,$langcode)	{return $string;		}

?>