<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// connector.inc.php 0.16.1 2005/12/04 C K Wu
//
// (connector for running CK-ERP atop tikiwiki + LAMP)

	ini_set("display_errors","0") ;
	ini_set("log_errors","1");
	ini_set('memory_limit','16M') ;

	global $ckapi,$adodb,$template,$smarty,$outstream ;

	chdir('..') ;
	require_once('tiki-setup.php');
	$adodb = &$tikilib ;
	$ckapi['hostsys']['dbtype'] = $dbtype = $dbTiki->databaseType ;
	if ($dbtype=='postgres7')	$ckapi['hostsys']['dbtype'] = $dbtype = 'pgsql' ;
	$ckapi['hostsys']['dbhost'] = $dbTiki->host ;
	$ckapi['hostsys']['dbname'] = $dbTiki->database ;
	$ckapi['hostsys']['dbuser'] = $dbTiki->user ;
	switch ($language) :
		case 'en' :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		case 'en-uk' :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		case 'cn' :	$ckapi['hostsys']['guilang'] = 'zh-cn' ;	break ;
		case 'tw' :	$ckapi['hostsys']['guilang'] = 'zh-hk' ;	break ;
		case 'fr' :	$ckapi['hostsys']['guilang'] = 'fr-fr' ;	break ;
		case 'de' :	$ckapi['hostsys']['guilang'] = 'de-de' ;	break ;
		default :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		endswitch ;

	$smarty->assign('feature_sitemycode','y') ;
	$smarty->assign('feature_sitesearch', 'n');
	if (!isset($noheader))	require_once('ck-api/tiki/navbar.php') ;
	  else	{
		$smarty->assign('sitemycode','');
		$smarty->assign('feature_left_column','n') ;
		$smarty->assign('feature_right_column','n') ;
		}
	chdir($app) ;

	$ckapi['hostsys']['username'] = trim($user);
	$ckapi['hostsys']['dataarea'] = $uf_use_dir ;
	$ckapi['hostsys']['th_bg'] = '#BBBBBB' ;
	$ckapi['hostsys']['tr_color1'] = '" class="odd' ;
	$ckapi['hostsys']['tr_color2'] = '" class="even' ;
	$ckapi['hostsys']['tr_color3'] = 'grey' ;
	$ckapi['hostsys']['tr_color4'] = 'red' ;

	$smarty->assign('mid', '../ck-api/templates/default/ck-erp.tpl');
	$smarty->register_outputfilter('exapi_adj_cwd') ;

	$outstream = '' ;
	require_once('../ck-api/inc/class.ck_Template.inc.php') ;
	class tw_ck_Template extends ck_Template {
		function set_file($handle,$filename='')	 	{parent::set_file($handle,$filename) ;	}
		function set_block($parent,$handle,$name='')	{parent::set_block($parent,$handle,$name) ; }
		function set_var($varname,$value='')		{parent::set_var($varname,$value) ;	}
		function parse($target,$handle,$append=false)	{return parent::parse($target,$handle,$append) ; }
		function pparse($target,$handle,$append=false)	{
			global $outstream ;	$outstream.= $this->parse($target, $handle, $append) ;
			}
		}

	if (!isset($noheader))		require_once('inc/header.inc.php') ;

	if ($user=='') {
		$error = exapi_lang("You must be logged in to access CK-ERP") ;
		$advice1 = exapi_lang("Links in this page may now be corrupted") ;
		$advice2 = exapi_lang("Return to Home Page first before processing any further") ;
		$smarty->assign('msg', $error.'<br>'.$advice1.'<br>'.$advice2);
		chdir('..') ;
		$smarty->display("error.tpl");
		die;
		}

    function exapi_adj_cwd($tpl_output, &$smarty) {
	$search = array('src="img/','src="lib/','href="styles/','href="tiki') ;
	$replace = array('src="../img/','src="../lib/','href="../styles/','href="../tiki') ;
	return str_replace($search,$replace,$tpl_output) ;
	}

    function exapi_tpl($app) {

	$tpl = new tw_ck_Template("../$app/templates/default") ;
	return $tpl ;
	}

    function exapi_link($url,$getstr='') {
	if (strlen($getstr)<2)	return '..'.$url ;
	  else			return '..'.$url.'?'.$getstr ;
	}
	
    function exapi_footer() {
	global $smarty,$outstream;

	chdir('..') ;
	$smarty->assign('ckerp',$outstream) ;
	$smarty->display('tiki.tpl') ;
	}

    function exapi_groups($user='')	{global $userlib ;	return $userlib->get_user_groups($user);}

    function exapi_is_group($name) {
	global $adodb ;

	$is_group = False ;
	$result = $adodb->query("SELECT * FROM users_groups");
	while ($rs=$result->fetchRow())
		foreach ($rs as $key => $value)		if ($key=='groupName' and $value==$name)  $is_group=True;
	return $is_group ;
	}

    function exapi_lang ($phrase,$z1='',$z2='',$z3='',$z4='') {
	global $ckapi,$env ;

	$tmp = get_i18n($phrase) ;
	if ($env=='adminins')			$tmp = addslashes($tmp);
	switch ($ckapi['hostsys']['guilang']) :
		case 'zh-hk' :	$tmp1=iconv('big5','utf8',$tmp.'<zz>');
				list($tmp)=explode('<zz>',$tmp1);	break ;
		case 'zh-cn' :	$tmp1=iconv('gb18030','utf8',$tmp.'<zz>');
				list($tmp)=explode('<zz>',$tmp1);	break ;
		case 'fr-fr' :	$tmp=iconv('iso-8859-1','utf8',$tmp);	break ;
		case 'de-de' :	$tmp=iconv('iso-8859-1','utf8',$tmp);	break ;
		endswitch ;
						if ($z1==='') return $tmp ;
	$tmp = str_replace('%1',$z1,$tmp) ;	if ($z2==='') return $tmp ;
	$tmp = str_replace('%2',$z2,$tmp) ;	if ($z3==='') return $tmp ;
	$tmp = str_replace('%3',$z3,$tmp) ;	if ($z4==='') return $tmp ;
	return str_replace('%4',$z4,$tmp);
	}

    function exapi_is_admin($user='')		{global $user;	return ($user=='admin');}

    function exapi_dbrc(&$result)		{	return $result->RecordCount();	}

    function exapi_dbflds(&$result,$field)	{	return $result->fields($field);	}

    function exapi_dbcharset($string,$langcode)	{	return $string;			}

?>