<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// invoicewtoff.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-ar' ;
	$tran = 'invoicewt' ;
	$noheader = $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$regenerate = isset($_GET['regenerate']) ? $_GET['regenerate'] : (isset($_POST['regenerate'])?$_POST['regenerate']:'');
	$email_inv = isset($_GET['email_inv']) ? $_GET['email_inv'] : (isset($_POST['email_inv'])?$_POST['email_inv']:'');
	$email_rem = isset($_GET['email_rem']) ? $_GET['email_rem'] : (isset($_POST['email_rem'])?$_POST['email_rem']:'');
	$tax1cap = isset($_GET['tax1cap']) ? $_GET['tax1cap'] : (isset($_POST['tax1cap'])?$_POST['tax1cap']:'');
	$tax2cap = isset($_GET['tax2cap']) ? $_GET['tax2cap'] : (isset($_POST['tax2cap'])?$_POST['tax2cap']:'');
	$filter=stripslashes($filter);

	$t = exapi_tpl($app);
	$t->set_file(array('report'	=> "${tran}off.tpl",
                       'items'		=> "${tran}off.tpl"));
	$t->set_block('items','item_row','item_section');
	$t->set_block('items','paypal_button','paypal_section');
	$t->set_block('items','paymate_button','paymate_section');
	$t->set_block('items','done','done_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$geninv = exapi_lang('Regenerate as Invoice') ;
	$genrem = exapi_lang('Regenerate as Reminder') ;
	$title=exapi_lang('Invoice Image (Use browser print function to output the invoice shown above)');
	$t->set_var('lang_title',$title);
	$note1=exapi_lang('[This is a sample subject to tailoring per individual printer & invoice format]');
	$note1a=exapi_lang('For email function to work, your email/SMTP/DNS environment must be properly setup.');
	$t->set_var('lang_note1',"$note1<br>$note1a");
	$note2=exapi_lang('To adjust the tax captions, modify following caption fields, then press regenerate');
	$charset = exapi_lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('lang_note2',$note2);
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$logofile = $ckapi['hostsys']['dataarea']."/images/logo.png" ;
	$logourl = exapi_link("/ck-api/view_image.php","imgfile=$logofile") ;
	$t->set_var('logo',$logourl);

/*------------- Write Payment to Screen Display ----------------------------*/

	$result = $adodb->query("SELECT * FROM ${pre}defaults");
	$company = exapi_dbflds($result,'company') ;
	$comemail = exapi_dbflds($result,'email') ;
	$inv_rmkid = exapi_dbflds($result,'inv_rmkid') ;
	$rmd_rmkid = exapi_dbflds($result,'rmd_rmkid') ;
	$paypalyn = exapi_dbflds($result,'paypalyn') ;
	$paymateyn = exapi_dbflds($result,'paymateyn') ;
	$payasiayn = exapi_dbflds($result,'payasiayn') ;
	$paypalemail = exapi_dbflds($result,'paypalemail') ;
	$paymateuname = exapi_dbflds($result,'paymateuname') ;
	$result = $adodb->query("SELECT * FROM ${pre}remark where id='$inv_rmkid'");
	$remark = exapi_dbflds($result,'description') ;
	$result = $adodb->query("SELECT * FROM ${pre}remark where id='$rmd_rmkid'");
	$remind = exapi_dbflds($result,'description') ;

	$result = $adodb->query("SELECT * FROM ${pre}ar WHERE id='$id'");
	$customer = exapi_dbflds($result,'customer') ;
	$transdate = exapi_dbflds($result,'transdate') ;
	$duedate = exapi_dbflds($result,'duedate') ;
	$invnumber = exapi_dbflds($result,'invnumber') ;
	$taxincluded = exapi_dbflds($result,'taxincluded') ;
	$billamount = exapi_dbflds($result,'amount') ;
	$currency = exapi_dbflds($result,'isocode') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$result = $adodb->query("SELECT * FROM ${pre}customer a, ${pre}org b WHERE a.id='$customer' and contactid=b.id");
	if (exapi_dbrc($result)>0) {
		$name = exapi_dbflds($result,'orgname') ;
		$emailname = exapi_lang('Accounts Department')." - $name" ;
		$contactid = exapi_dbflds($result,'contactid') ;
		$terms = exapi_dbflds($result,'terms') ;
		}
	  else	{
		$result = $adodb->query("SELECT * FROM ${pre}customer a,${pre}person b WHERE a.id='$customer' and contactid=b.id");
		$name = $emailname = strtoupper(exapi_dbflds($result,'family'))." ".exapi_dbflds($result,'given') ;
		$contactid = exapi_dbflds($result,'contactid') ;
		$terms = exapi_dbflds($result,'terms') ;
		}

	$t->set_var('name',$name) ;
	$result = $adodb->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='bemail'");
	$custemail = exapi_dbflds($result,'commdata') ;
	$billaddr = exapi_lang('billaddr') ;
	$result = $adodb->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='$billaddr'");
	$addr1 = exapi_dbflds($result,'line1') ;
	$addr2 = exapi_dbflds($result,'line2') ;
	$addr3 = exapi_dbflds($result,'line3') ;
	$addr4 = exapi_dbflds($result,'line4') ;
	$shipaddr = exapi_lang('shipaddr') ;
	$sql = "SELECT name,b.* FROM ${pre}customer a, ${pre}address b " ;
	$sql.= "WHERE a.id='$customer' and a.contactid=b.contactid and addresscode='$shipaddr'";
	$result = $adodb->query($sql);
	$shiptoaddr1 = exapi_dbflds($result,'line1') ;
	$shiptoaddr2 = exapi_dbflds($result,'line2') ;
	$shiptoaddr3 = exapi_dbflds($result,'line3') ;
	$shiptoaddr4 = exapi_dbflds($result,'line4') ;

	if ($regenerate==$genrem or $email_rem)
			$t->set_var('lang_invoice',exapi_lang('*** INVOICE - REMINDER ***'));
		else	$t->set_var('lang_invoice',exapi_lang('*** INVOICE ***'));
	$t->set_var('lang_transdate',exapi_lang('Invoice Date'));
	$t->set_var('lang_duedate',exapi_lang('Due Date'));
	$t->set_var('lang_invnumber',exapi_lang('Number'));
	$t->set_var('lang_billto',exapi_lang('Bill To:'));
	$t->set_var('lang_shipto',exapi_lang('Ship To:'));
	$t->set_var('lang_itemid',exapi_lang('Item ID'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_price',exapi_lang('Price'));
	$t->set_var('lang_discount',exapi_lang('Disc'));
	$t->set_var('lang_amount',exapi_lang('Amount'));
	$t->set_var('lang_netamount',exapi_lang('Amount<br>(net of tax)'));
	$t->set_var('lang_tax1cap',exapi_lang('Tax1 caption')) ;
	$t->set_var('lang_tax2cap',exapi_lang('Tax2 caption')) ;
	$result = $adodb->query("SELECT artax1cap,artax2cap FROM ${pre}defaults");
	$tax1cap = (!$tax1cap) ? exapi_dbflds($result,'artax1cap') : $tax1cap ;
	$tax2cap = (!$tax2cap) ? exapi_dbflds($result,'artax2cap') : $tax2cap ;
	$t->set_var('lang_tax1',$tax1cap.exapi_lang('<br>(Rate)'));
	$t->set_var('lang_tax2',$tax2cap.exapi_lang('<br>(Rate)'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('invnumber',$invnumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shiptoname',$name) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

	// ---------------------------- Begin list items -----------------------------------------

	$total = $totnet = $tottax1 = $tottax2 = 0 ;
	$result = $adodb->query("SELECT * FROM ${pre}invoice WHERE trans_id='$id'");
	While ($rs=$result->fetchRow()) {
		$itemid = $rs['itemid'] ;
		$description = $rs['description'] ;
		$qty = $rs['qty'] ;
		$price = $rs['price'] ;
		$discount = $rs['discount'] ;
		$amount = number_format($qty*$price-$discount,2,".",'') ;
		$tax1 = number_format($rs['tax1'],2,".",'') ;
		$tax2 = number_format($rs['tax2'],2,".",'') ;
		$netamount = ($taxincluded=='t') ? number_format($amount-$tax1-$tax2,2,".",'') : $amount ;
		$tax1rate = number_format($tax1/$netamount*100,2,".",'') ;
		$tax2rate = number_format($tax2/$netamount*100,2,".",'') ;
		$tax1str = "$tax1 ($tax1rate%)" ;
		$tax2str = "$tax2 ($tax2rate%)" ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $description,
					'qty'		=> $qty,
					'price'		=> $price,
					'discount'	=> $discount ,
					'amount'	=> $amount ,
					'netamount'	=> $netamount ,
					'tax1'		=> $tax1str ,
					'tax2'		=> $tax2str ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		$totnet += $netamount ;
		$tottax1 += $tax1 ;
		$tottax2 += $tax2 ;
		}
	$t->set_var('lang_subtotal',exapi_lang("Subtotal")) ;
	$t->set_var('lang_total_payable',exapi_lang("Total Payable")) ;
	$t->set_var('total_amount',number_format($total,2,".",'')) ;
	$t->set_var('total_netamount',number_format($totnet,2,".",'')) ;
	$t->set_var('total_tax1',number_format($tottax1,2,".",'')) ;
	$t->set_var('total_tax2',number_format($tottax2,2,".",'')) ;
	$t->set_var('billamount',number_format($billamount,2,".",'')) ;
	$t->set_var('lang_term',exapi_lang("Terms Net")." $terms ".exapi_lang("days")) ;
	$t->set_var('lang_currency',exapi_lang("All prices are in").' '.$currency) ;
	$t->set_var('lang_thank',exapi_lang("Thank you for your valued business!")) ;
	if ($regenerate==$genrem or $email_rem)
				$t->set_var('lang_remark',$remark."<br><br><b>".$remind."</b>") ;
		else 		$t->set_var('lang_remark',$remark) ;
	$t->set_var('company',$company) ;
	$t->set_var('paypalemail',$paypalemail) ;
	$t->set_var('paymateuname',$paymateuname) ;
	$t->set_var('currency',$currency) ;
	if ($paypalyn<>"yes")	$t->set_var('paypal_section','') ;
		else		$t->parse('paypal_section','paypal_button',true);
	if ($paymateyn<>"yes")	$t->set_var('paymate_section','') ;
		else		$t->parse('paymate_section','paymate_button',true);
	$t->set_var('lang_tax1cap',exapi_lang('Tax1 caption')) ;
	$t->set_var('lang_tax2cap',exapi_lang('Tax2 caption')) ;
	$t->set_var('tax1cap',$tax1cap) ;
	$t->set_var('tax2cap',$tax2cap) ;

/*--------------------Write bottom Section------------------------------------------*/

	$tax1cap=urlencode($tax1cap) ;
	$tax2cap=urlencode($tax2cap) ;
	$t->set_var('regenerate_action',exapi_link("/$app/${tran}off.php","id=$id&filter=$filter")) ;
	if ($regenerate==$genrem or $email_rem)		$t->set_var('lang_regenerate',$geninv);
	  else  					$t->set_var('lang_regenerate',$genrem);
	$t->set_var('lang_email_inv',exapi_lang('Email Invoice'));
	$t->set_var('lang_email_rem',exapi_lang('Email Reminder'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","filter=$filter")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	if ($email_inv or $email_rem)	{
		$err = "" ; $error=exapi_lang("Error") ; $noemail=exapi_lang("No email sent") ;
		$custmsg = exapi_lang("Customer") ;	$invmsg = exapi_lang("Invoice") ;
		$successmsg = exapi_lang("Email successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email fails to deliver to") ;

		if (!$custemail)				$err = exapi_lang("Customer email missing") ;
		if ($custemail and strpos($custemail,'@')=='')	$err = exapi_lang("Invalid customer email") ;
		if (!$comemail)					$err = exapi_lang("Company return email missing");
		if ($comemail and strpos($comemail,'@')=='')	$err = exapi_lang("Invalid company return email");
		if ($paypalyn=="yes" and $paypalemail=="")	$err = exapi_lang("Paypay email address missing");
		if ($paymateyn=="yes" and $paymateuname=="")	$err = exapi_lang("Paymate login user name missing");
		if ($err<>'') {
			$note1 = "$custmsg/$name -- $invmsg/$id -- $noemail -- $error: $err" ;
			$t->set_var('lang_note1',$note1) ;
			}
		   else {
			$recipient = "$emailname < $custemail >" ;
			$subject = exapi_lang("Invoice#: %1 dated %2",$invnumber,$transdate) ;
			$bdmarker = "CK-ERP_".md5(uniqid(time())) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$headers.= "MIME-Version: 1.0\n" ;
			$headers.= "Content-Type: multipart/mixed; boundary=\"$bdmarker\"\n" ;
			$message = "--$bdmarker\n" ;
			$message.= "Content-Type: text/html; charset=$charset\n" ;
			$message.= "Content-Transfer-Encoding: 7bit\n" ;
			$contentid = md5(uniqid(time())) ;
			$htmlpart = str_replace($logourl,"cid:$contentid",$t->parse('out','items','report')) ;
			$message.= str_replace('{done_section}','',$htmlpart) ;
			$message.= "--$bdmarker\n" ;
			$message.= "Content-Type: image/png\n" ;
			$message.= "Content-Transfer-Encoding: base64\n" ;
			$message.= "Content-ID: $contentid\n\n" ;
			$fd = fopen("$logofile","r");
			$message.= chunk_split(base64_encode(fread($fd,filesize($logofile))))."\n";
			$message.= "--$bdmarker--\n" ;
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	$note1 = "$custmsg/$name -- $invmsg/$id -- $successmsg $custemail" ;
				else	$note1 = "$custmsg/$name -- $invmsg/$id -- $failuremsg $custemail" ;
			$t->set_var('lang_note1',$note1);
			}
		}
	$t->parse('done_section','done',true);
	$t->pparse('out','items','report');
	exapi_footer() ;

?>
