<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// importbulk.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-bank' ;
	$tran = 'import' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$filter = urldecode(stripslashes($filter)) ;
	$proc = newobj('ck-api','process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$db_type = $ckapi['hostsys']['dbtype'] ;

	$t = exapi_tpl($app);
	$t->set_file('question','confirm.tpl');
	$t->set_var('lang_title',exapi_lang("Import Ledger Items"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Ask for Confirmation.  If yes, action ----------------------------*/

$user = $ckapi['hostsys']['username'];
$temp1 = "${pre}br1".$user.time() ;
$temp2 = "${pre}br2".$user.time() ;
$sql =	"CREATE TABLE $temp1 AS " ;
$sql.=	"SELECT a.id,chart_id,trans_id,a.transdate,source,description,b.id as refnumber,amount " ;
$sql.=	"FROM ${pre}acc_trans a, ${pre}gl b WHERE 1=1 $where and trans_id=b.id" ;
$adodb->query($sql);
$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT a.id,chart_id,trans_id,a.transdate,source,description,a.refnumber,cheque,a.amount " ;
$sql.=	"FROM $temp1 a, ${pre}payment b WHERE trans_id=b.id" ;
$adodb->query($sql);
$sql =	"INSERT INTO $temp2 (id,chart_id,trans_id,transdate,source,description,refnumber,cheque,amount) ";
$sql.=	"SELECT a.id,chart_id,trans_id,a.transdate,source,description,a.refnumber,b.cheque,a.amount " ;
$sql.=	"FROM $temp1 a, ${pre}receipt b WHERE trans_id=b.id" ;
$adodb->query($sql);
$sql =	"INSERT INTO $temp2 (id,chart_id,trans_id,transdate,source,description,refnumber,amount) " ;
$sql.=	"SELECT * FROM $temp1 WHERE source<>'APPY' and source<>'ARRT'" ;
$adodb->query($sql);
//	trans_id = gl_id
//	trans_id = acc_tran_id
$adodb->query("UPDATE $temp2 SET amount=-amount,trans_id=id");
$dashpos = "position('-' in description)+1" ;
$blkpos = "position(' ' in description)-1" ;
$sql = "UPDATE $temp2 SET cheque=substring(description,$dashpos,$blkpos-$dashpos) ";
$sql.= "WHERE source='PYPY'" ;
$adodb->query($sql);

$imported = "(" ;
$result = $adodb->query("SELECT trans_id FROM ${pre}bkr_trans");
While ($rs=$result->fetchRow())		$imported.= $rs['trans_id']."," ;
if (strlen($imported)>1) {
	$imported = substr($imported,0,strlen($imported)-1).")";
	$adodb->query("DELETE FROM $temp2 WHERE trans_id IN $imported");
	}

$ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
$user = $ckapi['hostsys']['username'];
$op = 'new' ;
$now = mktime() ;

$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
$adodb->query($sql);

$sql ="INSERT INTO ${pre}bkr_trans (id,chart_id,trans_id,transdate,source,description,refnumber,cheque,amount) ";
$sql.=	"SELECT * FROM $temp2" ;
$adodb->query($sql);
$adodb->query("UPDATE ${pre}bkr_trans SET trans_id=id");
$result = $adodb->query("SELECT * FROM $temp2");
For ($i=1;$rs=$result->fetchRow();$i++)		$trans_id[$i]=$rs['trans_id'] ;
For ($i=1;isset($trans_id[$i]);$i++) {
	$id = $trans_id[$i] ;
	$iptime = "$ip=$now=$script=$id" ;
	$result = $adodb->query("SELECT * FROM ${pre}bkr_trans WHERE trans_id='$id'");
	While ($rs=$result->fetchRow()) {
		$headerarr["${pre}bkr_trans"] = $rs;
		$bkr_id = $rs['id'] ;
		$header = addslashes(serialize($headerarr));
		$sql= "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,header,iptime) ";
		$sql.="VALUES ('$bkr_id','$app','$script','$ip','$user','$op','$now','$header','$iptime')" ;
		$adodb->query($sql);
		}
	}
$item_count = $i-1 ;

$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
$adodb->query($sql);

if (isset($temp1))	$adodb->query("DROP TABLE $temp1,$temp2");

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',$item_count.' '.exapi_lang('Ledger Items Imported'));
	$t->set_var('lang_yes',exapi_lang('done'));
	$t->set_var('lang_no',exapi_lang('done'));
	$t->set_var('yes_action',exapi_link("/$app/${tran}filter.php")) ;
	$t->set_var('no_action',exapi_link("/$app/${tran}filter.php")) ;
	$t->pparse('out','question',True);
	exapi_footer() ;

?>
