<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.import.inc.php 0.16.1 2005/12/04 C K Wu

    class import {

//---- Import Item List SQL Formation

    function import_list_sql() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;
	$pre = &$ckapi['params']['pre'] ;
	$t = &$ckapi['objects']['template'] ;

	$user = $ckapi['hostsys']['username'];
	$temp1 = "${pre}br1".$user.time() ;
	$temp2 = "${pre}br2".$user.time() ;
	
	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=	"SELECT a.id,chart_id,trans_id,a.transdate,source,description,b.id as refnumber,amount " ;
	$sql.=	"FROM ${pre}acc_trans a, ${pre}gl b WHERE 1=1 $where and trans_id=b.id" ;
	$adodb->query($sql);
	$sql =	"CREATE TABLE $temp2 AS " ;
	$sql.=	"SELECT a.id,chart_id,trans_id,a.transdate,source,description,a.refnumber,cheque,a.amount " ;
	$sql.=	"FROM $temp1 a, ${pre}payment b WHERE trans_id=b.id" ;
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp2 (id,chart_id,trans_id,transdate,source,description,refnumber,cheque,amount) ";
	$sql.=	"SELECT a.id,chart_id,trans_id,a.transdate,source,description,a.refnumber,b.cheque,a.amount " ;
	$sql.=	"FROM $temp1 a, ${pre}receipt b WHERE trans_id=b.id" ;
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp2 (id,chart_id,trans_id,transdate,source,description,refnumber,amount) " ;
	$sql.=	"SELECT * FROM $temp1 WHERE source<>'APPY' and source<>'ARRT'" ;
	$adodb->query($sql);
	$adodb->query("UPDATE $temp2 SET amount=-amount,trans_id=id");
	$dashpos = "position('-' in description)+1" ;
	$blkpos = "position(' ' in description)-1" ;
	$sql = "UPDATE $temp2 SET cheque=substring(description,$dashpos,$blkpos-$dashpos) ";
	$sql.= "WHERE source='PYPY'" ;
	$adodb->query($sql);

	$imported = "(" ;
	$result = $adodb->query("SELECT trans_id FROM ${pre}bkr_trans");
	While ($rs=$result->fetchRow())		$imported.= $rs['trans_id']."," ;
	if (strlen($imported)>1) {
		$imported = substr($imported,0,strlen($imported)-1).")";
		$adodb->query("DELETE FROM $temp2 WHERE trans_id IN $imported");
		}

	$sql =  "SELECT *,trans_id as id FROM $temp2 ORDER BY ".$order." ".$sort ;
	$ckapi['params_sql']['temp1'] = $temp1 ;
	$ckapi['params_sql']['temp2'] = $temp2 ;
	return $sql ;
	}

//---- Import Item List Link Adjustement

    function import_list_adjust() {
	global $ckapi ;

	foreach ($ckapi['params_list']['dt'] as $key => $value)	$$key = $value ;
	$t = &$ckapi['objects']['template'] ;

	if ($source=="PYPY") {
		$dashpos = strpos($description,"-") ;
		$blkpos = strpos($description," ") ;
		$cheque = substr($description,$dashpos+1,$blkpos-$dashpos) ;
		}
	$t->set_var('cheque',$cheque);
	}

    }

?>
