<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// worksheetfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-bank' ;
	$tran = 'worksheet' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang('Enter Reconciliation Worksheet Parameters :'),
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Worksheet Generation") ,
				'lang_add'	=> exapi_lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);
	$where = "WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'" ;
	$bankac_sl = selectlist('chart','accno',$where,'','id','accno','description') ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Bank Account') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$bankac_sl ,
				'varname'	=>	'chart_id' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Select the appropriate bank account'));

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Reconciliation Period from') ,
				'type'		=>	'input' ,
				'varname'	=>	'from' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Reconciliation Period to') ,
				'type'		=>	'input' ,
				'varname'	=>	'to' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Beginning Bank Statement Balance') ,
				'type'		=>	'input' ,
				'varname'	=>	'beginbal' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a number') ) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Ending Bank Statement Balance') ,
				'type'		=>	'input' ,
				'varname'	=>	'endbal' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a number'));

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
