<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// importorgbulk.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-contact' ;
	$class = 'import' ;
	$tran = 'importorg' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$oname = isset($_GET['oname']) ? $_GET['oname'] : (isset($_POST['oname'])?$_POST['oname']:'');
	$omask = isset($_GET['omask']) ? $_GET['omask'] : (isset($_POST['omask'])?$_POST['omask']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$filter = urldecode(stripslashes($filter)) ;

	$imporg = newobj($app,$class) ;
	$ckapi['objects']['tranobj'] = &$imporg ;
	$t = exapi_tpl($app);
	$ckapi['objects']['template'] = &$t ;
	$proc1 = newobj('ck-api','process1') ;
	$where = $proc1->decode_where($filter) ;

	$t->set_file('question','confirm.tpl');
	$t->set_var('lang_title',exapi_lang("Import Contact Organization Items"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Build $commcode, $addrcode array ----------------------------*/

	$user = $ckapi['hostsys']['username'];
	$where1 = "WHERE resource='contactimport'" ;
	$result = $adodb->query("SELECT * FROM ${pre}resourcelock $where1");
	$used_by = exapi_dbflds($result,'used_by') ;
	if ($used_by=="")	
		$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' $where1");
	  else	{
		$error=exapi_lang("Error");	$err=exapi_lang("Contact Import is being accessed by ").$used_by;
		$t->set_var('lang_confirm',"$error:  $err");
		$t->set_var('lang_yes',exapi_lang('done'));
		$t->set_var('lang_no',exapi_lang('done'));
		$t->set_var('yes_action',exapi_link("/$app/importfilter.php")) ;
		$t->set_var('no_action',exapi_link("/$app/importfilter.php")) ;
		$t->pparse('out','question',True);
		exit() ;
		}

	$lang_comm = exapi_lang("comm") ;
	$result = $adodb->query("SELECT * FROM ${pre}category WHERE app='$app' and type='$lang_comm' and parent<>'0'");
	while ($rs = $result->fetchRow()) {
		$name = $rs['name'] ;
		$commcode[$name] = $name ;
		switch ($name) :
			case "hemail" :	$commcode["home email"]=$name;	break;
			case "wemail" :	$commcode["work email"]=$name;	break;
			case "hphone" :	$commcode["home phone"]=$name;	break;
			case "wphone" :	$commcode["work phone"]=$name;	break;
			case "vphone" :	$commcode["voice phone"]=$name;	break;
			case "msgphone":$commcode["msg phone"]=$name;	break;
			case "cellphone":$commcode["mobile (cell) phone"]=$name; break;
			case "carphone":$commcode["car phone"]=$name;	break;
			case "hfax" :	$commcode["home fax"]=$name;	break;
			case "wfax" :	$commcode["work fax"]=$name;	break;
			endswitch ;
		}
	$lang_address = exapi_lang("address") ;
	$result = $adodb->query("SELECT * FROM ${pre}category WHERE app='$app' and type='$lang_address'");
	while ($rs = $result->fetchRow()) {
		$name = $rs['name'] ;
		$addrcode[$name] = $name ;
		switch ($name) :
			case "hdomaddr" :	$addrcode["home"]=$name;	break;
			case "workaddr" :	$addrcode["work"]=$name;	break;
			endswitch ;
		}

/*------------- Import Contact Data into CK-ERP tables ---------------------*/

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $class ,
				'tran'		=> $tran ,
				'table'		=> "${pre}org" ,
				'uniqueflds'	=> array("orgnumber")		) ;
	$ckapi['tables']['parents'] = array(	"${pre}org"	=> ""		) ;
	$ckapi['tables']["children"] = array("${pre}comm"		=> "contactid" ,
					"${pre}address"		=> "contactid" ,
					"${pre}status"		=> "contactid" ,
					"${pre}others"		=> "contactid"	);
	$ckapi['params_post']['op'] = "add" ;

	if ($ckapi['hostsys']['dbtype']=="mysql")
		$catmatched = "instr(b.cat_id,concat(',',c.cat_id,','))>0" ;
	  else	$catmatched = "strpos(b.cat_id,','||c.cat_id||',')>0" ;
	$delimiter = "****" ;
	$lang_stdnote = exapi_lang("Imported from phpGW") ;
	$lang_others = exapi_lang("others") ;

	$markter="zzDnAzz";
	$where = str_replace($markter,"substring(name,1,1)",$where) ;
	$sql =	"SELECT distinct org_id as hostsysid,org_id as id,name as orgname " ;
	$sql.=	"FROM exapi_contact_org WHERE active='Y' $where ORDER BY org_id" ;
	$result = $adodb->query($sql);
	while ($org[] = $result->fetchRow())	;

	$i = 0 ;
	foreach ($org as $key => $dt) {
		$dt['orgnumber'] = str_replace(" ","_",$dt['orgname']) ;
		$sql =	"SELECT descr,comm_data " ;
		$sql.=	"FROM exapi_contact_org a,exapi_contact_comm b,exapi_contact_comm_descr c ";
		$sql.=	"WHERE org_id='$dt[id]' and org_id=contact_id and b.comm_descr_id=c.comm_descr_id";
		$result = $adodb->query($sql);
		while ($rs = $result->fetchRow())
			$dt['comm'][] = array(	"commcode" => $commcode["$rs[descr]"],
						"commdata" => $rs['comm_data']	);
		$sql =	"SELECT description,b.* " ;
		$sql.=	"FROM exapi_contact_org a,exapi_contact_addr b,exapi_contact_addr_type c ";
		$sql.=	"WHERE org_id='$dt[id]' and org_id=contact_id and b.addr_type_id=c.addr_type_id";	
		$result = $adodb->query($sql);
		while ($rs = $result->fetchRow()) {
			$line4 = "$rs[city] $rs[state] $rs[country]" ;
			$dt['addr'][] = array(	"addresscode"=>$addrcode["$rs[description]"],
						"line1" => $rs['add1'],
						"line2" => $rs['add2'],
						"line3" => $rs['add3'],
						"line4" => $line4,
						"zip"	=> $rs['postal_code']		);
			}
		$sql =	"SELECT other_name,other_value " ;
		$sql.=	"FROM exapi_contact_org a,exapi_contact_others b ";
		$sql.=	"WHERE org_id='$dt[id]' and org_id=contact_id";
		$result = $adodb->query($sql);
		while ($rs = $result->fetchRow())
			$dt['othr'][] = array(	"description"	=> $rs['other_name'],
						"value"		=> $rs['other_value']	);
		$sql =	"SELECT c.cat_id,cat_name,cat_description " ;
		$sql.=	"FROM exapi_contact_org a,exapi_contact b,exapi_categories c ";
		$sql.=	"WHERE org_id='$dt[id]' and org_id=b.contact_id " ;
		$sql.=				"and $catmatched and cat_appname='addressbook'";
		$result = $adodb->query($sql);
		while ($rs = $result->fetchRow())
			$dt['cat'][]=$cat_arr[]= array(	"cat_id" => $rs['cat_id'],
							"cttcode"=> $rs['cat_name'],
							"cttdesc"=> $rs['cat_description']);
		$sql =	"SELECT c.cat_id,cat_name,cat_description " ;
		$sql.=	"FROM exapi_contact_org a,exapi_contact b,exapi_categories c ";
		$sql.=	"WHERE org_id='$dt[id]' and org_id=b.contact_id " ;
		$sql.=				"and b.cat_id=c.cat_id and cat_appname='addressbook'";
		$result = $adodb->query($sql);
		while ($rs = $result->fetchRow())
			$dt['cat'][]=$cat_arr[]= array(	"cat_id" => $rs['cat_id'],
							"cttcode"=> $rs['cat_name'],
							"cttdesc"=> $rs['cat_description']);
		
		$dt['note'] = "$lang_stdnote${delimiter}hostsysid=$dt[id]" ;

		$ckapi['params_post']['dt'] = $dt ;
		$proc1->process1_post() ;
		$i++ ;
		}

	$lang_org = exapi_lang('org') ;
	$j = 0 ;
	foreach ($cat_arr as $key => $val) {
		$sql =	"SELECT * FROM ${pre}category WHERE app='$app' and type='$lang_org' " ;
		$sql.=		"and name='$val[cttcode]' and description='$val[cttdesc]'";
		$result = $adodb->query($sql);
		if (exapi_dbrc($result)==0) {
			$ckapi['params'] = array( 'pre'		=> $pre ,
						'app'		=> $app ,
						'class'		=> 'category' ,
						'tran'		=> 'category' ,
						'table'		=> "${pre}category" ,
						'uniqueflds'	=> array("type","name")		) ;
			$ckapi['tables']['parents'] = array(	"${pre}category"=> ""		) ;
			$ckapi['params_post']['op'] = "add" ;
			$ckapi['params_post']['dt'] = array('app'	=>	$app,
							'type'	=>	$lang_org,
							'name'	=>	$val['cttcode'] ,
							'description'=>	$val['cttdesc'] ,
							'parent'=>	0 ,
							'allowdelete'=>	'n' ,
							'id'	=>	$val['cat_id']		);
			$proc1->process1_post() ;
			$j++ ;
			}
		}

	$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='contactimport'");

/*--------------------Write bottom Section------------------------------------------*/

	$org_confirm = "$i  ".exapi_lang('Contact Org Item(s) Imported') ;
	$cat_confirm = "$j  ".exapi_lang('Contact Code(s) Imported') ;
	$reminder = exapi_lang('Please remember to rectify the org code,person code and the various preferred fields.');
	$t->set_var('lang_confirm',"$org_confirm<br>$cat_confirm<br><br>$reminder");
	$t->set_var('lang_yes',exapi_lang('done'));
	$t->set_var('lang_no',exapi_lang('done'));
	$t->set_var('yes_action',exapi_link("/$app/importfilter.php")) ;
	$t->set_var('no_action',exapi_link("/$app/importfilter.php")) ;
	$t->pparse('out','question',True);
	exapi_footer() ;

?>
