<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// importorgdlist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-contact' ;
	$tran = 'importorgd' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$oname = isset($_GET['oname']) ? $_GET['oname'] : (isset($_POST['oname'])?$_POST['oname']:'');
	$omask = isset($_GET['omask']) ? $_GET['omask'] : (isset($_POST['omask'])?$_POST['omask']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'import',
				'tran'		=> $tran ,
				'table'		=> "${pre}org" ,
				'sortkey'	=> 'hostsysid' ,
				'doneexit'	=> "importorgbulk.php"			);
	$msg1 = exapi_lang("Only Active Organizations will be listed and be imported.") ;
	$msg2 = exapi_lang("It is advisable to save or print a copy of this list for future reference.") ;
	$msg3 = exapi_lang("Because of semantic difference, the field [preferred] is not imported.") ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Contact Organizations to be imported") ,
				'lang_add'	=> exapi_lang("Start Bulk Import") ,
				'lang_orgnumber'=> exapi_lang('Org shortname/# after import') ,
				'lang_data'	=> exapi_lang("Contact Data") ,
				'lang_type'	=> exapi_lang('Type') ,
				'lang_nature'	=> exapi_lang('Nature') ,
				'lang_portion'	=> exapi_lang('Data or portions thereof') ,
				'lang_alter'	=> exapi_lang("Display Summary List") ,
				'alter_action'	=> exapi_link("/$app/importorgslist.php"),
				'oname'		=> $oname ,
				'omask'		=> $omask ,
				'filter'	=> $filter ,
				'message'	=> "$msg1  $msg2  $msg3"			);
	$ckapi['columns'] = array('hostsysid'	=> exapi_lang('Host System ID') ,
				'name'		=> exapi_lang('Organization Name') ,
				'orgnumber'	=> exapi_lang('Org shortname/# after import') ,
				'type'		=> exapi_lang('Type') ,
				'nature'	=> exapi_lang('Nature') ,
				'data'		=> exapi_lang('Data or portions thereof')	);
	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;

	if (isset($ckapi['params']['temp1']))	$adodb->query('DROP TABLE '.$ckapi['params']['temp1']);
	exapi_footer() ;

?>
