<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.limit.inc.php 0.16.1 2005/12/04 C K Wu

    class limit {

//---- limit Read

    function limit_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$id = $ckapi['params_post']['id'] ;
	$op = $ckapi['params_post']['op'] ;

	$result = $adodb->query("select * from ${pre}customer where id='$id'");
	$dt = $result->fetchRow() ;
	$result = $adodb->query("select * from ${pre}org where id='$dt[contactid]'");
	if (exapi_dbrc($result)>0)	$dt['orgid'] = $dt['contactid'] ;
		else			$dt['prsid'] = $dt['contactid'] ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- limit Detail Validation Checks

    function limit_validate() {
	global $ckapi ;

	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang("Error");
	if ($dt['creditlimit']=="")			$err=exapi_lang("Credit Limit Missing");
	if ($dt['creditlimit'] and !is_numeric($dt['creditlimit']))
							$err=exapi_lang("Credit Limit must be numeric");
	if ($dt['creditlimit']<0)			$err=exapi_lang("Credit Limit must be +ve");
	
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write limit Detail

    function limit_write() {
	global $ckapi,$pre,$adodb ;

	$dt = &$ckapi['params_post']['dt'] ;
	$op = $ckapi['params_post']['op'] ;
	$t = &$ckapi['objects']['template'] ;

	$result = $adodb->query("SELECT nativecurr from ${pre}defaults");
	$nativecurr = exapi_dbflds($result,'nativecurr') ;

	$t->set_var('lang_id',exapi_lang('Audit ID').':');
	$t->set_var('lang_org',exapi_lang('Organization'));
	$t->set_var('lang_prs',exapi_lang('Person'));
	$limit = exapi_lang('Credit Limit') ;
	$t->set_var('lang_creditlimit',"$limit [$nativecurr]");
	$t->set_var('nativecurr',$nativecurr);

	$fields = array('id','control','orgid','prsid','creditlimit') ;
	foreach ($fields as $field)	$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;

	$t->set_var('id',$dt['id']);
	$t->set_var('control',$dt['control']);
	$dt['orgid'] = ($dt['orgid']=="") ? 0 : $dt['orgid'] ;
	$dt['prsid'] = ($dt['prsid']=="") ? 0 : $dt['prsid'] ;
	$name = 'substring(orgname,1,25)' ;
	$t->set_var('org_selectlist',selectlist('org','orgnumber',"WHERE id='$dt[orgid]'",$dt['orgid'],'id','orgnumber',$name,'id'));
	$name = ($ckapi['hostsys']['dbtype']=="mysql") ? "substring(concat(family,', ',given),1,25)" : "substring((family||', '||given),1,25)" ;
	$t->set_var('prs_selectlist',selectlist('person','prsnumber',"WHERE id='$dt[prsid]'",$dt['prsid'],'id','prsnumber',$name,'id'));
	$lang_cust = exapi_lang('Customer') ;
	$t->set_var('creditlimit',$dt['creditlimit']);
	$t->parse('out','report',True);
	}

//---- limit Post Initialisation

    function limit_post_init() {
	global $ckapi,$pre,$adodb ;

	$dt = &$ckapi['params_post']['dt'] ;
	$creditlimit = $dt['creditlimit'] ;
	$result = $adodb->query("select * from ${pre}customer where id='$dt[id]'");
	$dt = $result->fetchRow() ;
	$dt['creditlimit'] = $creditlimit ;
	}

    }
