<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// helpcaselist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-css' ;
	$tran = 'helpcase' ;
	require_once('../ck-api/ckapi.inc.php') ;
	require_once('custid.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}helpcase" ,
				'bulkcnt'	=> 0				);
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Helpdesk Cases") ,
				'lang_add'	=> exapi_lang("Done") ,
				'bulk_action'	=> exapi_link("/$app/${tran}filter.php" ) ,
				'message'	=> ''				);
	$ckapi['columns'] = array('casenumber'	=> exapi_lang('Helpdesk Case Name/#') ,
				'name'		=> exapi_lang('Customer Name') ,
				'description'	=> exapi_lang('Helpdesk Case Description') ,
				'start'		=> exapi_lang('Started on') ,
				'id'		=> exapi_lang('Audit ID') 	);
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"	) ;
	$ckapi['lang_links'] = array('lang_view'	=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")		) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;

	if (isset($ckapi['params_sql']['temp']))	$adodb->query('DROP TABLE '.$ckapi['params_sql']['temp']);
	exapi_footer() ;

?>
