<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.status.inc.php 0.16.1 2005/12/04 C K Wu

    class status {

//---- Status Read

    function status_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$table = $ckapi['params']['table'] ;
	$id = $ckapi['params_post']['id'] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	if ($table=="${pre}org")	$dt['name'] = $dt['orgnumber'] ;
	if ($table=="${pre}person")	$dt['name'] = $dt['prsnumber'] ;
	$result = $adodb->query("SELECT * FROM ${pre}status where contactid='$id'");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['statuscode'.$i]	=	$rs['statuscode'] ;
		$dt['preferred'.$i]	=	$rs['preferred'] ;
		}
	return $dt;
	}

//---- Status Validation Checks

    function status_validate() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$err=""; $error = exapi_lang("Error") ;
	$pra = "" ;
	$row = exapi_lang("Row") ;
	For ($i=1;isset($dt['statuscode'.$i]);$i++) {
		if ($dt['preferred'.$i]=='y')
			if ($pra<>"")	$err="[$row $i]".exapi_lang("More than one [preferred] Status Datum");		else $pra="1";
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Status Header

    function status_header_write() {
	global $ckapi ;

	$dt = $ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;
	$t->set_var('lang_name',exapi_lang('Contact Name/# :'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('name',$dt['name']) ;
	$t->set_var('id',$dt['id']) ;
	$t->set_var('control',$dt['control']) ;
	$t->set_var('table',$ckapi['params']['table']) ;
	$t->parse('out','report',True);
	}

//---- Write Status Detail

    function status_detail_write() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	$table = $ckapi['params']['table'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;

	$posted = ($ckapi['params_post']['op']=="view" or $ckapi['params_post']['op']=="delete") ;
	$row_ = exapi_lang('Row')." " ;
	$id = $dt['id'] ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_statuscode',exapi_lang("Status Code -- Description") );
	$t->set_var('lang_preferred',exapi_lang('Preferred Data'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_org = strtolower(exapi_lang('org')) ;
	$lang_person = strtolower(exapi_lang('person')) ;
	$lang_no = exapi_lang("no") ;
	$lang_yes = exapi_lang("yes") ;
	if ($table=="${pre}org")
		$statuscode_sl=selectlist('category','type',"WHERE type='$lang_org'",'','name','name','description') ;
	if ($table=="${pre}person")
		$statuscode_sl=selectlist('category','type',"WHERE type='$lang_person'",'','name','name','description') ;
	$preferred_sl = "<OPTION value='n'>n -- $lang_no</OPTION><OPTION value='y'>y -- $lang_yes</OPTION>" ;
	$insrowno = (isset($insert) and $insert<>'') ? intval(str_replace($row_,"",$insert)) : '' ;
	$delrowno = (isset($delete) and $delete<>'') ? intval(str_replace($row_,"",$delete)) : '' ;
	For ($i=1;isset($dt['statuscode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('statuscode_fld','statuscode'.$i);
			$t->set_var('preferred_fld','preferred'.$i) ;
			$t->set_var('statuscode_selectlist',$statuscode_sl) ;
			$t->set_var('preferred_selectlist',$preferred_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $insert<>'' and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $delete<>'' and $i>$delrowno)	$j=$i-1;

		$statuscode	= $dt['statuscode'.$i] ;
		$preferred	= $dt['preferred'.$i] ;
		$t->set_var('statuscode_fld','statuscode'.$j);
		$t->set_var('preferred_fld','preferred'.$j) ;
		
		$t->set_var('statuscode_selectlist',str_replace("'$statuscode'","'$statuscode' selected",$statuscode_sl)) ;
		$t->set_var('preferred_selectlist',str_replace("'$preferred'","'$preferred' selected",$preferred_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;  else  $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done") ;  else  $t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('statuscode_fld','statuscode'.$i);
		$t->set_var('preferred_fld','preferred'.$i) ;
		$t->set_var('statuscode_selectlist',$statuscode_sl) ;
		$t->set_var('preferred_selectlist',$preferred_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

//---- Status Post - PreCommit Routine

    function status_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$adodb->query("DELETE from ${pre}status where contactid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['statuscode'.$i]);$i++) {
			$statuscode = $dt['statuscode'.$i] ;
			$preferred = $dt['preferred'.$i] ;
			$sql = "INSERT INTO ${pre}status (contactid,statuscode,preferred) " ;
			$sql.= "VALUES('$id','$statuscode','$preferred')" ;
			$adodb->query($sql);
			}
		}
	}

    }

?>