<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// attendfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-hr' ;
	$tran = 'attend' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'attend',
				'tran'		=> $tran ,
				'table'		=> "${pre}attendance" 			) ;
	$msg1 = exapi_lang('Attendance Records are auto-created via staff signing in/out.') ;
	$msg2 = exapi_lang('Normally, HR staff should not create/amend attendance records.') ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among existing Attendance Record :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Attendance Record") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$type_sl = "<OPTION value='sign-in'>".exapi_lang('sign-in')."</OPTION>" ;
	$type_sl.= "<OPTION value='sign-out'>".exapi_lang('sign-out')."</OPTION>" ;
	$msg1 = exapi_lang('Target date falling within (from/to) period will be listed.') ;
	$msg2 = exapi_lang('Target date: Sign In/Out Date') ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Department') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.selectlist('department','name','','','id','description') ,
				'varname'	=>	'dept' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for Attendance Record of target Department'));

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Record Type') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.$type_sl ,
				'varname'	=>	'type' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for the target Record Type')) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Employee Name/#') ,
				'type'		=>	'input' ,
				'varname'	=>	'name' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for target key word in the Employee Name Field') ) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Period From') ,
				'type'		=>	'input' ,
				'varname'	=>	'datefrom' ,
				'defval'	=>	'' ,
				'note'		=>	"$msg1  $msg2  $dateformat"		) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Period To') ,
				'type'		=>	'input' ,
				'varname'	=>	'dateto' ,
				'defval'	=>	'' ,
				'note'		=>	"$msg1  $msg2  $dateformat"		) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
