<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// leaveapplist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-hr' ;
	$tran = 'leaveapp' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}leaveapp" 			);
	$msg = exapi_lang('Features provided here is for use by HR staff, in case ck-sss is not deployed.') ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Leave Application List") ,
				'lang_add'	=> exapi_lang("Add New Leave Application") ,
				'message'	=> $msg					);
	$ckapi['columns'] = array('staff'	=> exapi_lang('Employee Name/#') ,
				'leavefrom'	=> exapi_lang('Leave From') ,
				'leaveto'	=> exapi_lang('Leave To') ,
				'description'	=> exapi_lang('Leave Description') ,
				'duration'	=> exapi_lang('Duration in Work Days') ,
				'approved_by'	=> exapi_lang('Approved By') ,
				'id'		=> exapi_lang('Audit ID') 		);
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi['lang_links'] = array('lang_view'=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")			) ;
	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;
	exapi_footer() ;

?>
