<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// adminfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'admin' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$warning1 = exapi_lang('Additional installed language will slow down system performance') ;
	$warning2 = exapi_lang('There is no concurrency control over language admin functions') ;
	$warning3 = exapi_lang('Please make sure no other user is accessing the i18n module at this moment') ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Choose Language Admin Action to Perform :") ,
				'lang_criteria'	=> exapi_lang("Admin Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Action") ,
				'lang_add'	=> exapi_lang("Done") ,
			'lang_search_message'	=> "$warning1<br>$warning2<br>$warning3" ,
				'message'	=> ''				);

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Which Action') ,
				'type'		=>	'select' ,
				'selectlist'	=>	'' ,
				'varname'	=>	'actnum' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('If wrong action chosen, click [Language Admin] to restart'));

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Which Lanuage') ,
				'type'		=>	'select' ,
				'selectlist'	=>	selectlist('i18ncode','langcode','','','langcode','description','langcode') ,
				'varname'	=>	'lang' ,
				'defval'	=>	'' ,
				'note'		=>exapi_lang('Select the target language to install/delete'));

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Explanatory Message'),
				'type'		=>	'input' ,
				'varname'	=>	'dummy' ,
				'defval'	=>	exapi_lang('[No Input Required]') ,
				'note'		=>	exapi_lang('Obselete Phrases - those not used by any script')		);

	$act1 = '1 -- '.exapi_lang('Install Additional Language') ;
	$act2 = '2 -- '.exapi_lang('Delete Installed Language') ;
	$ckapi['filter']['actlist'] = array (	1=>	"<OPTION value='1'>$act1</OPTION>",
						2=>	"<OPTION value='2'>$act2</OPTION>"	) ;

	$ckapi['filter']['actstring'] = array(	"0",		/* first entry	*/
						"01",		/* Action 1	*/
						"01",		/* Action 2	*/		) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_filter() ;
	exapi_footer() ;

?>
