<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// moduleobsolete.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'module' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}i18n"			) ;
	$ckapi['tables']['parents'] = array("${pre}i18n"=> ""			) ;

	$proc1 = newobj('ck-api','process1') ;
	$t = exapi_tpl($app);
	$ckapi['objects']['template'] = &$t ;
	$t->set_file('report','confirm.tpl');
	$t->set_file('msg','message.tpl');

/* ------------- Read and Write Journal Detail --------------------------- */

	$msg0 = '<br><br>'.exapi_lang('This action may not delete all Obsolete Phrases') ;
	$msg0.= '<br>'.exapi_lang('You may have to carry out further deletion manually') ;
	$t->set_var('message',$msg0);
	$t->pparse('out','msg',True);

	$commonphrases = array() ;
	$commoncnt = array() ;
	$phrases = array() ;
	$obsoletes = array() ;
	$maybe = array() ;
	$marker = 'exapi_lang(';
	$basehdl = opendir($basedir) ;
	while ($module = readdir($basehdl))	{
		if (!strstr($module,'ck-'))					continue ;
		$moddir = $basedir.'/'.$module ;
		if (!is_dir($moddir))						continue ;
		$modhdl = opendir($moddir) ;
		while ($msdir = readdir($modhdl))	{
			if ($msdir=='..')					continue ;
			$modsdir = ($msdir=='.') ? $moddir : $moddir.'/'.$msdir ;
			if (!is_dir($modsdir))					continue ;
			if (strstr('doc,images,setup,templates',$msdir))	continue ;
			$modshdl = opendir($modsdir) ;
			while ($targetfile = readdir($modshdl))	{
				if (!strstr($targetfile,'.php'))		continue ;
				if (strstr($targetfile,'.php~'))		continue ;
				$infile = $modsdir.'/'.$targetfile ;
				$lines = file($infile);
				foreach($lines as $line) {
					if (!strstr($line,$marker))		continue ;
					unset($str1,$str2,$str3,$str4,$str5) ;
					$strs = explode($marker,$line) ;
					if (isset($strs[1]))	processstr($strs[1]) ;	else continue ;
					if (isset($strs[2]))	processstr($strs[2]) ;	else continue ;
					if (isset($strs[3]))	processstr($strs[3]) ;	else continue ;
					if (isset($strs[4]))	processstr($strs[4]) ;	else continue ;
					if (isset($strs[5]))	processstr($strs[5]) ;	else continue ;
					}
				}
			}
		}

	$result = $adodb->query("SELECT * FROM ${pre}i18n");
	while ($rs=$result->fetchRow()) {
		$id = $rs['id'] ;
		$module = $rs['module'] ;
		$langcode = $rs['langcode'] ;
		$i18nkey = $rs['i18nkey'] ;
		$i18nval = $rs['i18nval'] ;
		$control = $rs['control'] ;
		if (!isset($phrases[$i18nkey]) and !isset($commonphrases[$i18nkey])) {
			$obsolete[] = array($id,$module,$langcode,$i18nkey,$i18nval,$control) ;
			continue ;
			}
		if (!isset($phrases[$i18nkey]) and isset($commonphrases[$i18nkey])) {
			if ($module=='ck-api')		continue ;
			$maybe[] = array($id,$module,$langcode,$i18nkey,$i18nval,$control) ;
			}
		}
	foreach($maybe as $key => $val) {
		$langcode = $maybe[$key][2] ;
		$i18nkey = $maybe[$key][3] ;
		$result = $adodb->query("SELECT * FROM ${pre}i18n WHERE module='ck-api' and langcode='$langcode' and i18nkey='$i18nkey'");
		if (exapi_dbrc($result)>0)	$obsolete[]=$maybe[$key] ;
		}

	$dt = &$ckapi['params_post']['dt'] ;
	foreach($obsolete as $key => $val) {
		$dt['id'] = $obsolete[$key][0] ;
		$dt['module'] = $obsolete[$key][1] ;
		$dt['langcode'] = $obsolete[$key][2] ;
		$dt['i18nkey'] = $obsolete[$key][3] ;
		$dt['i18nval'] = $obsolete[$key][4] ;
		$dt['control'] = $obsolete[$key][5] ;
		$ckapi['phrases']['lang_tran'] = '' ;
		$ckapi['params_post']['op'] = 'delete' ;
		$proc1->process1_post() ;
		}

/*--------------------Write bottom Section------------------------------------------*/

	$msg1 = count($obsolete).' '.exapi_lang('Obsolete Phrases Deleted') ;	
	$t->set_var('lang_confirm',$msg1);
	$t->set_var('lang_yes',exapi_lang('Done'));
	$t->set_var('lang_no',exapi_lang('Done'));
	$t->set_var('yes_action',exapi_link("/$app/${tran}filter.php")) ;
	$t->set_var('no_action',exapi_link("/$app/${tran}filter.php")) ;

	$t->pparse('out','report',True);
	exapi_footer() ;


    function processstr($str) {
	global $commonphrases, $commoncnt, $phrases, $module ;

	$str = trim($str) ;
	if ($str=="';")					return ;
	list($dummy,$phrase) = explode(chr(ord($str)),$str) ;
	$phrase = stripslashes(trim($phrase)) ;
	$phrasekey = strtolower($phrase) ;

	if (isset($phrases[$phrasekey]) and $phrases[$phrasekey]===$module)	return ;
	$phrases[$phrasekey] = $module ;
	if (isset($commoncnt[$phrasekey]))	$commoncnt[$phrasekey]++ ;
		else				{$commoncnt[$phrasekey]=1; $commonphrases[$phrasekey]=$phrase;}
	return ;
	}

?>
