<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// gdfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-inv' ;
	$tran = 'gd' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> 'il'			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among posted Goods Delivery (GD) :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Goods Delivery") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);
	$customer_sl = "<OPTION value='ALL'></OPTION>".selectlist('customer','name','','','id','name','id');
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Which customer') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$customer_sl ,
				'varname'	=>	'customer' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Pick the customer to which goods are being sent') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Goods Delivery Date (from)') ,
				'type'		=>	'input' ,
				'varname'	=>	'from' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Goods Delivery Date (to)') ,
				'type'		=>	'input' ,
				'varname'	=>	'to' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Source') ,
				'type'		=>	'input' ,
				'varname'		=>	'source' ,
				'defval'		=>	"" ,
				'note'		=>	exapi_lang('Search for target key word in the GD source field')) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Description') ,
				'type'		=>	'input' ,
				'varname'	=>	'description' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Search for target key word in the GD description field')) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
