<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// accounthist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'account' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$start = isset($_GET['start']) ? $_GET['start'] : (isset($_POST['start'])?$_POST['start']:'');
	$end = isset($_GET['end']) ? $_GET['end'] : (isset($_POST['end'])?$_POST['end']:'');
	$attrib1 = isset($_GET['attrib1']) ? $_GET['attrib1'] : (isset($_POST['attrib1'])?$_POST['attrib1']:'');
	$attrib2 = isset($_GET['attrib2']) ? $_GET['attrib2'] : (isset($_POST['attrib2'])?$_POST['attrib2']:'');
	$attrib3 = isset($_GET['attrib3']) ? $_GET['attrib3'] : (isset($_POST['attrib3'])?$_POST['attrib3']:'');
	$filter=stripslashes($filter);

	$t = exapi_tpl($app);
	$t->set_file('report','accounthist.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',exapi_lang('View Account Journal History'));
	$t->set_var('lang_notes',exapi_lang('Press (done) button at View Detail screen to go on to transaction maintenance'));
	$t->set_var('message','') ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;

/*------------- Validate History Start and End Date ----------------------------*/

	$err=""; $error = exapi_lang('Error') ;
	if ($start<>'')		if (input2date($start)=="")	$err=exapi_lang("Invalid History Start Date");
	if ($end<>'')		if (input2date($end)=="")	$err=exapi_lang("Invalid History End Date");

	$end = (!$end) ? date("Y-m-d") : $end ;
	$start = (!$start) ?date("Y-m-d",mktime(0,0,0,substr($end,5,2)-1,1,intval(substr($end,0,4)))) :$start;
	if ($start>$end)			$err=exapi_lang("History Start later than End Date");

	$result = $adodb->query("SELECT * FROM ${pre}chart WHERE id='$id'");
	$type = exapi_dbflds($result,'charttype') ;
	$desc = exapi_dbflds($result,'accno')." -- ".exapi_dbflds($result,'description') ;

	if ($type<>"A")				$err=exapi_lang("No history for non-posting A/C") ;
	if ($err)	$err="<b>$error:  $err</b>" ;

/*------------- Write Header to Screen Display ----------------------------*/

	$t->set_var('lang_account',exapi_lang('Account'));
	$t->set_var('lang_start',exapi_lang('Start Date'));
	$t->set_var('lang_end',exapi_lang('End Date'));
	$t->set_var('lang_id',exapi_lang('Audit ID'));

	$t->set_var('desc',$desc);
	$t->set_var('id',$id) ;
	$t->set_var('start',$start);
	$t->set_var('end',$end) ;

	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$result = $adodb->query("Select * from ${pre}defaults");
		$a1cap = exapi_dbflds($result,'attrib1cap');	$a1tbl = exapi_dbflds($result,'attrib1tbl');	$a1ldf = exapi_dbflds($result,'attrib1ldesc');
		$a2cap = exapi_dbflds($result,'attrib2cap');	$a2tbl = exapi_dbflds($result,'attrib2tbl');	$a2ldf = exapi_dbflds($result,'attrib2ldesc');
		$a3cap = exapi_dbflds($result,'attrib3cap');	$a3tbl = exapi_dbflds($result,'attrib3tbl');	$a3ldf = exapi_dbflds($result,'attrib3ldesc');

		if ($attrib1<>'') {
			$result = $adodb->query("Select * from ${pre}$a1tbl where id=$attrib1");
			$ldesc = exapi_dbflds($result,"$a1ldf") ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$result = $adodb->query("Select * from ${pre}$a2tbl where id=$attrib2");
			$ldesc = exapi_dbflds($result,"$a2ldf") ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$result = $adodb->query("Select * from ${pre}$a3tbl where id=$attrib3");
			$ldesc = exapi_dbflds($result,"$a3ldf") ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}

/*------------- Write History to Screen Display ----------------------------*/

	$t->set_var('lang_date',exapi_lang('Date'));
	$t->set_var('lang_description',exapi_lang('Journal Description'));
	$t->set_var('lang_trans_id',exapi_lang('Audit ID'));
	$t->set_var('lang_dr',exapi_lang('Debit'));
	$t->set_var('lang_cr',exapi_lang('Credit'));
	$t->set_var('lang_bal',exapi_lang('Balance (dr/cr)'));
	$t->set_var('lang_viewdetail',exapi_lang('View Detail'));
	$lang_dr = exapi_lang('dr') ;

if ($err=="") {

	$sql =	"SELECT sum(amount) as amount FROM ${pre}acc_trans " ;
	$sql.=	"WHERE chart_id='$id' and transdate<'$start'" ;
	if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
	if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
	if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
	$result = $adodb->query($sql);
	$bal =	exapi_dbflds($result,'amount') ;
	$t->set_var('date',$start);
	$t->set_var('description',exapi_lang('Balance Brought Forward'));
	$t->set_var('trans_id','');
	$t->set_var('dr','');
	$t->set_var('cr','');
	$balance = $bal>= 0 ? sprintf("%01.2f",$bal) : sprintf("%01.2f",-$bal)." [$lang_dr]" ;
	$t->set_var('bal',$balance);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT a.transdate,trans_id,substring(source,1,4) as transcode,description,amount " ;
	$sql.= "FROM ${pre}acc_trans a, ${pre}gl b " ;
	$sql.= "WHERE chart_id='$id' and a.trans_id=b.id and a.transdate>='$start' and a.transdate<='$end' " ;
	if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
	if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
	if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
	$sql.= "ORDER BY a.transdate" ;
	$result = $adodb->query($sql);
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	While ($rs=$result->fetchRow()) {
		$t->set_var('date',$rs['transdate']);
		$t->set_var('description',$rs['description']);
		$trans_id = $rs['trans_id'] ;
		$transcode = $rs['transcode'] ;
		$amount = $rs['amount'] ;
		$dr = $amount>=0 ? "." : sprintf("%01.2f",-$amount) ;
		$cr = $amount>=0 ? sprintf("%01.2f",$amount) : "." ;
		$bal += $amount ;
		$t->set_var('trans_id',$trans_id);
		$t->set_var('dr',$dr);
		$t->set_var('cr',$cr);
		$balance = $bal>= 0 ? sprintf("%01.2f",$bal) : sprintf("%01.2f",-$bal)." [$lang_dr]" ;
		$t->set_var('bal',$balance);
		$jfilter = urlencode("${markpri}01=1${markpri}1id${marksec}$trans_id") ;
		$sfilter = urlencode("${markpri}1a.id${marksec}$trans_id") ;
		$t->set_var('journal',exapi_link("/$app/journalview.php","id=$trans_id&filter=$jfilter"));
		$t->set_var('lang_journal',exapi_lang("Journal"));
		switch ($transcode) :
			case "GLJL" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			case "APNT" :	$script = "/ck-ap/invoicentview.php" ;			break ;
			case "APWT" :	$script = "/ck-ap/invoicewtview.php" ;			break ;
			case "APPY" :	$script = "/ck-ap/paymentview.php" ;			break ;
			case "ARNT" :	$script = "/ck-ar/invoicentview.php" ;			break ;
			case "ARWT" :	$script = "/ck-ar/invoicewtview.php" ;			break ;
			case "ARRT" :	$script = "/ck-ar/receiptview.php" ;			break ;
			case "CSNT" :	$script = "/ck-pos-c/csntview.php" ;			break ;
			case "CSWT" :	$script = "/ck-pos-c/cswtview.php" ;			break ;
			case "CBTR" :	$script = "/ck-pos-m/cbtranview.php" ;			break ;
			case "PYRO" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			case "PYPY" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			default : 	$script = "error" ;					break ;
			endswitch ;
		$t->set_var('origin',exapi_link("$script","id=$trans_id&filter=$sfilter"));
		$t->set_var('lang_origin',exapi_lang("Origin"));
		if ($script=="error")	{
			$t->set_var('origin',"");
			$t->set_var('lang_origin',"<b>".exapi_lang("Error")."</b>");
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',$end);
	$t->set_var('description',exapi_lang('Balance Carried Forward'));
	$t->set_var('trans_id','');
	$t->set_var('dr','');
	$t->set_var('cr','');
	$balance = $bal>= 0 ? sprintf("%01.2f",$bal) : sprintf("%01.2f",-$bal)." [$lang_dr]" ;
	$t->set_var('bal',$balance);
	$t->set_var('lang_journal',"");
	$t->set_var('journal',"");
	$t->set_var('lang_origin',"");
	$t->set_var('origin',"");
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);
	}
else {
 	$t->set_var('message',$err);
	$t->set_var('detail_section',"") ;
	}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter&attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
	$t->set_var('action',exapi_link("/$app/${tran}hist.php",$getstr)) ;
	$t->set_var('lang_regenerate',exapi_lang('Regenerate (after changing start/end date)'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","filter=$filter")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report',True);
	exapi_footer() ;

?>
