<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// attriblist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'attrib' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$order = isset($_GET['order']) ? $_GET['order'] : (isset($_POST['order'])?$_POST['order']:'');
	$sort = isset($_GET['sort']) ? $_GET['sort'] : (isset($_POST['sort'])?$_POST['sort']:'');
	$attrib = isset($_GET['attrib']) ? $_GET['attrib'] : (isset($_POST['attrib'])?$_POST['attrib']:'');
	$caption = isset($_GET['caption']) ? $_GET['caption'] : (isset($_POST['caption'])?$_POST['caption']:'');
	$table = isset($_GET['table']) ? $_GET['table'] : (isset($_POST['table'])?$_POST['table']:'');
	$sdfld = isset($_GET['sdfld']) ? $_GET['sdfld'] : (isset($_POST['sdfld'])?$_POST['sdfld']:'');
	$ldfld = isset($_GET['ldfld']) ? $_GET['ldfld'] : (isset($_POST['ldfld'])?$_POST['ldfld']:'');
	$qfield = isset($_GET['qfield']) ? $_GET['qfield'] : (isset($_POST['qfield'])?$_POST['qfield']:'');
	$filter = urldecode(stripslashes($filter)) ;
	$where = decode_where($filter,$table,$attrib) ;
	$filter = urlencode($filter) ;

	$attrib = isset($attrib) ? $attrib : $qfield ;
	$qfield = $attrib ;

	$t = exapi_tpl($app);
	$proc = newobj('ck-api','process') ;
	$t->set_file(array('report'=>"${tran}list.tpl", 'detail'=>"${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$msg1 = exapi_lang("This is for illustrative purpose only.") ;
	$msg2 = exapi_lang("Other modules will provide better facility to process these data.") ;
	$t->set_var('message',"$msg1  $msg2");

//---------------------------- list variable template-declarations -------------------------

	$result = $adodb->query("Select * from ${pre}defaults");
	switch ($attrib) :
		case "1" :	$sdfld=exapi_dbflds($result,'attrib1sdesc');
				$ldfld=exapi_dbflds($result,'attrib1ldesc');
				$caption=exapi_dbflds($result,'attrib1cap'); break ;
		case "2" :	$sdfld=exapi_dbflds($result,'attrib2sdesc');
				$ldfld=exapi_dbflds($result,'attrib2ldesc');
				$caption=exapi_dbflds($result,'attrib2cap'); break ;
		case "3" :	$sdfld=exapi_dbflds($result,'attrib3sdesc');
				$ldfld=exapi_dbflds($result,'attrib3ldesc');
				$caption=exapi_dbflds($result,'attrib3cap'); break ;
		endswitch ;
	$t->set_var('lang_title',exapi_lang("List of %1",$caption));
	$t->set_var('lang_sorthead',exapi_lang('[click column heading to re-sort table]'));
	$script = "/$app/${tran}list.php" ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('sort_sdesc',$proc->sortlink($sdfld,$script,"$sdfld",$sort,$getstr));
	$t->set_var('sort_ldesc',$proc->sortlink($ldfld,$script,"$ldfld",$sort,$getstr));
	$t->set_var('sort_id',$proc->sortlink(exapi_lang('Audit ID'),$script,'id',$sort,$getstr));

	if (!$order) $order = $sdfld ;
	if (!$sort)  $sort = "ASC" ;
	$result = $adodb->query("SELECT * from $table WHERE 1=1 $where order by $order $sort");

// -------------------------------- end declaration -----------------------------------------

if (exapi_dbrc($result)==0) {
	$t->set_var(array(	'sdesc'		=> exapi_lang("No Matching Item Found"),
				'ldesc'		=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "",
				'lang_log'	=> "" ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',True);
	}
While ($rs=$result->fetchRow()) {
	$id = $rs['id'] ;
	$getstr = "id=$id&attrib=$attrib&caption=$caption&" ;
	$getstr.= "table=$table&sdfld=$sdfld&ldfld=$ldfld&filter=$filter" ;
	$loggetstr = "return=/$app/${tran}list.php&$getstr" ;
	$t->set_var(array(	'sdesc'	=> $rs["$sdfld"],
				'ldesc'	=> $rs["$ldfld"],
				'id'	=> $id,
				'view'	=> exapi_link("/$app/${tran}view.php",$getstr),
				'edit'	=> exapi_link("/$app/${tran}edit.php",$getstr),
				'copy'	=> exapi_link("/$app/${tran}copy.php",$getstr),
				'delete'=> exapi_link("/$app/${tran}delete.php",$getstr),
				'log'	=> exapi_link('/ck-admin/loglist.php',$loggetstr)  ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',exapi_lang("Add New %1",$caption));
	$t->set_var('add_action',exapi_link("/$app/${tran}add.php",$getstr));
	$t->set_var('lang_edit',exapi_lang('Edit'));
	$t->set_var('lang_view',exapi_lang('View'));
	$t->set_var('lang_copy',exapi_lang('Copy/Modify'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_log',exapi_lang('Log'));
	$t->pparse('out','detail','report');
	exapi_footer() ;



//---- Decode 'where' filter string

    function decode_where($filter,&$table,&$attrib) {
	global $ckapi,$exapi ;

	if (trim($filter)<>"") {
		$markpri = $ckapi['params']['markpri'] = "zzAnDzz" ;
		$marksec = $ckapi['params']['marksec'] = "z2z1z3z" ;	
		$where = '' ;
		$pieces = explode($markpri,$filter) ;
		foreach ($pieces as $piece) {
			$str = explode($marksec,$piece) ;
			$str1 = $str[0] ;
			$str2 = isset($str[1]) ? $str[1] : '' ;
			$type = substr($str1,0,1) ;
			$str1 = substr($str1,1) ;
			if (strlen($str1)>15 or strlen($str2)>15) {
				echo "Please inform System Admin: Possible injected SQL attack -$piece==<br>";
				exit() ;
				}
			switch ($type) :
				case "x" :	$$str1 = $str2 ;			break ;
				case "0" :	$where .= "$str1 $str2" ;		break ;
				case "1" :	$where .= " AND $str1 = '$str2' " ;	break ;
				case "2" :	$where .= " AND $str1 >= '$str2' ";	break ;
				case "3" :	$where .= " AND $str1 > '$str2' ";	break ;
				case "4" :	$where .= " AND $str1 <= '$str2' ";	break ;
				case "5" :	$where .= " AND $str1 < '$str2' ";	break ;
				case "6" :	$where .= " AND lower($str1) like lower('%$str2%') ";  break;
				case "7" :	$where .= " AND OPEN " ;		break ;
//				case "8" :						break ;
				endswitch ;
			}
		}
	return $where ;
	}

?>
