<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'controlreport' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$status_date = isset($_GET['status_date']) ? $_GET['status_date'] : (isset($_POST['status_date'])?$_POST['status_date']:'');

	$t = exapi_tpl($app);
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', exapi_lang('Ledger Audit Control Report'));
	$t->set_var('lang_journal_date', exapi_lang('Journal Date'));
	$t->set_var('lang_system_date', exapi_lang('System Date'));
	$t->set_var('lang_dr', exapi_lang('Debit'));
	$t->set_var('lang_cr', exapi_lang('Credit'));
	$t->set_var('lang_accounts', exapi_lang('Accounts'));
	$t->set_var('lang_journals', exapi_lang('Journals'));
	$t->set_var('lang_entries', exapi_lang('Dr/Cr Entries'));
	$t->set_var('lang_requested_status', exapi_lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL LEDGER STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_status_note', ' '.exapi_lang('(note the effect of postdated journals)'));
	$t->set_var('status_date', $status_date );
	$t->set_var('lang_total_amount', exapi_lang('Total Amount'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Status Date Info---------------------------------*/


$sql =	"SELECT sum(amount) as cr_amount from ${pre}acc_trans " ;
$sql.=	"WHERE transdate <= '$status_date' AND amount>0" ;
$result = $adodb->query($sql);

$cr = exapi_dbflds($result,'cr_amount') ;

$sql =	"SELECT -sum(amount) as dr_amount from ${pre}acc_trans " ;
$sql.=	"WHERE transdate <= '$status_date' AND amount<0" ;
$result = $adodb->query($sql);

$dr = exapi_dbflds($result,'dr_amount') ;

$sql =	"SELECT count(id) as journal_count from ${pre}gl WHERE transdate <= '$status_date'" ;
$result = $adodb->query($sql);

$journal_count = exapi_dbflds($result,'journal_count') ;

$sql =	"SELECT count(chart_id) as entry_count from ${pre}acc_trans WHERE transdate <= '$status_date'" ;
$result = $adodb->query($sql);

$entry_count = exapi_dbflds($result,'entry_count') ;

$sql =	"SELECT max(id) as max_id from ${pre}gl WHERE transdate <= '$status_date'" ;
$result = $adodb->query($sql);

$journal_id = exapi_dbflds($result,'max_id') ;

$sql =	"SELECT max(trans_id) as max_id from ${pre}acc_trans WHERE transdate <= '$status_date'" ;
$result = $adodb->query($sql);

$entry_id = exapi_dbflds($result,'max_id') ;

if ($journal_id>$entry_id) {$max_id=$journal_id;} else {$max_id=$entry_id;}
if ($max_id=="") {$max_id=0;}

$sql =	"SELECT max(id) as max_id from ${pre}chart WHERE id <= $max_id" ;
$result = $adodb->query($sql);

$account_id = exapi_dbflds($result,'max_id') ;

$sql =	"SELECT count(accno) as account_count from ${pre}chart WHERE id <= $max_id" ;
$result = $adodb->query($sql);

$account_count = exapi_dbflds($result,'account_count') ;

$t->set_var('dr',sprintf("%01.2f",$dr)) ;
$t->set_var('cr',sprintf("%01.2f",$cr)) ;
$t->set_var('account_count',$account_count) ;
$t->set_var('journal_count',$journal_count) ;
$t->set_var('entry_count',$entry_count) ;
$t->set_var('account_id',$account_id) ;
$t->set_var('journal_id',$journal_id) ;
$t->set_var('entry_id',$entry_id) ;

/*-----------------Gather and Write Current System Date Info-----------------------------*/

$result = $adodb->query("SELECT sum(amount) as cr_amount from ${pre}acc_trans WHERE amount>0");
$current_cr = exapi_dbflds($result,'cr_amount') ;

$result = $adodb->query("SELECT -sum(amount) as dr_amount from ${pre}acc_trans WHERE amount<0");
$current_dr = exapi_dbflds($result,'dr_amount') ;

$result = $adodb->query("SELECT count(accno) as account_count from ${pre}chart");
$current_account_count = exapi_dbflds($result,'account_count') ;

$result = $adodb->query("SELECT count(id) as journal_count from ${pre}gl");
$current_journal_count = exapi_dbflds($result,'journal_count') ;

$result = $adodb->query("SELECT count(chart_id) as entry_count from ${pre}acc_trans");
$current_entry_count = exapi_dbflds($result,'entry_count') ;

$result = $adodb->query("SELECT max(id) as max_id from ${pre}chart");
$current_account_id = exapi_dbflds($result,'max_id') ;

$result = $adodb->query("SELECT max(id) as max_id from ${pre}gl");
$current_journal_id = exapi_dbflds($result,'max_id') ;

$result = $adodb->query("SELECT max(trans_id) as max_id from ${pre}acc_trans");
$current_entry_id = exapi_dbflds($result,'max_id') ;

$t->set_var('system_date',date("Y-m-d",time())) ;
$t->set_var('current_dr',sprintf("%01.2f",$current_dr)) ;
$t->set_var('current_cr',sprintf("%01.2f",$current_cr)) ;
$t->set_var('current_account_count',$current_account_count) ;
$t->set_var('current_journal_count',$current_journal_count) ;
$t->set_var('current_entry_count',$current_entry_count) ;
$t->set_var('current_account_id',$current_account_id) ;
$t->set_var('current_journal_id',$current_journal_id) ;
$t->set_var('current_entry_id',$current_entry_id) ;


/*--------------------Write bottom Section------------------------------------------*/

    $t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
    $t->set_var('lang_done',exapi_lang('Done'));

    $t->pparse('out','report');
	exapi_footer() ;

?>
