<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.attrib.inc.php 0.16.1 2005/12/04 C K Wu

    class attrib {

//---- Attribute Read

    function attrib_read() {
	global $ckapi,$adodb ;

	$uniqueflds = isset($ckapi['params']['uniqueflds']) ? $ckapi['params']['uniqueflds'] : '' ;
	$id = $ckapi['params_post']['id'] ;
	$op = $ckapi['params_post']['op'] ;


	$attrib = isset($_GET['attrib']) ? $_GET['attrib'] : (isset($_POST['attrib'])?$_POST['attrib']:'');
	$caption = isset($_GET['caption']) ? $_GET['caption'] : (isset($_POST['caption'])?$_POST['caption']:'');
	$table = isset($_GET['table']) ? $_GET['table'] : (isset($_POST['table'])?$_POST['table']:'');
	$sdfld = isset($_GET['sdfld']) ? $_GET['sdfld'] : (isset($_POST['sdfld'])?$_POST['sdfld']:'');
	$ldfld = isset($_GET['ldfld']) ? $_GET['ldfld'] : (isset($_POST['ldfld'])?$_POST['ldfld']:'');

	$result = $adodb->query("SELECT * from $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$dt['attrib'] = $attrib ;
	$dt['caption'] = $caption ;
	$dt['table'] = $table ;
	$dt['sdfld'] = $sdfld ;
	$dt['ldfld'] = $ldfld ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Attribute Add Initialisation

    function attrib_add_init() {
	global $ckapi ;

	$attrib = isset($_GET['attrib']) ? $_GET['attrib'] : (isset($_POST['attrib'])?$_POST['attrib']:'');
	$caption = isset($_GET['caption']) ? $_GET['caption'] : (isset($_POST['caption'])?$_POST['caption']:'');
	$table = isset($_GET['table']) ? $_GET['table'] : (isset($_POST['table'])?$_POST['table']:'');
	$sdfld = isset($_GET['sdfld']) ? $_GET['sdfld'] : (isset($_POST['sdfld'])?$_POST['sdfld']:'');
	$ldfld = isset($_GET['ldfld']) ? $_GET['ldfld'] : (isset($_POST['ldfld'])?$_POST['ldfld']:'');

	$dt = &$ckapi['params_post']['dt'] ;
	$dt = array(	'attrib'	=> $attrib,
			'caption'	=> $caption,
			'table'		=> $table ,
			'sdfld'		=> $sdfld ,
			'ldfld'		=> $ldfld		) ;

	$fields = array('attrib','caption','table','id','control',$sdfld,$ldfld,"old$sdfld") ;
	foreach ($fields as $field)	$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;
	}

//---- Attribute Detail Validation Checks

    function attrib_validate() {
	global $ckapi,$adodb ;

	$sdfld = isset($_GET['sdfld']) ? $_GET['sdfld'] : (isset($_POST['sdfld'])?$_POST['sdfld']:'');
	$ldfld = isset($_GET['ldfld']) ? $_GET['ldfld'] : (isset($_POST['ldfld'])?$_POST['ldfld']:'');
	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;

	$err="";  $error = exapi_lang("Error") ;
	$missing = exapi_lang("Missing") ;
	$alreadyexists = exapi_lang("already exists") ;
	if ($dt["$sdfld"]=="")		$err="$sdfld $missing";
	if ($dt["$ldfld"]=="")		$err="$ldfld $missing";
	$dt["old$sdfld"] = isset($dt["old$sdfld"]) ? $dt["old$sdfld"] : '' ;
	if ($dt[$sdfld]<>$dt["old$sdfld"]) {
		$result = $adodb->query("SELECT * FROM $table WHERE $sdfld='$dt[$sdfld]'");
		if (exapi_dbrc($result)>0)	$err="$sdfld $alreadyexists" ;
		}

	if ($err)			$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$caption = isset($_GET['caption']) ? $_GET['caption'] : (isset($_POST['caption'])?$_POST['caption']:'');
	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This %1 is in use within an existing",$caption) ;
	$journal = exapi_lang('journal');
	$id = $dt['id'] ;
	$result = $adodb->query("SELECT * from ${pre}acc_trans WHERE attrib1='$id' or attrib2='$id' or attrib3='$id'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $journal id#".exapi_dbflds($result,'trans_id') ;

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Attribute Detail

    function attrib_write() {
	global $ckapi ;

	$sdfld = isset($_GET['sdfld']) ? $_GET['sdfld'] : (isset($_POST['sdfld'])?$_POST['sdfld']:'');
	$ldfld = isset($_GET['ldfld']) ? $_GET['ldfld'] : (isset($_POST['ldfld'])?$_POST['ldfld']:'');
	$uniqueflds = isset($ckapi['params']['uniqueflds']) ? $ckapi['params']['uniqueflds'] : '' ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_sdfld',$sdfld);
	$t->set_var('lang_ldfld',$ldfld);

	if (is_array($uniqueflds))
	  	foreach ($uniqueflds as $key => $val) {
			$t->set_var('oldsdfld',"old$val");
			$t->set_var('oldsdesc',$dt["old$val"]);
			}

	$t->set_var('attrib',$dt['attrib']);
	$t->set_var('caption',$dt['caption']);
	$t->set_var('table',$dt['table']);
	$t->set_var('sdfld',$sdfld);
	$t->set_var('ldfld',$ldfld);
	$t->set_var('id',$dt['id']);
	$t->set_var('control',$dt['control']);
	$t->set_var('sdesc',$dt[$sdfld]);
	$t->set_var('ldesc',$dt[$ldfld]);
	$t->parse('out','report',True);
	}

    }

?>
