<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// bulkpayrollfilter_validate.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-payroll' ;
	$tran = 'bulkpayroll' ;
	$noheader = True ;  $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;


	$err = isset($_GET['err']) ? $_GET['err'] : (isset($_POST['err'])?$_POST['err']:'');
	$actnum = isset($_GET['actnum']) ? $_GET['actnum'] : (isset($_POST['actnum'])?$_POST['actnum']:'');
	$period = isset($_GET['period']) ? $_GET['period'] : (isset($_POST['period'])?$_POST['period']:'');
	$datefrom = isset($_GET['datefrom']) ? $_GET['datefrom'] : (isset($_POST['datefrom'])?$_POST['datefrom']:'');
	$dateto = isset($_GET['dateto']) ? $_GET['dateto'] : (isset($_POST['dateto'])?$_POST['dateto']:'');
	$empid = isset($_GET['empid']) ? $_GET['empid'] : (isset($_POST['empid'])?$_POST['empid']:'');
	$dummy = isset($_GET['dummy']) ? $_GET['dummy'] : (isset($_POST['dummy'])?$_POST['dummy']:'');

/* --------------------- Validation Check Start ----------------------------	*/

	$error = exapi_lang("Error") ;
	$lang_payperiod = exapi_lang('Payroll for period') ;
	$lang_from = exapi_lang('*from*') ;
	$lang_to = exapi_lang('*to*') ;
	$lang_scheque = exapi_lang('SalaryCheque') ;
	$lang_empid = exapi_lang('empid') ;
	$lang_period = exapi_lang('period') ;

	if ($err)	$err=exapi_lang("Error flagged before validation") ;
	if ($period<>'' and ($actnum==1 or $actnum==2)) {
		$result = $adodb->query("SELECT * FROM ${pre}payroll WHERE period='$period'");
		if (exapi_dbrc($result)==0)	$err=exapi_lang("No staff (with the selected pay period) found");
		}
	if ($datefrom<>"") {
		$date=input2date($datefrom) ;
		if ($date=="")	$err=exapi_lang("Invalid Period From Date");
			else	$datefrom = $date ;
		}
	if ($dateto<>"") {
		$date=input2date($dateto) ;
		if ($date=="")	$err=exapi_lang("Invalid Period To Date");
			else	$dateto = $date ;
		}
	if ($datefrom<>"" and $dateto<>"" and strtotime($datefrom)>strtotime($dateto))
				$err=exapi_lang("Period From later than Period To");
	if ($actnum==1 or $actnum==2) {

//		$lang_from = exapi_lang('*from*') ;
//		$lang_to = exapi_lang('*to*') ;
		$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
		$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
		$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
		$topos = "position('$tomarker' in description)+$tomarkerlen" ;
		$descdatefrom = "substring(description,$frompos,10)" ;
		$descdateto = "substring(description,$topos,10)" ;

		$sql =	"SELECT * FROM ${pre}gl " ;
		$sql.=	"WHERE source='PYRO' and " ;
		$sql.=	"(($descdatefrom>='$datefrom' and $descdatefrom<='$dateto') " ;
		$sql.=	"or ($descdateto>='$datefrom' and $descdateto<='$dateto'))" ;
		$result = $adodb->query($sql);
		if (exapi_dbrc($result)>0)	$err=exapi_lang("Period From/To overlaps with previous payroll periods") ;
		if ($datefrom=="")		$err=exapi_lang("Payroll Generation From Date must not be blank") ;
		if ($dateto=="")		$err=exapi_lang("Payroll Generation To Date must not be blank") ;
		}
	if ($actnum==2 and !$err)	{
		$user = $ckapi['hostsys']['username'];
		$where = "WHERE resource='bulkpayrollgen'" ;
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock $where");
		$used_by = exapi_dbflds($result,'used_by') ;
		if ($used_by=="")
				$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' $where");
			else	$err = exapi_lang("Bulk Payroll Generation is being accessed by")." $used_by";
		}

	if ($err)		$err = "<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

if (!$err)
	{
	switch ($actnum) {
		case 1:
			$getstr = "period=$period&datefrom=$datefrom&dateto=$dateto" ;
			Header('Location: '.exapi_link("/$app/${tran}test.php",$getstr));
			exit();
		case 2:
			$getstr = "period=$period&datefrom=$datefrom&dateto=$dateto" ;
			Header('Location: '.exapi_link("/$app/${tran}gen.php",$getstr));
			exit();
		case 3:
			$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
			$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
			$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
			$topos = "position('$tomarker' in description)+$tomarkerlen" ;
			$descdatefrom = "substring(description,$frompos,10)" ;
			$descdateto = "substring(description,$topos,10)" ;
			$filter = '' ;
			if ($datefrom)
				$filter .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
			if ($dateto)
				$filter .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";
			$filter = urlencode($filter) ;
			Header('Location: '.exapi_link("/$app/${tran}list.php","filter=$filter"));
			exit();
		default:
			echo exapi_lang("Should not be here.  Weird Action Number") ;
		}
	}
else
	{
	$getstr = "actnum=$actnum&period=$period&datefrom=$datefrom&dateto=$dateto&empid=$empid&dummy=$dummy&err=$err" ;
	Header('Location: '.exapi_link("/ck-payroll/bulkpayrollfilter.php",$getstr));
	exit();
	}

?>
