<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.payjournal.inc.php 0.16.1 2005/12/04 C K Wu

    class payjournal {

//---- PayJournal List SQL Formation

    function payjournal_list_sql() {
	global $ckapi ;
	
	$pre = $ckapi['params']['pre'] ;
	$sortkey = $ckapi['params']['sortkey'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$lang_from = strtolower(exapi_lang('*from*')) ;
	$lang_to = strtolower(exapi_lang('*to*')) ;
	$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
	$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
	$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
	$topos = "position('$tomarker' in description)+$tomarkerlen" ;
	$descdatefrom = "substring(description,$frompos,10)" ;
	$descdateto = "substring(description,$topos,10)" ;

	if (substr_count($where,"b.empid")>0) {
		list($dummy,$empidstr) = explode("b.empid",$where) ;
		list($dummy,$empid) = explode("'",$empidstr) ;
		}
	if (substr_count($where,"datefrom")>0) {
		list($dummy,$datestr) = explode("datefrom",$where) ;
		list($dummy,$datefrom) = explode("'",$datestr) ;
		}
	if (substr_count($where,"dateto")>0) {
		list($dummy,$datestr) = explode("dateto",$where) ;
		list($dummy,$dateto) = explode("'",$datestr) ;
		}
	$where = "" ;
	if (isset($empid) and $empid<>'')	$where .= " AND b.empid='$empid' ";
	if (isset($datefrom) and $datefrom<>'')	$where .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
	if (isset($dateto) and $dateto<>'')	$where .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";

	if (!$order)	{if ($sortkey<>"")	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;
	$sql =	"SELECT b.empid,name,bankacname,bankac," ;
	$sql.=	"$descdatefrom as datefrom,$descdateto as dateto,amount,a.id as bpyroid,codeid as id " ;
	$sql.=	"FROM ${pre}gl a, ${pre}pyrohist b, ${pre}employee c, ${pre}payroll d " ;
	$sql.=	"WHERE 1=1 $where and source='PYRO' and trans_id=a.id and type='NETP' " ;
	$sql.=	"and b.empid=c.id and b.empid=d.empid " ;
	$sql.=	"order by $order $sort" ;
	return $sql ;
	}

//---- PayJournal List Link Adjustement

    function payjournal_list_adjust() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)		$$key = $value ;
	foreach ($ckapi['params_list']['dt'] as $key => $value)	$$key = $value ;
	$filter = $ckapi['params_list']['filter'] ;
	$t = &$ckapi['objects']['template'] ;
	if ($id==0) {
		$ckapi['params_list']['dt']['id']=='' ;
		$getstr = "empid=$empid&bpyroid=$bpyroid&datefrom=$datefrom&dateto=$dateto&filter=$filter" ;
		$t->set_var(array(	'id'		=> '' ,
					'lang_view'	=> '' ,
					'lang_delete'	=> '' ,
					'lang_log'	=> '' ,
					'view'		=> '' ,
					'genpj'		=> exapi_link("/$app/${tran}gen.php",$getstr) ,
					'delete'	=> '' ,
					'loge'		=> ''	)) ;
		}
	  else	$t->set_var(array(	'lang_genpj'=>'', 'genpj'=>''	)) ;
	$url = $ckapi['links']['cheque'] ;
	$empid = $ckapi['params_list']['dt']['empid'] ;
	$amount = $ckapi['params_list']['dt']['amount'] ;
	$getstr = "empid=$empid&amount=$amount&filter=$filter" ;
	$t->set_var('cheque',exapi_link($url,$getstr)) ;
	$ckapi['params']['total'] = isset($ckapi['params']['total']) ? $ckapi['params']['total'] : 0 ;
	$ckapi['params']['total'] += $amount ;
	$t->set_var('total',$ckapi['params']['total']) ;
	}

//---- PayJournal Read

    function payjournal_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$id = $ckapi['params_post']['id'] ;
	$op = $ckapi['params_post']['op'] ;

	$result = $adodb->query("SELECT * FROM ${pre}gl WHERE id='$id'");
	$dt = $result->fetchRow() ;
	list($dummy,$partdesc) = explode("-",$dt['description']) ;
	list($dt['refno'],$partdesc) = explode(" ",$partdesc) ;

	$sql = "SELECT chart_id,attrib1,attrib2,attrib3,amount " ;
	$sql.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
	$sql.= "WHERE trans_id='$id'and a.chart_id=b.id ORDER BY a.id" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['accno'.$i]		=	$rs['chart_id'] ;
		$dt['attrib1'.$i]	=	$rs['attrib1'] ;
		$dt['attrib2'.$i]	=	$rs['attrib2'] ;
		$dt['attrib3'.$i]	=	$rs['attrib3'] ;
		$cr			=	sprintf("%01.2f",$rs['amount']);
		$dr			=	sprintf("%01.2f",-$cr) ;
		if ($cr>0)	$dr='';		else $cr='';
		$dt['dr'.$i]		=	$dr ;
		$dt['cr'.$i]		=	$cr ;
		}
	return $dt ;
	}

//---- PayJournal Add Initialisation

    function payjournal_add_init() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	foreach ($ckapi['gen'] as $key => $value)		$dt[$key] = $$key = $value ;

	$dt['source'] = "PYPY" ;
	$sql = "SELECT * FROM ${pre}pyrohist " ;
	$sql.= "WHERE trans_id='$bpyroid' and empid='$empid' and type='NETP'" ;
	$result = $adodb->query($sql) ;
	$dt['transdate']= date("Y-m-d") ;
	$dt['accno1']	= exapi_dbflds($result,'chart_id') ;
	$dt['dr1']	= exapi_dbflds($result,'amount') ;
	$dt['cr1']	= '' ;
	$dt['accno2']	= '' ;
	$dt['dr2']	= '' ;
	$dt['cr2']	= exapi_dbflds($result,'amount') ;
	}

//---- PayJournal Validation Checks

    function payjournal_validate() {
	global $ckapi,$adodb ;

	$pre = &$ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang("Error") ;
	$date=input2date( $dt['transdate'] ) ;
	if ($date=="")				$err=exapi_lang("Invalid Salary Payment Journal Date");
	if ($dt["refno"]=="")			$err=exapi_lang("Cheque/Reference number Missing");
	if ($err=="") {
		$user = $ckapi['hostsys']['username'];
		$where = "WHERE resource='payjournalgen'" ;
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock $where");
		$used_by = exapi_dbflds($result,'used_by') ;
		if ($used_by=="")	$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' $where");
			else	$err=exapi_lang("Salary Payment Journal Generation is being accessed by")." $used_by";
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write PayJournal Header

    function payjournal_header_write() {
	global $ckapi ;

//	$uniwhere = $ckapi['params']['uniwhere'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$op = &$ckapi['params_post']['op'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_date',exapi_lang('Date :'));
	$t->set_var('lang_refno',exapi_lang('Cheque/Ref# :'));
	$t->set_var('lang_source',exapi_lang('Source :'));
	$t->set_var('lang_description',exapi_lang('Description :'));
	$t->set_var('lang_id',exapi_lang('Audit ID').' :');
	$t->set_var('transdate',$dt['transdate']) ;
	$t->set_var('source',$dt['source']) ;

	$fields = array('id','control','description','refno','empid','bpyroid','datefrom','dateto') ;
	foreach ($fields as $field)	$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;
	$empid = isset($empid) ? $empid : '' ;

	if ($op=="new") {
		$lang_refno = exapi_lang('SalaryCheque/Ref#') ;
		$lang_empid = exapi_lang('empid') ;
		$lang_period = exapi_lang('period') ;
		$lang_from = strtolower(exapi_lang('*from*')) ;
		$lang_to = strtolower(exapi_lang('*to*')) ;
		$refno = $dt['refno'] ;
		$empid = $dt['empid'] ;
		$datefrom = $dt['datefrom'] ;
		$dateto = $dt['dateto'] ;
		$dt['description'] = "$lang_refno-$refno $lang_empid-$empid " ;
		$dt['description'].= "$lang_period $lang_from/$datefrom $lang_to/$dateto" ;
		}
	$t->set_var('description',$dt['description']) ;
	$t->set_var('id',$dt['id']) ;
	$t->set_var('control',$dt['control']) ;
	$t->set_var('refno',$dt['refno']) ;
	$t->set_var('empid',$dt['empid']) ;
	$t->set_var('bpyroid',$dt['bpyroid']) ;
	$t->set_var('datefrom',$dt['datefrom']) ;
	$t->set_var('dateto',$dt['dateto']) ;

	$t->set_var('lang_replicate',exapi_lang('Replicate Attribute Values from Caption :'));
	$t->set_var('lang_nonbs',exapi_lang('Done'));
	$t->set_var('lang_all',exapi_lang('Done'));
	$t->set_var('lang_newrow',exapi_lang('Done'));
	$t->parse('out','report',True);
	}

//---- Write PayJournal Detail

    function payjournal_detail_write() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$posted = ($ckapi['params_post']['op']=="view" or $ckapi['params_post']['op']=="delete") ;
	$row_ = exapi_lang("Row")." " ;

	$fields = array('a1cap','a2cap','a3cap','at1cap','at2cap','at3cap','a1slist','a2slist','a3slist') ;
	foreach ($fields as $field)		$$field = isset($$field) ? $$field : '' ;

	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_insert',exapi_lang('Insert<br>before'));
	$t->set_var('lang_accno',exapi_lang('Account Number'));
	$t->set_var('lang_attrib1',exapi_lang("Attribute").":<br>$a1cap");
	$t->set_var('lang_attrib2',exapi_lang("Attribute"),":<br>$a2cap");
	$t->set_var('lang_attrib3',exapi_lang("Attribute").":<br>$a3cap");
	$t->set_var('attrib1cap_selectlist',str_replace("'$at1cap'","'$at1cap'"." selected",$a1slist)) ;
	$t->set_var('attrib2cap_selectlist',str_replace("'$at2cap'","'$at2cap'"." selected",$a2slist)) ;
	$t->set_var('attrib3cap_selectlist',str_replace("'$at3cap'","'$at3cap'"." selected",$a3slist)) ;
	$t->set_var('lang_dr',exapi_lang('Debit'));
	$t->set_var('lang_cr',exapi_lang('Credit'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$total_dr = 0;
	$total_cr = 0;
	$acc_list = selectlist('chart','accno',"WHERE charttype='A'",'','id','accno','description') ;
	$insrowno = (isset($insert) and $insert<>'') ? intval(str_replace($row_,"",$insert)) : '' ;
	$delrowno = (isset($delete) and $delete<>'') ? intval(str_replace($rtrow_,"",$delete)) : '' ;
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('accno_fld','accno'.$i) ;
			$t->set_var('attrib1_fld','attrib1'.$i) ;
			$t->set_var('attrib2_fld','attrib2'.$i) ;
			$t->set_var('attrib3_fld','attrib3'.$i) ;
			$t->set_var('dr_fld','dr'.$i);
			$t->set_var('cr_fld','cr'.$i);
			$t->set_var('account_selectlist',$acc_list);
			$t->set_var('attrib1_selectlist',$a1slist) ;
			$t->set_var('attrib2_selectlist',$a2slist) ;
			$t->set_var('attrib3_selectlist',$a3slist) ;
			$t->set_var('dr',"") ;
			$t->set_var('cr',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $insert<>'' and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $delete<>'' and $i>$delrowno)	$j=$i-1;
		$chart_id	=	$dt['accno'.$i] ;
		$attrib1	=	isset($dt['attrib1'.$i]) ? $dt['attrib1'.$i] : '' ;
		$attrib2	=	isset($dt['attrib2'.$i]) ? $dt['attrib2'.$i] : '' ;
		$attrib3	=	isset($dt['attrib3'.$i]) ? $dt['attrib3'.$i] : '' ;
		$dr		=	$dt['dr'.$i];
		$cr		=	$dt['cr'.$i];
		$total_dr	+=	$dr ;
		$total_cr	+=	$cr ;
		$accno_fld	=	'accno'.$j ;
		$attrib1_fld	=	'attrib1'.$j ;
		$attrib2_fld	=	'attrib2'.$j ;
		$attrib3_fld	=	'attrib3'.$j ;
		$dr_fld		=	'dr'.$j ;
		$cr_fld		=	'cr'.$j ;
		$t->set_var('accno_fld',$accno_fld) ;
		$t->set_var('attrib1_fld',$attrib1_fld) ;
		$t->set_var('attrib2_fld',$attrib2_fld) ;
		$t->set_var('attrib3_fld',$attrib3_fld) ;
		$t->set_var('dr_fld',$dr_fld);
		$t->set_var('cr_fld',$cr_fld);
		$t->set_var('account_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$acc_list)) ;
		$t->set_var('attrib1_selectlist',str_replace("'$attrib1'","'$attrib1'"." selected",$a1slist)) ;
		$t->set_var('attrib2_selectlist',str_replace("'$attrib2'","'$attrib2'"." selected",$a2slist)) ;
		$t->set_var('attrib3_selectlist',str_replace("'$attrib3'","'$attrib3'"." selected",$a3slist)) ;
		$t->set_var('dr',$dr) ;
		$t->set_var('cr',$cr) ;
		if ($posted)	$t->set_var('insrowno',exapi_lang("Done"));	else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',exapi_lang("Done"));	else $t->set_var('delrowno',$row_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('accno_fld','accno'.$i) ;
		$t->set_var('attrib1_fld','attrib1'.$i) ;
		$t->set_var('attrib2_fld','attrib2'.$i) ;
		$t->set_var('attrib3_fld','attrib3'.$i) ;
		$t->set_var('dr_fld','dr'.$i);
		$t->set_var('cr_fld','cr'.$i);
		$t->set_var('account_selectlist',$acc_list);
		$t->set_var('attrib1_selectlist',$a1slist) ;
		$t->set_var('attrib2_selectlist',$a2slist) ;
		$t->set_var('attrib3_selectlist',$a3slist) ;
		$t->set_var('dr',"") ;
		$t->set_var('cr',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',exapi_lang('Total'));
	$t->set_var('total_dr',sprintf("%01.2f",$total_dr)) ;
	$t->set_var('total_cr',sprintf("%01.2f",$total_cr)) ;

	$t->parse('out','report',True);
	}

//---- PayJournal Post - PreCommit Routine

    function payjournal_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;

	if ($op=='delete') {
		$adodb->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		$adodb->query("UPDATE ${pre}pyrohist SET codeid=0 WHERE codeid='$id'");
		}
	if ($op=='new') {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$chart_id	= 	$dt['accno'.$i];
			$attrib1	=	isset($dt['attrib1'.$i]) ? $dt['attrib1'.$i] : '' ;
			$attrib2	=	isset($dt['attrib2'.$i]) ? $dt['attrib2'.$i] : '' ;
			$attrib3	=	isset($dt['attrib3'.$i]) ? $dt['attrib3'.$i] : '' ;
			$dr		=	$dt['dr'.$i] ;
			$cr		=	$dt['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,attrib1,attrib2,attrib3,amount,transdate)" ;
			$sql.= "VALUES ('$id','$chart_id','$attrib1','$attrib2','$attrib3','$amount','$dt[transdate]')" ;
			$adodb->query($sql);
			}
		$adodb->query("UPDATE ${pre}pyrohist SET codeid='$id' WHERE trans_id='$dt[bpyroid]' and empid='$dt[empid]' and type='NETP'");
		}
	}

//---- PayJournal Post - PostCommit Routine

    function payjournal_post_postcommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='payjournalgen'");
	}

    }

?>