<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.pyrcode.inc.php 0.16.1 2005/12/04 C K Wu

    class pyrcode {

//---- Allowance/Deduction Code Read

    function pyrcode_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	$result = $adodb->query("SELECT * from $table WHERE id='$id'");
	if (!is_array($uniqueflds) or $op<>'edit')    return $result->fetchRow();
	  else  {
		$dt = $result->fetchRow() ;
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
		return $dt ;
		}
	}

//---- Allowance/Deduction Code Detail Validation Checks

    function pyrcode_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	if ($dt['name']=="")		$err=exapi_lang('Allowance/Deduction Code Name Missing');
	if ($dt['name']=="basesalary")	$err=exapi_lang('Basic Salary should not be deleted') ;
	if (strlen($dt['name'])>10)	$err=exapi_lang('Allowance/Deduction Code Name too long (must be <=10)');
	if ($dt['description']=="")	$err=exapi_lang('Allowance/Deduction Code Description Missing');
	if (strlen($dt['description'])>50)
		$err=exapi_lang('Allowance/Deduction Code Description too long (must be <=50)');

	$basis = $dt['basis'] ;
	if (substr_count($basis,'qty')>0) {
		if (!is_numeric($dt['minqty']))	$err=exapi_lang('Min Quantity must be numeric');
		if (!is_numeric($dt['maxqty']))	$err=exapi_lang('Max Quantity must be numeric');
		if ($dt['minqty']>$dt['maxqty'])$err=exapi_lang('Min Quantity must not > Max Quantity') ;
		}
	if (substr_count($basis,'amt')>0) {
		if (!is_numeric($dt['minamt']))	$err=exapi_lang('Min Amount must be numeric');
		if (!is_numeric($dt['maxamt']))	$err=exapi_lang('Max Amount must be numeric');
		if ($dt['minamt']>$dt['maxamt'])$err=exapi_lang('Min Amount must not > Max Amount') ;
		}
	if (substr_count($basis,'pc')>0)
		if (!is_numeric($dt['unitamt']))$err=exapi_lang('Unit Amount must be numeric');
	if (!is_numeric($dt['rate']))	$err=exapi_lang('Pay Rate must be numeric');
	if ($dt['rate']==0)		$err=exapi_lang('Pay Rate cannot be zero');
	if ($dt['rate']=='')		$err=exapi_lang('Pay Rate Missing');
	if ($dt['name']<>$dt['oldname']) {
		$result = $adodb->query("SELECT * FROM ${pre}pyrcode where name='$dt[name]'");
		if (exapi_dbrc($result)>0)	$err=exapi_lang("Allowance/Deduction Code already exists") ;
		}
	if ($err)			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Allowance/Deduction Code Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	$id = $dt['id'] ;
	$errmsg1 = exapi_lang("This allowance/deduction code is in use within an existing") ;
	$recurpayroll = exapi_lang("recurring allowance/deduction record of employee") ;
	$sql = "SELECT empid FROM ${pre}pyrc_trans a,${pre}payroll b " ;
	$sql.= "WHERE pyrcodeid='$id' and a.pyroid=b.id" ;
	$result = $adodb->query($sql);
	if (exapi_dbrc($result)>0)		$err = "$errmsg1 $recurpayroll id#".exapi_dbflds($result,'empid') ;

	$pynr_tran = exapi_lang("non-recurring payroll item record") ;
	$result = $adodb->query("SELECT * FROM ${pre}pynr_trans WHERE pyrcodeid='$id'");
	if (exapi_dbrc($result)>0)		$err = "$errmsg1 $pynr_tran id#".exapi_dbflds($result,'id') ;

	$allow = $dt['allowdelete'] ;
	if ($allow<>"y" and $allow<>"Y")  $err=exapi_lang("Allowance/Deduction code flagged deletion not allowed");

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Allowance/Deduction Code Detail

    function pyrcode_write() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$noyes_sl = "<OPTION value='n'>".exapi_lang('No')."</OPTION><OPTION value='y'>".exapi_lang('Yes')."</OPTION>" ;
	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_name',exapi_lang('Code Name (10 char max)'));
	$t->set_var('lang_description',exapi_lang('Description (50 char max)'));
	$t->set_var('lang_basis',exapi_lang('Basis of Calculation'));
	$t->set_var('lang_minqty',exapi_lang('Minimum Quantity'));
	$t->set_var('lang_maxqty',exapi_lang('Maximum Quantity'));
	$t->set_var('lang_minamt',exapi_lang('Minimum Amount'));
	$t->set_var('lang_maxamt',exapi_lang('Maximum Amount'));
	$t->set_var('lang_unitamt',exapi_lang('Unit Amount'));
	$t->set_var('lang_unit',exapi_lang('Unit Measure'));
	$t->set_var('lang_rate',exapi_lang('Pay Rate (should normally be one)'));
	$t->set_var('lang_chart_id',exapi_lang('Payroll Expense Account'));
	$t->set_var('lang_single',exapi_lang('One item per Payroll'));
	$t->set_var('lang_allowssc',exapi_lang('Allow Staff Self Claim'));
	$t->set_var('lang_adelete',exapi_lang('Allow Delete'));

	$fields = array('id','control','basis','name','oldname','description','minqty','maxqty','minamt','maxamt','unitamt','unit','rate','chart_id','allowdelete','single','allowssc') ;
	foreach ($fields as $field)	$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;

	$id = $dt['id'] ;
	$basis = $dt['basis'] ;
	$t->set_var('id',$id);
	$t->set_var('control',$dt['control']);
	$t->set_var('name',$dt['name']);
	$t->set_var('oldname',$dt['oldname']);
	$t->set_var('description',$dt['description']);
	$t->set_var('basis_selectlist',selectlist('pyrcode','basis','',$basis,'distinct basis','basis'));
	$t->set_var('minqty',$dt['minqty']);
	$t->set_var('maxqty',$dt['maxqty']);
	if (substr_count($basis,'qty')>0)	$t->set_var('qty_readonly','');
			else			$t->set_var('qty_readonly','readonly') ;
	$t->set_var('minamt',$dt['minamt']);
	$t->set_var('maxamt',$dt['maxamt']);
	if (substr_count($basis,'amt')>0)	$t->set_var('amt_readonly','');
		else				$t->set_var('amt_readonly','readonly') ;
	$t->set_var('unitamt',$dt['unitamt']);
	if (substr_count($basis,'pc')>0)	$t->set_var('unitamt_readonly','');
		else				$t->set_var('unitamt_readonly','readonly') ;
	$t->set_var('unit',$dt['unit']);
	$t->set_var('rate',$dt['rate']);
	$pyexac_sl = selectlist('chart','accno',"WHERE link like '%PY_expense%'",$dt['chart_id'],'id','accno','description') ;
	$t->set_var('pyexac_selectlist',$pyexac_sl);
	$ad_sl = str_replace("'$dt[allowdelete]'","'$dt[allowdelete]' selected",$noyes_sl) ;
	$t->set_var('adelete_selectlist',$ad_sl);
	$single_sl = str_replace("'$dt[single]'","'$dt[single]' selected",$noyes_sl) ;
	$t->set_var('single_selectlist',$single_sl);
	$allowssc_sl = str_replace("'$dt[allowssc]'","'$dt[allowssc]' selected",$noyes_sl) ;
	$t->set_var('allowssc_selectlist',$allowssc_sl);

	$t->parse('out','report',True);
	}

    }

?>