<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// nrtranslist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-payroll' ;
	$tran = 'nrtrans' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'nrtrans',
				'tran'		=> $tran ,
				'table'		=> "${pre}pynr_trans" ,
				'sortkey'	=> "empname,pyrname"			);
	$msg1 = exapi_lang('Payroll staff is allowed to create/update payroll items independently.') ;
	$msg2 = exapi_lang('Affected staff and his/her supervisor will be advised by email of such update action.');
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Non-recurring Payroll Items") ,
				'lang_add'	=> exapi_lang("Add New Non-recurring Payroll Item") ,
				'message'	=> "$msg1   $msg2"		);
	$ckapi['columns'] = array('empname'	=> exapi_lang('Employee Name/#') ,
				'pyrname'	=> exapi_lang('E/A Name') ,
				'description'	=> exapi_lang('Expense/Allowance Description') ,
				'qty'		=> exapi_lang('Quantity') ,
				'unit'		=> exapi_lang('Unit') ,
				'rate'		=> exapi_lang('Pay Rate') ,
				'comment'	=> exapi_lang('Comment') ,
				'approved_by'	=> exapi_lang('Approved By') ,
				'id'		=> exapi_lang('Audit ID') 		);
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi['lang_links'] = array('lang_view'=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")			) ;
	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;
	exapi_footer() ;

?>
