<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-po' ;
	$tran = 'controlreport' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$repdate = isset($_GET['repdate']) ? $_GET['repdate'] : (isset($_POST['repdate'])?$_POST['repdate']:'');

	$t = exapi_tpl($app);
	$t->set_file('report',"${tran}.tpl");
	$t->set_block('report','block1','block1_section');
	$t->set_block('report','block2','block2_section');

/*---------------------------------------------------------------------------------*/

	$note1 = exapi_lang('Note 1') ;
	$t->set_var('lang_control_report', exapi_lang('Purchase Order Audit Control Report'));
	$t->set_var('lang_detail', exapi_lang('Detail'));
	$t->set_var('lang_note', exapi_lang('Note'));
	$t->set_var('lang_date', exapi_lang('Date'));
	$t->set_var('lang_vendor', exapi_lang('Vendor'));
	$t->set_var('lang_tax', exapi_lang('Tax Type'));
	$t->set_var('lang_po', exapi_lang('Purchase Order'));
	$t->set_var('lang_oitem', exapi_lang('Order Item'));
	$t->set_var('lang_requested_status', exapi_lang('REQUESTED STATUS'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL SYSTEM STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_print_date', exapi_lang('Date Report Printed'));
	$t->set_var('lang_status_note', ' '.exapi_lang('(note the effect of postdated POs)'));
	$t->set_var('lang_note1',$note1);
	$t->set_var('lang_total_amount', exapi_lang('Total Amount'));
	$t->set_var('lang_total_netamount', exapi_lang('Total Amount (Net of Tax)'));
	$t->set_var('lang_total_tax', exapi_lang('Total Tax'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));
	$note1a = exapi_lang('These lines are for control reconciliation purpose only') ;
	$note1b = exapi_lang('The figures represent an amalgamation of different currency amounts') ;
	$t->set_var('note1',"$note1 :-<br>$note1a.<br>$note1b.");

/*-----------------Gather and Write Status Date Info---------------------------------*/


$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}po " ;
$sql.=	"WHERE transdate <= '$repdate' GROUP BY isocode ORDER BY isocode" ;
$result = $adodb->query($sql);
if (exapi_dbrc($result)==0)	$t->set_var('block1_section',"");

While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block1_section','block1',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount " ;
$sql.=	"FROM ${pre}po WHERE transdate <= '$repdate'" ;
$result = $adodb->query($sql);
$po_amount = exapi_dbflds($result,'amount') ;
$po_netamount = exapi_dbflds($result,'netamount') ;

$sql =	"SELECT sum(qty*cost-discount-tax1-tax2) as oitem_amount " ;
$sql.=	"FROM ${pre}oitem a, ${pre}po b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='t'" ;
$result = $adodb->query($sql);
$oitem_netamount = exapi_dbflds($result,'oitem_amount') ;
$sql =	"SELECT sum(qty*cost-discount) as oitem_amount " ;
$sql.=	"FROM ${pre}oitem a, ${pre}po b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id and b.taxincluded='f'" ;
$result = $adodb->query($sql);
$oitem_netamount += exapi_dbflds($result,'oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 " ;
$sql.=	"FROM ${pre}oitem a, ${pre}po b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_tax = exapi_dbflds($result,'tax1')+exapi_dbflds($result,'tax2') ;

$sql =	"SELECT count(id) as count from ${pre}po WHERE transdate <= '$repdate'" ;
$result = $adodb->query($sql);
$po_count = exapi_dbflds($result,'count') ;

$sql =	"SELECT count(a.id) as count from ${pre}oitem a,${pre}po b " .
	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_count = exapi_dbflds($result,'count') ;

$sql =	"SELECT max(id) as id from ${pre}po WHERE transdate <= '$repdate'" ;
$result = $adodb->query($sql);
$po_id = exapi_dbflds($result,'id') ;

$sql =	"SELECT max(a.id) as id FROM ${pre}oitem a,${pre}po b " ;
$sql.=	"WHERE transdate <= '$repdate' and a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_id = exapi_dbflds($result,'id') ;

$t->set_var('status_date',$repdate) ;
$t->set_var('po_amount',sprintf("%01.2f",$po_amount)) ;
$t->set_var('po_netamount',sprintf("%01.2f",$po_netamount)) ;
$t->set_var('oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('po_count',$po_count) ;
$t->set_var('oitem_count',$oitem_count) ;
$t->set_var('po_id',$po_id) ;
$t->set_var('oitem_id',$oitem_id) ;

/*-----------------Gather and Write Total System Info-----------------------------*/

$sql =	"SELECT isocode,sum(amount) as curr_amount FROM ${pre}po " ;
$sql.=	"GROUP BY isocode ORDER BY isocode" ;
$result = $adodb->query($sql);
if (exapi_dbrc($result)==0)	$t->set_var('block2_section',"");

While ($rs=$result->fetchRow()) {
	$t->set_var(array('isocode'	=> $rs['isocode'],
			'curr_amount'	=> $rs['curr_amount']  ));
	$t->parse('block2_section','block2',true);
	}

$sql =	"SELECT sum(amount) as amount,sum(netamount) as netamount from ${pre}po " ;
$result = $adodb->query($sql);
$po_amount = exapi_dbflds($result,'amount') ;
$po_netamount = exapi_dbflds($result,'netamount') ;

$sql =	"SELECT sum(qty*cost-discount-tax1-tax2) as oitem_amount " ;
$sql.=	"FROM ${pre}oitem a,${pre}po b " ;
$sql.=	"WHERE a.trans_id=b.id and b.taxincluded='t'" ;
$result = $adodb->query($sql);
$oitem_netamount = exapi_dbflds($result,'oitem_amount') ;
$sql =	"SELECT sum(qty*cost-discount) as oitem_amount from ${pre}oitem a,${pre}po b " .
	"WHERE a.trans_id=b.id and b.taxincluded='f'" ;
$result = $adodb->query($sql);
$oitem_netamount += exapi_dbflds($result,'oitem_amount') ;

$sql =	"SELECT sum(tax1) as tax1, sum(tax2) as tax2 from ${pre}oitem a,${pre}po b WHERE a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_tax = exapi_dbflds($result,'tax1')+exapi_dbflds($result,'tax2') ;

$sql =	"SELECT count(id) as count FROM ${pre}vendor" ;
$result = $adodb->query($sql);
$vendor_count = exapi_dbflds($result,'count') ;

$sql =	"SELECT count(id) as count FROM ${pre}tax WHERE taxgroup='ap'" ;
$result = $adodb->query($sql);
$tax_count = exapi_dbflds($result,'count') ;

$sql =	"SELECT count(id) as count FROM ${pre}po" ;
$result = $adodb->query($sql);
$po_count = exapi_dbflds($result,'count') ;

$sql =	"SELECT count(a.id) as count FROM ${pre}oitem a,${pre}po b WHERE a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_count = exapi_dbflds($result,'count') ;

$sql =	"SELECT max(id) as id FROM ${pre}vendor" ;
$result = $adodb->query($sql);
$vendor_id = exapi_dbflds($result,'id') ;

$sql =	"SELECT max(id) as id FROM ${pre}tax WHERE taxgroup='ap'" ;
$result = $adodb->query($sql);
$tax_id = exapi_dbflds($result,'id') ;

$sql =	"SELECT max(id) as id FROM ${pre}po" ;
$result = $adodb->query($sql);
$po_id = exapi_dbflds($result,'id') ;

$sql =	"SELECT max(a.id) as id FROM ${pre}oitem a,${pre}po b WHERE a.trans_id=b.id" ;
$result = $adodb->query($sql);
$oitem_id = exapi_dbflds($result,'id') ;

$t->set_var('print_date',date("Y-m-d")) ;
$t->set_var('sys_po_amount',sprintf("%01.2f",$po_amount)) ;
$t->set_var('sys_po_netamount',sprintf("%01.2f",$po_netamount)) ;
$t->set_var('sys_oitem_netamount',sprintf("%01.2f",$oitem_netamount)) ;
$t->set_var('sys_oitem_tax',sprintf("%01.2f",$oitem_tax)) ;
$t->set_var('sys_vendor_count',$vendor_count) ;
$t->set_var('sys_tax_count',$tax_count) ;
$t->set_var('sys_po_count',$po_count) ;
$t->set_var('sys_oitem_count',$oitem_count) ;
$t->set_var('sys_vendor_id',$vendor_id) ;
$t->set_var('sys_tax_id',$tax_id) ;
$t->set_var('sys_po_id',$po_id) ;
$t->set_var('sys_oitem_id',$oitem_id) ;


/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/reportfilter.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
