<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// reportfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-po' ;
	$tran = 'report' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$title = exapi_lang("Choose Report to Generate and to set Report Parameters :") ;
	$msg1 = exapi_lang('Generation of PO report requires lengthy processing time.') ;
	$msg2 = exapi_lang('You should initiate report generation only during off-peak hours.') ;
	$ckapi['phrases'] = array('lang_title'	=> $title ,
				'lang_criteria'	=> exapi_lang("Reporting Parameters") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Report Generation") ,
				'lang_add'	=> exapi_lang("Return to Index Page") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$note1 = exapi_lang("If wrong report chosen, click [Report] to restart.") ;
	$note1a = exapi_lang("Press [Start Report Generation] one more time to start.") ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Which Report') ,
				'type'		=>	'select' ,
				'selectlist'	=>	'' ,
				'varname'	=>	'actnum' ,
				'defval'	=>	'' ,
				'note'		=>	$note1				) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Which Vendor') ,
				'type'		=>	'select' ,
				'selectlist'	=>	selectlist('vendor','name','','','id','name','id') ,
				'varname'	=>	'vendor' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Select the target vendor') ) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Report Status as of') ,
				'type'		=>	'input' ,
				'varname'	=>	'rdate' ,
				'defval'	=>	'' ,
				'note'		=>	$dateformat			) ;

	$lang_reserved = exapi_lang('Reserved') ;
	$report5 = exapi_lang('Purchase Order Audit Control Report') ;

	$ckapi['filter']['actlist'] = array (	1=>	"<OPTION value='1'>1 -- $lang_reserved</OPTION>",
						2=>	"<OPTION value='2'>2 -- $lang_reserved</OPTION>",
						3=>	"<OPTION value='3'>3 -- $lang_reserved</OPTION>",
						4=>	"<OPTION value='4'>4 -- $lang_reserved</OPTION>",
						5=>	"<OPTION value='5'>5 -- $report5</OPTION>"	) ;
	$ckapi['filter']['actstring'] = array(	"0",	/* initial entry	*/
						"0",	/* report 1	*/
						"0",	/* report 2	*/
						"0",	/* report 3	*/
						"0",	/* report 4	*/
						"02"	/* report 5	*/			) ;
	if (isset($_POST['actnum']) and $_POST['actnum']<>"")	$ckapi['filter'][0]['note'] = $note1a ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_filter() ;
	exapi_footer() ;

?>
