<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// addonlist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'addon' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}addon" 			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Add-On Charge/Reduction") ,
				'lang_add'	=> exapi_lang("Add New AddOn Charge/Reduction") ,
				'lang_note'	=> exapi_lang('Factor: based on Cash Sale Total; Basis: g-gross sale, n-net sale') ,
				'lang_addon'	=> exapi_lang('AddOn Charge/Reduction') ,
				'lang_count'	=> exapi_lang('Count per Transaction') ,
				'lang_sale'	=> exapi_lang('Sales per Transaction') ,
				'lang_splan'	=> exapi_lang('Sales Plan') ,
				'lang_date'	=> exapi_lang('Date')				) ;
	$ckapi['columns'] = array('name'	=> exapi_lang('Name') ,
				'factor'	=> exapi_lang('Factor') ,
				'basis'		=> exapi_lang('Basis') ,
				'mincount'	=> exapi_lang('Min') ,
				'maxcount'	=> exapi_lang('Max') ,
				'minsale'	=> exapi_lang('Min') ,
				'maxsale'	=> exapi_lang('Max') ,
				'splan_id'	=> exapi_lang('ID') ,
				'start'		=> exapi_lang('Valid from') ,
				'endd'		=> exapi_lang('Valid to') ,
				'id'		=> exapi_lang('Audit ID') 			) ;
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"			) ;
	$ckapi['lang_links'] = array('lang_view'=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_list() ;
	exapi_footer() ;

?>
