<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// cashbalview.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'cashbal' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$order = isset($_GET['order']) ? $_GET['order'] : (isset($_POST['order'])?$_POST['order']:'');
	$sort = isset($_GET['sort']) ? $_GET['sort'] : (isset($_POST['sort'])?$_POST['sort']:'');
	$filter = urldecode(stripslashes($filter)) ;
	$proc = newobj('ck-api','process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$t = exapi_tpl($app);
	$t->set_file('report',"${tran}view.tpl") ;
	$t->set_block('report','cashbal','cashbal_section');
	$t->set_block('report','cashanal','cashanal_section');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;

//---------------------------- list variable template-declarations -------------------------

	$t->set_var('lang_title',exapi_lang('List of Shift End Balances (Detail View)'));
	$t->set_var('lang_cashbox',exapi_lang('Cash Box Name'));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","filter=$filter"));
	
	$script = "/$app/${tran}view.php" ;
	$getstr = "id=$id&filter=$filter" ;
	$t->set_var('sort_transdate',$proc->sortlink(exapi_lang('Cash Sale Date'),$script,'transdate',$sort,$getstr));
	$t->set_var('sort_shift',$proc->sortlink(exapi_lang('Shift'),$script,'shift',$sort,$getstr));
	$t->set_var('sort_name',$proc->sortlink(exapi_lang('Quasi-Cash Name'),$script,'name',$sort,$getstr));
	$t->set_var('sort_posnumber',$proc->sortlink(exapi_lang('Cash Sale#'),$script,'posnumber',$sort,$getstr));
	$t->set_var('sort_qty',$proc->sortlink(exapi_lang('Qty'),$script,'qty',$sort,$getstr));
	$t->set_var('sort_value',$proc->sortlink(exapi_lang('Value'),$script,'value',$sort,$getstr));
	$t->set_var('sort_amount',$proc->sortlink(exapi_lang('Amount'),$script,'amount',$sort,$getstr));
	$t->set_var('lang_view',exapi_lang('View Detail'));
	$t->set_var('lang_copy',exapi_lang('Copy/Modify'));
	$t->set_var('lang_delete',exapi_lang('Delete'));

	$rpos = strrpos($where,"'") ;
	$lpos = strrpos(substr($where,1,$rpos-1),"'") ;
	$cboxid = substr($where,$lpos) ;
	$result = $adodb->query("SELECT name FROM ${pre}cashbox WHERE id=$cboxid");
	$t->set_var('cashbox',exapi_dbflds($result,'name')) ;

// ------------------------- Write Quasi-Cash Balances (Detail View) -------------------------

if (!$order) {$order = "posnumber" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =	"SELECT itemid,transdate,b.shift as shift,c.name as name,posnumber,qty,a.value as value,";
$sql.=		"qty*a.value as amount " ;
$sql.=	"FROM ${pre}positem a, ${pre}pos b, ${pre}qcash c " ;
$sql.=	"WHERE $where and itemid=$id and a.trans_id=b.id and a.itemid=c.id  " ;
$sql.=	"ORDER BY $order $sort" ;
if ($id==0)	{
	$sql =	"SELECT transdate,shift,'Cash Change' as name,posnumber,qty,value,qty*value as amount " ;
	$sql.=	"FROM ${pre}positem a, ${pre}pos b " ;
	$sql.=	"WHERE $where and itemtype='c' and a.trans_id=b.id ORDER BY $order $sort" ;
	}
$result = $adodb->query($sql);
if (exapi_dbrc($result)==0) {
	$t->set_var(array(	'transdate'	=> exapi_lang("No Matching Item Found"),
				'shift'		=> "",
				'name'		=> "",
				'posnumber'	=> "",
				'qty'		=> "",
				'value'		=> "",
				'amount'	=> ""		)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',True);
	}
$total = 0 ;
While ($rs=$result->fetchRow()) {
	$amount = number_format($rs['amount'],2,".",'') ;
	$name = $rs['name'] ;
	$t->set_var(array(	'transdate'	=> $rs['transdate'],
				'shift'		=> $rs['shift'],
				'name'		=> $name,
				'posnumber'	=> $rs['posnumber'],
				'qty'		=> $rs['qty'] ,
				'value'		=> $rs['value'] ,
				'amount'	=> $amount 		)) ;
	if ($name=="Cash")	$cashamount = number_format($amount,2,".",'') ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',true);
	$total += $amount ;
	}

$t->parse('cashbal','cashbal_section',true);
$t->set_var('lang_total',exapi_lang("Total for this Shift -")." $name") ;
$t->set_var('total',$total) ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','report',True);
	exapi_footer() ;

?>
