<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.tax.inc.php 0.16.1 2005/12/04 C K Wu

    class tax {

//---- Tax Detail Validation Checks

    function tax_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$table = $ckapi['params']['table'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang("Error") ;
	if (!$dt['taxnumber'] or $dt['taxnumber']=="")	$err=exapi_lang('Tax Name/Number Missing');
		else	{
			$result = $adodb->query("SELECT * from $table WHERE taxnumber='$dt[taxnumber]'") ;
			if (exapi_dbrc($result)<>0 and $dt['taxnumber']<>$dt['oldtaxnumber'])
				$err=exapi_lang('Tax Name/Number already in use');
			}
	if ($dt['rate'] and !is_numeric($dt['rate']))	$err=exapi_lang('Tax Rate must be numeric');
	if ($dt['rate']<0 or $dt['rate']>10)		$err=exapi_lang('Rate must be 0-10(assumed maximum)');
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Tax Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	$errmsg1 = exapi_lang("This tax is still listed as default") ;
	$itemrec = exapi_lang("within add-on item record") ;
	$result = $adodb->query("SELECT * from ${pre}itemtax where tax_id='$dt[id]'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $itemrec id#".exapi_dbflds($result,'item_id') ;

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Tax Detail

    function tax_write() {
	global $ckapi ;

	$t = &$ckapi['objects']['template'] ;
	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_taxnumber',exapi_lang('Name/Number'));
	$t->set_var('lang_rate',exapi_lang('Rate'));
	$t->set_var('lang_account',exapi_lang('Associated Ledger A/C'));
	$t->set_var('lang_notes',exapi_lang('Notes'));

	$dt = &$ckapi['params_post']['dt'] ;
	$fields = array('id','control','taxnumber','oldtaxnumber','rate','chart_id','notes') ;
	foreach ($fields as $field) {
		$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;
		$t->set_var($field,$dt[$field]);
		}
	$t->set_var('acc_selectlist',selectlist('chart','accno',"WHERE link like '%CS_tax%'",$dt['chart_id'],'id','accno','substring(description,1,20)'));
	$t->parse('out','report',True);
	}

    }

?>