<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// spricelist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'sprice' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}sprice" 		);
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Special Prices") ,
				'lang_add'	=> exapi_lang("Add New Special Price")) ;
	$ckapi['columns'] = array('name'	=> exapi_lang('Special Price Name') ,
				'price'		=> exapi_lang('Special Price') ,
				'itemid'	=> exapi_lang('ID of Normally Priced Item') ,
				'splan_id'	=> exapi_lang('Sales Promo Plan ID') ,
				'start'		=> exapi_lang('Valid from') ,
				'endd'		=> exapi_lang('Valid to') ,
				'id'		=> exapi_lang('Audit ID') 	);
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"	) ;
	$ckapi['lang_links'] = array('lang_view'=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")		) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_list() ;
	exapi_footer() ;

?>
