<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// vendorstatement.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-vrm' ;
	$tran = 'vendor' ;
	$noheader = $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$start = isset($_GET['start']) ? $_GET['start'] : (isset($_POST['start'])?$_POST['start']:'');
	$end = isset($_GET['end']) ? $_GET['end'] : (isset($_POST['end'])?$_POST['end']:'');
	$sdate = isset($_GET['sdate']) ? $_GET['sdate'] : (isset($_POST['sdate'])?$_POST['sdate']:'');
	$filter=stripslashes($filter);

	$t = exapi_tpl($app);
	$t->set_file(array('report'		=> "${tran}statement.tpl",
	                   'items'		=> "${tran}statement.tpl"));
	$t->set_block('items','item_row','item_section');
	$t->set_block('items','done','done_section');

	$t->set_var('charset',exapi_lang('charset'));
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$logofile = $ckapi['hostsys']['dataarea']."/images/logo.png" ;
	$t->set_var('logo',exapi_link("/ck-api/view_image.php","imgfile=$logofile"));

	$err=""; $error = exapi_lang("Error") ;
	if ($start<>'')	{
		if (input2date($start)=="")	$err=exapi_lang('Invalid Statement Start Date');
		$jdstart = mktime(0,0,0,intval(substr($start,5,2)),intval(substr($start,8,2)),intval(substr($start,0,4))) ;
		}
	if ($end<>'')	{
		if (input2date($end)=="")	$err=exapi_lang('Invalid Statement End Date');
		$jdend = mktime(0,0,0,intval(substr($end,5,2)),intval(substr($end,8,2)),intval(substr($end,0,4))) ;
		}
	if ($sdate<>'')	{
		if (input2date($sdate)=="")	$err=exapi_lang('Invalid Statement Date');
		$jdsdate = mktime(0,0,0,intval(substr($sdate,5,2)),intval(substr($sdate,8,2)),intval(substr($sdate,0,4))) ;
		}
	if (isset($jdstart) and isset($jdend) and $jdstart>$jdend)
						$err=exapi_lang('Statement Start later than Statement End');
	if (isset($jdsdate) and isset($jdend) and $jdsdate<$jdend)
						$err=exapi_lang('Statement date earlier than Statement End');

	if ($err)	$err="<b>$error: $err</b>" ;

	$start = ($start=='') ? date("Y-m-d",mktime(0,0,0,date("m")-1,1,date("Y"))) : $start ;
	$end = ($end=='') ? date("Y-m-d",mktime(0,0,0,date("m"),0,date("Y"))) : $end ;
	$sdate = ($sdate=='') ? date("Y-m-d") : $sdate ;

/*------------- Write Statement Header to Screen Display ----------------------------*/

	$t->set_var('lang_statement',exapi_lang('*** STATEMENT ***'));
	$t->set_var('lang_start',exapi_lang('Statement Start'));
	$t->set_var('start',$start) ;
	$t->set_var('lang_end',exapi_lang('Statement End'));
	$t->set_var('end',$end) ;
	$t->set_var('lang_sdate',exapi_lang('Statement Date'));
	$t->set_var('sdate',$sdate) ;
	$t->set_var('lang_vendor',exapi_lang('Vendor:'));

	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_duedate',exapi_lang('Due Date'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_isocode',exapi_lang('Currency'));
	$t->set_var('lang_invoice_amount',exapi_lang('Invoice<br>Amount'));
	$t->set_var('lang_payment_sent',exapi_lang('Payment<br>Sent'));
	$t->set_var('lang_balance',exapi_lang('Balance'));
	$t->set_var('lang_remark',exapi_lang('Remark'));

	$result = $adodb->query("SELECT * FROM ${pre}vendor a, ${pre}org b WHERE a.id='$id' and contactid=b.id");
	if (exapi_dbrc($result)>0) {
		$name = exapi_dbflds($result,'orgname') ;
		$emailname = exapi_lang('Accounts Department') ;
		$contactid = exapi_dbflds($result,'contactid') ;
		}
	  else	{
		$result = $adodb->query("SELECT * FROM ${pre}vendor a,${pre}person b WHERE a.id='$id' and contactid=b.id");
		$name = $emailname = strtoupper(exapi_dbflds($result,'family'))." ".exapi_dbflds($result,'given') ;
		$contactid = exapi_dbflds($result,'contactid') ;
		}
	$t->set_var('name',$name) ;
	$result = $adodb->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='wemail'");
	$vendemail = exapi_dbflds($result,'commdata') ;
	$result = $adodb->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='workaddr'");
	$t->set_var('addr1',exapi_dbflds($result,'line1')) ;
	$t->set_var('addr2',exapi_dbflds($result,'line2')) ;
	$t->set_var('addr3',exapi_dbflds($result,'line3')) ;
	$t->set_var('addr4',exapi_dbflds($result,'line4')) ;
	$t->set_var('comment1',"") ;
	$t->set_var('comment2',"") ;
	$t->set_var('comment3',"") ;
	$t->set_var('comment4',"") ;

/*---------------------------------------------------------------------------------*/

if ($err=="")	{
	$user = $ckapi['hostsys']['username'];
	$temp0 = "${pre}vrmst0".$user.time() ;
	$temp1 = "${pre}vrmst1".$user.time() ;
	$temp2 = "${pre}vrmst2".$user.time() ;

/*------------Collect all transactions related to this vendor ($temp1)------------------*/
	$sql = "CREATE TABLE $temp1 AS " ;
	$sql.= "SELECT 'i' as flag,transdate,duedate,isocode,amount,invnumber as description FROM ${pre}ap ";
	$sql.= "WHERE vendor=$id and transdate<='$end'" ;
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp1 (flag,transdate,isocode,amount,description) " .
		"SELECT 'p',transdate, isocode, -amount, paynumber FROM ${pre}payment " .
		"WHERE vendor=$id and transdate<='$end'" ;
	$adodb->query($sql);

/*------------Create intra period detail transactions ($temp2)----------------------------*/

	$adodb->query("CREATE TABLE $temp2 AS SELECT * FROM $temp1 WHERE transdate>='$start' and transdate<='$end'");

/*------------Calculate and Print beginning balance-----------------------------------------*/

	$where = "WHERE vendor=$id and transdate<'$start'" ;
	$sql =	"CREATE TABLE $temp0 AS SELECT isocode,amount FROM ${pre}ap $where" ;
	$adodb->query($sql);
	$sql =	"INSERT INTO $temp0 (isocode,amount) SELECT isocode, -amount FROM ${pre}payment $where" ;
	$adodb->query($sql);
	$result = $adodb->query("SELECT isocode,sum(amount) as amount FROM $temp0 GROUP BY isocode");

	if (exapi_dbrc($result)==0) {
		$t->set_var(array('transdate'	=> $start,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Brought Forward"),
				'isocode'	=> "" ,
				'invamt'	=> "",
				'payamt'	=> "",
				'balance'	=> 0 ,
	      	    		'remark'	=> "" ));
		$t->parse('item_section','item_row',true);
		}
	While ($rs=$result->fetchRow()) {
		$amount = $rs['amount'] ;
		$remark = ($amount<0) ? exapi_lang('[DR]') : "" ;
		$t->set_var(array('transdate'	=> $start,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Brought Forward"),
				'isocode'	=> $rs['isocode'] ,
				'invamt'	=> "",
				'payamt'	=> "",
				'balance'	=> $amount ,
	      	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$t->set_var(array('transdate'	=> "",
			'duedate'	=> "",
			'description'	=> "",
			'isocode'	=> "" ,
			'invamt'	=> "",
			'payamt'	=> "",
			'balance'	=> "" ,
      	    		'remark'	=> "" ));
	$t->parse('item_section','item_row',true);

/*------------Obtain and Print Intra-Period Transactions-----------------------------------------*/

	$result = $adodb->query("SELECT * FROM $temp2 ORDER BY transdate");
	While ($rs=$result->fetchRow()) {
		$remark = "" ;
		$flag = $rs['flag'] ;
		$transdate = $rs['transdate'] ;
		$duedate = ($flag=="i") ? $rs['duedate'] : "" ;
		$description = $rs['description'] ;
		$isocode = $rs['isocode'] ;
		$invamt = ($flag=="i") ? $rs['amount'] : "" ;
		$payamt = ($flag=="p") ? -$rs['amount'] : "" ;
		$t->set_var(array(	'transdate'	=> $transdate,
					'duedate'	=> $duedate,
					'description'	=> $description,
					'isocode'	=> $isocode,
					'invamt'	=> $invamt,
					'payamt'	=> $payamt,
					'balance'	=> "",
	     	 	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$t->set_var(array('transdate'	=> "",
			'duedate'	=> "",
			'description'=> "",
			'isocode'	=> "" ,
			'invamt'	=> "",
			'payamt'	=> "",
			'balance'	=> "" ,
      	    		'remark'	=> "" ));
	$t->parse('item_section','item_row',true);

/*------------Calculate and Print Ending balance-----------------------------------------*/

	$adodb->query("DROP TABLE $temp0");
	$adodb->query("CREATE TABLE $temp0 AS SELECT isocode,amount FROM $temp1");
	$result = $adodb->query("SELECT isocode,sum(amount) as amount FROM $temp0 GROUP BY isocode");
	if (exapi_dbrc($result)==0) {
		$t->set_var(array('transdate'	=> $end,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Carried Forward"),
				'isocode'	=> "" ,
				'invamt'	=> "",
				'payamt'	=> "",
				'balance'	=> 0 ,
	      	    		'remark'	=> "" ));
		$t->parse('item_section','item_row',true);
		}
	While ($rs=$result->fetchRow()) {
		$amount = $rs['amount'] ;
		$remark = ($amount<0) ? exapi_lang('[DR]') : "" ;
		$t->set_var(array('transdate'	=> $end,
				'duedate'	=> "",
				'description'	=> exapi_lang("Bal. Carried Forward"),
				'isocode'	=> $rs['isocode'] ,
				'invamt'	=> "",
				'payamt'	=> "",
				'balance'	=> $amount ,
	      	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}

/*------------Print Others-----------------------------------------*/

	$t->set_var('lang_thank',exapi_lang('Thank you for your continuous support')) ;
	$t->set_var('lang_footer',"") ;

	$title=exapi_lang('Statement Image (Use browser print function to output the statement shown above):');
	$t->set_var('lang_title',$title);
	$note1=exapi_lang('[This is a sample subject to tailoring per individual printer & statement format]');
	$t->set_var('lang_note1',$note1);
	$note2=exapi_lang('To generate statement of a different period, modify the appropriate statement field(s), then press regenerate.');
	$t->set_var('lang_note2',$note2);

	$adodb->query("DROP TABLE $temp0");
	$adodb->query("DROP TABLE $temp1");
	$adodb->query("DROP TABLE $temp2");

	}
else {
 	$t->set_var('lang_title',$err);
	$t->set_var('item_section',"") ;
	$t->set_var('lang_thank',"") ;
	$t->set_var('lang_footer',"") ;
	$t->set_var('lang_note1',"");
	$t->set_var('lang_note2',"");
	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('regenerate_action',exapi_link("/$app/${tran}statement.php","id=$id&filter=$filter")) ;
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","filter=$filter")) ;
	$t->set_var('lang_regenerate',exapi_lang('Regenerate Statement'));
	$t->set_var('lang_email',exapi_lang('Email Statement'));
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','items','report');
	exapi_footer() ;

?>
