<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// adminddl.php 0.16.1 2005/12/04 C K Wu

	$dbtype = $ckapi['hostsys']['dbtype'] ;

	$float = ($dbtype=="mysql") ? "double default 0" : "float default 0" ;
	$int = "int default 0" ;

	if ($dbtype == "mysql")	$id_field = $logid_field = "id int unsigned PRIMARY KEY auto_increment" ;
	if ($dbtype == "pgsql")	{
		$id_field = "id int DEFAULT nextval('id')" ;
		$logid_field = "id int DEFAULT nextval('logid')" ;
		}

	$trans_id = "trans_id $int" ;
	$contactid = "contactid $int" ;
	$transdate = "transdate date DEFAULT 'now'" ;
	$desc = "description text" ;
	$name = "name text" ;
	$control = "control int DEFAULT 100" ;
	$allowdelete = "allowdelete char DEFAULT 'n'" ;
	$preferred = "preferred char DEFAULT 'n'" ;
	unset($sql) ;

/*---------------------------------------------------------------------------------*/

	$sql[] = "CREATE TABLE ${pre}md5 ($id_field,app text,script text,version text,checksum text)";
	$sql[] = "CREATE TABLE ${pre}category ($id_field,app text,type text,$name,$desc,parent $int,$allowdelete,$control)" ;
	$sql[] = "CREATE TABLE ${pre}makemodel ($id_field,parts_id $int,$name)" ;
	$sql[] = "CREATE TABLE ${pre}gl ($id_field,source text,$desc,$transdate,$control)" ;
	$sql[] = "CREATE TABLE ${pre}il ($id_field,source text,$desc,to_from $int,$transdate,$control)";
	$sql[] = "CREATE TABLE ${pre}chart ($id_field,accno $int UNIQUE,$desc,charttype char(1) DEFAULT 'A',gifi text,category char(1),link text,$control)" ;
	$sql[] = "CREATE TABLE ${pre}fund ($id_field,$name,$desc,$control)" ;
	$sql[] = "CREATE TABLE ${pre}project ($id_field,$name,$desc,$control)" ;
	$sql[] = "CREATE TABLE ${pre}achievement ($id_field,$name,$desc,min $float,max $float,rate $float,$control)";
	$sql[] = "CREATE TABLE ${pre}department ($id_field,$name,$desc,head $int,email text,$control)" ;
	$sql[] = "CREATE TABLE ${pre}remark ($id_field,$name,description text,$control)" ;
	$sql[] = "CREATE TABLE ${pre}currency ($id_field,isocode varchar(3),$desc,exrate $float,$control)";
	$sql[] = "CREATE TABLE ${pre}resourcelock (resource text,used_by text)";
	$sql[] = "CREATE TABLE ${pre}acc_trans ($id_field,$trans_id,chart_id $int,attrib1 $int, attrib2 $int, attrib3 $int,amount $float,$transdate)";
	$sql[] = "CREATE TABLE ${pre}bkr_trans ($id_field,$trans_id,chart_id $int,source text,$desc,cheque text,refnumber text,status char(1),amount $float,$transdate,$control)";
	$sql[] = "CREATE TABLE ${pre}inv_trans ($trans_id,order_id $int,parts_id $int,qty $float,$transdate)" ;
	$sqla =	"CREATE TABLE ${pre}invoice ($id_field,$trans_id,inventory_accno_id $int," ;
	$sqla.=		"income_accno_id $int,expense_accno_id $int,itemid $int,itemtype char(1)," ;
	$sqla.=		"$desc,qty $float,price $float,cost $float,discount $float," ;
	$sqla.=		"tax1 $float,tax2 $float,tax1_accno_id $int,tax2_accno_id $int,unit varchar(5))";
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}oitem ($id_field,$trans_id,itemid $int," ;
	$sqla.=		"itemtype char(1),$desc,qty $float,price $float,cost $float," ;
	$sqla.=		"discount $float,tax1 $float,tax2 $float,unit varchar(5))";
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}vendor ($id_field,$contactid,$name,catid $int,taxincluded char,terms $int,$control)";
	$sql[] = "CREATE TABLE ${pre}customer ($id_field,$contactid,$name,catid $int,taxincluded char,discount $float,creditlimit $float,terms $int,$control) " ;
	$sqla =	"CREATE TABLE ${pre}parts ($id_field,partnumber text,$desc," ;
	$sqla.=		"unit varchar(5),listprice $float,price $float,cost $float," ;
	$sqla.=		"notes text,bin text,priceupdate date DEFAULT 'now'," ;
	$sqla.=		"weight $float,costupdate date DEFAULT 'now',rop $float," ;
	$sqla.=		"inventory_accno_id $int,income_accno_id $int," ;
	$sqla.=		"expense_accno_id $int,$control)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}assembly ($id_field,assembly_id $int,item_id $int,qty $float)" ;
	$sql[] = "CREATE TABLE ${pre}alternate ($id_field,alternate_id $int,item_id $int)" ;
	$sqla =	"CREATE TABLE ${pre}service ($id_field,servicenumber text,$desc,unit varchar(5)," ;
	$sqla.=		"listprice $float,price $float,cost $float,notes text," ;
	$sqla.=		"priceupdate date DEFAULT 'now',costupdate date DEFAULT 'now'," ;
	$sqla.=		"income_accno_id $int,expense_accno_id $int,$control )" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}ar ($id_field,invnumber text,ar_accno_id $int," ;
	$sqla.=		"$transdate,customer $int,taxincluded char," ;
	$sqla.=		"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sqla.=		"duedate date,notes text,ordnumber text," ;
	$sqla.=		"shippingpoint text,terms $int,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}ap ($id_field,invnumber text,ap_accno_id $int," ;
	$sqla.=		"$transdate,vendor $int,taxincluded char," ;
	$sqla.=		"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sqla.=		"duedate date,ordnumber text,$control )" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}po ($id_field,ponumber text,$transdate,vendor $int,taxincluded char," ;
	$sqla.=		"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sqla.=		"duedate date,shipfrom text,notes text,$control )" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}so ($id_field,sonumber text,$transdate,customer $int,taxincluded char,";
	$sqla.=		"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sqla.=		"duedate date,shipfrom text,notes text,$control )" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}quote ($id_field,quotenumber text,so_id $int," ;
	$sqla.=			"$transdate,customer $int,taxincluded char," ;
	$sqla.=			"amount $float,netamount $float,isocode varchar(3),exrate $float," ;
	$sqla.=			"duedate date,shipfrom text,notes text,$control )" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}tax ($id_field,chart_id $int,rate $float,taxnumber text,taxgroup text,notes text,$control )" ;
	$sql[] = "CREATE TABLE ${pre}customertax (customer_id $int,tax_id $int,taxtype char)" ;
	$sql[] = "CREATE TABLE ${pre}vendortax (vendor_id $int,tax_id $int,taxtype char)" ;
	$sql[] = "CREATE TABLE ${pre}itemtax (item_id $int,tax_id $int,taxtype char)" ;
	$sqla =	"CREATE TABLE ${pre}payment ($id_field,paynumber text,cheque text," ;
	$sqla.=		"$transdate,vendor $int,amount $float,isocode varchar(3),exrate $float," ;
	$sqla.=		"payee text,remark text,dr_accno_id $int,cr_accno_id $int,$control )" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}receipt ($id_field,rptnumber text,cheque text," ;
	$sqla.=		"$transdate,customer $int,amount $float,isocode varchar(3),exrate $float," ;
	$sqla.=		"remark text,dr_accno_id $int,cr_accno_id $int,$control )" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}p_match (paymentid $int,invoiceid $int,s_amount $float)" ;
	$sql[] = "CREATE TABLE ${pre}r_match (receiptid $int,invoiceid $int,s_amount $float)" ;
	$sql[] = "CREATE TABLE ${pre}ipmatch (poid $int,invoiceid $int,b_amount $float)" ;
	$sql[] = "CREATE TABLE ${pre}ismatch (soid $int,invoiceid $int,b_amount $float)" ;
	$sql[] = "CREATE TABLE ${pre}sqmatch (quoteid $int,soid $int,a_amount $float)" ;
	$sqla =	"CREATE TABLE ${pre}qcash ($id_field,$name,value $float,minsale $float,maxsale $float," ;
	$sqla.=		"minqty $int,maxqty $int,minvalue $float,maxvalue $float," ;
	$sqla.=		"posacc_id $int,start date,endd date,splan_id $int,notes text,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}addon ($id_field,$name,factor $float,basis char(1)," ;
	$sqla.=		"mincount $int,maxcount $int,minsale $float,maxsale $float," ;
	$sqla.=		"incacc_id $int,expacc_id $int,start date,endd date,splan_id $int,notes text,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}sprice ($id_field,$name,itemid $int,price $float," ;
	$sqla.=		"start date,endd date,splan_id $int,notes text,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}cashbox ($id_field,$name,cashier text,shift char(1)," ;
	$sqla.=		"location text,maxcash $float,notes text,$control)";
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}pos ($id_field,posnumber text,cboxid $int,cashier text," ;
	$sqla.=		"$transdate,shift char(1),customer $int," ;
	$sqla.=		"taxincluded char,amount $float,netamount $float,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}positem ($id_field,$trans_id," ;
	$sqla.=		"invacc_id $int,incacc_id $int,expacc_id $int,posacc_id $int," ;
	$sqla.=		"itemid $int,itemtype char(1),qty $float,price $float,cost $float," ;
	$sqla.=		"value $float,factor $float,discount $float,unit varchar(5),";
	$sqla.=		"tax1 $float,tax2 $float,tax1acc_id $int,tax2acc_id $int)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}cbtran ($id_field,cbtnumber text,cboxid $int,manager text," ;
	$sqla.=		"cashier text,trantype char(1),$transdate,shift char(1),amount $float," ;
	$sqla.=		"posac_id $int,citac_id $int,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}log ($logid_field,$trans_id,app text,script text,ip text," ;
	$sqla.=		"iptime text,userid text,op text,header text,detail text,timestamp $int)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}errlog ($id_field,$trans_id,dbtype varchar(5),app text,script text,ip text," ;
	$sqla.=		"userid text,timestamp $int,file varchar(255),line $int,type $int,message text)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}empperson ($id_field,prsnumber text,prefix text,family text,given text," ;
	$sqla.=		"suffix text,nationalid text,username text,birthday date,note text,pubkey text,$control)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}employee ($id_field,$contactid,$name,title text,supervisor $int,dept $int,grade text,$control)" ;
	$sqla =	"CREATE TABLE ${pre}address (contactid $int,line1 text,line2 text,line3 text,line4 text," ;
	$sqla.=		"addresscode text,region text,country text,zip text,$preferred)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}ec (contactid $int,prefix text,family text,given text,suffix text," ;
	$sqla.=		"contact text,relation text,eccode text,$preferred)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}dates (empid $int,empdate date,datecode text,notify $int)" ;
	$sql[] = "CREATE TABLE ${pre}leave (empid $int,$trans_id,leavefrom date,leaveto date,leavecode text,duration $float)" ;
	$sql[] = "CREATE TABLE ${pre}pr (empid $int,prfrom date,prto date,prcode text,comment text,reviewer $int,pddate date)" ;
	$sql[] = "CREATE TABLE ${pre}role (empid $int,rolecode text)" ;
	$sql[] = "CREATE TABLE ${pre}attendance ($id_field,empid $int,type text,reason text,$transdate,time text,$control)" ;
	$sqla =	"CREATE TABLE ${pre}timesheet ($id_field,empid $int,year $int,week $int," ;
	$sqla.=		"hour_ttl $float,day_ttl $float,approved_by text,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}ts_trans ($id_field,$trans_id,$transdate,project $int,activity text," ;
	$sqla.=		"hour $float,day $float,achieve $int,achival $float,achiunit $float)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}leaveapp ($id_field,empid $int,leavefrom date,leaveto date," ;
	$sqla.=		"leavecode text,duration $float,approved_by text,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}payroll ($id_field,empid $int,salary $int,period char(2),chart_id $int," ;
	$sqla.=		"bankacname text,bankac text,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}pyrcode ($id_field,$name,$desc,basis text,minqty $float,maxqty $float," ;
	$sqla.=		"minamt $float,maxamt $float,unitamt $float,unit text,rate $float,chart_id $int," ;
	$sqla.=		"single char,allowssc char,$allowdelete,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}pyrc_trans ($id_field,pyroid $int,pyrcodeid $int,qty $float," ;
	$sqla.=		"unit text,unitamt $float,rate $float,amount $float,comment text,chart_id $int)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}pynr_trans ($id_field,empid $int,pyrcodeid $int,qty $float,unit text," ;
	$sqla.=		"unitamt $float,rate $float,amount $float,comment text,chart_id $int,approved_by text," ;
	$sqla.=	"$control)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}rdtn_trans ($id_field,pyroid $int,rdtnid $int)" ;
	$sql[] = "CREATE TABLE ${pre}cntr_trans ($id_field,pyroid $int,cntrid $int)" ;
	$sqla=	"CREATE TABLE ${pre}reductn ($id_field,$name,$desc,locality text,chart_id $int," ;
	$sqla.=		"floor $int,min $int,actmin char(3),max $int,actmax char(3),$control)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}rdtnrate ($id_field,rdtnid $int,step $int,rate $float,subtract $int)";
	$sqla =	"CREATE TABLE ${pre}rdtnexem ($id_field,rdtnid $int,pyrcodeid $int," ;
	$sqla.=		"min $int,actmin char(3),max $int,actmax char(3))" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}contri ($id_field,$name,$desc,locality text,ac_exp $int,ac_liab $int," ;
	$sqla.=		"floor $int,min $int,actmin char(3),max $int,actmax char(3),$control)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}cntrrate ($id_field,cntrid $int,step $int,rate $float,subtract $int)";
	$sqla =	"CREATE TABLE ${pre}cntrexem ($id_field,cntrid $int,pyrcodeid $int," ;
	$sqla.=		"min $int,actmin char(3),max $int,actmax char(3))" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}pyrohist ($trans_id,empid $int,type char(4),codeid $int,basis text," ;
	$sqla.=		"qty $float,unit text,unitamt $float,rate $float,amount $float,comment text," ;
	$sqla.=		"approved_by text,chart_id $int,base $float,floor $int,subtract $int)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}org ($id_field,orgnumber text,orgname text,username text,nationalorgid text,note text,$control)" ;
	$sqla =	"CREATE TABLE ${pre}person ($id_field,prsnumber text,prefix text,family text,given text," ;
	$sqla.=		"suffix text,nationalid text,username text,birthday date,note text,pubkey text,$control)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}person_org (contactid $int,orgid $int,orgcode text,title text,department text,$preferred)" ;
	$sql[] = "CREATE TABLE ${pre}person_person (contactid $int,personid $int,personcode text,$preferred)" ;
	$sql[] = "CREATE TABLE ${pre}org_person (contactid $int,personid $int,personcode text,title text,department text,$preferred)" ;
	$sql[] = "CREATE TABLE ${pre}org_org (contactid $int,orgid $int,orgcode text,$preferred)" ;
	$sql[] = "CREATE TABLE ${pre}comm (contactid $int,commcode text,commdata text,$preferred)" ;
	$sql[] = "CREATE TABLE ${pre}status (contactid $int,statuscode text,$preferred)" ;
	$sql[] = "CREATE TABLE ${pre}others (contactid $int,description text,value text,$preferred)" ;
	$sql[] = "CREATE TABLE ${pre}scontract ($id_field,cntnumber text,start date,endd date,customer $int,$control)" ;
	$sql[] = "CREATE TABLE ${pre}pcontract ($id_field,cntnumber text,start date,endd date,vendor $int,$control)" ;
	$sql[] = "CREATE TABLE ${pre}stdterm ($id_field,contractid $int,stdpara text,catid $int)" ;
	$sql[] = "CREATE TABLE ${pre}spcterm ($id_field,contractid $int,spcpara text,detail text)" ;
	$sqla =	"CREATE TABLE ${pre}helpcase ($id_field,casenumber text,casecatid $int,customer $int,start date," ;
	$sqla.=		"itemid $int,$desc,pricatid $int,billable char(1),monitor $int,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}helpcall ($id_field,caseid $int,calldate date,calltime char(4),callcatid $int,";
	$sqla.=		"mediacatid $int,prsfrom text,prsto text,statecatid $int,assigned $int,actioned $int," ;
	$sqla.=		"deadline date,hours $float,summary text)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}salecase ($id_field,casenumber text,casecatid $int,customer $int,start date," ;
	$sqla.=		"itemid $int,$desc,pricatid $int,amount $float,prospect $float,monitor $int,$control)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}salecall ($id_field,caseid $int,calldate date,calltime char(4),callcatid $int,";
	$sqla.=		"mediacatid $int,prsfrom text,prsto text,statecatid $int,assigned $int,actioned $int," ;
	$sqla.=		"deadline date,hours $float,summary text)" ;
	$sql[] = $sqla ;
	$sqla =	"CREATE TABLE ${pre}vendcase ($id_field,casenumber text,casecatid $int,vendor $int,start date," ;
	$sqla.=		"itemid $int,$desc,pricatid $int,amount $float,prospect $float,monitor $int,$control)" ;
	$sql[] = $sqla ;
	$sqla = "CREATE TABLE ${pre}vendcall ($id_field,caseid $int,calldate date,calltime char(4),callcatid $int,";
	$sqla.=		"mediacatid $int,prsfrom text,prsto text,statecatid $int,assigned $int,actioned $int," ;
	$sqla.=		"deadline date,hours $float,summary text)" ;
	$sql[] = $sqla ;
	$sql[] = "CREATE TABLE ${pre}rights ($id_field,rgroup text,module text,rtable text,rfield text,rvalue text,$control)";
	$sql[] = "CREATE TABLE ${pre}i18ncode ($id_field,langcode varchar(10),$desc,installed text,charset text,$control)";
	$sql[] = "CREATE TABLE ${pre}i18n ($id_field,module varchar(15),langcode varchar(10),i18nkey text,i18nval text,$control)";
	$sql[] = "CREATE TABLE ${pre}i18nnew ($id_field,module varchar(15),langcode varchar(10),i18nkey text,i18nval text,$control)";

	$sqla =	"CREATE TABLE ${pre}defaults ($id_field,inventory_accno_id $int," ;
	$sqla.=	"income_accno_id $int,expense_accno_id $int," ;
	$sqla.=	"company varchar(35),addr1 varchar(35),addr2 varchar(35),addr3 varchar(35),";
	$sqla.=	"addr4 varchar(35),contact varchar(35),phone varchar(30),fax varchar(20),";
	$sqla.=	"aptax1cap text,aptax2cap text,aptax1pref char(1),aptax2pref char(1)," ;
	$sqla.=	"artax1cap text,artax2cap text,artax1pref char(1),artax2pref char(1)," ;
	$sqla.=	"postax1cap text,postax2cap text,postax1pref char(1),postax2pref char(1)," ;
	$sqla.=	"attrib1cap text,attrib2cap text,attrib3cap text,";
	$sqla.=	"attrib1tbl text,attrib2tbl text,attrib3tbl text," ;
	$sqla.=	"attrib1sdesc text,attrib2sdesc text,attrib3sdesc text," ;
	$sqla.=	"attrib1ldesc text,attrib2ldesc text,attrib3ldesc text," ;
	$sqla.=	"attrib1tblmn text,attrib2tblmn text,attrib3tblmn text," ;
	$sqla.=	"attrib1cnval text,attrib2cnval text,attrib3cnval text," ;
	$sqla.=	"email text,inv_rmkid $int,rmd_rmkid $int,po_rmkid $int,quo_rmkid $int," ;
	$sqla.=	"sm_rmkid $int,invnumber text,ponumber text,yearend date,nativecurr varchar(3),";
	$sqla.=	"weightunit varchar(5),businessnumber text,version varchar(8),readonlygrp text," ;
	$sqla.=	"paypalyn text,paymateyn text,payasiayn text,paypalemail text,paymateuname text," ;
	$sqla.=	"photoyn text,commyn text,addressyn text,ecyn text,othersyn text," ;
	$sqla.=	"mndfactor $int,smdfactor $int,wkdfactor $float," ;
	$sqla.=	"mnhfactor $int,smhfactor $int,wkhfactor $int,dyhfactor $int,";
	$sqla.=	"centeryn text,contactusyn text,ledreportyn text," ;
	$sqla.=	"custinfoyn text,cttinfoyn text,helpcaseyn text,contractyn text,quoteyn text," ;
	$sqla.=	"soyn text,invoiceyn text,ubsoyn text,osinvyn text,statementyn text,$control )" ;
	$sql[] = $sqla ;

?>

