<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// adminmaster.php 0.16.1 2005/12/04 C K Wu

/*---------------------------------------------------------------------------------*/

	$sqlcategory = "insert into ${pre}category (id,app,type,name,description) values " ;
	$sqlcategory1 = "insert into ${pre}category (id,app,type,name,description,parent) values " ;
	$sqlcurr = "insert into ${pre}currency (id,isocode,description,exrate) values " ;
	$sqlorg = "insert into ${pre}org (id,orgnumber,orgname,note) values " ;
	$sqlvend = "insert into ${pre}vendor (id,contactid,name,taxincluded) values ";
	$sqlcust = "insert into ${pre}customer (id,contactid,name,taxincluded) values ";
	$sqltax = "insert into ${pre}tax (id,chart_id,rate,taxnumber,taxgroup) values " ;
	$sqlqc = "insert into ${pre}qcash (id,name,value,minsale,maxsale,minqty,maxqty,minvalue,maxvalue," ;
	$sqlqc.= 	"posacc_id,start,endd,splan_id,notes) values " ;
	$sqlremark = "insert into ${pre}remark (id,name,description) values " ;
	$sqldef = "insert into ${pre}defaults (id,company,addr1,addr2,addr3,addr4,contact," ;
	$sqldef.= 	"inventory_accno_id,income_accno_id,expense_accno_id,nativecurr,weightunit," ;
	$sqldef.= 	"yearend,version,readonlygrp,inv_rmkid,rmd_rmkid,po_rmkid,quo_rmkid,sm_rmkid," ;
	$sqldef.= 	"aptax1cap,aptax2cap,aptax1pref,aptax2pref," ;
	$sqldef.= 	"artax1cap,artax2cap,artax1pref,artax2pref," ;
	$sqldef.= 	"postax1cap,postax2cap,postax1pref,postax2pref," ;
	$sqldef.=	"attrib1cap,attrib2cap,attrib3cap,attrib1tbl,attrib2tbl," ;
	$sqldef.= 	"attrib3tbl,attrib1sdesc,attrib2sdesc,attrib3sdesc,attrib1ldesc,attrib2ldesc," ;
	$sqldef.= 	"attrib3ldesc,attrib1tblmn,attrib2tblmn,attrib3tblmn,attrib1cnval," ;
	$sqldef.= 	"attrib2cnval,attrib3cnval,paypalyn,paymateyn,payasiayn," ;
	$sqldef.=	"photoyn,commyn,addressyn,ecyn,othersyn,paypalemail,paymateuname," ;
	$sqldef.=	"mndfactor,smdfactor,wkdfactor,mnhfactor,smhfactor,wkhfactor,dyhfactor," ;
	$sqldef.=	"centeryn,contactusyn,ledreportyn,custinfoyn,cttinfoyn,helpcaseyn,contractyn," ;
	$sqldef.=	"quoteyn,soyn,invoiceyn,ubsoyn,osinvyn,statementyn) values " ;
	$sqllock = "insert into ${pre}resourcelock (resource) values " ;
	$sqlachieve = "insert into ${pre}achievement (id,name,description) values " ;
	$sqli18ncode = "insert into ${pre}i18ncode (id,langcode,description,installed,charset) values " ;

/*--------------ck-admin CURRENCY codes ----------------------------------------------------*/

	$sqlval	= array ("'AUD','".exapi_lang('Australian Dollar')."','5.4')" ,
			"'CAD','".exapi_lang('Canadian Dollar')."','5.8')" ,
			"'CNY','".exapi_lang('Chinese Yuan Renminbi')."','0.9')" ,
			"'EUR','".exapi_lang('Euro')."','9')" ,
			"'HKD','".exapi_lang('Hong Kong Dollar')."','1')" ,
			"'MOP','".exapi_lang('Macau Pataca')."','1')" ,
			"'TWD','".exapi_lang('New Taiwanese Dollar')."','0.25')", 
			"'USD','".exapi_lang('United States Dollar')."','7.8')"
							) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqlcurr ('$sid',$sqlv");
		$sid++;
		}

	$lang_n_a = exapi_lang('not_applicable') ;
	$lang_na = exapi_lang('Not Applicable') ;
	$lang_nm = exapi_lang('Do not modify nor delete') ;
	$sqlval = "('$sid','$lang_n_a','$lang_na - $lang_nm')";
	$adodb->query($sqlachieve.$sqlval);						$sid++ ;

/*------------------ ck-contact CATEGORY AND CODE ------------------------------------------*/

	$lang_comm = strtolower(exapi_lang('comm')) ;
	$lang_org = strtolower(exapi_lang('org')) ;
	$lang_person = strtolower(exapi_lang('person')) ;
	$lang_country = strtolower(exapi_lang('country')) ;
	$lang_address = strtolower(exapi_lang('address')) ;
	$lang_hdomaddr = strtolower(exapi_lang('hdomaddr')) ;
	$lang_hintaddr = strtolower(exapi_lang('hintaddr')) ;
	$lang_parcaddr = strtolower(exapi_lang('parcaddr')) ;
	$lang_workaddr = strtolower(exapi_lang('workaddr')) ;
	$lang_billaddr = strtolower(exapi_lang('billaddr')) ;
	$lang_shipaddr = strtolower(exapi_lang('shipaddr')) ;
	$lang_prefix = strtolower(exapi_lang('prefix')) ;
	$lang_suffix = strtolower(exapi_lang('suffix')) ;
	$lang_region = strtolower(exapi_lang('region')) ;
	$lang_status = strtolower(exapi_lang('status')) ;
	
	$sqlval	= array (
		"'$lang_comm','".exapi_lang('email')."','".exapi_lang('Email')."')" ,
		"'$lang_comm','".exapi_lang('phone')."','".exapi_lang('Telephone')."')",
		"'$lang_comm','".exapi_lang('mphone')."','".exapi_lang('Mobile Telephone')."')",
		"'$lang_comm','".exapi_lang('fax')."','".exapi_lang('Fax')."')" ,
		"'$lang_comm','".exapi_lang('im')."','".exapi_lang('Instant Messaging')."')",
		"'$lang_comm','".exapi_lang('url')."','".exapi_lang('URL')."')" ,
		
		"'$lang_org','".exapi_lang('parent')."','".exapi_lang('Parent Organization')."')" ,
		"'$lang_org','".exapi_lang('vendor')."','".exapi_lang('Goods/Services Provider')."')" ,
		"'$lang_org','".exapi_lang('customer')."','".exapi_lang('Customer')."')" ,
		"'$lang_org','".exapi_lang('oem')."','".exapi_lang('Original Equipment Manufacturer')."')" ,
		"'$lang_org','".exapi_lang('magent')."','".exapi_lang('Marketing Agent')."')" ,
		"'$lang_org','".exapi_lang('employer')."','".exapi_lang('Employer')."')" ,
		"'$lang_org','".exapi_lang('sig')."','".exapi_lang('Special Interest Group')."')" ,
		"'$lang_org','".exapi_lang('lug')."','".exapi_lang('Linux User Group')."')" ,
		"'$lang_org','".exapi_lang('osorg')."','".exapi_lang('Open Source Software Org')."')" ,
		"'$lang_org','".exapi_lang('hobbygrp')."','".exapi_lang('Hobby Group')."')" ,

		"'$lang_person','".exapi_lang('emergency')."','".exapi_lang('Emergency Contact')."')" ,
		"'$lang_person','".exapi_lang('aliase')."','".exapi_lang('Aliase')."')" ,
		"'$lang_person','".exapi_lang('deputy')."','".exapi_lang('Deputy')."')" ,
		"'$lang_person','".exapi_lang('family')."','".exapi_lang('Family Member')."')" ,
		"'$lang_person','".exapi_lang('sales')."','".exapi_lang('Sales Contact')."')" ,
		"'$lang_person','".exapi_lang('purchase')."','".exapi_lang('Procurement Contact')."')" ,
		"'$lang_person','".exapi_lang('management')."','".exapi_lang('Senior Management Contact')."')" ,
		"'$lang_person','".exapi_lang('support')."','".exapi_lang('Technical Support Contact')."')" ,
		"'$lang_person','".exapi_lang('query')."','".exapi_lang('General Enquiry Contact')."')" ,
		"'$lang_person','".exapi_lang('legal')."','".exapi_lang('Legal Contact')."')" ,
		"'$lang_person','".exapi_lang('vendor')."','".exapi_lang('Goods/Services Provider')."')" ,
		"'$lang_person','".exapi_lang('customer')."','".exapi_lang('Customer')."')" ,
		
		"'$lang_country','".'AU'."','".exapi_lang('Australia')."')" ,
		"'$lang_country','".'CA'."','".exapi_lang('Canada')."')" ,
		"'$lang_country','".'DE'."','".exapi_lang('Federal Republic of Germany')."')" ,
		"'$lang_country','".'FR'."','".exapi_lang('French Republic')."')" ,
		"'$lang_country','".'HK'."','".exapi_lang('Hong Kong SAR, China')."')" ,
		"'$lang_country','".'MO'."','".exapi_lang('Macau SAR, China')."')" ,
		"'$lang_country','".'CN'."','".exapi_lang('People_s Republic of China')."')" ,
		"'$lang_country','".'CH'."','".exapi_lang('Swiss Confederation')."')" ,
		"'$lang_country','".'TW'."','".exapi_lang('Taiwan, Province of China')."')" ,
		"'$lang_country','".'US'."','".exapi_lang('United States of America (USA)')."')" ,

		"'$lang_address','$lang_hdomaddr','".exapi_lang('Home (Domestic) Address')."')" ,
		"'$lang_address','$lang_hintaddr','".exapi_lang('Home (International) Address')."')" ,
		"'$lang_address','$lang_parcaddr','".exapi_lang('Parcel Address')."')" ,
		"'$lang_address','$lang_workaddr','".exapi_lang('Work Address')."')" ,
		"'$lang_address','$lang_billaddr','".exapi_lang('Billing Address')."')" ,
		"'$lang_address','$lang_shipaddr','".exapi_lang('Shipping Address')."')" ,

		"'$lang_prefix','".'Mr'."','".exapi_lang('Mister')."')" ,
		"'$lang_prefix','".'Ms'."','".exapi_lang('Ms')."')" ,
		"'$lang_prefix','".'Sr'."','".exapi_lang('Senor')."')" ,
		"'$lang_prefix','".'Sra'."','".exapi_lang('Senorita')."')" ,

		"'$lang_suffix','".'esp'."','".exapi_lang('Esquire')."')" ,
		"'$lang_suffix','".'khan'."','".exapi_lang('Khan')."')" ,
		"'$lang_suffix','".'san'."','".exapi_lang('San')."')" ,
		"'$lang_suffix','".'singh'."','".exapi_lang('Singh')."')" ,

		"'$lang_region','HKG','".exapi_lang('Hong Kong SAR')."')" ,
		"'$lang_region','MAC','".exapi_lang('Macau SAR')."')" ,
		"'$lang_region','SSP','".exapi_lang('Sham Shui Po')."')" ,
		"'$lang_region','TST','".exapi_lang('Tsim Sha Tsui')."')" ,

					) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqlcategory ('$sid','ck-contact',$sqlv");
		switch ($key) :
			case "0" :	$catemail = $sid ;	break ;
			case "1" :	$catphone = $sid ;	break ;
			case "2" :	$catmphone = $sid ;	break ;
			case "3" :	$catfax = $sid ;	break ;
			case "4" :	$catim = $sid ;		break ;
			case "5" :	$caturl = $sid ;	break ;
			endswitch ;
		$sid++;
		}

	$sqlval	= array (
				"'".$lang_comm."','hemail','".exapi_lang('Home Email')."','$catemail')",
				"'".$lang_comm."','wemail','".exapi_lang('Work Email')."','$catemail')",
				"'".$lang_comm."','pemail','".exapi_lang('Project Email')."','$catemail')",
				"'".$lang_comm."','bemail','".exapi_lang('Billing Email')."','$catemail')",
				"'".$lang_comm."','semail','".exapi_lang('Shipping Email')."','$catemail')",
				"'".$lang_comm."','hphone','".exapi_lang('Home Phone')."','$catphone')",
				"'".$lang_comm."','wphone','".exapi_lang('Work Phone')."','$catphone')",
				"'".$lang_comm."','vphone','".exapi_lang('Voice Phone')."','$catphone')",
				"'".$lang_comm."','msgphone','".exapi_lang('Message Phone')."','$catphone')",
				"'".$lang_comm."','pager','".exapi_lang('Pager')."','$catphone')",
				"'".$lang_comm."','bbs','".exapi_lang('BBS Connection')."','$catphone')",
				"'".$lang_comm."','modem','".exapi_lang('Modem Link')."','$catphone')",
				"'".$lang_comm."','isdn','".exapi_lang('ISDN Phone')."','$catphone')",
				"'".$lang_comm."','video','".exapi_lang('Video Phone')."','$catphone')",
				"'".$lang_comm."','cellphone','".exapi_lang('Cell Phone')."','$catmphone')",
				"'".$lang_comm."','carphone','".exapi_lang('Car Phone')."','$catmphone')",
				"'".$lang_comm."','hfax','".exapi_lang('Home Fax')."','$catfax')",
				"'".$lang_comm."','wfax','".exapi_lang('Work Fax')."','$catfax')",
				"'".$lang_comm."','bfax','".exapi_lang('Billing Fax')."','$catfax')",
				"'".$lang_comm."','sfax','".exapi_lang('Shipping Fax')."','$catfax')",
				"'".$lang_comm."','msn','".exapi_lang('MSN messaging')."','$catim')",
				"'".$lang_comm."','aim','".exapi_lang('AOL messaging')."','$catim')",
				"'".$lang_comm."','yahoo','".exapi_lang('YAHOO messaging')."','$catim')",
				"'".$lang_comm."','icq','".exapi_lang('ICQ messaging')."','$catim')",
				"'".$lang_comm."','jabber','".exapi_lang('JABBER messaging')."','$catim')",
				"'".$lang_comm."','qq','".exapi_lang('QQ messaging')."','$catim')",
				"'".$lang_comm."','website','".exapi_lang('Website Address')."','$caturl')",
				"'".$lang_comm."','forum','".exapi_lang('Web Forum Address')."','$caturl')",
				"'".$lang_comm."','irc','".exapi_lang('IRC Server/Channel Address')."','$caturl')",
				"'".$lang_comm."','ml','".exapi_lang('Mailing List Address')."','$caturl')",
				"'".$lang_comm."','newsgroup','".exapi_lang('Newsgroup Address')."','$caturl')",
				"'".$lang_comm."','blog','".exapi_lang('BLOG Address')."','$caturl')",
										) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqlcategory1 ('$sid','ck-contact',$sqlv");
		$sid++;
		}

/*------------------ ck-crm CATEGORY AND CODE ------------------------------------------*/

	$lang_customer = strtolower(exapi_lang('customer')) ;
	$lang_term = strtolower(exapi_lang('term')) ;
	$lang_helpcase = strtolower(exapi_lang('helpcase')) ;
	$lang_helpcall = strtolower(exapi_lang('helpcall')) ;
	$lang_salecase = strtolower(exapi_lang('salecase')) ;
	$lang_salecall = strtolower(exapi_lang('salecall')) ;
	$lang_media = strtolower(exapi_lang('media')) ;
	$lang_cstate = strtolower(exapi_lang('cstate')) ;
	$lang_priority = strtolower(exapi_lang('priority')) ;
	$lang_closure = strtolower(exapi_lang('closure')) ;
	$sqlval	= array (
		"'$lang_customer','".exapi_lang('VIP')."','".exapi_lang('Very Important Customer')."')" ,
		"'$lang_customer','".exapi_lang('premium')."','".exapi_lang('Premium Customer')."')" ,
		"'$lang_customer','".exapi_lang('general')."','".exapi_lang('General Ordinary Customer')."')" ,
		"'$lang_customer','".exapi_lang('others')."','".exapi_lang('Other types of Customer')."')" ,
		"'$lang_customer','".exapi_lang('delinquent')."','".exapi_lang('Customer with major debt(s) in arrear')."')" ,
		"'$lang_term','".exapi_lang('plan30')."','".exapi_lang('($30/month) * 12 payments')."')" ,
		"'$lang_term','".exapi_lang('plan30a')."','".exapi_lang('$330 annual fee; prepayment')."')" ,
		"'$lang_term','".exapi_lang('serv24x7')."','".exapi_lang('24x7 service; guarantee uptime 98%')."')" ,
		"'$lang_term','".exapi_lang('exit1')."','".exapi_lang('written notice; no refund')."')" ,
		"'$lang_term','".exapi_lang('exit2')."','".exapi_lang('w. notice; prorata refund; $100 penalty')."')" ,
		"'$lang_helpcase','".exapi_lang('enquiry')."','".exapi_lang('Enquiry from (prospective) client')."')" ,
		"'$lang_helpcase','".exapi_lang('suggestion')."','".exapi_lang('Suggestion from (prospective) client')."')" ,
		"'$lang_helpcase','".exapi_lang('request')."','".exapi_lang('Support request from existing client')."')",
		"'$lang_helpcase','".exapi_lang('complaint')."','".exapi_lang('Complaint from (prospective) client')."')" ,
		"'$lang_helpcase','".exapi_lang('complement')."','".exapi_lang('Commendation on product / service')."')",
		"'$lang_helpcase','".exapi_lang('bugreport')."','".exapi_lang('Report on bugs and errors discovered')."')" ,
		"'$lang_helpcall','".exapi_lang('initial')."','".exapi_lang('Initial call from (prospective) client')."')" ,
		"'$lang_helpcall','".exapi_lang('research')."','".exapi_lang('Investigation into the reported case')."')" ,
		"'$lang_helpcall','".exapi_lang('resolution')."','".exapi_lang('Action to resolve issues raised')."')",
		"'$lang_helpcall','".exapi_lang('followup')."','".exapi_lang('Followup action (post resolution)')."')" ,
		"'$lang_helpcall','$lang_closure','".exapi_lang('Final closure of subject case log')."')" ,
		"'$lang_salecase','".exapi_lang('enquiry')."','".exapi_lang('Sales enquiry from (prospective) client')."')" ,
		"'$lang_salecase','".exapi_lang('referral')."','".exapi_lang('Sales opportunity referred in by 3rd party')."')" ,
		"'$lang_salecase','".exapi_lang('regular')."','".exapi_lang('Regular sale call on existing client')."')" ,
		"'$lang_salecase','".exapi_lang('campaign')."','".exapi_lang('Sale campaign call on client')."')" ,
		"'$lang_salecase','".exapi_lang('coldcall')."','".exapi_lang('Self initiated contact with client')."')" ,
		"'$lang_salecase','".exapi_lang('tender')."','".exapi_lang('Sale case with lengthy tendering process')."')" ,
		"'$lang_salecall','".exapi_lang('initial')."','".exapi_lang('Initial call from/to client')."')" ,
		"'$lang_salecall','".exapi_lang('research')."','".exapi_lang('Research into client requirements')."')" ,
		"'$lang_salecall','".exapi_lang('promote')."','".exapi_lang('Action to promote competitive edge')."')" ,
		"'$lang_salecall','".exapi_lang('checkcomp')."','".exapi_lang('Identify/Evaluate potential competitors')."')",
		"'$lang_salecall','".exapi_lang('estimate')."','".exapi_lang('Estimate potential sales proceeds')."')" ,
		"'$lang_salecall','".exapi_lang('quote')."','".exapi_lang('Provide sale quotation to client')."')" ,
		"'$lang_salecall','".exapi_lang('negotiate')."','".exapi_lang('Negotiate terms of sales with client')."')" ,
		"'$lang_salecall','".exapi_lang('followup')."','".exapi_lang('Followup action (post sale win/lost')."')",
		"'$lang_salecall','".exapi_lang('close_win')."','".exapi_lang('Closure with sales win')."')" ,
		"'$lang_salecall','".exapi_lang('close_lost')."','".exapi_lang('Closure with sales lost')."')" ,

		"'$lang_media','".exapi_lang('phone')."','".exapi_lang('Telephone conversation')."')" ,
		"'$lang_media','".exapi_lang('email')."','".exapi_lang('Email communication')."')" ,
		"'$lang_media','".exapi_lang('fax')."','".exapi_lang('Facsimile')."')" ,
		"'$lang_media','".exapi_lang('letter')."','".exapi_lang('Letter Mail')."')" ,
		"'$lang_media','".exapi_lang('im')."','".exapi_lang('Instant Messaging')."')" ,
		"'$lang_media','".exapi_lang('sms')."','".exapi_lang('Short Message Service')."')" ,
		"'$lang_media','".exapi_lang('meeting')."','".exapi_lang('F2F Meeting / Onsite Visit')."')" ,
		"'$lang_media','".exapi_lang('videoconf')."','".exapi_lang('Video Conference')."')" ,
		"'$lang_media','".exapi_lang('website')."','".exapi_lang('Website / Portal / Forum posting')."')" ,
		"'$lang_media','".exapi_lang('others')."','".exapi_lang('Other communication medium')."')" ,
		"'$lang_cstate','".exapi_lang('furious')."','".exapi_lang('Customer furious about the case')."')" ,
		"'$lang_cstate','".exapi_lang('angry')."','".exapi_lang('Customer angry about the case')."')" ,
		"'$lang_cstate','".exapi_lang('annoyed')."','".exapi_lang('Customer mildly annoyed')."')" ,
		"'$lang_cstate','".exapi_lang('neutral')."','".exapi_lang('Customer being indifferent')."')" ,
		"'$lang_cstate','".exapi_lang('pleased')."','".exapi_lang('Customer happy with us')."')" ,
		"'$lang_cstate','".exapi_lang('excited')."','".exapi_lang('Customer excited with our offerring')."')" ,
		"'$lang_cstate','".exapi_lang('worry')."','".exapi_lang('Customer worry about the reported case')."')" ,
		"'$lang_priority','".exapi_lang('v.high')."','".exapi_lang('Very High')."')" ,
		"'$lang_priority','".exapi_lang('high')."','".exapi_lang('High')."')" ,
		"'$lang_priority','".exapi_lang('neutral')."','".exapi_lang('Neutral')."')" ,
		"'$lang_priority','".exapi_lang('low')."','".exapi_lang('Low')."')" ,
		"'$lang_priority','".exapi_lang('v.low')."','".exapi_lang('Very Low')."')" ,
						) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqlcategory ('$sid','ck-crm',$sqlv");
		$sid++;
		}

/*------------------ ck-vrm CATEGORY AND CODE ------------------------------------------*/

	$lang_vendor = strtolower(exapi_lang('vendor')) ;
	$lang_vendcase = strtolower(exapi_lang('vendcase')) ;
	$lang_vendcall = strtolower(exapi_lang('vendcall')) ;
	$lang_vstate = strtolower(exapi_lang('vstate')) ;
	$sqlval	= array (
		"'$lang_vendor','".exapi_lang('related')."','".exapi_lang('Vendor related to our company')."')" ,
		"'$lang_vendor','".exapi_lang('allied')."','".exapi_lang('Vendor with Corporate Alliance')."')" ,
		"'$lang_vendor','".exapi_lang('preferred')."','".exapi_lang('Preferred Supplier')."')" ,
		"'$lang_vendor','".exapi_lang('general')."','".exapi_lang('General Ordinary Vendor')."')" ,
		"'$lang_vendor','".exapi_lang('firsttime')."','".exapi_lang('First Time Supplier')."')" ,
		"'$lang_vendor','".exapi_lang('others')."','".exapi_lang('Other types of Vendor')."')" ,
		"'$lang_term','".exapi_lang('hklaw')."','".exapi_lang('Hong Kong law applies')."')" ,
		"'$lang_term','".exapi_lang('certcompl')."','".exapi_lang('Require Certificate of Completion')."')" ,
		"'$lang_term','".exapi_lang('pay1m')."','".exapi_lang('Payment within 1 month')."')" ,
		"'$lang_term','".exapi_lang('pay2m')."','".exapi_lang('Payment within 2 months')."')" ,
		"'$lang_term','".exapi_lang('emailcomm')."','".exapi_lang('All communications to be via email')."')" ,
		"'$lang_vendcase','".exapi_lang('coldcall')."','".exapi_lang('Self initiated contact from vendor')."')" ,
		"'$lang_vendcase','".exapi_lang('assess')."','".exapi_lang('Preferred Supplier Assessment')."')" ,
		"'$lang_vendcase','".exapi_lang('rfi')."','".exapi_lang('Request for Information from Vendor')."')" ,
		"'$lang_vendcase','".exapi_lang('preorder')."','".exapi_lang('Pre-Order Award Process')."')" ,
		"'$lang_vendcase','".exapi_lang('tender')."','".exapi_lang('Procurement with lengthy tendering process')."')" ,
		"'$lang_vendcase','".exapi_lang('chaseorder')."','".exapi_lang('Chase up on goods/service delivery')."')" ,
		"'$lang_vendcase','".exapi_lang('complaint')."','".exapi_lang('Complaint on delivered Goods/Service')."')" ,
		"'$lang_vendcall','".exapi_lang('initial')."','".exapi_lang('Initial call from/to vendor')."')" ,
		"'$lang_vendcall','".exapi_lang('research')."','".exapi_lang('Research into requirement/problem')."')" ,
		"'$lang_vendcall','".exapi_lang('estimate')."','".exapi_lang('Estimate monetary ramification')."')" ,
		"'$lang_vendcall','".exapi_lang('quote')."','".exapi_lang('Quotation provided by Vendor')."')" ,
		"'$lang_vendcall','".exapi_lang('negotiate')."','".exapi_lang('Negotiate purchase/settlement with vendor')."')" ,
		"'$lang_vendcall','".exapi_lang('stoppay')."','".exapi_lang('Stop payment pending solution/ settlement')."')" ,
		"'$lang_vendcall','".exapi_lang('award')."','".exapi_lang('Order/Tender awarded to vendor')."')" ,
		"'$lang_vendcall','".exapi_lang('rectify')."','".exapi_lang('Action to rectify problem')."')" ,
		"'$lang_vendcall','".exapi_lang('followup')."','".exapi_lang('Followup action (post order/settlement)')."')",
		"'$lang_vendcall','".exapi_lang('close')."','".exapi_lang('Closure')."')" ,

		"'$lang_media','".exapi_lang('phone')."','".exapi_lang('Telephone conversation')."')" ,
		"'$lang_media','".exapi_lang('email')."','".exapi_lang('Email communication')."')" ,
		"'$lang_media','".exapi_lang('fax')."','".exapi_lang('Facsimile')."')" ,
		"'$lang_media','".exapi_lang('letter')."','".exapi_lang('Letter Mail')."')" ,
		"'$lang_media','".exapi_lang('im')."','".exapi_lang('Instant Messaging')."')" ,
		"'$lang_media','".exapi_lang('sms')."','".exapi_lang('Short Message Service')."')" ,
		"'$lang_media','".exapi_lang('meeting')."','".exapi_lang('F2F Meeting / Onsite Visit')."')" ,
		"'$lang_media','".exapi_lang('videoconf')."','".exapi_lang('Video Conference')."')" ,
		"'$lang_media','".exapi_lang('website')."','".exapi_lang('Website / Portal / Forum posting')."')" ,
		"'$lang_media','".exapi_lang('others')."','".exapi_lang('Other communication medium')."')" ,
		"'$lang_vstate','".exapi_lang('denial')."','".exapi_lang('Vendor denies any wrong doing')."')" ,
		"'$lang_vstate','".exapi_lang('ntr')."','".exapi_lang('Vendor claims not their responsibility')."')" ,
		"'$lang_vstate','".exapi_lang('dispute')."','".exapi_lang('Vendor disputes what happens')."')" ,
		"'$lang_vstate','".exapi_lang('indiff')."','".exapi_lang('Vendor being indifferent')."')" ,
		"'$lang_vstate','".exapi_lang('helpful')."','".exapi_lang('Vendor eager to help')."')" ,
		"'$lang_vstate','".exapi_lang('apologetic')."','".exapi_lang('Vendor apologies for error')."')" ,
		"'$lang_priority','".exapi_lang('v.high')."','".exapi_lang('Very High')."')" ,
		"'$lang_priority','".exapi_lang('high')."','".exapi_lang('High')."')" ,
		"'$lang_priority','".exapi_lang('neutral')."','".exapi_lang('Neutral')."')" ,
		"'$lang_priority','".exapi_lang('low')."','".exapi_lang('Low')."')" ,
		"'$lang_priority','".exapi_lang('v.low')."','".exapi_lang('Very Low')."')" ,
						) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqlcategory ('$sid','ck-vrm',$sqlv");
		$sid++;
		}

/*------------------ ck-hr CATEGORY AND CODE ------------------------------------------*/

	$lang_grade = strtolower(exapi_lang('grade')) ;
	$lang_date = strtolower(exapi_lang('date')) ;
	$lang_leave = strtolower(exapi_lang('leave')) ;
	$lang_signin = strtolower(exapi_lang('sign-in')) ;
	$lang_signout = strtolower(exapi_lang('sign-out')) ;
	$lang_activity = strtolower(exapi_lang('activity')) ;
	$lang_relation = strtolower(exapi_lang('relation')) ;
	$lang_ec = strtolower(exapi_lang('ec')) ;
	$lang_pr = strtolower(exapi_lang('pr')) ;
	$lang_role = strtolower(exapi_lang('role')) ;
	$lang_status = strtolower(exapi_lang('status')) ;
		
	$sqlval	= array (
	
		"'$lang_comm','".exapi_lang('email')."','".exapi_lang('Email')."')" ,
		"'$lang_comm','".exapi_lang('phone')."','".exapi_lang('Telephone')."')",
		"'$lang_comm','".exapi_lang('mphone')."','".exapi_lang('Mobile Telephone')."')",
		"'$lang_comm','".exapi_lang('fax')."','".exapi_lang('Fax')."')" ,
		"'$lang_comm','".exapi_lang('im')."','".exapi_lang('Instant Messaging')."')",
		"'$lang_comm','".exapi_lang('url')."','".exapi_lang('URL')."')" ,
		
		"'$lang_country','".'AU'."','".exapi_lang('Australia')."')" ,
		"'$lang_country','".'CA'."','".exapi_lang('Canada')."')" ,
		"'$lang_country','".'DE'."','".exapi_lang('Federal Republic of Germany')."')" ,
		"'$lang_country','".'FR'."','".exapi_lang('French Republic')."')" ,
		"'$lang_country','".'HK'."','".exapi_lang('Hong Kong SAR, China')."')" ,
		"'$lang_country','".'MO'."','".exapi_lang('Macau SAR, China')."')" ,
		"'$lang_country','".'CN'."','".exapi_lang('People_s Republic of China')."')" ,
		"'$lang_country','".'CH'."','".exapi_lang('Swiss Confederation')."')" ,
		"'$lang_country','".'TW'."','".exapi_lang('Taiwan, Province of China')."')" ,
		"'$lang_country','".'US'."','".exapi_lang('United States of America (USA)')."')" ,

		"'$lang_address','$lang_hdomaddr','".exapi_lang('Home (Domestic) Address')."')" ,
		"'$lang_address','$lang_hintaddr','".exapi_lang('Home (International) Address')."')" ,
		"'$lang_address','$lang_parcaddr','".exapi_lang('Parcel Address')."')" ,
		"'$lang_address','$lang_workaddr','".exapi_lang('Work Address')."')" ,
		"'$lang_address','$lang_billaddr','".exapi_lang('Billing Address')."')" ,
		"'$lang_address','$lang_shipaddr','".exapi_lang('Shipping Address')."')" ,

		"'$lang_prefix','".'Mr'."','".exapi_lang('Mister')."')" ,
		"'$lang_prefix','".'Ms'."','".exapi_lang('Ms')."')" ,
		"'$lang_prefix','".'Sr'."','".exapi_lang('Senor')."')" ,
		"'$lang_prefix','".'Sra'."','".exapi_lang('Senorita')."')" ,

		"'$lang_suffix','".'esp'."','".exapi_lang('Esquire')."')" ,
		"'$lang_suffix','".'khan'."','".exapi_lang('Khan')."')" ,
		"'$lang_suffix','".'san'."','".exapi_lang('San')."')" ,
		"'$lang_suffix','".'singh'."','".exapi_lang('Singh')."')" ,
		
		"'$lang_region','HKG','".exapi_lang('Hong Kong SAR')."')" ,
		"'$lang_region','MAC','".exapi_lang('MAC SAR')."')" ,
		"'$lang_region','SSP','".exapi_lang('Sham Shui Po')."')" ,
		"'$lang_region','TST','".exapi_lang('Tsim Sha Tsui')."')" ,
		
		"'$lang_status','".exapi_lang('management')."','".exapi_lang('Management Staff')."')" ,
		"'$lang_status','".exapi_lang('expatriate')."','".exapi_lang('Expatriate Staff')."')" ,
		"'$lang_status','".exapi_lang('localstaff')."','".exapi_lang('Local Staff')."')" ,
		"'$lang_status','".exapi_lang('trainee')."','".exapi_lang('Staff under trainee program')."')" ,
		"'$lang_status','".exapi_lang('tempstaff')."','".exapi_lang('Temporary Staff')."')" ,
		"'$lang_status','".exapi_lang('second_in')."','".exapi_lang('Staff seconded in from outside')."')" ,
		"'$lang_status','".exapi_lang('second_out')."','".exapi_lang('Staff seconded to other organisation')."')" ,
		"'$lang_status','".exapi_lang('student')."','".exapi_lang('Staff under Student Placement Program')."')" ,

		"'$lang_grade','BD','".exapi_lang('Board of Directors')."')" ,
		"'$lang_grade','CEO','".exapi_lang('Chief Executive Officer')."')" ,
		"'$lang_grade','P','".exapi_lang('President')."')" ,
		"'$lang_grade','VP','".exapi_lang('Vice President')."')" ,
		"'$lang_grade','DVP','".exapi_lang('Deputy Vice President')."')" ,
		"'$lang_date','BA','".exapi_lang('Birthday Anniversary')."')" ,
		"'$lang_date','BD','".exapi_lang('Birthday')."')" ,
		"'$lang_date','C1','".exapi_lang('Contract 1 ends')."')" ,
		"'$lang_date','C2','".exapi_lang('Contract 2 ends')."')" ,
		"'$lang_date','HD','".exapi_lang('Hire Day')."')" ,
		"'$lang_date','PC','".exapi_lang('Probation Completion Day')."')" ,
		"'$lang_date','P1','".exapi_lang('Performance Review Date 1')."')" ,
		"'$lang_date','P2','".exapi_lang('Performance Review Date 2')."')" ,
		"'$lang_date','S1','".exapi_lang('Salary Review Date 1')."')" ,
		"'$lang_date','S2','".exapi_lang('Salary Review Date 2')."')" ,
		"'$lang_date','TD','".exapi_lang('Termination Date')."')" ,
		"'$lang_leave','AL','".exapi_lang('Annual Leave')."')" ,
		"'$lang_leave','CL','".exapi_lang('Compationate Leave')."')" ,
		"'$lang_leave','JI','".exapi_lang('Leave due to Job Injury')."')" ,
		"'$lang_leave','JS','".exapi_lang('Jury Service')."')" ,
		"'$lang_leave','ML','".exapi_lang('Maternity Leave')."')" ,
		"'$lang_leave','SL','".exapi_lang('Sick Leave')."')" ,
		"'$lang_leave','UA','".exapi_lang('Unauthorised Absence')."')" ,
		"'$lang_leave','UL','".exapi_lang('Unpaid Leave')."')" ,
		"'$lang_signin','SOS','".exapi_lang('Start of shift')."')" ,
		"'$lang_signin','RMB','".exapi_lang('Return (meal break)')."')" ,
		"'$lang_signin','RMWC','".exapi_lang('Return (meeting w/ client)')."')" ,
		"'$lang_signin','RMWV','".exapi_lang('Return (meeting w/ vendor)')."')" ,
		"'$lang_signin','RSMA','".exapi_lang('Return (meeting w/ doctor)')."')" ,
		"'$lang_signin','RUD','".exapi_lang('Return (urgent duty)')."')" ,
		"'$lang_signin','RST','".exapi_lang('Return (staff training)')."')" ,
		"'$lang_signin','RMPD','".exapi_lang('Return (purchase/delivery)')."')" ,
		"'$lang_signout','EOS','".exapi_lang('End of shift')."')" ,
		"'$lang_signout','MB','".exapi_lang('Meal Break')."')" ,
		"'$lang_signout','MWC','".exapi_lang('Meeting with client')."')" ,
		"'$lang_signout','MWV','".exapi_lang('Meeting with vendor')."')" ,
		"'$lang_signout','EES','".exapi_lang('Early exit - sick')."')" ,
		"'$lang_signout','EEWI','".exapi_lang('Early exit - work injury')."')" ,
		"'$lang_signout','ST','".exapi_lang('Staff Training')."')" ,
		"'$lang_signout','UDS','".exapi_lang('Urgent duty (supervisor auth.)')."')" ,
		"'$lang_signout','MPD','".exapi_lang('Miscel. purchase/delivery')."')" ,
		"'$lang_activity','CLTRA','".exapi_lang('Conducting Training Class')."')" ,
		"'$lang_activity','COPRO','".exapi_lang('Sewing Collar onto Shirt')."')" ,
		"'$lang_activity','DOPRO','".exapi_lang('Processing Legal Document')."')" ,
		"'$lang_activity','OFSUP','".exapi_lang('Office Support Work')."')" ,
		"'$lang_activity','PCASS','".exapi_lang('Assembling X86 PC Units')."')" ,
		"'$lang_activity','PROGM','".exapi_lang('Writing Computer Program')."')" ,
		"'$lang_activity','SYSAN','".exapi_lang('Analysing System Setup')."')" ,
		"'$lang_activity','SYSDE','".exapi_lang('Designing Computer System')."')" ,
		"'$lang_relation','PA','".exapi_lang('Parent')."')" ,
		"'$lang_relation','BS','".exapi_lang('Brother/Sister')."')" ,
		"'$lang_relation','CH','".exapi_lang('Child')."')" ,
		"'$lang_relation','GP','".exapi_lang('Grand Parent')."')" ,
		"'$lang_relation','GC','".exapi_lang('Grand Child')."')" ,
		"'$lang_relation','UA','".exapi_lang('Uncle/Aunt')."')" ,
		"'$lang_relation','CS','".exapi_lang('Cousin')."')" ,
		"'$lang_relation','FM','".exapi_lang('Other Family Member')."')" ,
		"'$lang_relation','NB','".exapi_lang('Neighbour')."')" ,
		"'$lang_ec','EC1','".exapi_lang('Emergency Contact 1')."')" ,
		"'$lang_ec','EC2','".exapi_lang('Emergency Contact 2')."')" ,
		"'$lang_ec','EC3','".exapi_lang('Emergency Contact 3')."')" ,
		"'$lang_ec','NK','".exapi_lang('Next of Kin')."')" ,
		"'$lang_pr','PR0','".exapi_lang('Awful - Warning TBC')."')" ,
		"'$lang_pr','PR1','".exapi_lang('Very Poor')."')" ,
		"'$lang_pr','PR2','".exapi_lang('Poor')."')" ,
		"'$lang_pr','PR3','".exapi_lang('Undesirable')."')" ,
		"'$lang_pr','PR4','".exapi_lang('Below Par')."')" ,
		"'$lang_pr','PR5','".exapi_lang('Acceptable')."')" ,
		"'$lang_pr','PR6','".exapi_lang('Fine')."')" ,
		"'$lang_pr','PR7','".exapi_lang('Good')."')" ,
		"'$lang_pr','PR8','".exapi_lang('Very Good')."')" ,
		"'$lang_pr','PR9','".exapi_lang('Excellent - Award TBC')."')" ,
		"'$lang_role','SysAdm','".exapi_lang('System Administrator')."')" ,
		"'$lang_role','AccAdm','".exapi_lang('Accounting Administrator')."')" ,
		"'$lang_role','AccMgr','".exapi_lang('Accounting Manager')."')" ,
		"'$lang_role','Auditor','".exapi_lang('Auditor')."')" ,
		"'$lang_role','AudMgr','".exapi_lang('Audit Manager')."')" ,
		"'$lang_role','InvAdm','".exapi_lang('Inventory Administrator')."')" ,
		"'$lang_role','InvMgr','".exapi_lang('Inventory Manager')."')" ,
		"'$lang_role','SvcAdm','".exapi_lang('Service Administrator')."')" ,
		"'$lang_role','SvcMgr','".exapi_lang('Service Manager')."')" ,
		"'$lang_role','APAdm','".exapi_lang('Accounts Payable Administrator')."')" ,
		"'$lang_role','APMgr','".exapi_lang('Accounts Payable Manager')."')" ,
		"'$lang_role','ARAdm','".exapi_lang('Accounts Receivable Administrator')."')" ,
		"'$lang_role','ARMgr','".exapi_lang('Accounts Receivable Manager')."')" ,
		"'$lang_role','PurAdm','".exapi_lang('Purchasing Administrator')."')" ,
		"'$lang_role','PurMgr','".exapi_lang('Purchasing Manager')."')" ,
		"'$lang_role','SalAdm','".exapi_lang('Sales Administrator')."')" ,
		"'$lang_role','SalMgr','".exapi_lang('Sales Manager')."')" ,
		"'$lang_role','CSAdm','".exapi_lang('Cash Sale Administrator - Cashier')."')" ,
		"'$lang_role','CSMgr','".exapi_lang('Cash Sale Manager')."')" ,
		"'$lang_role','HRAdm','".exapi_lang('Human Resources Administrator')."')" ,
		"'$lang_role','HRMgr','".exapi_lang('Human Resources Manager')."')" ,
		"'$lang_role','PyrAdm','".exapi_lang('Payroll Administrator')."')" ,
		"'$lang_role','PyrMgr','".exapi_lang('Payroll Manager')."')" ,
						) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqlcategory ('$sid','ck-hr',$sqlv");
		switch ($key) :
			case "0" :	$catemail = $sid ;	break ;
			case "1" :	$catphone = $sid ;	break ;
			case "2" :	$catmphone = $sid ;	break ;
			case "3" :	$catfax = $sid ;	break ;
			case "4" :	$catim = $sid ;		break ;
			case "5" :	$caturl = $sid ;	break ;
			endswitch ;
		$sid++;
		}

	$sqlval	= array (
				"'".$lang_comm."','hemail','".exapi_lang('Home Email')."','$catemail')",
				"'".$lang_comm."','wemail','".exapi_lang('Work Email')."','$catemail')",
				"'".$lang_comm."','pemail','".exapi_lang('Project Email')."','$catemail')",
				"'".$lang_comm."','bemail','".exapi_lang('Billing Email')."','$catemail')",
				"'".$lang_comm."','semail','".exapi_lang('Shipping Email')."','$catemail')",
				"'".$lang_comm."','hphone','".exapi_lang('Home Phone')."','$catphone')",
				"'".$lang_comm."','wphone','".exapi_lang('Work Phone')."','$catphone')",
				"'".$lang_comm."','vphone','".exapi_lang('Voice Phone')."','$catphone')",
				"'".$lang_comm."','msgphone','".exapi_lang('Message Phone')."','$catphone')",
				"'".$lang_comm."','pager','".exapi_lang('Pager')."','$catphone')",
				"'".$lang_comm."','bbs','".exapi_lang('BBS Connection')."','$catphone')",
				"'".$lang_comm."','modem','".exapi_lang('Modem Link')."','$catphone')",
				"'".$lang_comm."','isdn','".exapi_lang('ISDN Phone')."','$catphone')",
				"'".$lang_comm."','video','".exapi_lang('Video Phone')."','$catphone')",
				"'".$lang_comm."','cellphone','".exapi_lang('Cell Phone')."','$catmphone')",
				"'".$lang_comm."','carphone','".exapi_lang('Car Phone')."','$catmphone')",
				"'".$lang_comm."','hfax','".exapi_lang('Home Fax')."','$catfax')",
				"'".$lang_comm."','wfax','".exapi_lang('Work Fax')."','$catfax')",
				"'".$lang_comm."','bfax','".exapi_lang('Billing Fax')."','$catfax')",
				"'".$lang_comm."','sfax','".exapi_lang('Shipping Fax')."','$catfax')",
				"'".$lang_comm."','msn','".exapi_lang('MSN messaging')."','$catim')",
				"'".$lang_comm."','aim','".exapi_lang('AOL messaging')."','$catim')",
				"'".$lang_comm."','yahoo','".exapi_lang('YAHOO messaging')."','$catim')",
				"'".$lang_comm."','icq','".exapi_lang('ICQ messaging')."','$catim')",
				"'".$lang_comm."','jabber','".exapi_lang('JABBER messaging')."','$catim')",
				"'".$lang_comm."','qq','".exapi_lang('QQ messaging')."','$catim')",
				"'".$lang_comm."','website','".exapi_lang('Website Address')."','$caturl')",
				"'".$lang_comm."','forum','".exapi_lang('Web Forum Address')."','$caturl')",
				"'".$lang_comm."','irc','".exapi_lang('IRC Server/Channel Address')."','$caturl')",
				"'".$lang_comm."','ml','".exapi_lang('Mailing List Address')."','$caturl')",
				"'".$lang_comm."','newsgroup','".exapi_lang('Newsgroup Address')."','$caturl')",
				"'".$lang_comm."','blog','".exapi_lang('BLOG Address')."','$caturl')",
										) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqlcategory1 ('$sid','ck-hr',$sqlv");
		$sid++;
		}

/*------------------------------------------------------------------------------------*/

	$warning = exapi_lang('Do not Modify nor Delete');
	$____myself = exapi_lang('____Myself') ;
	$____cash = exapi_lang('____Cash') ;
	$dummy = exapi_lang('Dummy Contact') ;
	$sqlval = "('$sid','$____cash','$dummy','$warning')";
	$adodb->query($sqlorg.$sqlval);			$org_cash=$sid;		$sid++ ;
	$sqlval = "('$sid','$____myself','$dummy','$warning')";
	$adodb->query($sqlorg.$sqlval);			$org_self=$sid;		$sid++ ;
	$sqlval = "('$sid','$org_cash','$____cash','f')";
	$adodb->query($sqlcust.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$org_self','$____myself','f')";
	$adodb->query($sqlcust.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$org_self','$____myself','f')";
	$adodb->query($sqlvend.$sqlval);						$sid++ ;

	$ac2310 = isset($ac2310) ? $ac2310 : 0 ;
	$ac2311 = isset($ac2311) ? $ac2311 : 0 ;
	$ac2319 = isset($ac2319) ? $ac2319 : 0 ;
	$ac1070 = isset($ac1070) ? $ac1070 : 0 ;
	$ac1200 = isset($ac1200) ? $ac1200 : 0 ;
	$ac1060 = isset($ac1060) ? $ac1060 : 0 ;
	$ac1075 = isset($ac1075) ? $ac1075 : 0 ;
	$ac5613 = isset($ac5613) ? $ac5613 : 0 ;
	$ac1520 = isset($ac1520) ? $ac1520 : 0 ;
	$ac4020 = isset($ac4020) ? $ac4020 : 0 ;
	$ac5020 = isset($ac5020) ? $ac5020 : 0 ;

	$sqlval = "('$sid','$ac2310',0.07,'".exapi_lang('CA GST collected on sales (from customer)')."','ar')";
	$adodb->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac2311',0.08,'".exapi_lang('CA PST collected on sales (from customer)')."','ar')";
	$adodb->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac1310',0.07,'".exapi_lang('CA GST paid on purchases/expenses (to vendor)')."','ap')";
	$adodb->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac1311',0.08,'".exapi_lang('CA PST paid on purchases/expenses (to vendor)')."','ap')";
	$adodb->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac2310',0.07,'".exapi_lang('CA GST collected on cash sale')."','cs')";
	$adodb->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac2311',0.08,'".exapi_lang('CA PST collected on cash sale')."','cs')";
	$adodb->query($sqltax.$sqlval);						$sid++ ;
	$sqlval = "('$sid','$ac2319',0.1,'".exapi_lang('Local VAT collected on cash sale')."','cs')";
	$adodb->query($sqltax.$sqlval);						$sid++ ;
//	Local VAT is needed for POS Audit Control Report

	$sqlval = "('$sid','".exapi_lang('Cash')."','0','0','999999','0','9999','0','10000'," ;
	$sqlval.= "'$ac1070','1970-01-01','2038-01-01','0','".exapi_lang('Multiple Cash Tender allowed')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('Visa Card')."','0','100','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".exapi_lang('Visa Credit Card.  Be sure to check signature')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('Master Card')."','0','100','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".exapi_lang('Master Credit Card.  Be sure to check signature')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('AE Card')."','0','100','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".exapi_lang('American Express Credit Card.  Be sure to check signature')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('Octopus Card')."','0','0','9999','0','9999','0','999'," ;
	$sqlval.= "'$ac1200','1970-01-01','2038-01-01','0','".exapi_lang('Stored Value Smart Card')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('EPS')."','0','0','99999','0','9999','0','9999'," ;
	$sqlval.= "'$ac1060','1970-01-01','2038-01-01','0','".exapi_lang('Electronic Payment System providing direct bank account transfer')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('Personal Cheque')."','0','100','99999','0','9999','0','5000'," ;
	$sqlval.= "'$ac1075','1970-01-01','2038-01-01','0','".exapi_lang('Personal Cheque - must check against PHOTOED ID')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('Bank Cheque')."','0','0','999999','0','9999','0','99999'," ;
	$sqlval.= "'$ac1075','1970-01-01','2038-01-01','0','".exapi_lang('Bank Cheque - MUST BE ISSUED BY A LOCAL BANK')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('Workstation Trade-in')."','50','300','99999','0','1','0','50'," ;
	$sqlval.= "'$ac5613','1970-01-01','2038-01-01','0','".exapi_lang('Trade-in items assumed to carry no asset value')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('$10 Cash Coupon')."','10','150','9999','0','3','0','30'," ;
	$sqlval.= "'$ac5613','1970-01-01','2038-01-01','0','".exapi_lang('Company issued FOC Cash Coupon')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;
	$sqlval = "('$sid','".exapi_lang('Exchange Coupon')."','0','80','9999','0','5','0','0'," ;
	$sqlval.= "'0','1970-01-01','2038-01-01','0','".exapi_lang('5 for 1 exchange for complimentary gift')."')";
	$adodb->query($sqlqc.$sqlval);						$sid++ ;

	$lang_rmk = exapi_lang('Invoice Remark1') ;
	$rmk1 = exapi_lang("Interest on overdue amounts is charged at 1.5% per month from due date until the invoice is paid in full.");
	$rmk2 = exapi_lang("Items returned are subject to a 10% restocking charge.") ;
	$rmk3 = exapi_lang("A return authorization must be obtained from us before items are returned.") ;
	$rmk4 = exapi_lang("Item returned must be shipped with freight prepaid and properly and adequately insured.") ;
	$rmk5 = exapi_lang("We will not be responsible for any damage during transit.") ;
	$rmk6 = exapi_lang("E. & O.E.") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1  $rmk2  $rmk3  $rmk4  $rmk5  $rmk6')" ;
	$adodb->query($sqlremark.$sqlval);		$inv_rmk1=$sid;		$sid++ ;
	$lang_rmk = exapi_lang('Reminder Remark1') ;
	$rmk1 = exapi_lang("This invoice is now due for payment.");
	$rmk2 = exapi_lang("Please settle this invoice as soon as possible.") ;
	$rmk3 = exapi_lang("If you have already remit/despatch payment, please ignore this reminder.") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1  $rmk2  $rmk3')" ;
	$adodb->query($sqlremark.$sqlval);		$rmd_rmk1=$sid;		$sid++ ;
	$lang_rmk = exapi_lang('PO Remark1') ;
	$rmk1 = exapi_lang("We require an Official Purchase Order (PO) to be issued to commit and pay for delivery of goods and services.") ;
	$rmk2 = exapi_lang("Goods and services delivered to us without a supporting Official PO from us will be rejected and sent back.") ;
	$rmk3 = exapi_lang("Invoices submitted to our Accounts Department without an Official PO number referenced will not be paid.") ;
	$rmk4 = exapi_lang("Please insist on obtaining an Official PO from us before delivering any goods or service to us.") ;
	$rmk5 = exapi_lang("Other PO Terms and Conditions are listed at http://www.company.com .") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1  $rmk2  $rmk3  $rmk4  $rmk5')" ;
	$adodb->query($sqlremark.$sqlval);		$po_rmk1=$sid;		$sid++ ;
	$lang_rmk = exapi_lang('Quotation Remark1') ;
	$rmk1 = exapi_lang("Terms and Conditions of Sale are listed at http://www.company.com .") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1')" ;
	$adodb->query($sqlremark.$sqlval);		$quo_rmk1=$sid;		$sid++ ;
	$lang_rmk = exapi_lang('Sales Memo Remark1') ;
	$rmk1 = exapi_lang("Come and try out our online Shopping Mall at http://www.company.com .") ;
	$sqlval = "('$sid','$lang_rmk','$rmk1')" ;
	$adodb->query($sqlremark.$sqlval);		$sm_rmk1=$sid;		$sid++ ;

/*------------------------------------------------------------------------------------*/

	$comname = exapi_lang('Testing Company Limited') ;
	$addr1 = exapi_lang('addr1') ;
	$addr2 = exapi_lang('addr2') ;
	$addr3 = exapi_lang('addr3') ;
	$addr4 = exapi_lang('addr4') ;
	$acdept = exapi_lang('Accounts Department') ;

	$hkd = exapi_lang('HKD') ;
	$kg = exapi_lang('kg') ;
	$tax1 = exapi_lang('GST') ;
	$tax2 = exapi_lang('PST') ;
	$lang_fund = exapi_lang('Fund') ;
	$lang_proj = exapi_lang('Project') ;
	$lang_dept = exapi_lang('Department') ;
	$lang_exec = exapi_lang('executive') ;
	$sqlval = "('$sid','$comname','$addr1','$addr2','$addr3','$addr4','$acdept'," ;
	$sqlval.= "'$ac1520','$ac4020','$ac5020','HKD','$kg','2005-12-31','0.16.1','$lang_exec',";
	$sqlval.= "'$inv_rmk1','$rmd_rmk1','$po_rmk1','$quo_rmk1','$sm_rmk1'," ;
	$sqlval.= "'$tax1','$tax2','i','','$tax1','$tax2','i','','$tax1','$tax2','i','i'," ;
	$sqlval.= "'$lang_fund','$lang_proj','$lang_dept'," ;
	$sqlval.= "'${pre}fund','${pre}project','${pre}department'," ;
	$sqlval.= "'name','name','name','description','description','description'," ;
	$sqlval.= "'yes','no','no','yes','no','no','yes','yes','yes','yes','yes','yes','yes','yes'," ;
	$sqlval.= "'paypal@example.com','paymateuser',20,10,5,140,70,35,7," ;
	$sqlval.= "'yes','yes','yes','yes','yes','yes','yes','yes','yes','yes','yes','yes','yes')" ;

	$adodb->query($sqldef.$sqlval);						$sid++ ;

/*------------------------------------------------------------------------------------*/

	$lang_no = exapi_lang('no') ;
	$sqlval	= array ("'en-hk','".exapi_lang('English')."','$lang_no','ISO-8859-1')" ,
			"'zh-cn','".exapi_lang('Simplified Chinese')."','$lang_no','GB18030')" ,
			"'zh-hk','".exapi_lang('Traditional Chinese')."','$lang_no','BIG5')" ,
			"'fr-fr','".exapi_lang('French')."','$lang_no','ISO-8859-1')" ,
			"'de-de','".exapi_lang('German')."','$lang_no','ISO-8859-1')" ,
							) ;

	while (list($key,$sqlv)=each($sqlval)) {
		$adodb->query("$sqli18ncode ('$sid',$sqlv");
		$sid++;
		}

/*------------------------------------------------------------------------------------*/

	$sqlval = "('ledgerlisting')";
	$adodb->query($sqllock.$sqlval);
	$sqlval = "('bulkpayrollgen')";
	$adodb->query($sqllock.$sqlval);
	$sqlval = "('payjournalgen')";
	$adodb->query($sqllock.$sqlval);
	$sqlval = "('bankledgerbulk')";
	$adodb->query($sqllock.$sqlval);
	$sqlval = "('defaultsedit')";
	$adodb->query($sqllock.$sqlval);
	$sqlval = "('contactimport')";
	$adodb->query($sqllock.$sqlval);
	$sqlval = "('writelangfile')";
	$adodb->query($sqllock.$sqlval);

/*------------------------------------------------------------------------------------*/

	$id = 10000 ;
	$ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
	$iptime = "$ip=$now=$script=$id" ;
	$user = $ckapi['hostsys']['username'];
	$sql = "INSERT INTO ${pre}log (id,trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
	$sql.= "VALUES ('$id','$id','$app','$script','$ip','$user','marker','$now','$iptime')";
	$adodb->query($sql) ;

	$log->update_log($script,'new',array("${pre}chart"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}currency"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}category"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}achievement"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}vendor"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}customer"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}tax"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}qcash"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}remark"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}defaults"),'',$now,'','') ;
	$log->update_log($script,'new',array("${pre}i18ncode"),'',$now,'','') ;

	$id = 30000 ;
	$ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
	$iptime = "$ip=$now=$script=$id" ;
	$user = $ckapi['hostsys']['username'];
	$sql = "INSERT INTO ${pre}log (id,trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
	$sql.= "VALUES ('$id','$id','$app','$script','$ip','$user','marker','$now','$iptime')";
	$adodb->query($sql) ;

	if ($db_type=="pgsql")		$adodb->query("SELECT setval('logid',30000)");
	
	
	$imgdir = $ckapi['hostsys']['dataarea']."/images" ;
	umask(000) ;
	if (!is_dir($imgdir))	mkdir($imgdir) ;
	$infl = array('abacus','blankpic') ;
	$outfl = array('logo','blankpic') ;
	while (list($key,$val)=each($infl)) {
		$filename = "images/$val.png" ;
		$fd = fopen($filename,"r");
		$contents = fread($fd,filesize($filename)) ;
		fclose($fd) ;
		$outfile = $outfl[$key] ;
		$filename = "$imgdir/$outfile.png" ;
		umask(000) ;
		if ($fp = fopen($filename, "w")) {fputs($fp, $contents); fclose($fp);}
		}

	if (PLATFORM=='egw') {
		$adodb->query("UPDATE egw_languages set lang_name='Chinese (Simplified)' WHERE lang_id='zh'");
		$adodb->query("UPDATE egw_languages set lang_name='Chinese (Traditional)' WHERE lang_id='zh-tw'");
		}

/*--------------------Write bottom Section------------------------------------------*/
?>
