<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// multiled.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-admin' ;
	$tran = 'multiled' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$t = exapi_tpl('ck-api');
	$t->set_file('report','index.tpl') ;
	$t->set_block('report','detail','detail_row');
	$t->set_block('report','ack','ack_row');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;

$title = exapi_lang("Guide to Setting up Multiple Ledger") ;
$t->set_var('lang_caption',$title);
$t->set_var('lang_motto',exapi_lang("CK: Common Knowledge - to be shared and developed by all"));

//$t->set_var('lang_welcome',"$msg1  $msg2  $msg3<br><br>$msg4 $msg5  $msg6  $msg7");
$t->set_var('lang_user_admin',exapi_lang('General Principle'));
$t->set_var('lang_auditor',exapi_lang('Virtual Domain Approach'));
$t->set_var('lang_developer',exapi_lang('Attribute Approach'));
$user1a = exapi_lang("Multiple ledger is best implemented using the virtual domain feature of eGroupWare.") ;
$user1b = exapi_lang("This feature allows one database to hold one distinct ledger.") ;
$user1 = "$user1a  $user1b" ;
$user2a = exapi_lang("If all different ledgers are to be housed within one database and utilize the same Chart of Accounts,") ;
$user2b = exapi_lang("they may be segregated using different values of a single attribute.") ;
$user2 = "$user2a $user2b" ;
$user3 = $user4 = $user5 = '' ;
$auditor1	= exapi_lang("Deploy eGroupWare as usual, making sure the header configuration page have 'Domain select box on login' set to (True)") ;
$auditor2	= exapi_lang("Utilize the [Add a domain] feature of the header configuration page to create a virtual domain, say HKGLedger.") ;
$auditor3a = exapi_lang("Login as administrator to @default and @HKGLedger individually, to set up 2 separate ledger structures;") ;
$auditor3b = exapi_lang("Users' access right and/or grouping can be set differently for each of the virtual domain/ledger.");
$auditor3  = "$auditor3a $auditor3b" ;
$auditor4  = exapi_lang("Users can then log on @default or @HKGLedger to access the separate ledgers in accordance to their access rights");
$auditor5  = exapi_lang("More ledgers can be produced by creating more virtual domains.");
$dev1a = exapi_lang('ck-admin') ;
$dev1b = exapi_lang('Default Values') ;
$dev1c = exapi_lang('Ledger Default Values') ;
$dev1d = exapi_lang('Edit') ;
$dev1e = exapi_lang('set relevant [Keep Value Constant within a single journal] to [yes]') ;
$developer1 = "$dev1a -> $dev1b -> $dev1c ($dev1d) -> $dev1e" ;
$developer2 = exapi_lang("For detail, please refer to the test data set, which utilizes attribute 1 to segregate the accounting entries of different Funds within a company.") ;
$developer3 = $developer4 = $developer5 = '' ;
For ($i=1;$i<=5;$i++) {
	$user='user'.$i;
	$auditor='auditor'.$i;
	$developer='developer'.$i;
	$t->set_var('user',$$user);
	$t->set_var('auditor',$$auditor);
	$t->set_var('developer',$$developer);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_row','detail',True);
	}

$t->set_var('lang_ack','');
$t->set_var('ack_row','');
$t->set_var('lang_date','');
$t->set_var('lang_detail','');
$t->set_var('lang_contributor','');

$t->pparse('out','report', true);
	exapi_footer() ;

?>

