<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// restore.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-admin' ;
	$tran = 'restore' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$search = isset($_GET['search']) ? $_GET['search'] : (isset($_POST['search'])?$_POST['search']:'');
	$attrib = isset($_GET['attrib']) ? $_GET['attrib'] : (isset($_POST['attrib'])?$_POST['attrib']:'');
	$file = isset($_GET['file']) ? $_GET['file'] : (isset($_POST['file'])?$_POST['file']:'');

	$rt = exapi_tpl($app);
	$rt->set_file('report','selectfilter.tpl') ;
	$rt->set_block('report','detail','detail_section');
	$rt->set_block('report','select','select_section');
	$rt->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;

	$title = exapi_lang('Choose Which Backup File to Restore :') ;
	$msg1 = exapi_lang("Currently, automatic restoration only works with PostgreSQL and MySQL databases.") ;
	$msg2 = exapi_lang("However, for other DBMS, restoration from the same backup files may be possible via command line action.") ;
	$msg3 = exapi_lang("Attribute tables should be further backuped/restored independently if they affect other host system modules.") ;
	$msg4 = exapi_lang("If different attribute tables were choosen after backup file was produced, restoration will not be effective.") ;
	$rt->set_var('lang_title',$title);
	$rt->set_var('lang_search_message',"$msg1  $msg2  $msg3  $msg4");

/* ------------- Read and Write Journal Detail --------------------------- */

	$rt->set_var('lang_criteria',exapi_lang('Action'));
	$rt->set_var('lang_value',exapi_lang('Backup Files'));
	$rt->set_var('lang_note',exapi_lang('Note'));

	$db_type =	$ckapi['hostsys']['dbtype'] ;
	$database =	$exapi_info['server']['db_name'] ;
	$dbuser	=	$exapi_info['server']['db_user'] ;
	$dir	=	$ckapi['hostsys']['dataarea'] ;
	$selectlist = "" ;
	$handle = opendir($dir) ;
	while ($fl = readdir($handle)) {
		if (substr($fl,0,strlen($database))==$database and strpos($fl,".$db_type.restore.sql")<>'') {
			$filename = $dir."/".$fl ;
			$selectlist .= "<OPTION value='$filename'>$filename</OPTION>" ;
			}
		}
	$nochoice = exapi_lang("No - Do not Restore") ;
	$yeschoice = exapi_lang("Yes - Restore") ;
	$attrib_selectlist = "<OPTION value='no'>$nochoice</OPTION><OPTION value='yes'>$yeschoice</OPTION>" ;

	$filter = array (	'cond1'		=>	exapi_lang('Which file to restore') ,
				'condvar1'	=>	'file' ,
				'conddefault1'	=>	'' ,
				'condnote1'	=>	exapi_lang('Pick the appropriate file to restore data from') ,
				'cond2'		=>	exapi_lang('Restore Attribute Tables ?') ,
				'condvar2'	=>	'attrib' ,
				'conddefault2'	=>	'no' ,
				'condnote2'	=>	exapi_lang('Choose whether to restore Attribute Tables and then click Start Restoration')
														 ) ;

	$rt->set_var('condition',$filter['cond1']) ;
	$rt->set_var('var',$filter['condvar1']) ;
	$rt->set_var('note',$filter['condnote1']);
	$rt->set_var('selectlist',$selectlist);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$rt->set_var('tr_color',$tr_color) ;
	$rt->parse('select_section','select', True);
	$rt->set_var('detail_section',"");
	$rt->set_var('condition',$filter['cond2']) ;
	$rt->set_var('var',$filter['condvar2']) ;
	$rt->set_var('note',$filter['condnote2']);
	$rt->set_var('selectlist',$attrib_selectlist);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$rt->set_var('tr_color',$tr_color) ;
	$rt->parse('select_section','select', True);
	$rt->set_var('detail_section',"");
	If ($search) {
		if (file_exists($file)) {
			$fd = fopen($file,"r");
			while (!feof($fd)) {
				$line = fgets($fd,65536);
				$first2 = substr($line,0,2) ;
				if (trim($first2)=='')			continue ;
				if ($first2=='--')			continue ;
				if ($first2=='**' and $attrib=='no')	continue ;
				if ($first2=='**' and $attrib=='yes')	$adodb->query(substr($line,2,-1)) ;
					else				$adodb->query(substr($line,0,-1)) ;
				}
			fclose($fd) ;
			$complete = exapi_lang("Database Restoration Complete") ;
			$msg = "<br><font size='+2'>$complete</font>" ;
			$msg.= exapi_lang("<br>Source File:")." $file<br>" ;
			$msg.= exapi_lang("Please remember to restore additionally the (images) folder within your host system files area")."<br>" ;
			}
		  else	$msg = $file.' '.exapi_lang('does not exist') ;
		$rt->set_var('lang_search_message',$msg);
		}

	$rt->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	if (!$search) {
		$rt->set_var('search_action',exapi_link("/$app/restore.php")) ;
		$rt->set_var('lang_search',exapi_lang('Start Database Restoration'));
		}
	    else {
		$rt->set_var('search_action',exapi_link("/$app/index.php")) ;
		$rt->set_var('lang_search',exapi_lang('Done'));
		}
	$rt->set_var('add_action',exapi_link("/$app/index.php")) ;
	$rt->set_var('lang_add',exapi_lang('Done'));

	$rt->pparse('out','report',True);
	exapi_footer() ;

?>
