<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// paymentfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-ap' ;
	$tran = 'payment' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among posted payments :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Payment") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning=exapi_lang("Make sure you have completed all payment allocation before checking on unallocated payments") ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Vendor') ,
				'type'		=>	'select' ,
				'selectlist'	=>$nullopt.selectlist('vendor','name','','','id','name','id') ,
				'varname'	=>	'vendor' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Select the appropriate vendor') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Currency') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.selectlist('currency','isocode','','','isocode','isocode','description') ,
				'varname'	=>	'isocode' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Select the appropriate currency') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Payment Date (from)') ,
				'type'		=>	'input' ,
				'varname'	=>	'from' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Payment Date (to)') ,
				'type'		=>	'input' ,
				'varname'	=>	'to' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Payment Number') ,
				'type'		=>	'input' ,
				'varname'	=>	'paynumber' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Search for target key word/number in the payment number field') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Remark') ,
				'type'		=>	'input' ,
				'varname'	=>	'remark' ,
				'defval'	=>	"" ,
				'note'	=>exapi_lang('Search for target key word/number in the remark field') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Unallocated Payment Only') ,
				'type'		=>	'checkbox' ,
				'varname'	=>	'opentran' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang("Click box if only non fully allocated payments are to be retrieved")."<br><b>".$warning."</b>" );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
