<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// reportfilter_validate.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-ap' ;
	$tran = 'report' ;
	$noheader = True ;  $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$pass2 = isset($_GET['pass2']) ? $_GET['pass2'] : (isset($_POST['pass2'])?$_POST['pass2']:'');
	$err = isset($_GET['err']) ? $_GET['err'] : (isset($_POST['err'])?$_POST['err']:'');
	$actnum = isset($_GET['actnum']) ? $_GET['actnum'] : (isset($_POST['actnum'])?$_POST['actnum']:'');
	$vendor = isset($_GET['vendor']) ? $_GET['vendor'] : (isset($_POST['vendor'])?$_POST['vendor']:'');
	$rdate = isset($_GET['rdate']) ? $_GET['rdate'] : (isset($_POST['rdate'])?$_POST['rdate']:'');
	$datefrom = isset($_GET['datefrom']) ? $_GET['datefrom'] : (isset($_POST['datefrom'])?$_POST['datefrom']:'');
	$dateto = isset($_GET['dateto']) ? $_GET['dateto'] : (isset($_POST['dateto'])?$_POST['dateto']:'');

/* --------------------- Validation Check Start ----------------------------	*/
	
	$err="";  $error = exapi_lang("Error") ;
	$result = $adodb->query("SELECT sum(amount) as amount FROM ${pre}acc_trans");
	$net = sprintf("%01.2f",exapi_dbflds($result,'amount')) ;
	if ($net<>0)	$err=exapi_lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;

	if ($rdate<>'') {
		$date=input2date($rdate) ;
		if ($date=="")	$err=exapi_lang("Invalid Report Status Date");	else	$rdate = $date ;
		}
	    else	$rdate=date("Y-m-d") ;
	if ($datefrom<>'') {
		$date=input2date($datefrom) ;
		if ($date=="")	$err=exapi_lang("Invalid Date From");		else	$datefrom = $date ;
		}
	if ($dateto<>'') {
		$date=input2date($dateto) ;
		if ($date=="")	$err=exapi_lang("Invalid Date To");		else	$dateto = $date ;
		}
	if ($actnum==4)			$err="Report# $actnum is reserved for future use" ;
	if ($actnum<1 or $actnum>5)	$err="Invalid Report Number" ;
	if ($actnum=='')		$err="You have choosen a blank line" ;

	if ($err<>'')	$err="<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if ($err=='')
		{
		switch ($actnum) {
			case 1:
				$param_list = "repdate=$rdate" ;
				Header('Location: '.exapi_link("/$app/apaging.php","$param_list"));
				exit();
			case 2:
				$param_list = "repdate=$rdate&vendor=$vendor" ;
				Header('Location: '.exapi_link("/$app/invoiceaging.php","$param_list"));
				exit();
			case 3:
				$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;	$filter='' ;
				if ($datefrom)		$filter.= "${markpri}2transdate${marksec}${datefrom}" ;
				if ($dateto)		$filter.= "${markpri}4transdate${marksec}${dateto}" ;
				$filter =urlencode($filter) ;
				Header('Location: '.exapi_link("/$app/taxpaidlist.php","filter=$filter"));
				exit();
			case 5:
				$param_list = "repdate=$rdate" ;
				Header('Location: '.exapi_link("/$app/controlreport.php","$param_list"));
				exit();
			default:
				echo "Should not be here.  Weird Report Number" ;
			}
		}
	else
		{
		$getstr = "actnum=$actnum&vendor=$vendor&rdate=$rdate&" ;
		$getstr.= "datefrom=$datefrom&dateto=$dateto&err=$err" ;
		Header('Location: '.exapi_link("/$app/reportfilter.php",$getstr));
		exit();
		}

?>
