<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// connector.inc.php 0.16.1 2005/12/04 C K Wu
//
// (connector for running CK-ERP atop phpBB + LAMP)

	global $ckapi,$adodb,$template ;

	define('IN_PHPBB', true) ;
	define('PAGE_CKERP',99999) ;
	$phpbb_root_path = '../' ;
	require_once($phpbb_root_path.'extension.inc') ;
	require_once($phpbb_root_path.'common.'.$phpEx) ;
	$userdata = session_pagestart($user_ip, PAGE_CKERP) ;
	init_userprefs($userdata) ;

	require_once('../includes/db.php') ;
	class phpbb_db extends sql_db {
		function query($query='') 			{parent::sql_query($query); return $this;}
		function fetchRow($query_id=0)			{return parent::sql_fetchrow($query_id);}
		function fields($field, $rownum=-1, $query_id=0){return parent::sql_fetchfield($field) ;}
		}
	$ckapi['hostsys']['dbtype'] = $dbtype = $dbms ;
	if ($dbtype=='postgres')	$ckapi['hostsys']['dbtype'] = $dbtype = 'pgsql' ;
	if ($dbtype=='mysql4')		$ckapi['hostsys']['dbtype'] = $dbtype = 'mysql' ;
	$ckapi['hostsys']['dbhost'] = $dbhost ;
	$ckapi['hostsys']['dbname'] = $dbname ;
	$ckapi['hostsys']['dbuser'] = $dbuser ;

	$adodb = new phpbb_db($dbhost, $dbuser, $db->password, $dbname, false) ;
	
	$ckapi['hostsys']['username'] = trim($userdata['username']);
	$ckapi['hostsys']['dataarea'] = $_SERVER['DOCUMENT_ROOT'].$board_config['script_path'].$board_config["avatar_path"] ;
	$ckapi['hostsys']['th_bg'] = $theme['th_color1'] ;
	$ckapi['hostsys']['tr_color1'] = $theme['tr_color1'] ;
	$ckapi['hostsys']['tr_color2'] = $theme['tr_color2'] ;
	$ckapi['hostsys']['tr_color3'] = $theme['tr_color3'] ;
	$ckapi['hostsys']['tr_color4'] = $theme['tr_color4'] ;

	switch ($userdata['user_lang']) :
		case 'english' :		$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		case 'chinese_simplified' :	$ckapi['hostsys']['guilang'] = 'zh-cn' ;	break ;
		case 'chinese_traditional' :	$ckapi['hostsys']['guilang'] = 'zh-hk' ;	break ;
		case 'french' :			$ckapi['hostsys']['guilang'] = 'fr-fr' ;	break ;
		case 'german' :			$ckapi['hostsys']['guilang'] = 'de-de' ;	break ;
		default :			$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		endswitch ;

	if (!$noheader) {
		require_once('../ck-api/phpbb/page_header.'.$phpEx);
		require_once('../ck-api/phpbb/navbar.php') ;
		require_once("inc/header.inc.php") ;
		}

	if (!$userdata['session_logged_in'])	die(exapi_lang('You must be logged in to access CK-ERP'));

    function exapi_tpl($app) {
	global $ckapi;

	require_once('../ck-api/inc/class.ck_Template.inc.php') ;
	$tpl = new ck_Template("../$app/templates/default") ;
	return $tpl ;
	}

    function exapi_link($url,$getstr='') {
	if (strlen($getstr)<2)	return append_sid('..'.$url) ;
	  else			return append_sid('..'.$url).'?'.$getstr ;
	}
	
    function exapi_footer() {
	global $phpbb_root_path,$phpEx,$template,$db;	require_once($phpbb_root_path.'includes/page_tail.'.$phpEx) ;
	}

    function exapi_groups($user='') {
	global $adodb,$userdata ;
	
	$sql = "SELECT g.group_id, g.group_name as account_name, g.group_type, ug.user_pending " ;
	$sql.= "FROM " . GROUPS_TABLE . " g, " . USER_GROUP_TABLE . " ug " ;
	$sql.= "WHERE ug.user_id = '$userdata[user_id]' AND ug.group_id = g.group_id ORDER BY g.group_name, ug.user_id";
	$result = $adodb->query($sql);
	While ($rs=$result->fetchRow()) $groups[]=$rs	;
	return $groups ;
	}

    function exapi_is_group($name) {
	global $adodb ;
	
	$result = $adodb->query("SELECT * FROM " . GROUPS_TABLE . " WHERE group_name = '$name'");
	return $result->RecordCount()>0 ;
	}

    function exapi_lang ($phrase,$z1='',$z2='',$z3='',$z4='') {
	global $ckapi,$env ;

	$tmp = get_i18n($phrase) ;
	if ($env=='adminins')			$tmp = addslashes($tmp);
						if ($z1==='') return $tmp ;
	$tmp = str_replace('%1',$z1,$tmp) ;	if ($z2==='') return $tmp ;
	$tmp = str_replace('%2',$z2,$tmp) ;	if ($z3==='') return $tmp ;
	$tmp = str_replace('%3',$z3,$tmp) ;	if ($z4==='') return $tmp ;
	return str_replace('%4',$z4,$tmp);
	}

    function exapi_is_admin($user='')		{global $userdata; return $userdata['user_level']==ADMIN ;}

    function exapi_dbrc(&$result)		{return $result->sql_numrows($query_id=0);}

    function exapi_dbflds(&$result,$field)	{return $result->fields($field);}

    function exapi_dbcharset($string,$langcode)	{return $string;		}


?>