<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// connector.inc.php 0.16.1 2005/12/04 C K Wu
//
// (connector for running CK-ERP atop xaraya + LAMP)

	global $ckapi,$adodb,$template,$outstream ;

	chdir('../../') ;

	require_once('includes/xarCore.php');
	xarCoreInit(XARCORE_SYSTEM_ALL);

	$_SERVER['REQUEST_URI'] = str_replace("/modules/$app",'',$_SERVER['REQUEST_URI']) ;
	$SiteSlogan = xarModGetVar('themes', 'SiteSlogan');
	xarTplSetPageTitle(xarVarPrepForDisplay($SiteSlogan));
	$markercontent = 'Marker Content<br>' ;
        $pageOutput = xarTpl_renderPage($markercontent);

	$GLOBALS['ADODB_FETCH_MODE'] = ADODB_FETCH_BOTH;
	$adodb =& xarDBGetConn();
	$ckapi['hostsys']['dbtype'] = $dbtype = $adodb->databaseType ;
	if ($dbtype=='postgres')	$ckapi['hostsys']['dbtype'] = $dbtype = 'pgsql' ;
	if ($dbtype=='postgres7')	$ckapi['hostsys']['dbtype'] = $dbtype = 'pgsql' ;
	if ($dbtype=='postgres8')	$ckapi['hostsys']['dbtype'] = $dbtype = 'pgsql' ;
	$ckapi['hostsys']['dbhost'] = $adodb->host ;
	$ckapi['hostsys']['dbname'] = $adodb->database ;
	$ckapi['hostsys']['dbuser'] = $adodb->user ;
	$ckapi['hostsys']['tblpre'] = xarCore_getSystemVar('DB.TablePrefix') ;
	list($language,$charset) = explode('.',$xarMLS_currentLocale) ;
	switch ($language) :
		case 'en_US' :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		case 'en-uk' :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		case 'zh_CN' :	$ckapi['hostsys']['guilang'] = 'zh-cn' ;	break ;
		case 'zh_HK' :	$ckapi['hostsys']['guilang'] = 'zh-hk' ;	break ;
		case 'zh_TW' :	$ckapi['hostsys']['guilang'] = 'zh-hk' ;	break ;
		case 'fr_FR' :	$ckapi['hostsys']['guilang'] = 'fr-fr' ;	break ;
		case 'de_DE' :	$ckapi['hostsys']['guilang'] = 'de-de' ;	break ;
		default :	$ckapi['hostsys']['guilang'] = 'en-hk' ;	break ;
		endswitch ;
	$ckapi['hostsys']['guicharset'] = $charset ;

	$ckapi['hostsys']['username'] = trim(xarUserGetVar('uname'));
	$ckapi['hostsys']['dataarea'] = getcwd().'/var/uploads' ;
	$ckapi['hostsys']['th_bg'] = '#CCCCCC' ;
	$ckapi['hostsys']['tr_color1'] = '" class="row1' ;
	$ckapi['hostsys']['tr_color2'] = '" class="row2' ;
	$ckapi['hostsys']['tr_color3'] = 'grey' ;
	$ckapi['hostsys']['tr_color4'] = 'red' ;

	$outstream = '' ;
	chdir('modules/'.$app) ;
	require_once('../ck-api/inc/class.ck_Template.inc.php') ;
	class xar_ck_Template extends ck_Template {
		function set_file($handle,$filename='')	 	{parent::set_file($handle,$filename) ;	}
		function set_block($parent,$handle,$name='')	{parent::set_block($parent,$handle,$name) ; }
		function set_var($varname,$value='')		{parent::set_var($varname,$value) ;	}
		function parse($target,$handle,$append=false)	{return parent::parse($target,$handle,$append) ; }
		function pparse($target,$handle,$append=false)	{
			global $outstream ;	$outstream.= $this->parse($target, $handle, $append) ;
			}
		}

	if (!isset($noheader)) {
		require_once ('../ck-api/xaraya/navbar.php') ;
		$outstream = $navcode ;
		require_once("../$app/inc/header.inc.php") ;
		}

	if (!xarUserIsLoggedIn()) {
		$outstream = exapi_lang("You must be logged in to access CK-ERP") ;
		exapi_footer() ;
		die() ;
		}

    function exapi_tpl($app) {

	$tpl = new xar_ck_Template("../$app/templates/default") ;
	return $tpl ;
	}

    function exapi_link($url,$getstr='') {
	if (strlen($getstr)<2)	return '..'.xarVarPrepForDisplay($url) ;
	  else			return '..'.xarVarPrepForDisplay($url).'?'.$getstr ;
	}
	
    function exapi_footer() {
	global $markercontent,$outstream,$pageOutput;

	$outstream = str_replace('../','modules/',$outstream) ;
	$pageOutput = str_replace($markercontent,$outstream,$pageOutput) ;
        echo $pageOutput;
	}

    function exapi_groups($user='')	{
	global $ckapi,$adodb ;

	$tblpre = $ckapi['hostsys']['tblpre'] ;
	$uid = xarUserGetVar('uid');
	$query = "SELECT xar_name as account_name FROM ${tblpre}_roles a,${tblpre}_rolemembers b " ;
	$query.= "WHERE a.xar_uid=b.xar_parentid and b.xar_uid='$uid'" ;
	$result = $adodb->query($query);
	While ($rs=$result->fetchRow()) $groups[]=$rs	;
	return $groups ;
	}

    function exapi_is_group($name) {
	global $ckapi,$adodb ;
	$tblpre = $ckapi['hostsys']['tblpre'] ;
	$result = $adodb->query("SELECT * FROM ${tblpre}_roles WHERE xar_uname ='$name' and xar_type=1");
	return exapi_dbrc($result)>0 ;
	}

    function exapi_lang ($phrase,$z1='',$z2='',$z3='',$z4='') {
	global $ckapi,$env ;

	$tmp = get_i18n($phrase) ;
	if ($env=='adminins')			$tmp = addslashes($tmp);
	switch ($ckapi['hostsys']['guilang']) :
		case 'zh-hk' :	$tmp1=iconv('big5','utf8',$tmp.'<zz>');
				list($tmp)=explode('<zz>',$tmp1);	break ;
		case 'zh-cn' :	$tmp1=iconv('gb18030','utf8',$tmp.'<zz>');
				list($tmp)=explode('<zz>',$tmp1);	break ;
		case 'fr-fr' :	$tmp=iconv('iso-8859-1','utf8',$tmp);	break ;
		case 'de-de' :	$tmp=iconv('iso-8859-1','utf8',$tmp);	break ;
		endswitch ;
						if ($z1==='') return $tmp ;
	$tmp = str_replace('%1',$z1,$tmp) ;	if ($z2==='') return $tmp ;
	$tmp = str_replace('%2',$z2,$tmp) ;	if ($z3==='') return $tmp ;
	$tmp = str_replace('%3',$z3,$tmp) ;	if ($z4==='') return $tmp ;
	return str_replace('%4',$z4,$tmp);
	}

    function exapi_is_admin($user='')		{return xarModGetVar('roles','admin')==xarUserGetVar('uid') ;}

    function exapi_dbrc(&$result)		{	return $result->RecordCount();	}

    function exapi_dbflds(&$result,$field)	{	return $result->fields[$field];	}

    function exapi_dbcharset($string,$langcode)	{	return $string;			}

?>