<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// ledgerbulk.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-bank' ;
	$tran = 'ledger' ;
	require_once('../ck-api/ckapi.inc.php') ;


	$status = isset($_GET['status']) ? $_GET['status'] : (isset($_POST['status'])?$_POST['status']:'');
	foreach ($_POST as $key => $value)	if ($key<>'status')	$_POST[$key] = strip_tags($value) ;
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$order = isset($_GET['order']) ? $_GET['order'] : (isset($_POST['order'])?$_POST['order']:'');
	$sort = isset($_GET['sort']) ? $_GET['sort'] : (isset($_POST['sort'])?$_POST['sort']:'');
	$post = isset($_GET['post']) ? $_GET['post'] : (isset($_POST['post'])?$_POST['post']:'');
	$delete = isset($_GET['delete']) ? $_GET['delete'] : (isset($_POST['delete'])?$_POST['delete']:'');

	$filter = urldecode(stripslashes($filter)) ;
	$proc = newobj('ck-api','process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$ckapi['params']['table'] = "${pre}bkr_trans" ;
	$proc = newobj('ck-api','process') ;
	$t = exapi_tpl($app);
	$t->set_file('question','confirm.tpl');
	$t->set_file(array('report'=>"${tran}bulk.tpl",  'ledgers'=>"${tran}bulk.tpl"));
	$t->set_block('ledgers','ledger_row','ledger_section');
	$db_type = $ckapi['hostsys']['dbtype'] ;
	$float = ($db_type=="mysql") ? "double" : "float" ;
	$err = '' ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_bankac',exapi_lang('Bank Account'));
list($dummy,$chart_id) = explode("'",$where) ;
$result = $adodb->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'");
$bankac = exapi_dbflds($result,'accno')."--".exapi_dbflds($result,'description') ;
$t->set_var('bankac',$bankac);
$t->set_var('message',"");

$t->set_var('lang_post',exapi_lang('Post Bulk Update'));
$t->set_var('lang_delete',exapi_lang('Delete (non-blank) items'));
$getstr = "filter=$filter&sort=$sort&order=$order" ;
$t->set_var('post_action',exapi_link("/$app/${tran}bulk.php",$getstr));

if ($post<>'' or $delete<>'') {
	$user = $ckapi['hostsys']['username'];
	$lockwhere = "WHERE resource='bankledgerbulk'" ;
	$result = $adodb->query("SELECT * FROM ${pre}resourcelock $lockwhere");
	$used_by = exapi_dbflds($result,'used_by') ;
	if ($used_by=="")	$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' $lockwhere");
	  else	{
	  	$err = exapi_lang("Bank Rec. Ledger Item [Bulk] Update/Edit/Delete is being accessed by ").$used_by;
		$t->set_var('message',"<b>".exapi_lang("Error").":  $err") ;
		$t->set_var('lang_post',exapi_lang('Done - Error'));
		$t->set_var('lang_delete',exapi_lang('Done - Error'));
		$t->set_var('post_action',exapi_link("/$app/${tran}list.php",$getstr));
		}
	}
if (($post<>'' or $delete<>'') and $err=="") {
	$ip = isset($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'];
	$user = $ckapi['hostsys']['username'];
	$now = mktime() ;
	$op = (isset($post)) ? 'edit' : 'delete' ;
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);
	if ($post<>'') {
		foreach ($status as $key => $value) {
			$value = strip_tags($value) ;
			$iptime = "$ip=$now=$script=$key" ;
			$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
			$sql.= "VALUES ('$key','$app','$script','$ip','$user','$op','$now','$iptime')" ;
			$adodb->query($sql);
			$result = $adodb->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
			$logid = exapi_dbflds($result,'id');
			$sql = "UPDATE ${pre}bkr_trans SET status='$value',control=control+1 " ;
			$sql.= "WHERE trans_id=$key";
			$adodb->query($sql);
			$ckapi['params_post']['id'] = $key ;
			$ckapi['params_post']['logid'] = $logid ;
			$proc->update_log_header() ;
			}
		$t->set_var('lang_post',exapi_lang('Done - Bulk Update Posted'));
		$t->set_var('lang_delete',exapi_lang('Done'));
		}
	if ($delete<>'') {
		foreach ($status as $key => $value) {
			$iptime = "$ip=$now=$script=$key" ;
			$sql = "INSERT INTO ${pre}log (trans_id,app,script,ip,userid,op,timestamp,iptime) " ;
			$sql.= "VALUES ('$key','$app','$script','$ip','$user','$op','$now','$iptime')" ;
			$adodb->query($sql);
			$result = $adodb->query("SELECT id from ${pre}log WHERE iptime='$iptime'");
			$logid = exapi_dbflds($result,'id');
			$ckapi['params_post']['id'] = $key ;
			$ckapi['params_post']['logid'] = $logid ;
			$proc->update_log_header() ;
			$adodb->query("DELETE FROM ${pre}bkr_trans WHERE trans_id=$key");
			}
		$t->set_var('lang_post',exapi_lang('Done'));
		$t->set_var('lang_delete',exapi_lang('Done - Items deleted'));
		}
	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);
	$t->set_var('post_action',exapi_link("/$app/${tran}list.php",$getstr));
	$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='bankledgerbulk'");
	}
$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
$t->set_var('lang_title',exapi_lang('List of Ledger Items'));
$t->set_var('lang_sorthead','');
$t->set_var('lang_status',exapi_lang('Cheque/Item Status'));
$t->set_var('lang_transdate',exapi_lang('ledger Date'));
$t->set_var('lang_source',exapi_lang('Source'));
$t->set_var('lang_description',exapi_lang('Description'));
$t->set_var('lang_refnumber',exapi_lang('Ref Number'));
$t->set_var('lang_cheque',exapi_lang('Cheque'));
$t->set_var('lang_amount',exapi_lang('Amount<br>(Dr being +ve)'));
$t->set_var('lang_cleared',exapi_lang('Cleared'));
$t->set_var('lang_stopped',exapi_lang('Stopped'));
$t->set_var('lang_neither',exapi_lang('Neither'));
$t->set_var('lang_id',exapi_lang('Audit ID'));

if (!$order) $order = "transdate" ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT * FROM ${pre}bkr_trans " ;
$sql.=	"WHERE substring(source,1,2)<>'SI' and substring(source,1,2)<>'SU' $where ORDER BY ".$order." ".$sort ;
$result = $adodb->query($sql);

// -------------------------------- end declaration -----------------------------------------

if (exapi_dbrc($result)==0) {
	$t->set_var(array('transdate'	=> exapi_lang("No Matching Item Found"),
			'source'	=> "",
			'description'	=> "",
			'refnumber'	=> "",
			'cheque'	=> "",
			'amount'	=> "",
			'id'		=> ""			)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('ledger_section','ledger_row',True);
	}
While ($rs=$result->fetchRow()) {
	$id	= $rs['id'] ;
	$cchecked = ($rs['status']=="c") ? 'checked' : '' ;
	$schecked = ($rs['status']=="s") ? 'checked' : '' ;
	$nchecked = ($rs['status']=="") ? 'checked' : '' ;
	$t->set_var(array(
		'transdate'	=> $rs['transdate'],
		'source'	=> $rs['source'],
		'description'	=> $rs['description'],
		'refnumber'	=> $rs['refnumber'],
		'cheque'	=> $rs['cheque'],
		'amount'	=> $rs['amount'],
		'cchecked'	=> $cchecked,
		'schecked'	=> $schecked,
		'nchecked'	=> $nchecked,
		'id'		=> $id					));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('ledger_section','ledger_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','ledgers','report');
	exapi_footer() ;

?>
