<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// reportfilter_validate.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-bank' ;
	$tran = 'report' ;
	$noheader = True ;  $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$err = isset($_GET['err']) ? $_GET['err'] : (isset($_POST['err'])?$_POST['err']:'');
	$actnum = isset($_GET['actnum']) ? $_GET['actnum'] : (isset($_POST['actnum'])?$_POST['actnum']:'');
	$chart_id = isset($_GET['chart_id']) ? $_GET['chart_id'] : (isset($_POST['chart_id'])?$_POST['chart_id']:'');
	$from = isset($_GET['from']) ? $_GET['from'] : (isset($_POST['from'])?$_POST['from']:'');
	$to = isset($_GET['to']) ? $_GET['to'] : (isset($_POST['to'])?$_POST['to']:'');
	$bankbal = isset($_GET['bankbal']) ? $_GET['bankbal'] : (isset($_POST['bankbal'])?$_POST['bankbal']:'');

/* --------------------- Validation Check Start ----------------------------	*/

	$err="";  $error = exapi_lang("Error") ;
	$result = $adodb->query("SELECT sum(amount) as amount FROM ${pre}acc_trans");
	$net = sprintf("%01.2f",exapi_dbflds($result,'amount')) ;
	if ($net<>0)			$err=exapi_lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;
	if ($from=='')			$err=exapi_lang("Reconciliation Period From Date missing") ;
	if ($to=='')			$err=exapi_lang("Reconciliation Period To Date missing") ;
	if ($actnum==1 and !is_numeric($bankbal))
					$err=exapi_lang("Bank Balance must be non-blank and numeric") ;
	if ($from<>'') {
		$date=input2date($from) ;
		if ($date=="")		$err=exapi_lang("Invalid Reconciliation Period From Date");
			else	$from = $date ;
		}
	if ($to<>'') {
		$date=input2date($to) ;
		if ($date=="")		$err=exapi_lang("Invalid Reconciliation Period To Date");
			else	$to = $date ;
		}
	if ($actnum<>1 and $actnum<>5)	$err=exapi_lang("Invalid Report chosen") ;
	if ($err<>'')	$err="<b>$error:  $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if ($err=='')
		{
		switch ($actnum) {
			case 1:
				$getstr = "chart_id=$chart_id&from=$from&to=$to&bankbal=$bankbal" ;
				Header('Location: '.exapi_link("/$app/brstatement.php",$getstr));
				exit();
			case 2:	exit();
			case 3:	exit();
			case 4:	exit();
			case 5:
				$getstr = "chart_id=$chart_id&from=$from&to=$to" ;
				Header('Location: '.exapi_link("/$app/controlreport.php",$getstr));
				exit();
			default:
				echo "Should not be here.  Weird Report Number" ;
			}
		}
	else
		{
		$getstr = "actnum=$actnum&chart_id=$chart_id&" ;
		$getstr.= "from=$from&to=$to&bankbal=$bankbal&err=$err" ;
		$return = exapi_link("/$app/${tran}filter.php",$getstr) ;
		Header('Location: '.$return);
		}

?>
