<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// suspensefilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-bank' ;
	$tran = 'suspense' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi['phrases'] = array('lang_title'=> exapi_lang('Search among Reconciliation Worksheet Suspense Items :'),
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Suspense Item") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);
	$where = "WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'" ;
	$bankac_sl = selectlist('chart','accno',$where,'','id','accno','description') ;
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Bank Account') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$bankac_sl ,
				'varname'	=>	'chart_id' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Select the appropriate bank account')	) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Suspense Item Date (from)') ,
				'type'		=>	'input' ,
				'varname'	=>	'from' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Suspense Item Date (to)') ,
				'type'		=>	'input' ,
				'varname'	=>	'to' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Must be a valid date')."; $dateformat" );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Source') ,
				'type'		=>	'input' ,
				'varname'	=>	'source' ,
				'defval'	=>	"" ,
				'note'		=>exapi_lang('Search for target keyword in item source field') ) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Description') ,
				'type'		=>	'input' ,
				'varname'	=>	'description' ,
				'defval'	=>	"" ,
				'note'	=>exapi_lang('Search for target keyword in item description field') ) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
