<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// importorgprslist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-contact' ;
	$tran = 'importorgprs' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'import',
				'tran'		=> $tran ,
				'table'		=> "${pre}org_person" ,
				'doneexit'	=> "importorgprsbulk.php"		);
				
	$msg1 = exapi_lang("Only previously unimported links [relating to imported organizations and persons] will be imported.") ;
	$msg2 = exapi_lang('Linkages that had been overtaken by manually created organization<=>person links within ContactManagement will not be imported.') ;
	$msg3 = exapi_lang("It is advisable to save or print a copy of this list for future reference.") ;
	$msg4 = exapi_lang("Because of semantic difference, the field [preferred] is not imported.") ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Contact Organization<=>Person Links to be imported"),
				'lang_add'	=> exapi_lang("Start Bulk Import") ,
				'linkmark'	=> "<=>" ,
				'message'	=> "$msg1  $msg2  $msg3  $msg4"		);
	$ckapi['columns'] = array('org_id'	=> exapi_lang('Org ID [Host System]') ,
				'orgnumber'	=> exapi_lang('Organization shortname/#') ,
				'orid'		=> exapi_lang('Org ID [ContactManagement]') ,
				'pid'		=> exapi_lang('Person ID [ContactManagement]') ,
				'prsnumber'	=> exapi_lang('Person_s shortname/#') ,
				'person_id'	=> exapi_lang('Person ID [Host System]') ,
				'title'		=> exapi_lang('Title') ,
				'department'	=> exapi_lang('Department')			);
	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;

	if (isset($ckapi['params']['temp']))	$adodb->query('DROP TABLE '.$ckapi['params']['temp']);
	exapi_footer() ;

?>
