<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.helpcase.inc.php 0.16.1 2005/12/04 C K Wu

    class helpcase {

//---- Callcase List SQL Formation

    function helpcase_list_sql() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$app = $ckapi['params']['app'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$lang_noncustomer = exapi_lang('Non-Customer') ;
	$user = $ckapi['hostsys']['username'] ;
	$ckapi['params_sql']['temp'] = $temp = "${pre}tmphelpcase".$user.time() ;
	$fields = "casenumber,name,description,customer,start,a.id as id" ;
	$sql = "SELECT $fields FROM ${pre}helpcase a,${pre}customer b, ${pre}org c WHERE a.customer = b.id and b.contactid=c.id" ;
	$adodb->query("CREATE TABLE $temp AS $sql");
	$fields = "casenumber,name,description,customer,start,a.id as id" ;
	$sql = "SELECT $fields FROM ${pre}helpcase a,${pre}customer b, ${pre}person c WHERE a.customer = b.id and b.contactid=c.id" ;
	$adodb->query("INSERT INTO $temp $sql") ;
	$fields = "casenumber,'$lang_noncustomer' as name,description,customer,start,id" ;
	$sql = "SELECT $fields FROM ${pre}helpcase WHERE customer='0'" ;
	$adodb->query("INSERT INTO $temp $sql") ;
	$last10 = substr($where,strlen($where)-10,10) ;
	if ($last10==' AND OPEN '){
		$where = substr($where,0,strlen($where)-10) ;
		$lang_helpcall = exapi_lang('helpcall');	$lang_close = exapi_lang('closure') ;
		$result = $adodb->query("SELECT id FROM ${pre}category where app='$app' and type='$lang_helpcall' and name='$lang_close'");
		$cloid = exapi_dbflds($result,'id') ;
		if ($ckapi['hostsys']['dbtype']=="mysql")	{
			$sql = "SELECT a.* FROM $temp a LEFT JOIN ${pre}helpcall b " ;
			$sql.= "ON caseid=a.id and callcatid='$cloid' WHERE b.id is null and $where" ;
			}
		  else	{
		  	$sql = "SELECT * FROM $temp WHERE $where EXCEPT " ;
			$sql.= "SELECT a.* FROM $temp a, ${pre}helpcall b WHERE caseid=a.id and callcatid='$cloid'"; 
			}
		}
	  else	$sql =	"SELECT * FROM $temp WHERE $where ORDER BY $order $sort";
	return $sql ;
	}

//---- helpcase Data Read

    function helpcase_read() {
	global $ckapi,$pre,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$id = $ckapi['params_post']['id'] ;

	$result = $adodb->query("SELECT * FROM $table WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$table = $pre."helpcall" ;
	$result = $adodb->query("SELECT * FROM $table WHERE caseid='$id' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt["calldate$i"]	=	$rs['calldate'] ;
		$dt["calltime$i"]	=	$rs['calltime'] ;
		$dt["callcatid$i"]	=	$rs['callcatid'] ;
		$dt["mediacatid$i"]	=	$rs['mediacatid'] ;
		$dt["prsfrom$i"]	=	$rs['prsfrom'] ;
		$dt["prsto$i"]		=	$rs['prsto'] ;
		$dt["statecatid$i"]	=	$rs['statecatid'] ;
		$dt["assigned$i"]	=	$rs['assigned'] ;
		$dt["actioned$i"]	=	$rs['actioned'] ;
		$dt["deadline$i"]	=	$rs['deadline'] ;
		$dt["hours$i"]		=	$rs['hours'] ;
		$dt["summary$i"]	=	$rs['summary'] ;
		$dt["rowno$i"]		=	"dummy" ;
		}
	if ($ckapi['params_post']['op']=="edit")	$dt['oldcasenumber'] = $dt['casenumber'] ;
	
	return $dt ;
	}

//---- helpcase Detail Validation Checks

    function helpcase_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$app = $ckapi['params']['app'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang("Error");	$row = exapi_lang("Row") ;
	$lang_helpcall = exapi_lang('helpcall');	$lang_close = exapi_lang('closure') ;
	$result = $adodb->query("SELECT id,name FROM ${pre}category where app='$app' and type='$lang_helpcall' and name='$lang_close'");
	$close_id = exapi_dbflds($result,'id') ;
	if ($dt['casenumber']=="")			$err=exapi_lang("Case Number Missing");
	if ($dt['description']=="")			$err=exapi_lang("Case Description Missing");
	if ($dt['casecatid']=="")			$err=exapi_lang("Case Category ID Missing");
	if ($dt['monitor']=="")				$err=exapi_lang("Monitoring Officer ID Missing");
	if ($dt['customer']=="")			$err=exapi_lang("Customer ID Missing");
	if ($dt['itemid']=="")				$err=exapi_lang("Product/Service ID Missing");
	if ($dt['pricatid']=="")			$err=exapi_lang("Priority Category ID Missing");
	if ($dt['billable']<>"y" and $dt['billable']<>"n")	$err=exapi_lang("Invalid Billable Input");
	if ($dt['start']=="")				$err=exapi_lang("History Log Starting Date Missing");
	  else	if (input2date($dt['start'])=="")	$err=exapi_lang("Invalid History Log Starting Date");
	$clo = $maxdate = $maxtime = "" ;
	For ($i=1;isset($dt["rowno$i"]);$i++) {
		$rowi = "[$row $i]" ;
		$calldate = $dt["calldate$i"] ;
		$calltime = $dt["calltime$i"] ;
		$callcatid = $dt["callcatid$i"] ;
		$hours = $dt["hours$i"] ;
		if ($calldate=="")			$err=$rowi.exapi_lang("Call Date Missing");
		if ($calltime=="")			$err=$rowi.exapi_lang("Call Time Missing");
		if ($callcatid=="")			$err=$rowi.exapi_lang("Call Type ID Missing");
		if ($dt["mediacatid$i"]=="")		$err=$rowi.exapi_lang("Call Media ID Missing");
		if ($dt["prsfrom$i"]=="")		$err=$rowi.exapi_lang("Person From Missing");
		if ($dt["prsto$i"]=="")			$err=$rowi.exapi_lang("Person To Missing");
		if ($dt["statecatid$i"]=="")		$err=$rowi.exapi_lang("Caller State of Mind ID Missing");
		if ($dt["assigned$i"]=="")		$err=$rowi.exapi_lang("Assigned-to Staff ID Missing");
		if ($dt["deadline$i"]=="")		$err=$rowi.exapi_lang("Response Deadline Missing");
		if ($dt["actioned$i"]=="")		$err=$rowi.exapi_lang("Actioned-by Staff ID Missing");
		if ($hours=="")				$err=$rowi.exapi_lang("Hours Spent Missing");
		if ($dt["summary$i"]=="")		$err=$rowi.exapi_lang("Call Summary Missing");

		if (input2date($calldate)=="")		$err=$rowi.exapi_lang("Invalid Call Date");
		if (strlen($calltime)<>4)		$err=$rowi.exapi_lang("Invalid Call Time [must be 4 chars long]") ;
		if (ereg('[^0-9]',$calltime))		$err=$rowi.exapi_lang("Invalid Call Time [only char 0-9 allowed]") ;
		$hr = substr($calltime,0,2);		$mn = substr($calltime,2,2) ;
		if ($hr<0 or $hr>24)			$err=$rowi.exapi_lang("Invalid Call Time [hour must be within 00-24]") ;
		if ($mn<0 or $mn>60)			$err=$rowi.exapi_lang("Invalid Call Time [minute must be within 00-60]") ;
		if ($calltime<0 or $calltime>2400)	$err=$rowi.exapi_lang("Invalid Call Time [time must be within 0000-2400]") ;
		if (input2date($dt["deadline$i"])=="")	$err=$rowi.exapi_lang("Invalid Response Deadline Date");
		if (!is_numeric($hours))		$err=$rowi.exapi_lang("Hours Spent must be numeric") ;
		if ($hours<0)				$err=$rowi.exapi_lang("Hours Spent must be +ve") ;
		if ($hours*1000%10>0)			$err=$rowi.exapi_lang("Invalid Hours Spent [only 2 decimal place allowed]");
		if ($calldate>$dt["deadline$i"])	$err=$rowi.exapi_lang("Response Deadline earlier than Call Date");
		if ($callcatid==$close_id)
			if ($clo<>"")			$err=$rowi.exapi_lang("Duplicate Help Case Closure") ;
				else			{$clo='**'; $close_date=$calldate;  $close_time=$calltime;}
		if ($calldate>$maxdate or ($calldate==$maxdate and $calltime>$maxtime))
							{$maxdate=$calldate; $maxtime=$calltime;}
		}
	if ($err<>$rowi.exapi_lang("Duplicate Help Case Closure"))
		if ($clo=='**' and ($maxdate<>$close_date or $maxtime<>$close_time))
							$err=exapi_lang("Closure date/time is not the latest within this log") ;
	if ($dt['casenumber']<>$dt['oldcasenumber']) {
		$result = $adodb->query("SELECT * from ${pre}helpcase where casenumber='$dt[casenumber]'");
		if (exapi_dbrc($result)>0)		$err = exapi_lang("Case Name/# already exists") ;
		}
	
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- helpcase Delete Validation Checks

    function delete_validate() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write helpcase Header

    function helpcase_header_write() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_id',exapi_lang('Audit ID').':');
	$t->set_var('lang_casenumber',exapi_lang('Case Name/#'));
	$t->set_var('lang_casecat',exapi_lang('Case Category'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_start',exapi_lang('Date History Log Started'));
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_contact',exapi_lang('Contact'));
	$t->set_var('lang_item',exapi_lang('Relevant Product/Service'));
	$t->set_var('lang_priority',exapi_lang('Priority'));
	$t->set_var('lang_bill',exapi_lang('Billable'));
	$t->set_var('billmsg',exapi_lang("If yes, make sure client_s preferred payment method and associated details are already on record."));
	$t->set_var('lang_monitor',exapi_lang('Monitoring Officer'));

	$fields = array('id','control','casenumber','oldcasenumber','description','start','casecatid','customer','itemid','pricatid','billable','monitor') ;
	foreach ($fields as $field)	$dt[$field] = isset($dt[$field]) ? $dt[$field] : '' ;

	$t->set_var('id',$dt['id']) ;
	$t->set_var('control',$dt['control']) ;
	$t->set_var('casenumber',$dt['casenumber']) ;
	$t->set_var('description',$dt['description']) ;
	$t->set_var('start',$dt['start']) ;
	$lang_helpcase = exapi_lang('helpcase') ;
	$casecat_sl = selectlist('category','type',"WHERE app='$app' and type='$lang_helpcase'",$dt['casecatid'],'id','name','id') ;
	$t->set_var('casecat_selectlist',$casecat_sl) ;
	$customer_sl = "<OPTION value='0'>".exapi_lang("Non-Customer")."</OPTION>".selectlist('customer','name','','','id','name','id') ;
	$customer_sl = str_replace("'$dt[customer]'","'$dt[customer]'"." selected",$customer_sl) ;
	$t->set_var('customer_selectlist',$customer_sl) ;
	$t->set_var('item_selectlist',item_selectlist('',$dt['itemid'])) ;
	$lang_priority = strtolower(exapi_lang('priority')) ;
	$priority_sl = selectlist('category','type',"WHERE app='$app' and type='$lang_priority'",$dt['pricatid'],'id','name','id') ;
	$t->set_var('priority_selectlist',$priority_sl) ;
	$yesno_sl = "<OPTION value='y'>".exapi_lang('Yes')."</option><OPTION value='n'>".exapi_lang('No')."</option>" ;
	$yesno_sl = str_replace("'$dt[billable]'","'$dt[billable]'"." selected",$yesno_sl) ;
	$t->set_var('bill_selectlist',$yesno_sl) ;
	$t->set_var('monitor_selectlist',selectlist('employee','name','',$dt['monitor'],'id','name','id')) ;

	if ($ckapi['params_post']['op']=="edit")	$t->set_var('oldcasenumber',$dt['oldcasenumber']);

	$t->parse('out','report',True);
	}

//---- Write Callcase Detail to Screen

    function helpcase_detail_write() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$id = &$ckapi['params_post']['id'] ;
	$t = &$ckapi['objects']['template'] ;
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;

	$posted = ($ckapi['params_post']['op']=="view" or $ckapi['params_post']['op']=="delete") ;
	$row_ = exapi_lang('Row')." " ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$t->set_var('lang_caselog',exapi_lang('Call Case History Log'));
	$t->set_var('lang_insert',exapi_lang('Insert before'));
	$t->set_var('lang_calldate',exapi_lang('Date'));
	$t->set_var('lang_calltime',exapi_lang('Time<br>[HHmm]'));
	$t->set_var('lang_callcatid',exapi_lang('Type'));
	$t->set_var('lang_mediacatid',exapi_lang('Media'));
	$t->set_var('lang_prsfrom',exapi_lang('Person From'));
	$t->set_var('lang_prsto',exapi_lang('Person To'));
	$t->set_var('lang_statecatid',exapi_lang('Caller State of Mind'));
	$t->set_var('lang_assigned',exapi_lang('<- Followup Action Assigned to'));
	$t->set_var('lang_deadline',exapi_lang('<- Response Deadline'));
	$t->set_var('lang_actioned',exapi_lang('<- Actioned by'));
	$t->set_var('lang_hours',exapi_lang('<- Hours Spent'));
	$t->set_var('lang_summary',exapi_lang('Summary'));
	$t->set_var('lang_delete_cap',exapi_lang('Delete'));

	$lang_helpcall = exapi_lang('helpcall') ;
	$lang_media = exapi_lang('media') ;
	$lang_state = exapi_lang('cstate') ;
	$callcatid_sl = selectlist('category','type',"WHERE app='$app' and type='$lang_helpcall'",'','id','name','id') ;
	$mediacatid_sl = selectlist('category','type',"WHERE app='$app' and type='$lang_media'",'','id','name','id') ;
	$statecatid_sl = "<OPTION value='0'></OPTION>".selectlist('category','type',"WHERE app='$app' and type='$lang_state'",'','id','name','id') ;
	$employee_sl = "<OPTION value='0'></OPTION>".selectlist('employee','name','','','id','name','id') ;
	$insrowno = (isset($insert) and $insert<>'') ? intval(str_replace($row_,"",$insert)) : '' ;
	$delrowno = (isset($delete) and $delete<>'') ? intval(str_replace($row_,"",$delete)) : '' ;
	if ($delrowno==0)	$delrowno = 999999 ;
	For ($i=1;isset($dt["rowno$i"]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('calldate_fld',"calldate$i") ;
			$t->set_var('calltime_fld',"calltime$i") ;
			$t->set_var('callcatid_fld',"callcatid$i") ;
			$t->set_var('mediacatid_fld',"mediacatid$i") ;
			$t->set_var('prsfrom_fld',"prsfrom$i") ;
			$t->set_var('prsto_fld',"prsto$i") ;
			$t->set_var('statecatid_fld',"statecatid$i") ;
			$t->set_var('assigned_fld',"assigned$i") ;
			$t->set_var('deadline_fld',"deadline$i") ;
			$t->set_var('actioned_fld',"actioned$i") ;
			$t->set_var('hours_fld',"hours$i") ;
			$t->set_var('summary_fld',"summary$i") ;
			$t->set_var('rowno_fld',"rowno$i") ;
			$t->set_var('calldate',"") ;
			$t->set_var('calltime',"") ;
			$t->set_var('callcatid_selectlist',$callcatid_sl);
			$t->set_var('mediacatid_selectlist',$mediacatid_sl);
			$t->set_var('prsfrom',"") ;
			$t->set_var('prsto',"") ;
			$t->set_var('statecatid_selectlist',$statecatid_sl);
			$t->set_var('assigned_selectlist',$employee_sl);
			$t->set_var('deadline',"") ;
			$t->set_var('actioned_selectlist',$employee_sl);
			$t->set_var('hours',"") ;
			$t->set_var('summary',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $insert<>'' and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $delete<>'' and $i>$delrowno)	$j=$i-1;
		$calldate	=	$dt['calldate'.$i] ;
		$calltime	=	$dt['calltime'.$i] ;
		$callcatid	=	$dt['callcatid'.$i] ;
		$mediacatid	=	$dt['mediacatid'.$i] ;
		$prsfrom	=	$dt['prsfrom'.$i] ;
		$prsto		=	$dt['prsto'.$i] ;
		$statecatid	=	$dt['statecatid'.$i] ;
		$assigned	=	$dt['assigned'.$i] ;
		$deadline	=	$dt['deadline'.$i] ;
		$actioned	=	$dt['actioned'.$i] ;
		$hours		=	$dt['hours'.$i] ;
		$summary	=	$dt['summary'.$i] ;
		$t->set_var('calldate_fld',"calldate$j") ;
		$t->set_var('calltime_fld',"calltime$j") ;
		$t->set_var('callcatid_fld',"callcatid$j") ;
		$t->set_var('mediacatid_fld',"mediacatid$j") ;
		$t->set_var('prsfrom_fld',"prsfrom$j") ;
		$t->set_var('prsto_fld',"prsto$j") ;
		$t->set_var('statecatid_fld',"statecatid$j") ;
		$t->set_var('assigned_fld',"assigned$j") ;
		$t->set_var('deadline_fld',"deadline$j") ;
		$t->set_var('actioned_fld',"actioned$j") ;
		$t->set_var('hours_fld',"hours$j") ;
		$t->set_var('summary_fld',"summary$j") ;
		$t->set_var('rowno_fld',"rowno$j") ;
		$t->set_var('calldate',$calldate) ;
		$t->set_var('calltime',$calltime) ;
		$t->set_var('callcatid_selectlist',str_replace("'$callcatid'","'$callcatid' selected",$callcatid_sl));
		$t->set_var('mediacatid_selectlist',str_replace("'$mediacatid'","'$mediacatid' selected",$mediacatid_sl));
		$t->set_var('prsfrom',$prsfrom) ;
		$t->set_var('prsto',$prsto) ;
		$t->set_var('statecatid_selectlist',str_replace("'$statecatid'","'$statecatid' selected",$statecatid_sl));
		$t->set_var('assigned_selectlist',str_replace("'$assigned'","'$assigned' selected",$employee_sl));
		$t->set_var('deadline',$deadline) ;
		$t->set_var('actioned_selectlist',str_replace("'$actioned'","'$actioned' selected",$employee_sl));
		$t->set_var('hours',$hours) ;
		$t->set_var('summary',$summary) ;
		if ($posted)	$t->set_var('insrowno',"done");  else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done");  else $t->set_var('delrowno',$row_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('calldate_fld',"calldate$i") ;
		$t->set_var('calltime_fld',"calltime$i") ;
		$t->set_var('callcatid_fld',"callcatid$i") ;
		$t->set_var('mediacatid_fld',"mediacatid$i") ;
		$t->set_var('prsfrom_fld',"prsfrom$i") ;
		$t->set_var('prsto_fld',"prsto$i") ;
		$t->set_var('statecatid_fld',"statecatid$i") ;
		$t->set_var('assigned_fld',"assigned$i") ;
		$t->set_var('deadline_fld',"deadline$i") ;
		$t->set_var('actioned_fld',"actioned$i") ;
		$t->set_var('hours_fld',"hours$i") ;
		$t->set_var('summary_fld',"summary$i") ;
		$t->set_var('rowno_fld',"rowno$i") ;
		$t->set_var('calldate',"") ;
		$t->set_var('calltime',"") ;
		$t->set_var('callcatid_selectlist',$callcatid_sl);
		$t->set_var('mediacatid_selectlist',$mediacatid_sl);
		$t->set_var('prsfrom',"") ;
		$t->set_var('prsto',"") ;
		$t->set_var('statecatid_selectlist',$statecatid_sl);
		$t->set_var('assigned_selectlist',$employee_sl);
		$t->set_var('deadline',"") ;
		$t->set_var('actioned_selectlist',$employee_sl);
		$t->set_var('hours',"") ;
		$t->set_var('summary',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if (($i==1 and $newrow=="") or ($i==2 and $delrowno==1))	$t->set_var('detail_section',"") ;

	$t->parse('out','report',True);
	}

//---- helpcase Post - PreCommit Routine

    function helpcase_post_precommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$adodb->query("DELETE from ${pre}helpcall where caseid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt["rowno$i"]);$i++) {
			$calldate	=	$dt["calldate$i"] ;
			$calltime	=	$dt["calltime$i"] ;
			$callcatid	=	$dt["callcatid$i"] ;
			$mediacatid	=	$dt["mediacatid$i"] ;
			$prsfrom	=	addslashes($dt["prsfrom$i"]) ;
			$prsto		=	addslashes($dt["prsto$i"]) ;
			$statecatid	=	$dt["statecatid$i"] ;
			$assigned	=	$dt["assigned$i"] ;
			$deadline	=	$dt["deadline$i"] ;
			$actioned	=	$dt["actioned$i"] ;
			$hours		=	$dt["hours$i"] ;
			$summary	=	addslashes($dt["summary$i"]) ;
			$sql = "INSERT INTO ${pre}helpcall (caseid,calldate,calltime,callcatid,mediacatid,prsfrom,prsto,statecatid," ;
			$sql.=				"assigned,deadline,actioned,hours,summary) " ;
			$sql.= "VALUES ('$id','$calldate','$calltime','$callcatid','$mediacatid','$prsfrom','$prsto','$statecatid'," ;
			$sql.=				"'$assigned','$deadline','$actioned','$hours','$summary') " ;
			$adodb->query($sql);
			}
		}
	}
	
//---- Callcase Post - PostCommit Routine

    function helpcase_post_postcommit() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	$lang_tran = $ckapi['phrases']['lang_tran'] ;
	$actioned = $ckapi['phrases']['actioned'] ;

	$subject1 = exapi_lang("You are the monitoring officer of the case") ;
	$subject2 = exapi_lang("You are one of the assigned-to staff of the case") ;
	$informmon = exapi_lang("Please manually inform monitoring officer") ;
	$user = $ckapi['hostsys']['username'];
	$err=""; $err1=""; $error=exapi_lang("Error"); $noemail=exapi_lang("No email sent") ;
	$result = $adodb->query("SELECT b.id as crmid,name FROM ${pre}employee a,${pre}empperson b WHERE contactid=b.id and username='$user'");
	if (exapi_dbrc($result)>0)	{$crmname = exapi_dbflds($result,'name'); $crmid = exapi_dbflds($result,'crmid');}
		else			$err = exapi_lang("HR record of CRM staff missing") ;
	if ($err=="") {
		$result = $adodb->query("SELECT commdata FROM ${pre}comm WHERE contactid='$crmid' and commcode='wemail'");
		if (exapi_dbrc($result)>0)	$crmemail = exapi_dbflds($result,'commdata');
		  else				$err = exapi_lang("Work email of CRM staff missing") ;
		}
	if ($err=="") {
		$result = $adodb->query("SELECT b.id as monid,name FROM ${pre}employee a,${pre}empperson b WHERE contactid=b.id and a.id='$dt[monitor]'");
		if (exapi_dbrc($result)>0)	{$monname = exapi_dbflds($result,'name'); $monid = exapi_dbflds($result,'monid');}
			else			$err = exapi_lang("HR record of monitoring staff missing") ;
		if ($err=="") {
			$result = $adodb->query("SELECT commdata FROM ${pre}comm WHERE contactid='$monid' and commcode='wemail'");
			if (exapi_dbrc($result)>0)	$monemail = exapi_dbflds($result,'commdata');
			  else				$err = exapi_lang("Work email of monitoring staff missing") ;
			}
		}
	$subject0 = "$lang_tran [id#$id] $actioned" ;
	if ($err<>"")	$ckapi['phrases']["reminder"] = "<br>$error: $err.  $noemail.  $informmon." ;
	  else	{
		$recipient = "$monname < $monemail >" ;
		$subject = "$subject0.  $subject1." ;
		$message = '' ;
		$headers = "From: $crmname < $crmemail >\n" ;
		$charset = exapi_lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $crmname < $crmemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email advising action on helpdesk case successfully queued for despatch to monitoring officer") ;
		$failuremsg=exapi_lang("Email advising action on helpdesk case fails to deliver.")."  $informmon";
		if ($result)	$msg = "<br>$successmsg $monname." ;
			else	$msg = "<br>$failuremsg $monname." ;
		$ckapi['phrases']["reminder"] = $msg ;
		}
	$informasg = exapi_lang("Please manually inform all assigned-to staff") ;
	$row = exapi_lang("Row") ;
	$recipient = "" ;
	For ($i=1;isset($dt["rowno$i"]);$i++) {
		$assigned = $dt["assigned$i"] ;
		if ($assigned==0)	continue ;
		$rowi = "[$row $i]" ;
		$result = $adodb->query("SELECT b.id as asgid,name FROM ${pre}employee a,${pre}empperson b WHERE contactid=b.id and a.id='$assigned'");
		if (exapi_dbrc($result)>0)	{$asgname = exapi_dbflds($result,'name'); $asgid = exapi_dbflds($result,'asgid');}
			else			$err1 = $rowi.exapi_lang("HR record of at least one assigned-to staff missing") ;
		if ($err1=="") {
			$result = $adodb->query("SELECT commdata FROM ${pre}comm WHERE contactid='$asgid' and commcode='wemail'");
			if (exapi_dbrc($result)>0)	$asgemail = exapi_dbflds($result,'commdata');
			  else				$err1 = exapi_lang("Work email of at least one assigned-to staff missing") ;
			}
		if (isset($asgemail) and substr_count($recipient,$asgname)<=0)
			$recipient.= " $asgname < $asgemail >," ;
		}
	if ($err1<>"")	$ckapi['phrases']["reminder"].= "<br>$error: $err1.  $noemail.  $informasg." ;
	  else	{
		$subject = "$subject0.  $subject2." ;
		$message = '' ;
		$headers = "From: $crmname < $crmemail >\n" ;
		$charset = exapi_lang('charset') ;
		$headers.= "Content-Type: text/html; charset=$charset \n" ;
		$headers.= "Return-Path: $crmname < $crmemail >\n" ;
		$result= mail($recipient,$subject,$message,$headers) ;
		$successmsg = exapi_lang("Email advising action on helpdesk case successfully queued for despatch to assign-to staff,");
		$failuremsg = exapi_lang("Email advising action on helpdesk case fails to deliver.")."  $informasg";
		if ($result)	$msg = "<br>$successmsg $recipient." ;
			else	$msg = "<br>$failuremsg $recipient." ;
		$ckapi['phrases']["reminder"].= $msg ;
		}
	}

    }
