<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// salecasefilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-crm' ;
	$tran = 'salecase' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among existing Sale Cases :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Sale Case") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$non_customer = "<OPTION value='0'>".exapi_lang("Non-Customer")."</OPTION>" ;
	$startmsg = exapi_lang('Case Log Starting Date falling within (from/to) date range will be listed.') ; 
	$dateformat = exapi_lang('Format: YYYY-MM-DD') ;
	$opennote = exapi_lang("Click box if only outstanding (non-closed) sale cases are to be retrieved") ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Target Customer') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.$non_customer.selectlist('customer','name','','','id','name','id') ,
				'varname'	=>	'customer' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Search for contact cases of the target customer') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('From') ,
				'type'		=>	'input' ,
				'varname'	=>	'datefrom' ,
				'defval'	=>	'' ,
				'note'		=>	"$startmsg  $dateformat"		) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('To') ,
				'type'		=>	'input' ,
				'varname'	=>	'dateto' ,
				'defval'	=>	'' ,
				'note'		=>	"$startmsg  $dateformat"		) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Sale Case Number') ,
				'type'		=>	'input' ,
				'varname'	=>	'casenumber' ,
				'defval'	=>	"" ,
				'note'		=>exapi_lang('Search for target key word in the sale case number field') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Open Sale Cases Only') ,
				'type'		=>	'checkbox' ,
				'varname'	=>	'opentran' ,
				'defval'	=>	"" ,
				'note'		=>	$opennote				 );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
