<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// invoicewtlist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-css' ;
	$tran = 'invoicewt' ;
	require_once('../ck-api/ckapi.inc.php') ;
	require_once('custid.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'invoice' ,
				'tran'		=> $tran ,
				'table'		=> "${pre}ar" 			);
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Invoices [with Tax]") ,
				'lang_add'	=> exapi_lang("Done")		);
	$ckapi['columns'] = array('transdate'	=> exapi_lang('Invoice Date') ,
				'duedate'	=> exapi_lang('Due Date') ,
				'name'		=> exapi_lang('Customer') ,
				'invnumber'	=> exapi_lang('Invoice#') ,
				'isocode'	=> exapi_lang('Currency') ,
				'amount'	=> exapi_lang('Amount') ,
				'id'		=> exapi_lang('Audit ID') 	);
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'rpthist'	=> "/$app/invrpthist.php" ,
				'oinvoice'	=> "/$app/${tran}off.php" ,
				'acctran'	=> "/$app/${tran}acctran.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"	) ;

	$ckapi['lang_links'] = array('lang_view'	=> exapi_lang("View") ,
				'lang_rpthist'	=> exapi_lang('Receipt History') ,
				'lang_oinvoice'	=> exapi_lang('Invoice / Reminder') ,
				'lang_bulk'	=> exapi_lang("Bulk Despatch") ,
				'lang_acctran'	=> exapi_lang('Accounting Entries') ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")		) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;

	if (isset($ckapi['params_sql']['temp1']))	$adodb->query('DROP TABLE '.$ckapi['params_sql']['temp1']);
	if (isset($ckapi['params_sql']['temp2']))	$adodb->query('DROP TABLE '.$ckapi['params_sql']['temp2']);
	exapi_footer() ;

?>
