<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-hr' ;
	$tran = 'control' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$status_date = isset($_GET['status_date']) ? $_GET['status_date'] : (isset($_POST['status_date'])?$_POST['status_date']:'');

/*---------------------------------------------------------------------------------*/

	$t = exapi_tpl($app);
	$t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$msg1 = exapi_lang('CC - Communication Channel') ;
	$msg2 = exapi_lang('EC - Emergency Contact') ;
	$msg3 = exapi_lang('ID - Important Dates') ;
	$msg4 = exapi_lang('PR - Performance Review') ;
	$t->set_var('message',"[$msg1;  $msg2;  $msg3; $msg4]");
	$t->set_var('lang_control_report', exapi_lang('Human Resources Audit Control Report'));
	$t->set_var('lang_system_date', exapi_lang('System Date'));
	$t->set_var('lang_empperson', exapi_lang('Employee Personal Record'));
	$t->set_var('lang_employee', exapi_lang('Employee'));
	$t->set_var('lang_code', exapi_lang('HR<br>Code'));
	$t->set_var('lang_commcat', exapi_lang('CC<br>Category'));
	$t->set_var('lang_commcode', exapi_lang('CC<br>Code'));
	$t->set_var('lang_dept', exapi_lang('Depart<br>ment'));
	$t->set_var('lang_achieve', exapi_lang('Achieve<br>ment'));
	$t->set_var('lang_comm', exapi_lang('Comm Data'));
	$t->set_var('lang_address', exapi_lang('Address'));
	$t->set_var('lang_ec', exapi_lang('EC'));
	$t->set_var('lang_others', exapi_lang('Others'));
	$t->set_var('lang_dates', exapi_lang('ID'));
	$t->set_var('lang_leave', exapi_lang('Leave'));
	$t->set_var('lang_pr', exapi_lang('PR'));
	$t->set_var('lang_role', exapi_lang('Role'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL DATABASE STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));

/*-----------------Gather and Write Database Info---------------------------------*/

$lang_comm = strtolower(exapi_lang('comm')) ;
$t->set_var('system_date',date("Y-m-d",time())) ;

$result = $adodb->query("SELECT count(id) as empperson_count, max(id) as max_id from ${pre}empperson WHERE prsnumber<>''");
$t->set_var('empperson_count',exapi_dbflds($result,'empperson_count')) ;
$t->set_var('latest_empperson_id',exapi_dbflds($result,'max_id')) ;

$result = $adodb->query("SELECT count(id) as employee_count, max(id) as max_id from ${pre}employee WHERE name<>''");
$t->set_var('employee_count',exapi_dbflds($result,'employee_count')) ;
$t->set_var('latest_employee_id',exapi_dbflds($result,'max_id')) ;

$sql =	"SELECT count(id) as code_count, max(id) as max_id from ${pre}category WHERE app='$app' and type<>'$lang_comm'" ;
$result = $adodb->query($sql);
$t->set_var('code_count',exapi_dbflds($result,'code_count')) ;
$t->set_var('latest_code_id',exapi_dbflds($result,'max_id')) ;

$sql =	"SELECT count(id) as commcat_count, max(id) as max_id from ${pre}category WHERE app='$app' and type='$lang_comm' and parent=0" ;
$result = $adodb->query($sql);
$t->set_var('commcat_count',exapi_dbflds($result,'commcat_count')) ;
$t->set_var('latest_commcat_id',exapi_dbflds($result,'max_id')) ;

$sql =	"SELECT count(id) as commcode_count, max(id) as max_id from ${pre}category WHERE app='$app' and type='$lang_comm' and parent<>0" ;
$result = $adodb->query($sql);
$t->set_var('commcode_count',exapi_dbflds($result,'commcode_count')) ;
$t->set_var('latest_commcode_id',exapi_dbflds($result,'max_id')) ;

$result = $adodb->query("SELECT count(id) as dept_count, max(id) as max_id from ${pre}department WHERE name<>''");
$t->set_var('dept_count',exapi_dbflds($result,'dept_count')) ;
$t->set_var('latest_dept_id',exapi_dbflds($result,'max_id')) ;

$result = $adodb->query("SELECT count(id) as achieve_count, max(id) as max_id from ${pre}achievement WHERE name<>''");
$t->set_var('achieve_count',exapi_dbflds($result,'achieve_count')) ;
$t->set_var('latest_achieve_id',exapi_dbflds($result,'max_id')) ;

$result = $adodb->query("SELECT count(contactid) as cnt from ${pre}comm,${pre}empperson WHERE contactid=id");
$t->set_var('comm_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_comm_id',exapi_lang('N/A')) ;

$result = $adodb->query("SELECT count(contactid) as cnt from ${pre}address,${pre}empperson WHERE contactid=id");
$t->set_var('address_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_address_id',exapi_lang('N/A')) ;

$result = $adodb->query("SELECT count(contactid) as cnt from ${pre}ec,${pre}empperson WHERE contactid=id");
$t->set_var('ec_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_ec_id',exapi_lang('N/A')) ;

$result = $adodb->query("SELECT count(contactid) as cnt from ${pre}others,${pre}empperson WHERE contactid=id");
$t->set_var('others_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_others_id',exapi_lang('N/A')) ;

$result = $adodb->query("SELECT count(empid) as cnt from ${pre}dates");
$t->set_var('dates_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_dates_id',exapi_lang('N/A')) ;

$result = $adodb->query("SELECT count(empid) as cnt from ${pre}leave");
$t->set_var('leave_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_leave_id',exapi_lang('N/A')) ;

$result = $adodb->query("SELECT count(empid) as cnt from ${pre}pr");
$t->set_var('pr_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_pr_id',exapi_lang('N/A')) ;

$result = $adodb->query("SELECT count(empid) as cnt from ${pre}role");
$t->set_var('role_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_role_id',exapi_lang('N/A')) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link('/ck-hr/reportfilter.php')) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>