<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// reportfilter_validate.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-hr' ;
	$tran = 'report' ;
	$noheader = True ;  $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$pass2 = isset($_GET['pass2']) ? $_GET['pass2'] : (isset($_POST['pass2'])?$_POST['pass2']:'');
	$err = isset($_GET['err']) ? $_GET['err'] : (isset($_POST['err'])?$_POST['err']:'');
	$actnum = isset($_GET['actnum']) ? $_GET['actnum'] : (isset($_POST['actnum'])?$_POST['actnum']:'');
	$event = isset($_GET['event']) ? $_GET['event'] : (isset($_POST['event'])?$_POST['event']:'');
	$datefrom = isset($_GET['datefrom']) ? $_GET['datefrom'] : (isset($_POST['datefrom'])?$_POST['datefrom']:'');
	$dateto = isset($_GET['dateto']) ? $_GET['dateto'] : (isset($_POST['dateto'])?$_POST['dateto']:'');
	$rdate = isset($_GET['rdate']) ? $_GET['rdate'] : (isset($_POST['rdate'])?$_POST['rdate']:'');

/* --------------------- Validation Check Start ----------------------------	*/

	if ($err)		$err="Error flagged before validation." ;
	$error = exapi_lang("Error") ;
	$result = $adodb->query("SELECT sum(amount) as amount FROM ${pre}acc_trans");
	$net = sprintf("%01.2f",exapi_dbflds($result,'amount')) ;
	if ($net<>0)		$err=exapi_lang("Dr/Cr Imbalance detected.  Pls inform System Admin immediately.") ;

	if ($datefrom) {
		$date=input2date($datefrom) ;
		if ($date=="")	$err=exapi_lang("Invalid Period from Date");	else	$datefrom = $date ;
		}
	if ($dateto) {
		$date=input2date($dateto) ;
		if ($date=="")	$err=exapi_lang("Invalid Period to Date");	else	$dateto = $date ;
		}
	if ($err)		$err = "<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)	{
		switch ($actnum) {
			case 1:
				$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ; $filter = '' ;
				if ($event)		$filter .= "${markpri}1datecode${marksec}${event}" ;
				if ($datefrom)		$filter .= "${markpri}2empdate${marksec}${datefrom}" ;
				if ($dateto)		$filter .= "${markpri}4empdate${marksec}${dateto}" ;
				$filter = urlencode($filter) ;
				$getstr = "event=$event&datefrom=$datefrom&dateto=$dateto&filter=$filter" ;
				Header('Location: '.exapi_link("/$app/notifylist.php",$getstr));exit();
			case 2:
				$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ; $filter = '' ;
				if ($datefrom)		$filter .= "${markpri}2transdate${marksec}${datefrom}" ;
				if ($dateto)		$filter .= "${markpri}4transdate${marksec}${dateto}" ;
				$filter = urlencode($filter) ;
				$getstr = "datefrom=$datefrom&dateto=$dateto&filter=$filter" ;
				Header('Location: '.exapi_link("/$app/dailyattlist.php",$getstr));exit();
			case 3:	Header('Location: '.exapi_link("/$app/reportfilter.php"));	exit();
			case 4:	Header('Location: '.exapi_link("/$app/reportfilter.php"));	exit();
			case 5:	Header('Location: '.exapi_link("/$app/controlreport.php"));	exit();
			default:
				echo exapi_lang("Should not be here.  Weird Report Number") ;		exit();
			}
		}
	else
		{
		$getstr = "actnum=$actnum&datefrom=$datefrom&dateto=$dateto&rdate=$rdate&err=$err" ;
		Header('Location: '.exapi_link("/$app/${tran}filter.php",$getstr));
		exit() ;
		}

?>
