<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// adminins.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'admin' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$t = exapi_tpl($app);
	$t->set_file('report','confirm.tpl') ;
	$t->set_file('msg','message.tpl');

	$roothdl = opendir($basedir) ;
	while ($sdir = readdir($roothdl))	{if (!strstr($sdir,'ck-')) continue;	$modules[]=$sdir;}	
	$langcode = $_GET['lang'] ;

	$sql = ($ckapi['hostsys']['dbtype']=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$adodb->query($sql);

	$result = $adodb->query("SELECT max(id) as max_id from ${pre}i18n");
	$sid = exapi_dbflds($result,'max_id') + 1 ;
	$sid = $sid>10000000 ? $sid : 10000000 ;
	$i=0; $msg=''; $errors=array();
	foreach ($modules as $module) {
		$filer = "$basedir/$module/setup/${module}_$langcode.lang" ;
		if (!is_file($filer))		continue ;
		$fdr = fopen($filer,"r") ;
		$j = 0 ;
		while (!feof($fdr)) {
			$liner = fgets($fdr,10240);
			$marker = "\t" ;
			if (trim($liner)=="")		continue ;
			list($i18nkey,$i18napp,$i18nlang,$i18nval) = explode($marker,$liner) ;
			if (trim($liner==''))		continue ;
			if ($i18napp<>$module)		{$errors[] = array($filer,$liner,'1');	continue ;}
			if ($i18nlang<>$langcode)	{$errors[] = array($filer,$liner,'2');	continue ;}
			$i18nkey = trim($i18nkey) ;
			if ($i18nkey=="")		continue ;
			$i18nkey = addslashes(strtolower(trim($i18nkey))) ;
			$i18nval = addslashes(exapi_dbcharset(trim($i18nval),$langcode)) ;
			$sql =	"INSERT INTO ${pre}i18n (id,module,langcode,i18nkey,i18nval) " ;
			$sql.=	"VALUES ('$sid','$module','$langcode','$i18nkey','$i18nval')";
			$adodb->query($sql);
			$sid++ ;
			$j++ ;
			}
		fclose($fdr) ;
		$msg.= "[$langcode] language set for $module generated -- $j phrases added<br>" ;
		$i++ ;
		}

	$sql = ($ckapi['hostsys']['dbtype']=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$adodb->query($sql);

	$cfmmsg = "$i ".exapi_lang('language files parsed') ;
	$cfmmsg.= '<br>'."$langcode ".exapi_lang('language installation completed') ;

	$t->set_var('lang_confirm',$cfmmsg) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_yes',exapi_lang('done'));
	$t->set_var('lang_no',exapi_lang('done'));
	$t->set_var('yes_action',exapi_link("/$app/adminfilter.php")) ;
	$t->set_var('no_action',exapi_link("/$app/adminfilter.php")) ;
	
	$t->pparse('out','report',True);

	$invmod = exapi_lang('Invalid Module') ;
	$invlang = exapi_lang('Invalid Language Code') ;
	$msg.= '<br><br>' ;
	foreach($errors as $error) {
		if ($error[2]=='1')	$msg.= "$invmod -- $error[0] -- $error[1]<br>" ;
		if ($error[2]=='2')	$msg.= "$invlang -- $error[0] -- $error[1]<br>" ;
		}
	$t->set_var('message',$msg);
	$t->pparse('out','msg',True);

	exapi_footer() ;

?>
