<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.tip.inc.php 0.16.1 2005/12/04 C K Wu

    class tip {


//---- TIP List SQL Formation

    function tip_list_sql() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$lang_search = exapi_lang('Search for new untranslated phrases within current target module') ;
	$ckapi['objects']['template']->set_var('lang_search',$lang_search);
	$ckapi['objects']['template']->set_var('search_action',exapi_link("/$app/${tran}search.php",$getstr));
	$sql = "SELECT a.*,b.charset from $table a,${pre}i18ncode b " ;
	$sql.= "WHERE a.langcode=b.langcode $where order by ".$order." ".$sort;
	return $sql ;
	}

//---- TIP List Adjustement

    function tip_list_adjust() {
	global $ckapi ;

	$t = &$ckapi['objects']['template'] ;
	$i18nval = $ckapi['params_list']['dt']['i18nval'] ;
	$ckcharset = $ckapi['params_list']['dt']['charset'] ;
	$guicharset = isset($ckapi['hostsys']['guicharset']) ? $ckapi['hostsys']['guicharset'] : '' ;
	$i18nvalgui =($ckcharset==$guicharset or $guicharset=='')? $i18nval:iconv($ckcharset,$guicharset,$i18nval);
	$t->set_var('i18nvalgui',$i18nvalgui) ;
	if (isset($ckapi['hostsys']['dbcharset']) and $ckapi['hostsys']['dbcharset']=='utf8') {
		if ($ckcharset<>'utf8')		$t->set_var('i18nval',iconv('utf8',$ckcharset,$i18nval)) ;
		if ($guicharset<>'utf8')	$t->set_var('i18nvalgui',iconv('utf8',$guicharset,$i18nval)) ;
		}
	}

//---- TIP Read

   function tip_read() {
	global $ckapi,$adodb,$pre,$proc1 ;

	$table = $ckapi['params']['table'] ;
	$uniqueflds = isset($ckapi['params']['uniqueflds']) ? $ckapi['params']['uniqueflds'] : '' ;
	$id = $ckapi['params_post']['id'] ;
	$op = &$ckapi['params_post']['op'] ;

	$sql = "SELECT a.*,b.charset FROM $table a,${pre}i18ncode b WHERE a.id='$id' and a.langcode=b.langcode" ;
	$result = $adodb->query($sql);
	$dt = $result->fetchRow() ;
	if (is_array($uniqueflds) and $op=='edit')
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;

	if (isset($ckapi['hostsys']['dbcharset']) and $ckapi['hostsys']['dbcharset']=='utf8' and $dt['charset']<>'utf8')
		$dt['i18nval']=iconv('utf8',$dt['charset'],$dt['i18nval']) ;

	return $dt ;
	}

//---- TIP Validation Checks

    function tip_validate() {
	global $ckapi,$adodb,$basedir ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$dt = $ckapi['params_post']['dt'] ;
	$err=""; $error=exapi_lang("Error") ;
	if ($dt['i18nkey']=="")			$err=exapi_lang("Phrase Key Missing");
	   else	{
		$sql = "SELECT * from $table " ;
		$sql.= "WHERE i18nkey='$dt[i18nkey]' and langcode='$dt[langcode]' and module='$dt[module]'" ;
		$result = $adodb->query($sql);
		if (exapi_dbrc($result)>0 and !($dt['i18nkey']==$dt['oldi18nkey'] and $dt['langcode']==$dt['oldlangcode'] and $dt['module']==$dt['oldmodule']))
				$err=exapi_lang("Phrase Key / Language Code / Module combo already exists");
		}
	$result = $adodb->query("SELECT * from ${pre}i18ncode WHERE langcode='$dt[langcode]'");
	if (exapi_dbrc($result)<=0)		$err=exapi_lang("Language Code not yet defined"); 
	if ($dt['langcode']=='')			$err=exapi_lang("Language Code Missing");
	if (!is_dir($basedir.'/'.$dt['module']))$err=exapi_lang("Invalid Module");
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- TIP Delete Validation Checks

    function delete_validate() {
	global $adodb,$pre ;

	$err=""; $error=exapi_lang('Error') ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write TIP Detail

    function tip_write() {
	global $ckapi,$adodb,$pre ;

	$dt = $ckapi['params_post']['dt'] ;
	$op = $ckapi['params_post']['op'] ;
	$t = &$ckapi['objects']['template'] ;

	$dt['i18nkey'] = isset($dt['i18nkey']) ? strtolower($dt['i18nkey']) : '' ;
	$dt['langcode'] = isset($dt['langcode']) ? $dt['langcode'] : '' ;
	$dt['module'] = isset($dt['module']) ? $dt['module'] : '' ;
	$result = $adodb->query("SELECT charset from ${pre}i18ncode WHERE langcode='$dt[langcode]'");
	$rs = $result->fetchRow();
	$dt['charset'] = $rs['charset'] ;

	$msg1 = 'Words in Phrase Key (normally in English) should all be in lower case' ;
	$msg2 = 'This screen needs to be displayed in CK-ERP character set format to process correctly' ;
	$msg3 = 'Please ensure new/edited TIPs are displayed correctly in the List of TIPs' ;
	$t->set_var('lang_id',exapi_lang('Audit ID'));
	$t->set_var('lang_id_en','Audit ID');
	$t->set_var('lang_i18nkey',exapi_lang('Phrase Key'));
	$t->set_var('lang_i18nkey_en','Phrase Key');
	$t->set_var('lang_i18nval',exapi_lang('Phrase Translation'));
	$t->set_var('lang_i18nval_en','Phrase Translation');
	$t->set_var('lang_langcode',exapi_lang('Language Code'));
	$t->set_var('lang_langcode_en','Language Code');
	$t->set_var('lang_charset',exapi_lang('CK-ERP Character Set'));
	$t->set_var('lang_charset_en','CK-ERP Character Set');
	$t->set_var('lang_module',exapi_lang('Module'));
	$t->set_var('lang_module_en','Module');
	$t->set_var('lang_msg',exapi_lang ($msg1).'...'.exapi_lang ($msg2).'...'.exapi_lang ($msg3));
	$t->set_var('lang_msg_en',$msg1.'...'.$msg2.'...'.$msg3);

	$fields = array('id','control','i18nkey','i18nval','langcode','charset','module','oldi18nkey','oldlangcode','oldmodule') ;
	foreach ($fields as $field)
		if (isset($dt[$field]))		$t->set_var($field,$dt[$field]);
			else			$t->set_var($field,'') ;
	$t->set_var('langcode_selectlist',selectlist('i18ncode','langcode','',$dt['langcode'],'langcode','description','langcode'));
	$t->set_var('module_selectlist',module_selectlist('', $dt['module']));

	$t->parse('out','report',True);
	}

//---- TIP Post Initialisation

    function tip_post_init() {
	global $ckapi,$adodb,$pre ;

	$dt = &$ckapi['params_post']['dt'] ;
	$dt['i18nkey'] = strtolower($dt['i18nkey']) ;

	if ($ckapi['params_post']['op']=='new') {
		$result = $adodb->query("SELECT charset FROM ${pre}i18ncode WHERE langcode='$dt[langcode]'");
		$rs = $result->fetchRow() ;
		$dt['charset'] = $rs['charset'] ;
		}
	if (isset($ckapi['hostsys']['dbcharset']) and $ckapi['hostsys']['dbcharset']=='utf8' and $dt['charset']<>'utf8')
		$dt['i18nval']=iconv($dt['charset'],'utf8',$dt['i18nval']) ;
	}

    }

?>
