<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// modulefilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'module' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "${tran}filter_validate.php"		) ;

	$lang_obsolete = exapi_lang('Delete Obsolete phrases') ;
	$link_obsolete = exapi_link("/$app/${tran}obsolete.php");
	$link_fv = exapi_link("/$app/${tran}filter_validate.php");
	$obsolete_button = '</form>' ;
	$obsolete_button.= '<FORM method="POST" action="'.$link_obsolete.'">' ;
	$obsolete_button.= '<input type="submit" name="obsolete" value="'.$lang_obsolete.'">' ;
	$obsolete_button.= '</form>' ;
	$obsolete_button.= '<FORM method="POST" action="'.$link_fv.'">' ;

	$msg1 = exapi_lang('Common Phrases are those that are common across all modules') ;
	$msg2 = exapi_lang('Common Phrases are kept within the language files of ck-api') ;

	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among existing Translated Phrases :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Write Translated Phrases to Language Files") ,
			'lang_search_message'	=> $obsolete_button.$msg1.'<br>'.$msg2 ,
				'message'	=> ''						);

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Module') ,
				'type'		=>	'select' ,
				'selectlist'	=>	module_selectlist('','') ,
				'varname'	=>	'module' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Select the target module') );

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Language Code') ,
				'type'		=>	'select' ,
				'selectlist'	=>	selectlist('i18ncode','langcode','','','langcode','description','langcode') ,
				'varname'	=>	'langcode' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Select the target Language'));


	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Phrase Key') ,
				'type'		=>	'input' ,
				'varname'	=>	'i18nkey' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang('Search for target key word in the Phrase Key field (usually in English)') ) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Phrase Translation') ,
				'type'		=>	'input' ,
				'varname'	=>	'i18nval' ,
				'defval'	=>	"" ,
				'note'=>exapi_lang('Search for target key word in the Phrase Translation field') ) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Blank Translation') ,
				'type'		=>	'checkbox' ,
				'varname'	=>	'blank' ,
				'defval'	=>	"" ,
				'note'		=>	exapi_lang("Click box if phrases with totally blank translation are to be retrieved") );

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
