<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// modulewrite.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-i18n' ;
	$tran = 'module' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$t = exapi_tpl($app);
	$t->set_file('question','confirm.tpl');
	$t->set_file('msg','message.tpl');

	$modname=array(	'ck-api'	=>	'API' ,
			'ck-admin'	=>	'Administration' ,
			'ck-i18n'	=>	'i18n' ,
			'ck-contact'	=>	'Contact Management' ,
			'ck-crm'	=>	'Customer Relationship' ,
			'ck-css'	=>	'Customer Self Service' ,
			'ck-vrm'	=>	'Vendor Relationship' ,
			'ck-inv'	=>	'Inventory' ,
			'ck-service'	=>	'Service' ,
			'ck-ledger'	=>	'General Ledger' ,
			'ck-bank'	=>	'Bank Reconciliation' ,
			'ck-ap'		=>	'Accounts Payable / Invoices' ,
			'ck-ar'		=>	'Accounts Receivable / Invoices' ,
			'ck-po'		=>	'Purchase Order' ,
			'ck-so'		=>	'Sales Order' ,
			'ck-quote'	=>	'Quotation' ,
			'ck-pos-c'	=>	'POS for Cashier' ,
			'ck-pos-m'	=>	'POS for Manager' ,
			'ck-hr'		=>	'Human Resources' ,
			'ck-sss'	=>	'Staff Self Service' ,
			'ck-payroll'	=>	'Payroll'			) ;

	if (!isset($_POST['yes'])) {
		$msg1 = exapi_lang("Please make sure the webserver can create/overwrite Language Files within %1",exapi_lang('each CK-ERP module [setup] subfolder')) ;
		$msg2 = exapi_lang('Please restore directory/file access rights after current action') ;
		$qtn = exapi_lang('Are you sure you want to create new Language Files ?') ;
		$t->set_var('message',$msg1.'<br/>'.$msg2);
		$t->set_var('lang_confirm',$qtn);
		$t->set_var('lang_yes',exapi_lang('Yes'));
		$t->set_var('lang_no',exapi_lang('No'));
		$t->set_var('yes_action', exapi_link("/$app/${tran}write.php"));
		}
	   else {
		if (isset($ckapi['hostsys']['dbcharset']) and $ckapi['hostsys']['dbcharset']<>'') {
			$needconvert = True ;
			$dbcharset = $ckapi['hostsys']['dbcharset'] ;
			}
		  else	$needconvert = False ;
		$user = $ckapi['hostsys']['username']; $err='' ;
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='writelangfile'");
		if (exapi_dbflds($result,'used_by')<>"") {
			$err=exapi_lang("Language File Creation is being accessed by ").exapi_dbflds($result,'used_by');
			$t->set_var('lang_confirm',exapi_lang('Error').": $err");
			}
		  else	{
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='$user' WHERE resource='writelangfile'");
			$msg = '' ;
			$table = $pre.'i18n' ;
			$result = $adodb->query("SELECT distinct(module) FROM $table") ;
			while ($rs=$result->fetchRow())
				if (strstr($rs['module'],'ck-'))	$modules[]=$rs['module'] ;
			foreach ($modules as $module) {
				$result = $adodb->query("SELECT distinct(langcode) FROM $table WHERE module='$module'") ;
				while ($rs=$result->fetchRow())
					if ($rs['langcode']<>'')	$langs[]=$rs['langcode'];
				$i = 0 ;
				foreach ($langs as $langcode) {
					if ($needconvert) {
						$sql = "SELECT * FROM ck_i18ncode WHERE langcode='$langcode'";
						$result = $adodb->query($sql);
						$ckcharset = exapi_dbflds($result,'charset') ;
						}
					$filew = "$basedir/$module/setup/${module}_$langcode.lang" ;
					if ($_GET['test']<>'test')	exec("mv $filew $filew.old") ;
					  else				$filew.= '.test' ;
					$fdw = fopen($filew,"w") ;
					$sql = "SELECT * FROM $table WHERE module='$module' and langcode='$langcode' ORDER BY i18nkey";
					$result = $adodb->query($sql);
					while ($rs=$result->fetchRow()) {
						$i18nkey = strtolower(trim($rs['i18nkey'])) ;
						$i18nval = ($langcode=='en-hk' and isset($modname[$i18nkey])) ? $modname[$i18nkey] : $rs['i18nval'] ;
						if ($needconvert)  $i18nval=iconv($dbcharset,$ckcharset,$i18nval);
						fputs($fdw,"$i18nkey\t$module\t$langcode\t$i18nval\n");
						$i++ ;
						}
					fclose($fdw) ;
					$msg.= '<br/>'.exapi_lang('%1 created - %2 lines written',$filew,$i) ;
					$i = 0 ;
					}
				unset($langs) ;
				}
			$adodb->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='writelangfile'");
			$t->set_var('lang_confirm',exapi_lang('Module Language Files Created'));
			$t->set_var('message',$msg);
			}
		$t->set_var('lang_yes',exapi_lang('Done'));
		$t->set_var('lang_no',exapi_lang('Done'));
		$t->set_var('yes_action',exapi_link("/$app/${tran}filter.php")) ;
		}

	$t->set_var('no_action',exapi_link("/$app/${tran}filter.php")) ;
	$t->pparse('out','question',True);
	$t->pparse('out','msg',True);

	exapi_footer() ;

?>