<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// controlreport.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-inv' ;
	$tran = 'controlreport' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$status_date = isset($_GET['status_date']) ? $_GET['status_date'] : (isset($_POST['status_date'])?$_POST['status_date']:'');

/*---------------------------------------------------------------------------------*/

    $t = exapi_tpl($app);
    $t->set_file('report','controlreport.tpl');

/*---------------------------------------------------------------------------------*/

	$t->set_var('lang_control_report', exapi_lang('Inventory Audit Control Report'));
	$t->set_var('lang_system_date', exapi_lang('System Date'));
	$t->set_var('lang_parts', exapi_lang('Inventory<br>/Parts'));
	$t->set_var('lang_gr', exapi_lang('Goods<br>Receipt'));
	$t->set_var('lang_grtran', exapi_lang('Individual GR<br>Item/Line'));
	$t->set_var('lang_gd', exapi_lang('Goods<br>Delivery'));
	$t->set_var('lang_gdtran', exapi_lang('Individual GD<br>Item/Line'));
	$t->set_var('lang_ia', exapi_lang('Inventory<br>Adjustment'));
	$t->set_var('lang_iatran', exapi_lang('Individual IA<br>Item/Line'));
	$t->set_var('lang_current_status', exapi_lang('TOTAL DATABASE STATUS'));
	$t->set_var('lang_status_asof', exapi_lang('Status as of'));
	$t->set_var('lang_total_count', exapi_lang('Total Record Count'));
	$t->set_var('lang_latest_id', exapi_lang('Latest Audit Trail ID'));
	$lang_na = exapi_lang('N/A') ;

/*-----------------Gather and Write Database Info---------------------------------*/

$t->set_var('system_date',date("Y-m-d",time())) ;

$result = $adodb->query("SELECT count(id) as parts_count, max(id) as max_id FROM ${pre}parts WHERE inventory_accno_id<>0");
$t->set_var('parts_count',exapi_dbflds($result,'parts_count')) ;
$t->set_var('latest_parts_id',exapi_dbflds($result,'max_id')) ;

$result = $adodb->query("SELECT count(id) as gr_count, max(id) as max_id FROM ${pre}il WHERE substring(source,1,2)='GR'");
$t->set_var('gr_count',exapi_dbflds($result,'gr_count')) ;
$t->set_var('latest_gr_id',exapi_dbflds($result,'max_id')) ;

$result = $adodb->query("SELECT count(id) as gd_count, max(id) as max_id FROM ${pre}il WHERE substring(source,1,2)='GD'");
$t->set_var('gd_count',exapi_dbflds($result,'gd_count')) ;
$t->set_var('latest_gd_id',exapi_dbflds($result,'max_id')) ;

$result = $adodb->query("SELECT count(id) as ia_count, max(id) as max_id FROM ${pre}il WHERE substring(source,1,2)='IA'");
$t->set_var('ia_count',exapi_dbflds($result,'ia_count')) ;
$t->set_var('latest_ia_id',exapi_dbflds($result,'max_id')) ;

$sql =	"SELECT count(trans_id) as cnt FROM ${pre}inv_trans, ${pre}il " ;
$sql.=	"WHERE trans_id=id and substring(source,1,2)='GR'";
$result = $adodb->query($sql);
$t->set_var('grtran_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_grtran_id',$lang_na) ;

$sql =	"SELECT count(trans_id) as cnt FROM ${pre}inv_trans, ${pre}il " ;
$sql.=	"WHERE trans_id=id and substring(source,1,2)='GD'";
$result = $adodb->query($sql);
$t->set_var('gdtran_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_gdtran_id',$lang_na) ;

$sql =	"SELECT count(trans_id) as cnt FROM ${pre}inv_trans, ${pre}il " ;
$sql.=	"WHERE trans_id=id and substring(source,1,2)='IA'";
$result = $adodb->query($sql);
$t->set_var('iatran_count',exapi_dbflds($result,'cnt')) ;
$t->set_var('latest_iatran_id',$lang_na) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('done_action',exapi_link("/$app/index.php")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->pparse('out','report');
	exapi_footer() ;

?>
