<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.photo.inc.php 0.16.1 2005/12/04 C K Wu

    class photo {

//---- Phone Read

    function photo_read() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$id = $ckapi['params_post']['id'] ;

	$result = $adodb->query("SELECT * from ${pre}parts WHERE id='$id'");
	return $result->fetchRow() ;
	}


//---- Photo Detail Validation Checks

    function photo_validate() {
	global $ckapi ;

	$dt = &$ckapi['params_post']['dt'] ;
	$dt['phototype'] = isset($dt['phototype']) ? $dt['phototype'] : '' ;

	$err=""; $error=exapi_lang("Error") ;
	$maxfile = 10240 ;
	$newimg = "/tmp/$dt[id].ck-erp.img" ;
	if (isset($dt['post']) and $dt['post']<>'' and !is_file($newimg))
		$err = exapi_lang("Photo must be previewed before update");
	if (is_file($newimg) and filesize($newimg)>$maxfile)
		$err = exapi_lang("File size too large (max-10K)") ;
	if ($dt['phototype']<>"image")
		$err = exapi_lang("Photo must be of type (image), check if photo had been previewed") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Photo Detail

    function photo_write() {
	global $ckapi ;

	$app = $ckapi['params']['app'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$t->set_var('tr_color',$ckapi['hostsys']['tr_color2']) ;
	$t->set_var('lang_name',exapi_lang("Part Name/#"));
	$t->set_var('lang_id',exapi_lang("Audit ID").' :');
	$t->set_var('lang_oldphoto',exapi_lang('Existing Photo'));
	$t->set_var('lang_browse',exapi_lang("Click [Browse] to choose new photo's file name, then click [Preview New Photo]"));
	$t->set_var('lang_newphoto',exapi_lang('New Photo'));

	$id = $dt['id'] ;
	$dt['phototype'] = isset($dt['phototype']) ? $dt['phototype'] : '' ;
	$t->set_var('partnumber',$dt['partnumber']);
	$t->set_var('id',$id);
	$t->set_var('control',$dt['control']);
	$t->set_var('phototype',$dt['phototype']);
	$imgdir = $ckapi['hostsys']['dataarea']."/images" ;
	$oldimg = "$imgdir/$id.png" ;
	$newimg = '' ;
	$t->set_var('oldimage',exapi_link('/ck-api/view_image.php',"imgfile=$oldimg"));
	if (!isset($dt['post']) and isset($_FILES['photofile'])) {
		$tempimg = $_FILES['photofile']['tmp_name'] ;
		$types = explode("/",$_FILES['photofile']['type']) ;
		$dt['phototype'] = $types[0] ;
		$t->set_var('phototype',$dt['phototype']);
		exec("rm -f /tmp/*.ck-erp.img") ;
		$newimg = "/tmp/$id.ck-erp.img" ;
		move_uploaded_file($tempimg, $newimg) ;
		}
	$t->set_var('newimage',exapi_link('/ck-api/view_image.php',"imgfile=$newimg"));
	$t->parse('out','report',True);
	}

//---- Reformat Photo Data (Photo Preview)

    function photo_transform() {
	global $ckapi ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$preview = &$ckapi['buttons']['preview'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	if ($preview<>'') {
		$func = "${class}_validate" ;
		$err = $this->$func() ;
		if ($err) {
			$t->set_var('newimage',exapi_link('/ck-api/view_image.php'));
			$t->set_var('message',$err) ;
			}
		}
	}

//---- Photo Post - PreCommit Routine

    function photo_post_precommit() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	$op = $ckapi['params_post']['op'] ;
	$id = $ckapi['params_post']['id'] ;
	if ($op<>'delete') {
		$imgdir = $ckapi['hostsys']['dataarea']."/images" ;
		umask(000) ;
		if (!is_dir($imgdir))	mkdir($imgdir,0700) ;
		$newimg = "/tmp/$id.ck-erp.img" ;
		$fd = fopen($newimg,"r");
		$contents = fread($fd,filesize($newimg)) ;
		fclose($fd) ;
		$photo = "$imgdir/$id.png" ;
		umask(000) ;
		if ($fp = fopen($photo, "w")) {fputs($fp, $contents); fclose($fp);}
		}
	}

    }

?>
