<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// reportfilter_validate.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-ledger' ;
	$tran = 'report' ;
	$noheader = True ;  $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$err = isset($_GET['err']) ? $_GET['err'] : (isset($_POST['err'])?$_POST['err']:'');
	$actnum = isset($_GET['actnum']) ? $_GET['actnum'] : (isset($_POST['actnum'])?$_POST['actnum']:'');
	$account = isset($_GET['account']) ? $_GET['account'] : (isset($_POST['account'])?$_POST['account']:'');
	$attrib1 = isset($_GET['attrib1']) ? $_GET['attrib1'] : (isset($_POST['attrib1'])?$_POST['attrib1']:'');
	$attrib2 = isset($_GET['attrib2']) ? $_GET['attrib2'] : (isset($_POST['attrib2'])?$_POST['attrib2']:'');
	$attrib3 = isset($_GET['attrib3']) ? $_GET['attrib3'] : (isset($_POST['attrib3'])?$_POST['attrib3']:'');
	$rdate_curr = isset($_GET['rdate_curr']) ? $_GET['rdate_curr'] : (isset($_POST['rdate_curr'])?$_POST['rdate_curr']:'');
	$datefrom_curr = isset($_GET['datefrom_curr']) ? $_GET['datefrom_curr'] : (isset($_POST['datefrom_curr'])?$_POST['datefrom_curr']:'');
	$dateto_curr = isset($_GET['dateto_curr']) ? $_GET['dateto_curr'] : (isset($_POST['dateto_curr'])?$_POST['dateto_curr']:'');
	$rdate_comp = isset($_GET['rdate_comp']) ? $_GET['rdate_comp'] : (isset($_POST['rdate_comp'])?$_POST['rdate_comp']:'');
	$datefrom_comp = isset($_GET['datefrom_comp']) ? $_GET['datefrom_comp'] : (isset($_POST['datefrom_comp'])?$_POST['datefrom_comp']:'');
	$dateto_comp = isset($_GET['dateto_comp']) ? $_GET['dateto_comp'] : (isset($_POST['dateto_comp'])?$_POST['dateto_comp']:'');

/* --------------------- Validation Check Start ----------------------------	*/
	
	if (!$rdate_curr)			$rdate_curr = date("Y-m-d") ;

	$error = exapi_lang("Error") ;
	if ($actnum<1 or $actnum>6)		$err=exapi_lang("Invalid Report Number") ;
	if ($actnum==1 and !$rdate_curr)	$err=exapi_lang("Report Status Date (Current) missing");
	if ($actnum==2 and (!$datefrom_curr or !$dateto_curr or !$datefrom_comp or !$dateto_comp))
			$err=exapi_lang("Missing one of these:  Date from/to (Current/Comparison)");
	if ($actnum==3 and (!$rdate_curr or !$rdate_comp))
			$err=exapi_lang("Missing Report Status Date (Current or Comparison)");
	if ($actnum==4 and (!$datefrom_curr or !$dateto_curr))
			$err=exapi_lang("Missing Date from/to (Current).");
	if ($actnum==5 and !$rdate_curr)	$err=exapi_lang("Report Status Date (Current) missing");
	if ($rdate_curr) {
		$date=input2date($rdate_curr) ;
		if ($date=="")
			$err=exapi_lang("Invalid Report Status Date (Current)"); else $rdate_curr = $date ;
		}
	if ($datefrom_curr) {
		$date=input2date($datefrom_curr) ;
		if ($date=="")
			$err=exapi_lang("Invalid Report from Date (Current)"); else $datefrom_curr=$date;
		}
	if ($dateto_curr) {
		$date=input2date($dateto_curr) ;
		if ($date=="")
			$err=exapi_lang("Invalid Report to Date (Current)"); else $dateto_curr=$date ;
		}
	if ($rdate_comp) {
		$date=input2date($rdate_comp) ;
		if ($date=="")
			$err=exapi_lang("Invalid Report Status Date (Comparison)"); else $rdate_comp=$date;
		}
	if ($datefrom_comp) {
		$date=input2date($datefrom_comp) ;
		if ($date=="")
			$err=exapi_lang("Invalid Report from Date (Comparison)"); else $datefrom_comp=$date;
		}
	if ($dateto_comp) {
		$date=input2date($dateto_comp) ;
		if ($date=="")
			$err=exapi_lang("Invalid Report to Date (Comparison)"); else $dateto_comp=$date ;
		}
	if ($actnum==4 and (strtotime($dateto_curr)-strtotime($datefrom_curr))>366*24*60*60)
			$err=exapi_lang("(DateTo-DateFrom) must be < 367 days") ;
	if ($actnum==4 and !$err)	{
		$user = $ckapi['hostsys']['username'];
		$result = $adodb->query("SELECT * FROM ${pre}resourcelock WHERE resource='ledgerlisting'");
		if (exapi_dbflds($result,'used_by')=="") {
				$sql = "UPDATE ${pre}resourcelock SET used_by='$user' " ;
				$sql.= "WHERE resource='ledgerlisting'" ;
				$adodb->query($sql);
				}
			else $err=exapi_lang("Ledger Listing is being accessed by ").exapi_dbflds($result,'used_by');
		}

	if ($err)	$err="<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

if (!$err)
	{
	switch ($actnum) {
		case 1:
			$getstr = "report_date=$rdate_curr&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.exapi_link("/$app/trialbalance.php",$getstr));
			exit();
		case 2:
			$getstr = "start_this_period=$datefrom_curr&end_this_period=$dateto_curr&" ;
			$getstr.= "start_last_period=$datefrom_comp&end_last_period=$dateto_comp&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.exapi_link("/$app/incomestatement.php",$getstr));
			exit();
		case 3:
			$getstr = "this_period=$rdate_curr&last_period=$rdate_comp&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.exapi_link("/$app/balancesheet.php",$getstr));
			exit();
		case 4:
			$getstr = "start_date=$datefrom_curr&end_date=$dateto_curr&account=$account&" ;
			$getstr.= "attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
			Header('Location: '.exapi_link("/$app/ledgerlisting.php",$getstr));
			exit();
		case 5:
			$getstr = "status_date=$rdate_curr" ;
			Header('Location: '.exapi_link("/$app/controlreport.php",$getstr));
			exit();
		case 6:
			Header('Location: '.exapi_link("/$app/journalerrlist.php"));
			exit();
		default:
			echo "Should not be here.  Weird Report Number" ;
		}
	}
else
	{
	$getstr = "actnum=$actnum&attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3&account=$account&";
	$getstr.= "rdate_curr=$rdate_curr&datefrom_curr=$datefrom_curr&dateto_curr=$dateto_curr&" ;
	$getstr.= "rdate_comp=$rdate_comp&datefrom_comp=$datefrom_comp&dateto_comp=$dateto_comp&" ;
	$getstr.= "err=$err" ;
	Header('Location: '.exapi_link("/$app/reportfilter.php",$getstr));
	exit();
	}

?>
