<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// nrtransfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-payroll' ;
	$tran = 'nrtrans' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'nrtrans',
				'tran'		=> $tran ,
				'table'		=> "${pre}pynr_trans" 			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among existing Non-recurring Payroll Items :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Non-recurring Payroll Item") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Payroll Item Type') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.selectlist('pyrcode','name','','','id','description','id') ,
				'varname'	=>	'eaid' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for target non-recurring payroll item type'));

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Employee/#') ,
				'type'		=>	'input' ,
				'varname'	=>	'empname' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for target key word in the Employee Name field')) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
