<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// pyrcodefilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-payroll' ;
	$tran = 'pyrcode' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'pyrcode',
				'tran'		=> $tran ,
				'table'		=> "${pre}pyrcode" 			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among existing Allowance/Deduction Codes :"),
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Allowance/Deduction Code") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$note1 = exapi_lang('Search for target [Basis of Calculation]') ;
	$note2a = exapi_lang("bs - basic salary, pc - allowance/deduction unit amount, dp - imputed daily pay,") ;
	$note2b = exapi_lang("hp - imputed hourly pay, qty - inputted qty, amt - inputted amount");

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Basis of Calculation') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.selectlist('pyrcode','basis','','','distinct basis','basis') ,
				'varname'	=>	'basis' ,
				'defval'	=>	'' ,
				'note'		=>	"$note1:<br>$note2a<br>$note2b"		);

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Code Name') ,
				'type'		=>	'input' ,
				'varname'	=>	'name' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for target keyword embedded in the Allowance/Deduction Code'));

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Code Description') ,
				'type'		=>	'input' ,
				'varname'	=>	'desc' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for target keyword embedded in the Allowance/Deduction Description'));

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
