<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// pobillhist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-po' ;
	$tran = $ckapi['params']['tran'] = 'pobill' ; 
	$class = 'po' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$filter=stripslashes($filter);

	$po = newobj($app,$class) ;
	$t = exapi_tpl($app);
	$ckapi['objects']['template'] = &$t ;
	$t->set_file('report',"pobillhist.tpl") ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',exapi_lang('View PO Billing History'));
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;

/*------------- Write PO Billing History to Screen Display ----------------------------*/

	$result = $adodb->query("SELECT * FROM ${pre}po WHERE id='$id'");
	$ckapi['params_post']['dt'] = $result->fetchRow() ;
	$ckapi['params_post']['dt']['oldisocode'] = '' ;
	$duedate = $ckapi['params_post']['dt']['duedate'] ;
	$poamount = $ckapi['params_post']['dt']['amount'] ;
	$netamount = $ckapi['params_post']['dt']['netamount'] ;
	$taxincluded = $ckapi['params_post']['dt']['taxincluded'] ;
	$ckapi['params_post']['dt']['taxstatus'] = ($poamount==$netamount) ? "e" : $taxincluded ;
	$po->po_header_write() ;

	$t->set_var('lang_date',exapi_lang('Date'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_invoiceid',exapi_lang('Invoice ID'));
	$t->set_var('lang_invamount',exapi_lang('Invoice Amount'));
	$t->set_var('lang_bamount',exapi_lang('Amount billed<br>against this PO'));
	$t->set_var('lang_osamount',exapi_lang('Outstanding PO<br>Unbilled Amount'));
	$t->set_var('lang_title_detail',exapi_lang('Detail'));
	$t->set_var('note1',exapi_lang('Note 1 - Days Elapsed since PO due and not fully billed'));
	$t->set_var('note2',exapi_lang('Note 2 - Press [done] button at Detail screen to work on detail transaction maintenance'));

	$t->set_var('date',$duedate);
	$t->set_var('description','<- '.exapi_lang('Due Date').' / '.exapi_lang('PO Amount').' ->');
	$t->set_var('invoiceid','');
	$t->set_var('invamount','');
	$t->set_var('bamount','');
	$t->set_var('osamount',$poamount);
	$t->set_var('lang_item',exapi_lang('PO'));
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$pofilter = urlencode("${markpri}1a.id${marksec}${id}") ;
	$tran1 = ($poamount==$netamount) ? "pont" : "powt" ;
	$item = exapi_link("/$app/${tran1}view.php","id=$id&filter=$pofilter");
	$t->set_var('item',$item) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT transdate,id,invnumber,amount,netamount,b_amount FROM ${pre}ap, ${pre}ipmatch " ;
	$sql.= "WHERE poid='$id' and id=invoiceid ORDER BY transdate" ;
	$result = $adodb->query($sql);
	$osamount = $poamount ;
	While ($rs=$result->fetchRow()) {
		$id = $rs['id'] ;
		$invamount = $rs['amount'] ;
		$netaount = $rs['netamount'] ;
		$bamount = $rs['b_amount'] ;
		$t->set_var('date',$rs['transdate']);
		$lang_invno = exapi_lang('Invoice#') ;
		$t->set_var('description',"$lang_invno:    ".$rs['invnumber']);
		$t->set_var('invoiceid',$id);
		$t->set_var('invamount',$invamount);
		$bamount = $rs['b_amount'] ;
		$t->set_var('bamount',$bamount);
		$osamount -= $bamount ;
		$t->set_var('osamount',$osamount);
		$t->set_var('lang_item',exapi_lang('Invoice'));
		$pofilter = urlencode("${markpri}1a.id${marksec}${id}") ;
		$tran2 = ($invamount==$netamount) ? "invoicent" : "invoicewt" ;
		$item = exapi_link("/ck-ap/${tran2}view.php","id=$id&filter=$pofilter");
		$t->set_var('item',$item) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('description','<- '.exapi_lang('System Date').' / '.exapi_lang('Days Overdue [Note 1]').' ->');
	$t->set_var('invoiceid','');
	$t->set_var('invamount','');
	$t->set_var('bamount','');
	$t->set_var('osamount','');
	$t->set_var('lang_item','');
	$overdue = (time()-strtotime($duedate))/86400 ;

	$overdue = ($overdue<0 or $osamount<=0) ? exapi_lang("N/A") : floor($overdue) ;
	$t->set_var('invoiceid',$overdue);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',exapi_link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_post',exapi_lang('Done'));
	$t->set_var('lang_newrow',exapi_lang('Done'));
	$t->set_var('lang_update',exapi_lang('Done'));
	$t->set_var('done_action',exapi_link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_done',exapi_lang('Done'));
	$t->set_var('message','') ;
	$t->pparse('out','report',True);
	exapi_footer() ;

?>
