<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// cswtlist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-pos-c' ;
	$tran = 'cswt' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}pos" 				) ;
	$note = exapi_lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight') ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Cash Sales [with Tax]") ,
				'lang_add'	=> exapi_lang("Add New Cash Sale [with Tax]") ,
				'lang_note'	=> $note				) ;
	$ckapi['columns'] = array('transdate'	=> exapi_lang('Sale Date') ,
				'shift'		=> exapi_lang('Shift') ,
				'cashbox'	=> exapi_lang('Cash Box') ,
				'posnumber'	=> exapi_lang('Cash Sale# [cashier:date:time]') ,
				'amount'	=> exapi_lang('Amount') ,
				'id'		=> exapi_lang('Audit ID') 		) ;
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'memo'		=> "/$app/${tran}memo.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi['lang_links'] = array('lang_view'=> exapi_lang("View") ,
				'lang_memo'	=> exapi_lang("Sales Memo") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")			) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;
	exapi_footer() ;

?>
