<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.cswt.inc.php 0.16.1 2005/12/04 C K Wu

    class cswt {

//---- Cash Sale List SQL Formation

    function cswt_list_sql() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	foreach ($ckapi['params_sql'] as $key => $value)	$$key = $value ;

	$sql =  "SELECT transdate,a.shift as shift,b.name as cashbox,posnumber,amount,a.id as id " ;
	$sql.=  "FROM ${pre}pos a, ${pre}cashbox b " ;
	$sql.=	"WHERE amount<>netamount $where AND a.cboxid=b.id ORDER BY $order $sort" ;
	return $sql ;
	}

//---- Cash Sale Data Read

    function cswt_read() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$id = $ckapi['params_post']['id'] ;
	$op = $ckapi['params_post']['op'] ;

	$result = $adodb->query("SELECT * FROM ${pre}pos WHERE id='$id'");
	$dt = $result->fetchRow() ;
	$dt['taxstatus'] = $dt['taxincluded'] ;
	if ($op=='add' or $op=='copy') {
		$dt['cashier'] = $ckapi['hostsys']['username'];
		$dt['cboxid'] = $dt['shift'] = '' ;
		$dt['posnumber'] = exapi_lang('[to be assigned]') ;
		}

	$sql = "SELECT * FROM ${pre}positem WHERE trans_id='$id' and (itemtype='i' or itemtype='s') ORDER BY id" ;
	$result = $adodb->query($sql);
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['csitemid'.$i]	=	$rs['itemid'] ;
		$dt['csitemtype'.$i]	=	$rs['itemtype'] ;
		$dt['csqty'.$i]		=	$rs['qty'] ;
		$dt['csunit'.$i]	=	$rs['unit'] ;
		$dt['csprice'.$i]	=	$rs['price'] ;
		$dt['csdiscount'.$i]	=	$rs['discount'] ;
		$dt['cstax1'.$i]	=	$rs['tax1'] ;
		$dt['cstax2'.$i]	=	$rs['tax2'] ;
		$dt['cstax1accid'.$i]	=	$rs['tax1acc_id'] ;
		$dt['cstax2accid'.$i]	=	$rs['tax2acc_id'] ;
		}
	$result = $adodb->query("SELECT * FROM ${pre}positem WHERE trans_id='$id' and itemtype='a' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['aoitemid'.$i]	=	$rs['itemid'] ;
		$dt['aotax1'.$i]	=	$rs['tax1'] ;
		$dt['aotax2'.$i]	=	$rs['tax2'] ;
		$dt['aotax1accid'.$i]	=	$rs['tax1acc_id'] ;
		$dt['aotax2accid'.$i]	=	$rs['tax2acc_id'] ;
		}

	$result = $adodb->query("SELECT * FROM ${pre}positem WHERE trans_id='$id' and itemtype='q' ORDER BY id");
	For ($i=1;$rs=$result->fetchRow();$i++) {
		$dt['qcitemid'.$i]	=	$rs['itemid'] ;
		$dt['qcqty'.$i]		=	$rs['qty'] ;
		$dt['qcvalue'.$i]	=	$rs['value'] ;
		}
	return $dt ;
	}

//---- Cash Sale Add Initialisation

    function cswt_add_init() {
	global $ckapi,$pre,$adodb ;

	$dt = &$ckapi['params_post']['dt'] ;
	$dt['transdate'] = date("Y-m-d") ;
	$dt['cashier'] = $ckapi['hostsys']['username'];
	$dt['posnumber'] = exapi_lang("[to be assigned]") ;
	$result = $adodb->query("SELECT id FROM ${pre}customer WHERE name='____Cash'");
	$dt['customer'] = exapi_dbflds($result,'id') ;
	$fields = array('id','control','shift','cboxid','taxstatus') ;
	foreach ($fields as $field)	$dt[$field]='' ;
	}

//---- Cash Sale Detail Validation Checks

    function cswt_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$err = "";
	$csrow = exapi_lang("csRow") ;
	$cserr = exapi_lang("csError:") ;
	if (input2date($dt['transdate'])=="")	$err="$cserr ".exapi_lang("Invalid Cash Sale Date");
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$csrowi = "[$csrow $i]" ;
		if ($dt['csitemid'.$i]=='')	$err="$csrowi$cserr ".exapi_lang("Item Code Missing");
		if ($dt['csqty'.$i] and !is_numeric($dt['csqty'.$i]))
					$err="$csrowi$cserr ".exapi_lang("Invalid Qty, must be numeric");
		if ($dt['csdiscount'.$i] and !is_numeric($dt['csdiscount'.$i]))
				$err="$csrowi$cserr ".exapi_lang("Invalid Discount, must be numeric");
		}
	$cstotal = $dt['cstotal'] ;
	$cserrstatus = $err ;
	$aorow = exapi_lang("aoRow") ;
	$aoerr = exapi_lang("aoError:") ;
	For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
		$aorowi = "[$aorow $i]" ;
		if ($dt['aoitemid'.$i]=='')	$err="$aorowi$aoerr ".exapi_lang("Item Code Missing");
		  else	{
			$aoitemid = $dt['aoitemid'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}addon WHERE id='$aoitemid'");
			if (exapi_dbrc($result)>0) {
				$mincount = exapi_dbflds($result,"mincount") ;
				$maxcount = exapi_dbflds($result,"maxcount") ;
				$minsale = exapi_dbflds($result,"minsale") ;
				$maxsale = exapi_dbflds($result,"maxsale") ;
				}
			$count = 0 ;
			For ($j=1;isset($dt['aoitemid'.$j]);$j++) {
				if ($dt['aoitemid'.$j]==$aoitemid)	$count++ ;
				}
			if ($count<$mincount)
				$err="$aoerr ".exapi_lang("Item count < Min count for").$aorowi ;
			if ($count>$maxcount)
				$err="$aoerr ".exapi_lang("Item count > Max count for").$aorowi ;
			if ($cstotal<$minsale)
				$err="$aoerr ".exapi_lang("Total Gross Sale < Min sale for").$aorowi ;
			if ($cstotal>$maxsale)
				$err="$aoerr ".exapi_lang("Total Gross Sale > Max sale for").$aorowi ;
			}
		}
	if ($i==2 and $dt['aoitemid1']=='')		$err = $cserrstatus ;
	$qcrow = exapi_lang("qcRow") ;
	$qcerr = exapi_lang("qcError:") ;
	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		$qcrowi = "[$qcrow $i]" ;
		if ($dt['qcitemid'.$i]=='')	$err="$qcrowi$qcerr ".exapi_lang("Item Code Missing");
		  else	{
			if ($dt['qcqty'.$i] and !is_numeric($dt['qcqty'.$i]))
					$err="$qcrowi$qcerr ".exapi_lang("Invalid Qty, must be numeric");
			if ($dt['qcvalue'.$i] and !is_numeric($dt['qcvalue'.$i]))
				$err="$qcrowi$qcerr ".exapi_lang("Invalid Value, must be numeric");
			$qcitemid = $dt['qcitemid'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}qcash WHERE id='$qcitemid'");
			if (exapi_dbrc($result)>0) {
				$minsale = exapi_dbflds($result,"minsale") ;
				$maxsale = exapi_dbflds($result,"maxsale") ;
				$minqty = exapi_dbflds($result,"minqty") ;
				$maxqty = exapi_dbflds($result,"maxqty") ;
				$minvalue = exapi_dbflds($result,"minvalue") ;
				$maxvalue = exapi_dbflds($result,"maxvalue") ;
				}
			$qty = $value = 0 ;
			For ($j=1;isset($dt['qcitemid'.$j]);$j++) {
				if ($dt['qcitemid'.$j]==$qcitemid) {
					$qty += $dt['qcqty'.$j] ;
					$value += $dt['qcvalue'.$j] ;
					}
				}
			if ($qty<$minqty)
				$err="$qcerr ".exapi_lang("Total item qty < Min qty for").$qcrowi ;
			if ($qty>$maxqty)
				$err="$qcerr ".exapi_lang("Total item qty > Max qty for").$qcrowi ;
			if ($value<$minvalue)
				$err="$qcerr ".exapi_lang("Total item value < Min value for").$qcrowi ;
			if ($value>$maxvalue)
				$err="$qcerr ".exapi_lang("Total item value > Max value for").$qcrowi ;
			if ($cstotal<$minsale)
				$err="$qcerr ".exapi_lang("Total Gross Sale < Min sale for").$qcrowi ;
			if ($cstotal>$maxsale)
				$err="$qcerr ".exapi_lang("Total Gross Sale > Max sale for").$qcrowi ;
			}
		}
	if ($dt['totqc']<$dt['totpay'])	$err="$qcerr ".exapi_lang("Total Tendered < Total Payable") ;
	if ($dt['cboxid']=="")		$err="$cserr ".exapi_lang("Cashier with no Cash Box assigned");
	  else	{
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='s'" ;
		$result = $adodb->query($sql) ;
		if (exapi_dbrc($result)<=0)
			$err="$cserr ".exapi_lang("Cashbox start-of-shift action pending") ;
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
		$result = $adodb->query($sql) ;
		if (exapi_dbrc($result)>0)
			$err="$cserr ".exapi_lang("Cashbox closed (end-of-shift completed)") ;
		}
	if (!$err and $dt['cboxid']<>"")	{
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='s'" ;
		$result = $adodb->query($sql) ;
		if (exapi_dbrc($result)<=0)
			$err="$cserr ".exapi_lang("Cashbox start-of-shift action pending") ;
		$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
		$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
		$result = $adodb->query($sql) ;
		if (exapi_dbrc($result)>0)
			$err="$cserr ".exapi_lang("Cashbox closed (end-of-shift completed)") ;
		  else	{
			$result = $adodb->query("SELECT * FROM ${pre}cashbox where id='$dt[cboxid]'") ;
			$maxcash = exapi_dbflds($result,'maxcash') ;
			$cashbal = $this->cashbalance($dt['cboxid'],$dt['transdate'],$dt['shift']) ;
			$warning = exapi_lang("Warning:") ;
			if ($cashbal>=$maxcash)	$err="$warning ".exapi_lang("Cash Full Level reached") ;
			}
		}
	if ($err)	$err = "<b><font size='+2'>$err</font></b>" ;
	if (substr_count($err,exapi_lang("csError:"))>0)	$t->set_var('csmessage',$err);
	if (substr_count($err,exapi_lang("Warning:"))>0)	{$t->set_var('csmessage',$err); $err="";}
	if (substr_count($err,exapi_lang("aoError:"))>0)	$t->set_var('aomessage',$err);
	if (substr_count($err,exapi_lang("qcError:"))>0)	$t->set_var('qcmessage',$err);
	return $err ;
	}

//---- Cash Sale Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = $ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	$sql = "SELECT * FROM ${pre}cbtran WHERE cboxid='$dt[cboxid]' and " ;
	$sql.= "transdate='$dt[transdate]' and shift='$dt[shift]' and trantype='e'" ;
	$result = $adodb->query($sql) ;
	if (exapi_dbrc($result)>0)
		$err="$cserr ".exapi_lang("Cashbox closed (end-of-shift completed)") ;
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Cash Sale Header

    function cswt_header_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$script = &$ckapi['params_post']['script'] ;
	$t = &$ckapi['objects']['template'] ;

	$taxstatus = $dt['taxstatus'] ;
	$t->set_var('lang_posnumber',exapi_lang('Cash Sale#'));
	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_cashier',exapi_lang('Cashier:')." ");
	$t->set_var('lang_cashbox',exapi_lang('Cash Box:')." ");
	$t->set_var('lang_transdate',exapi_lang('Date'));
	$t->set_var('lang_shift',exapi_lang('Shift'));
	$t->set_var('lang_customer',exapi_lang('Customer'));
	$t->set_var('lang_taxstatus',exapi_lang('Unit Price Tax Status'));
	$t->set_var('posnumber',$dt['posnumber']) ;
	$cashier = $dt['cashier'] ;
	$transdate = $dt['transdate'] ;
	$shift = $dt['shift'] ;
	$customer = $dt['customer'] ;
	$cboxid = $dt['cboxid'] ;
	$sql = ($cboxid) ? "SELECT * FROM ${pre}cashbox WHERE id='$cboxid'" :
			"SELECT * FROM ${pre}cashbox WHERE cashier='$cashier'" ;
	$result = $adodb->query($sql) ;
	$t->set_var('cashbox',exapi_dbflds($result,'name')) ;
	if (!$cboxid)	$cboxid = exapi_dbflds($result,'id') ;
	if (!$shift)	$shift = exapi_dbflds($result,'shift') ;
	if ($shift=="1")		$shift_desc = "1 - Morning" ;
	if ($shift=="2")		$shift_desc = "2 - Afternoon" ;
	if ($shift=="3")		$shift_desc = "3 - Overnight" ;
	$t->set_var('id',$dt['id']) ;
	$t->set_var('control',$dt['control']) ;
	$t->set_var('cashier',$cashier) ;
	$t->set_var('transdate',$transdate) ;
	$t->set_var('shift',$shift) ;
	$t->set_var('shift_desc',$shift_desc) ;
	$t->set_var('cboxid',$cboxid) ;
	$t->set_var('customer',$customer) ;
	$t->set_var('customer_selectlist',selectlist('customer','name','',$customer,'id','name','id')) ;
	$tax_sl = "<OPTION value='t'>".exapi_lang('Tax Included')."</OPTION>" ;
	$tax_sl.= "<OPTION value='f'>".exapi_lang('Tax Not Included')."</OPTION>" ;
	$tax_sl.= "<OPTION value='e'>".exapi_lang('Tax Exempted')."</OPTION>" ;
	$tax_sl = str_replace("'$taxstatus'","'$taxstatus' selected",$tax_sl) ;
	$t->set_var('tax_selectlist',$tax_sl) ;
	$t->set_var('id',$dt['id']) ;
	$t->parse('out','report',True);
	}

//---- Reformat Cash Sales Array

    function cswt_transform() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;

	$csrow_ = exapi_lang('csRow')." " ;
	$csnewrow = exapi_lang('Add New Cash Sale Item Row') ;
//	$cashsale = exapi_lang('Cash Sale') ;
	$temp['id'] = $dt['id'] ;
	$temp['control'] = $dt['control'] ;
	$temp['cashier'] = $dt['cashier'] ;
	$temp['posnumber'] = $dt['posnumber'] ;
	$temp['transdate'] = $dt['transdate'] ;
	$temp['shift'] = $dt['shift'] ;
	$temp['cboxid'] = $dt['cboxid'] ;
	$temp['customer'] = $dt['customer'] ;
	$temp['taxstatus'] = $dt['taxstatus'] ;

	if (isset($delete)) {$delrowno = intval(str_replace($csrow_,"",$delete)); }
	$j = 1 ;
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$csitemid = $dt['csitemid'.$i] ;
		if ($i==$delrowno) continue;
		if ($csitemid<0)	{
			$csitemid = -$csitemid ;
			$csqty = $dt['csqty'.$i]==0 ? 1 : $dt['csqty'.$i] ;
			$result = $adodb->query("SELECT * FROM ${pre}assembly WHERE assembly_id='$csitemid'");
			While ($rs=$result->fetchRow()) {
				$temp['csitemid'.$j] = $rs['item_id'] ;
				$temp['csqty'.$j] = $rs['qty'] * $csqty ;
				$j++ ;
				}
			continue ;
			}
		$temp['csitemid'.$j]		=	$dt['csitemid'.$i] ;
		$temp['csqty'.$j]		=	$dt['csqty'.$i] ;
		$temp['csprice'.$j]		=	isset($dt['csprice'.$i]) ? $dt['csprice'.$i] : '' ;
		$temp['csdiscount'.$j]		=	$dt['csdiscount'.$i] ;
		$temp['cstax1'.$j]		=	isset($dt['cstax1'.$i]) ? $dt['cstax1'.$i] : '' ;
		$temp['cstax2'.$j]		=	isset($dt['cstax2'.$i]) ? $dt['cstax2'.$i] : '' ;
		$temp['cstax1accid'.$j]		=	isset($dt['cstax1accid'.$i]) ? $dt['cstax1accid'.$i] : '' ;
		$temp['cstax2accid'.$j]		=	isset($dt['cstax2accid'.$i]) ? $dt['cstax2accid'.$i] : '' ;
		$j++ ;
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$csnewrow ;
	if ($newrow==$csnewrow)	{
		$fields = array('csitemid','csitemtype','csunit','csqty','csprice','csdiscount','cstax1','cstax2','cstax1accid','cstax2accid') ;
		foreach ($fields as $field)	$temp[$field.$j] = '' ;
		}

	if ($newrow==$csnewrow)				$temp['csitemid'.$j] = "" ;
			
	For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
		$temp['aoitemid'.$i]		=	$dt['aoitemid'.$i] ;
		$temp['aotax1'.$i]		=	isset($dt['aotax1'.$i]) ? $dt['aotax1'.$i] : '' ;
		$temp['aotax2'.$i]		=	isset($dt['aotax2'.$i]) ? $dt['aotax2'.$i] : '' ;
		$temp['aotax1accid'.$i]		=	isset($dt['aotax1accid'.$i]) ? $dt['aotax1accid'.$i] : '' ;
		$temp['aotax2accid'.$i]		=	isset($dt['aotax2accid'.$i]) ? $dt['aotax2accid'.$i] : '' ;
		}

	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		$temp['qcitemid'.$i]		=	$dt['qcitemid'.$i] ;
		$temp['qcqty'.$i]		=	$dt['qcqty'.$i] ;
		$temp['qcvalue'.$i]		=	$dt['qcvalue'.$i] ;
		}
	
	$dt = $temp ;
	unset($temp) ;
	}

//---- Write Cash Sale Detail

    function cswt_detail_write() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$firstime = isset($ckapi['params_post']['firstime']) ? $ckapi['params_post']['firstime'] : '' ;
	$op = $ckapi['params_post']['op'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$csrow_ = exapi_lang('csRow')." " ;
	$csnewrow = exapi_lang('Add New Cash Sale Item Row') ;
	$taxstatus = $dt['taxstatus'] ;
	if ($op=="view" or $op=="delete")	$posted = True ;
	$result = $adodb->query("SELECT postax1cap,postax2cap,postax1pref,postax2pref FROM ${pre}defaults");
	$t->set_var('lang_tax1',exapi_dbflds($result,'postax1cap'));
	$t->set_var('lang_tax2',exapi_dbflds($result,'postax2cap'));
	$tax1pref = exapi_dbflds($result,'postax1pref') ;
	$tax2pref = exapi_dbflds($result,'postax2pref') ;
	if ($tax1pref=='s') {
		$sql="SELECT customer_id,chart_id,rate from ${pre}customertax a,${pre}tax b,${pre}customer c";
		$sql.= " WHERE c.name='____Myself' and customer_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$result = $adodb->query($sql);
		$stax1chartid = exapi_dbflds($result,'chart_id') ;
		$stax1rate = exapi_dbflds($result,'rate') ;
		}
	if ($tax2pref=='s') {
		$sql="SELECT customer_id,chart_id,rate from ${pre}customertax a,${pre}tax b,${pre}customer c";
		$sql.= " WHERE c.name='____Myself' and customer_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$result = $adodb->query($sql);
		$stax2chartid = exapi_dbflds($result,'chart_id') ;
		$stax2rate = exapi_dbflds($result,'rate') ;
		}
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_csale',exapi_lang('Cash Sale Items :'));
	$t->set_var('lang_number',exapi_lang('Item Code - Id'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_unit',exapi_lang('Unit'));
	$t->set_var('lang_btup',exapi_lang('BTUP'));
	$t->set_var('lang_discount',exapi_lang('Discount')."<br>$");
	$t->set_var('lang_price',exapi_lang('Unit Price'));
	$t->set_var('lang_netamount',exapi_lang('Net Sale [ns]<br>(w/o tax)'));
	$t->set_var('lang_grosssale',exapi_lang('Gross Sale [gs]<br>(with tax)'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_csnewrow',$csnewrow);
	$item_sl = item_selectlist("",'') ;

	$cstotnet = 0 ;
	$cstotal = 0 ;
	For ($i=1;isset($dt['csitemid'.$i]);$i++) {
		$t->set_var('itemid_fld','csitemid'.$i) ;
		$t->set_var('qty_fld','csqty'.$i);
		$t->set_var('discount_fld','csdiscount'.$i);
		$csitemid = $dt['csitemid'.$i] ;
		$t->set_var('csitemid',$csitemid) ;
		$t->set_var('item_selectlist',str_replace("'$csitemid'","'$csitemid'"." selected",$item_sl));
		$csqty = ($csitemid<>'' and $dt['csqty'.$i]=='') ? 1 : $dt['csqty'.$i] ;
		$csdiscount = $dt['csdiscount'.$i] ;
		$csprice = $dt['csprice'.$i] ;
		unset($itemid) ;
		$csitemid = ($csitemid=="") ? 0 : $csitemid ;
		$result = $adodb->query("SELECT * FROM ${pre}sprice WHERE id='$csitemid'") ;
		if (exapi_dbrc($result)>0) {
			$itemid = $dt['itemid'.$i] = exapi_dbflds($result,'itemid') ;
			$name = exapi_dbflds($result,'name') ;
			$price = exapi_dbflds($result,'price') ;
			}
		$item_id = isset($itemid) ? $itemid : $csitemid ;
		$result = $adodb->query("SELECT * FROM ${pre}service WHERE id='$item_id'") ;
		if (exapi_dbrc($result)>0) {
			$type = "s" ;
			$desc = exapi_dbflds($result,'description') ;
			$unit = exapi_dbflds($result,'unit') ;
			$dt['csincaccid'.$i] =  exapi_dbflds($result,'income_accno_id') ;
			if (!isset($itemid))	$price = exapi_dbflds($result,'price') ;
			}
		     else {
			$result = $adodb->query("SELECT * FROM ${pre}parts WHERE id='$item_id'");
			$type = "i" ;
			$desc = exapi_dbflds($result,'description') ;
			$unit = exapi_dbflds($result,'unit') ;
			$dt['cscost'.$i] = exapi_dbflds($result,'cost') ;
			$dt['csinvaccid'.$i] =  exapi_dbflds($result,'inventory_accno_id') ;
			$dt['csincaccid'.$i] =  exapi_dbflds($result,'income_accno_id') ;
			$dt['csexpaccid'.$i] =  exapi_dbflds($result,'expense_accno_id') ;
			if (!isset($itemid))	$price = exapi_dbflds($result,'price') ;
			}
		$description = isset($itemid) ? $name." -- Special -- ".$desc : $desc ;
		$csitemtype = $dt['csitemtype'.$i] = $type;
		$csunit = $dt['csunit'.$i] = $unit ;
		$csprice = $dt['csprice'.$i] = $price ;

		$tax1 = $tax1accid = $tax2 = $tax2accid = 0 ;
		switch ($tax1pref) :
			case "s" :	$tax1rate=$stax1rate; $tax1accid=$stax1chartid; break;
			case "i" :
				$sql = "SELECT chart_id,rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$item_id' and tax_id=id and " ;
				$sql.=		"taxtype='1' and taxgroup='cs'" ;
				$result = $adodb->query($sql) ;
				$tax1rate = (exapi_dbrc($result)>0) ? exapi_dbflds($result,'rate') : 0 ;
				$tax1accid = ($tax1rate==0) ? 0 : exapi_dbflds($result,'chart_id') ;
				break;
			endswitch ;
		switch ($tax2pref) :
			case "s" :	$tax2rate=$stax2rate; $tax2accid=$stax2chartid; break;
			case "i" :
				$sql = "SELECT chart_id,rate from ${pre}itemtax a, ${pre}tax b " ;
				$sql.= "WHERE item_id='$item_id' and tax_id=id and " ;
				$sql.=		"taxtype='2' and taxgroup='cs'" ;
				$result = $adodb->query($sql) ;
				$tax2rate = (exapi_dbrc($result)>0) ? exapi_dbflds($result,'rate') : 0 ;
				$tax2accid = ($tax2rate==0) ? 0 : exapi_dbflds($result,'chart_id') ;
				break;
			endswitch ;
		switch ($taxstatus) :
			case "f" :
				$netamount = number_format($csqty*$csprice-$csdiscount,2,".",'') ;
				$tax1 = number_format($netamount*$tax1rate,2,".",'') ;
				$tax2 = number_format($netamount*$tax2rate,2,".",'') ;
				$dt['csnetamount'.$i] = $netamount ;
				$itemtotal = $netamount + $tax1 + $tax2 ;
				break ;
			case "t" :
				$csdiscount = '' ;
				$itemtotal = $dt['csitemtotal'.$i] = number_format($csqty*$csprice,2,".",'') ;
				$tax1 = number_format($itemtotal*$tax1rate/(1+$tax1rate+$tax2rate),2,".",'') ;
				$tax2 = number_format($itemtotal*$tax2rate/(1+$tax1rate+$tax2rate),2,".",'') ;
				$dt['csnetamount'.$i] = $netamount = $itemtotal - $tax1 - $tax2 ;
				break ;
			case "e" :
				$netamount = number_format($csqty*$csprice-$csdiscount,2,".",'') ;
				$dt['csnetamount'.$i] = $itemtotal = $netamount ;
			default :	$itemtotal = $netamount = '' ;
			endswitch ;
		if ($firstime) {
			$tax1 = $dt['cstax1'.$i] ;
			$tax2 = $dt['cstax2'.$i] ;
			$tax1accid = $dt['cstax1accid'.$i] ;
			$tax2accid = $dt['cstax2accid'.$i] ;
			}
		$dt['cstax1'.$i] = $tax1 ;
		$dt['cstax2'.$i] = $tax2 ;
		$dt['cstax1accid'.$i] = $tax1accid ;
		$dt['cstax2accid'.$i] = $tax2accid ;
		$t->set_var('itemtype',$csitemtype);
		$t->set_var('description',$description);
		$t->set_var('unit',$csunit);
		$t->set_var('qty',$csqty);
		$t->set_var('discount',$csdiscount);
		if ($taxstatus=="t" or isset($posted))	$t->set_var('disc_readonly','readonly');
			else				$t->set_var('disc_readonly','');
		$t->set_var('price',$csprice);
		$t->set_var('netamount',$netamount);
		$t->set_var('tax1',$tax1);
		$t->set_var('tax2',$tax2);
		$t->set_var('itemtotal',$itemtotal);
		$cstotnet += $netamount ;
		$cstotal += $itemtotal ;
		$t->set_var('rowno',$csrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);

		$dt['csitemid'.$i] = $csitemid ;
		$dt['csitemtype'.$i] = $csitemtype ;
		$dt['csqty'.$i] = $csqty ;
		$dt['csprice'.$i] = $csprice ;
		$dt['csdiscount'.$i] = $csdiscount ;
		$dt['csunit'.$i] = $csunit ;
		}

	$dt['cstotnet'] = number_format($cstotnet,2,".",'') ;
	$dt['cstotal'] = number_format($cstotal,2,".",'') ;
	$t->set_var('lang_cstotal',exapi_lang('Total Cash Sale'));
	$t->set_var('cstotnet',$dt['cstotnet']) ;
	$t->set_var('cstotal',$dt['cstotal']) ;
	$this->cswt_addon_write();
	$this->cswt_qcash_write();
	}

//---- Write Cash Sale AddOn Items

    function cswt_addon_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$firstime = isset($ckapi['params_post']['firstime']) ? $ckapi['params_post']['firstime'] : '' ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_block('report','addon','addon_section');
	if ($op=="view" or $op=="delete")	$posted = True ;
	$aorow_ = exapi_lang('aoRow')." " ;
	$aonewrow = exapi_lang('Add New AddOn Row') ;
	$result = $adodb->query("SELECT postax1cap,postax2cap,postax1pref,postax2pref FROM ${pre}defaults");
	$t->set_var('lang_tax1',exapi_dbflds($result,'postax1cap'));
	$t->set_var('lang_tax2',exapi_dbflds($result,'postax2cap'));
	$tax1pref = exapi_dbflds($result,'postax1pref') ;
	$tax2pref = exapi_dbflds($result,'postax2pref') ;
	if ($tax1pref=='s') {
		$sql="SELECT customer_id,chart_id,rate from ${pre}customertax a,${pre}tax b,${pre}customer c";
		$sql.= " WHERE c.name='____Myself' and customer_id=c.id and a.tax_id=b.id and taxtype='1'" ;
		$result = $adodb->query($sql);
		$stax1chartid = exapi_dbflds($result,'chart_id') ;
		$stax1rate = exapi_dbflds($result,'rate') ;
		}
	if ($tax2pref=='s') {
		$sql="SELECT customer_id,chart_id,rate from ${pre}customertax a,${pre}tax b,${pre}customer c";
		$sql.= " WHERE c.name='____Myself' and customer_id=c.id and a.tax_id=b.id and taxtype='2'" ;
		$result = $adodb->query($sql);
		$stax2chartid = exapi_dbflds($result,'chart_id') ;
		$stax2rate = exapi_dbflds($result,'rate') ;
		}
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_addon',exapi_lang('Add On Charge/Reduction Items :'));
	$t->set_var('lang_addonnumber',exapi_lang('AddOn Name - Id'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_factorbasis',exapi_lang('% [Basis]'));
	$t->set_var('lang_aoamount',exapi_lang('Amount'));
	$t->set_var('lang_itemtotal',exapi_lang('Item Total'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_aonewrow',$aonewrow);
	if (isset($delete))	$delrowno = intval(str_replace($aorow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$today = date('Y-m-d') ;
	$addon_sl = "<OPTION value=''></OPTION>".selectlist('addon','name',"WHERE start<='$today' and endd>='$today'",'','id','name','id') ;
	$aonet = 0 ;
	$totpay = $dt['cstotal'] ;
	For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','aoitemid'.$j) ;
		$itemid = $dt['aoitemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('addon_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$addon_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$result = $adodb->query("SELECT * FROM ${pre}addon WHERE id='$itemid'") ;
		$notes = exapi_dbflds($result,'notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$factor = $dt['aofactor'.$i] = exapi_dbflds($result,'factor') ;
		$basis = exapi_dbflds($result,'basis') ;
		$incacc = $dt['aoincaccid'.$i] = exapi_dbflds($result,'incacc_id') ;
		$dt['aoexpaccid'.$i] = exapi_dbflds($result,'expacc_id') ;
		$salebasis = ($basis=='g') ? "gs" : "ns" ;
		$value = $dt['aovalue'.$i] = ($basis=='g') ? $dt['cstotal'] : $dt['cstotnet'] ;
		$aoamount = $dt['aoamount'.$i] = number_format($value*$factor,2,".",'') ;

		$tax1 = $tax1accid = $tax2 = $tax2accid = 0 ;
		if ($firstime) {
			$tax1 = $dt['aotax1'.$i] ;
			$tax2 = $dt['aotax2'.$i] ;
			$tax1accid = $dt['aotax1accid'.$i] ;
			$tax2accid = $dt['aotax2accid'.$i] ;
			}
		   else {
			switch ($tax1pref) :
				case "s" :	$tax1rate=$stax1rate;
						$tax1accid=$dt['aotax1accid'.$i]=$stax1chartid;
						break;
				case "i" :
					$sql = "SELECT chart_id,rate from ${pre}itemtax a, ${pre}tax b " ;
					$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
					$sql.=		"taxtype='1' and taxgroup='cs'" ;
					$result = $adodb->query($sql) ;
					$tax1rate = (exapi_dbrc($result)>0) ? exapi_dbflds($result,'rate') : 0 ;
					$tax1accid = $dt['aotax1accid'.$i] = ($tax1rate==0) ? 0 : exapi_dbflds($result,'chart_id') ;
					break;
				endswitch ;
			switch ($tax2pref) :
				case "s" :	$tax2rate=$stax2rate;
						$tax2accid=$dt['aotax2accid'.$i]=$stax2chartid;
						break;
				case "i" :
					$sql = "SELECT chart_id,rate from ${pre}itemtax a, ${pre}tax b " ;
					$sql.= "WHERE item_id='$itemid' and tax_id=id and " ;
					$sql.=		"taxtype='2' and taxgroup='cs'" ;
					$result = $adodb->query($sql) ;
					$tax2rate = (exapi_dbrc($result)>0) ? exapi_dbflds($result,'rate') : 0 ;
					$tax2accid = $dt['aotax2accid'.$i] = ($tax2rate==0) ? 0 : exapi_dbflds($result,'chart_id') ;
					break;
				endswitch ;
			$tax1 = $dt['aotax1'.$i] = number_format($aoamount*$tax1rate,2,".",'') ;
			$tax2 = $dt['aotax2'.$i] = number_format($aoamount*$tax2rate,2,".",'') ;
			}
		$itemtotal = $aoamount + $tax1 + $tax2 ;
		$t->set_var('notes',$notes) ;
		$t->set_var('factor',$factor*100) ;
		$t->set_var('salebasis',$salebasis) ;
		$t->set_var('aoamount',$aoamount) ;
		$t->set_var('tax1',$tax1) ;
		$t->set_var('tax2',$tax2) ;
		$t->set_var('itemtotal',$itemtotal) ;
		$totpay += $itemtotal ;
		$incacc = ($incacc=="") ? 0 : $incacc ;
		$result = $adodb->query("SELECT * FROM ${pre}tax WHERE chart_id='$incacc' and taxgroup='cs'") ;
		if (exapi_dbrc($result)<=0)		$aonet += $aoamount ;
		$t->set_var('rowno',$aorow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('addon_section','addon', True);
		}
	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$aonewrow ;
	if ($newrow==$aonewrow) {
		$t->set_var('itemid_fld','aoitemid'.$i) ;
		$t->set_var('addon_selectlist',$addon_sl);
		$t->set_var('notes',"");
		$t->set_var('factor',"");
		$t->set_var('salebasis',"") ;
		$t->set_var('aoamount',"");
		$t->set_var('tax1',"");
		$t->set_var('tax2',"");
		$t->set_var('itemtotal',"");
		$t->set_var('rowno',$aorow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('addon_section','addon', True);
		}
	$t->set_var('lang_totpay',exapi_lang('Total Payable'));
	$t->set_var('totpay',number_format($totpay,2,".",'')) ;
	$dt['totpay'] = $totpay ;
	$dt['aonet'] = $aonet ;
	}

//---- Write Cash Sale Payment / Quasi Cash Items

    function cswt_qcash_write() {
	global $ckapi,$adodb ;

	foreach ($ckapi['params'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['params_post'] as $key => $value)	$$key = $value ;
	foreach ($ckapi['buttons'] as $key => $value)	$$key = $value ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_block('report','qcash','qcash_section');
	if ($op=="view" or $op=="delete")	$posted = True ;
	$qcrow_ = exapi_lang('qcRow')." " ;
	$qcnewrow = exapi_lang('Add New QCash Row') ;
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$tr_color = $tr_color1 = $ckapi['hostsys']['tr_color1'] ;
	$tr_color2 = $ckapi['hostsys']['tr_color2'] ;
	$t->set_var('lang_qcash',exapi_lang('Payment / Quasi-Cash Tendered :'));
	$t->set_var('lang_qcashnumber',exapi_lang('QCash Name - Id'));
	$t->set_var('lang_notes',exapi_lang('Notes'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_value',exapi_lang('Value'));
	$t->set_var('lang_qcamount',exapi_lang('Amount'));
	$t->set_var('lang_delete',exapi_lang('Delete'));
	$t->set_var('lang_qcnewrow',$qcnewrow);
	if (isset($delete))	$delrowno = intval(str_replace($qcrow_,"",$delete));
	if ($delrowno==0)	unset($delete) ;
	$today = date('Y-m-d') ;
	$qcash_sl = "<OPTION value=''></OPTION>".selectlist('qcash','name',"WHERE start<='$today' and endd>='$today'",'','id','name','id') ;
	$totpay = $dt['totpay'] ;
	$totqc = 0 ;
	For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if (isset($delete) and $i>$delrowno) {$j=$i-1;} else {$j=$i;}
		$t->set_var('itemid_fld','qcitemid'.$j) ;
		$t->set_var('qty_fld','qcqty'.$j);
		$t->set_var('value_fld','qcvalue'.$j);
		$itemid = $dt['qcitemid'.$i] ;
		$t->set_var('itemid',$itemid) ;
		$t->set_var('qcash_selectlist',str_replace("'$itemid'","'$itemid'"." selected",$qcash_sl));
		$itemid = ($itemid=="") ? 0 : $itemid ;
		$result = $adodb->query("SELECT * FROM ${pre}qcash WHERE id='$itemid'") ;
		$notes = exapi_dbflds($result,'notes') ;
		$pos = strpos($notes,"--log--") ;
		$notes = ($pos=="" and substr($notes,0,7)<>"--log--") ? $notes : substr($notes,0,$pos) ;
		$dt['qcposaccid'.$i] = exapi_dbflds($result,'posacc_id') ;
		$qcqty = $dt['qcqty'.$i]<>'' ? $dt['qcqty'.$i]: 1;
		$faceval = exapi_dbflds($result,'value') ;
		$value = $dt['qcvalue'.$i] = ($faceval<>'' and $faceval<>0) ? $faceval : $dt['qcvalue'.$i] ;
		$qcamount = $dt['qcamount'.$i] = number_format($qcqty*$value,2,".",'') ;
		$t->set_var('notes',$notes);
		$t->set_var('qty',$qcqty);
		$t->set_var('value',$value);
		$t->set_var('qcamount',$qcamount);
		$totqc += $qcamount ;
		$t->set_var('rowno',$qcrow_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('qcash_section','qcash', True);
		}

	$lasti = $i-1 ;
	$dt['qcqty'.$lasti] = isset($qcqty) ? $qcqty : '' ;

	if ($i==2 and $delrowno==1)			$i=1 ;
	if ($i==1)					$newrow=$qcnewrow ;
	if ($newrow==$qcnewrow) {
		$t->set_var('itemid_fld','qcitemid'.$i) ;
		$t->set_var('qcash_selectlist',$qcash_sl);
		$t->set_var('qty_fld','qcqty'.$i);
		$t->set_var('value_fld','qcvalue'.$i);
		$t->set_var('notes',"");
		$t->set_var('qty',"");
		$t->set_var('value',"");
		$t->set_var('qcamount',"");
		$t->set_var('rowno',$qcrow_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('qcash_section','qcash', True);
		}
	$t->set_var('lang_totqc',exapi_lang('Total'));
	$t->set_var('totqc',number_format($totqc,2,".",'')) ;
	$t->set_var('lang_change',exapi_lang('Change'));
	$dt['totqc'] = $totqc ;
	$qcchange = $dt['qcchange'] = number_format($totqc-$totpay,2,".",'') ;
	$t->set_var('change',$qcchange) ;
	$lang_cash = exapi_lang('Cash') ;
	$result = $adodb->query("SELECT * FROM ${pre}qcash WHERE name='$lang_cash'") ;
	$dt['cashaccid'] = exapi_dbflds($result,'posacc_id') ;
	}

//---- Cash Sale Post Initialisation

    function cswt_post_init() {
	global $ckapi ;

	$dt = &$ckapi['params_post']['dt'] ;
	$op = &$ckapi['params_post']['op'] ;

	$user = $ckapi['hostsys']['username'];
	$dt['posnumber'] = ($op=='edit') ? $dt['posnumber'] : "$user:".date("Ymd:His") ;
	$dt['source']	= "CSWT" ;
	$desc = exapi_lang('Cash Sale') ;
	$dt['description'] = "CS: $desc# $dt[posnumber]" ;
	$dt['taxincluded'] = $dt['taxstatus'] ;
	$dt['amount'] = $dt['totpay'] ;
	$dt['netamount'] = $dt['cstotnet'] + $dt['aonet'] ;
	}

//---- Cash Sale Post - PreCommit Routine

    function cswt_post_precommit() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$op = $ckapi['params_post']['op'] ;
	$id = $ckapi['params_post']['id'] ;
	$dt = $ckapi['params_post']['dt'] ;
	$transdate = $dt['transdate'] ;

	if ($op<>'new')	{
		$adodb->query("DELETE from ${pre}positem where trans_id=$id");
		$adodb->query("DELETE from ${pre}acc_trans where trans_id=$id");
		$adodb->query("DELETE from ${pre}il where id=$id");
		$adodb->query("DELETE from ${pre}inv_trans where trans_id=$id");
		}

	if ($op<>'delete') {
		$invitem = False ;
		For ($i=1;isset($dt['csitemid'.$i]);$i++) {
			$csitemid	= $dt['csitemid'.$i];
			$csitemtype	= $dt['csitemtype'.$i];
			$csunit		= $dt['csunit'.$i];
			$csqty		= $dt['csqty'.$i];
			$csprice	= $dt['csprice'.$i];
			$csdiscount	= $dt['csdiscount'.$i];
			$netamount	= $dt['csnetamount'.$i] ;
			$cost		= isset($dt['cscost'.$i]) ? $dt['cscost'.$i] : '' ;
			$invaccid	= isset($dt['csinvaccid'.$i]) ? $dt['csinvaccid'.$i] : '' ;
			$incaccid	= $dt['csincaccid'.$i] ;
			$expaccid	= isset($dt['csexpaccid'.$i]) ? $dt['csexpaccid'.$i] : '' ;
			$tax1		= $dt['cstax1'.$i] ;
			$tax2		= $dt['cstax2'.$i] ;
			$tax1accid	= $dt['cstax1accid'.$i] ;
			$tax2accid	= $dt['cstax2accid'.$i] ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$incaccid','$netamount','$transdate')";
			$adodb->query($sql);
			if ($tax1<>0) {
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$tax1accid','$tax1','$transdate')";
				$adodb->query($sql);
				}
			if ($tax2<>0) {
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$tax2accid','$tax2','$transdate')";
				$adodb->query($sql);
				}
			if ($csitemtype=="i" and $cost<>0 and $cost<>'') {
				$cogs = number_format($csqty*$cost,2,".",'') ;
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$expaccid','-$cogs','$transdate')";
				$adodb->query($sql);
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$invaccid','$cogs','$transdate')";
				$adodb->query($sql);
				$sql="INSERT INTO ${pre}inv_trans(trans_id,order_id,parts_id,qty,transdate) ";
				$sql.= "VALUES ('$id','$id','$csitemid','-$csqty','$transdate')" ;
				$adodb->query($sql);
				$invitem = True ;
				}

			$invaccid = ($invaccid=="") ? 0 : $invaccid ;
			$incaccid = ($incaccid=="") ? 0 : $incaccid ;
			$expaccid = ($expaccid=="") ? 0 : $expaccid ;
			$tax1accid = ($tax1accid=="") ? 0 : $tax1accid ;
			$tax2accid = ($tax2accid=="") ? 0 : $tax2accid ;
			$sql = "INSERT INTO ${pre}positem (trans_id,invacc_id,incacc_id,expacc_id,itemid," ;
			$sql.= "itemtype,qty,price,cost,discount,unit,tax1,tax2,tax1acc_id,tax2acc_id) ";
			$sql.= "VALUES ('$id','$invaccid','$incaccid','$expaccid'," ;
			$sql.= "'$csitemid','$csitemtype','$csqty','$csprice','$cost'," ;
			$sql.= "'$csdiscount','$csunit','$tax1','$tax2','$tax1accid','$tax2accid')";
			$adodb->query($sql);
			}
		if ($invitem == True) {
			$ildesc1 = exapi_lang('GD against CS') ;
			$ildesc = "CS: $ildesc1# $dt[posnumber]" ;
			$sql = "INSERT INTO ${pre}il (id,source,description,to_from,transdate) " ;
			$sql.= "VALUES ('$id','$dt[source]','$ildesc','$dt[customer]','$transdate') " ;
			$adodb->query($sql) ;
			}
		For ($i=1;isset($dt['aoitemid'.$i]);$i++) {
			$aoitemid = $dt['aoitemid'.$i] ;
			if ($aoitemid=="")	continue ;
			$aovalue	= $dt['aovalue'.$i] ;
			$aofactor	= $dt['aofactor'.$i] ;
			$aoamount	= $dt['aoamount'.$i] ;
			$aoincaccid	= $dt['aoincaccid'.$i] ;
			$aoexpaccid	= $dt['aoexpaccid'.$i] ;
			$tax1		= $dt['aotax1'.$i] ;
			$tax2		= $dt['aotax2'.$i] ;
			$tax1accid	= $dt['aotax1accid'.$i] ;
			$tax2accid	= $dt['aotax2accid'.$i] ;
			$chartid = ($aoamount>0) ? $aoincaccid : $aoexpaccid ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$chartid','$aoamount','$transdate')";
			$adodb->query($sql);
			if ($tax1<>0) {
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$tax1accid','$tax1','$transdate')";
				$adodb->query($sql);
				}
			if ($tax2<>0) {
				$sql = "INSERT INTO ${pre}acc_trans(trans_id,chart_id,amount,transdate) ";
				$sql.= "VALUES ('$id','$tax2accid','$tax2','$transdate')";
				$adodb->query($sql);
				}
			$sql = "INSERT INTO ${pre}positem (trans_id,incacc_id,expacc_id," ;
			$sql.= "itemid,itemtype,value,factor,tax1,tax2,tax1acc_id,tax2acc_id) " ;
			$sql.= "VALUES ('$id','$aoincaccid','$aoexpaccid','$aoitemid','a'," ;
			$sql.= "'$aovalue','$aofactor','$tax1','$tax2','$tax1accid','$tax2accid')";
			$adodb->query($sql);
			}
		For ($i=1;isset($dt['qcitemid'.$i]);$i++) {
			$qcitemid 	= $dt['qcitemid'.$i] ;
			$qcqty 		= $dt['qcqty'.$i] ;
			$qcvalue 	= $dt['qcvalue'.$i] ;
			$qcamount 	= $dt['qcamount'.$i] ;
			$qcposaccid 	= $dt['qcposaccid'.$i] ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$qcposaccid','-$qcamount','$transdate')";
			$adodb->query($sql);
			$sql = "INSERT INTO ${pre}positem (trans_id,posacc_id,itemid,itemtype,qty,value) ";
			$sql.= "VALUES ('$id','$qcposaccid','$qcitemid','q','$qcqty','$qcvalue')" ;
			$adodb->query($sql);
			}
		if ($dt['qcchange']<>0) {
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id,amount,transdate) " ;
			$sql.= "VALUES ('$id','$dt[cashaccid]','$dt[qcchange]','$transdate')" ;
			$adodb->query($sql);
			$sql = "INSERT INTO ${pre}positem (trans_id,posacc_id,itemid,itemtype,qty,value) ";
			$sql.= "VALUES ('$id','$dt[cashaccid]',0,'c','1','-$dt[qcchange]')" ;
			$adodb->query($sql);
			}
		}
	}
	
//---- Calculate Cash Box Cash Balance

    function cashbalance($cboxid,$transdate,$shift) {
	global $adodb,$pre ;

	$sql =	"SELECT sum(qty*a.value) as amount FROM ${pre}positem a, ${pre}pos b, ${pre}qcash c " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and " ;
	$sql.=		"name='Cash' and a.trans_id=b.id and a.itemid=c.id GROUP BY itemid" ;
	$result = $adodb->query($sql);
	$amount = exapi_dbflds($result,'amount');
	$sql =	"SELECT sum(qty*value) as amount FROM ${pre}positem a, ${pre}pos b " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift' and " ;
	$sql.=		"itemtype='c' and a.trans_id=b.id GROUP BY itemid" ;
	$result = $adodb->query($sql);
	$amount+= exapi_dbflds($result,'amount');
	$sql =	"SELECT sum(amount) as amount from ${pre}cbtran " ;
	$sql.=	"WHERE cboxid='$cboxid' and transdate='$transdate' and shift='$shift'" ;
	$result = $adodb->query($sql);
	$amount+= exapi_dbflds($result,'amount');

	return $amount ;
	}

    }

?>