<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// class.sprice.inc.php 0.16.1 2005/12/04 C K Wu

    class sprice {

//---- Special Price Detail Validation Checks

    function sprice_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$table = $ckapi['params']['table'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang("Error") ;
	if (!$dt['name'] or $dt['name']=="")		$err=exapi_lang("Special Price Name missing");
		else	{
			$result = $adodb->query("SELECT * from $table WHERE name='$dt[name]'") ;
			if (exapi_dbrc($result)<>0 and $dt['name']<>$dt['oldname'])
				$err=exapi_lang('Special Price name already in use');
			}
	if (!$dt['itemid'] or $dt['itemid']=="")		$err=exapi_lang("ID of normally priced item missing");
	if (!$dt['price'] or $dt['price']=="")			$err=exapi_lang("Price missing");
	if ($dt['price'] and !is_numeric($dt['price']))		$err=exapi_lang("Price must be numeric");
	if (input2date($dt['start'])=="")			$err=exapi_lang("Invalid [Valid from] Date");
	if (input2date($dt['endd'])=="")			$err=exapi_lang("Invalid [Valid to] Date");
	if (strtotime($dt['start'])>strtotime($dt['endd']))	$err=exapi_lang("[Valid from] LaterThan [Valid to]");
	if (strtotime($dt['start'])=="-1")			$err=exapi_lang("[Valid from] beyond valid date range");
	if (strtotime($dt['endd'])=="-1")			$err=exapi_lang("[Valid to] beyond valid date range");

	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Special Price Delete Validation Checks

    function delete_validate() {
	global $ckapi,$adodb ;

	$pre = $ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;

	$err=""; $error=exapi_lang('Error') ;
	$cashsale = exapi_lang('cash sale') ;
	$errmsg1 = exapi_lang("This special price is in use within an existing") ;
	$result = $adodb->query("SELECT * from ${pre}positem WHERE itemid='$dt[id]'");
	if (exapi_dbrc($result)>0)	$err = "$errmsg1 $cashsale id#".exapi_dbflds($result,'trans_id') ;

	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Special Price Detail

    function sprice_write() {
	global $ckapi ;

	$pre = $ckapi['params']['pre'] ;
	$dt = &$ckapi['params_post']['dt'] ;
	$t = &$ckapi['objects']['template'] ;

	$t->set_var('lang_id',exapi_lang('Audit ID').': ');
	$t->set_var('lang_splan_id',exapi_lang('Sales Promotion ID:')."  ");
	$t->set_var('lang_name',exapi_lang('Name'));
	$t->set_var('lang_price',exapi_lang('Special Price'));
	$t->set_var('lang_itemid',exapi_lang('ID of normally priced item'));
	$t->set_var('lang_start',exapi_lang('Valid from'));
	$t->set_var('lang_endd',exapi_lang('Valid to'));
	$t->set_var('lang_notes',exapi_lang('Notes'));

	$dt = $ckapi['params_post']['dt'] ;
	$fields = array('id','control','name','oldname','splan_id','price','itemid','start','endd','notes') ;
	foreach ($fields as $field)
		if (isset($dt[$field]))		$t->set_var($field,$dt[$field]);
			else			$t->set_var($field,'') ;
	$itemid = isset($dt['itemid']) ? $dt['itemid'] : '' ;
	$t->set_var('itemid_sl',item_selectlist("",$itemid));
	$t->parse('out','report',True);
	}

    }

?>