<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// qcashlist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-pos-m' ;
	$tran = 'qcash' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}qcash" 			) ;

	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Quasi-Cash") ,
				'lang_add'	=> exapi_lang("Add New Quasi-Cash") ,
				'lang_sale'	=> exapi_lang('Cash Sale Value') ,
				'lang_qty'	=> exapi_lang('Qty per Transaction') ,
				'lang_value'	=> exapi_lang('Value per Transaction') ,
				'lang_splan'	=> exapi_lang('Sales Plan') ,
				'lang_date'	=> exapi_lang('Date')			) ;

	$ckapi['columns'] = array('name'	=> exapi_lang('Quasi-Cash Name') ,
				'value'		=> exapi_lang('Face Value') ,
				'minsale'	=> exapi_lang('Min') ,
				'maxsale'	=> exapi_lang('Max') ,
				'minqty'	=> exapi_lang('Min') ,
				'maxqty'	=> exapi_lang('Max') ,
				'minvalue'	=> exapi_lang('Min') ,
				'maxvalue'	=> exapi_lang('Max') ,
				'splan_id'	=> exapi_lang('ID') ,
				'start'		=> exapi_lang('Valid from') ,
				'endd'		=> exapi_lang('Valid to') ,
				'id'		=> exapi_lang('Audit ID') 		) ;
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi['lang_links'] = array('lang_view'=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_copy'	=> exapi_lang("Copy/Modify") ,
				'lang_delete'	=> exapi_lang("Delete") ,
				'lang_log'	=> exapi_lang("Log")			) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_list() ;
	exapi_footer() ;

?>
