<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// sontordack.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-so' ;
	$tran = 'sont' ;
	$noheader = $nonavbar = True ;
	require_once('../ck-api/ckapi.inc.php') ;

	$id = isset($_GET['id']) ? $_GET['id'] : (isset($_POST['id'])?$_POST['id']:'');
	$filter = isset($_GET['filter']) ? $_GET['filter'] : (isset($_POST['filter'])?$_POST['filter']:'');
	$start = isset($_GET['start']) ? $_GET['start'] : (isset($_POST['start'])?$_POST['start']:'');
	$end = isset($_GET['end']) ? $_GET['end'] : (isset($_POST['end'])?$_POST['end']:'');
	$sdate = isset($_GET['sdate']) ? $_GET['sdate'] : (isset($_POST['sdate'])?$_POST['sdate']:'');
	$regenerate = isset($_GET['regenerate']) ? $_GET['regenerate'] : (isset($_POST['regenerate'])?$_POST['regenerate']:'');
	$email = isset($_GET['email']) ? $_GET['email'] : (isset($_POST['email'])?$_POST['email']:'');
	$filter=stripslashes($filter);

	$t = exapi_tpl($app);
	$t->set_file(array('report'	=> "${tran}ordack.tpl",
 	                   'items'	=> "${tran}ordack.tpl"));
	$t->set_block('items','item_row','item_section');
	$t->set_block('items','done','done_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=exapi_lang('Order Acknowledgement (OA) Image (Use browser to print OA shown above)');
	$t->set_var('lang_title',$title);
	$note1=exapi_lang('[This is a sample subject to tailoring per individual printer & order acknowledgement format]');
	$note2=exapi_lang('For email function to work, your email/SMTP/DNS environment must be properly setup.');
	$t->set_var('lang_notes',"$note1<br>$note2");
	$charset = exapi_lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$ckapi['hostsys']['th_bg']);
	$logofile = $ckapi['hostsys']['dataarea']."/images/logo.png" ;
	$logourl = exapi_link("/ck-api/view_image.php","imgfile=$logofile") ;	
	$t->set_var('logo',$logourl);

/*------------- Write Payment to Screen Display ----------------------------*/

	$result = $adodb->query("SELECT * FROM ${pre}defaults");
	$company = exapi_dbflds($result,'company') ;
	$comemail = exapi_dbflds($result,'email') ;

	$result = $adodb->query("SELECT * FROM ${pre}so WHERE id='$id'");
	$customer = exapi_dbflds($result,'customer') ;
	$transdate = exapi_dbflds($result,'transdate') ;
	$duedate = exapi_dbflds($result,'duedate') ;
	$sonumber = exapi_dbflds($result,'sonumber') ;
	$currency = exapi_dbflds($result,'isocode') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$result = $adodb->query("SELECT * FROM ${pre}customer a, ${pre}org b WHERE a.id='$customer' and contactid=b.id");
	if (exapi_dbrc($result)>0) {
		$name = $emailname = exapi_dbflds($result,'orgname') ;
		$contactid = exapi_dbflds($result,'contactid') ;
		}
	  else	{
		$result = $adodb->query("SELECT * FROM ${pre}customer a,${pre}person b WHERE a.id='$customer' and contactid=b.id");
		$name = $emailname = strtoupper(exapi_dbflds($result,'family'))." ".exapi_dbflds($result,'given') ;
		$contactid = exapi_dbflds($result,'contactid') ;
		}
	$terms = exapi_dbflds($result,'terms') ;
	$t->set_var('name',$name) ;
	$t->set_var('shiptoname',$name) ;

	$result = $adodb->query("SELECT * FROM ${pre}comm WHERE contactid='$contactid' and commcode='bemail'");
	$custemail = exapi_dbflds($result,'commdata') ;
	$billaddr = exapi_lang('billaddr') ;
	$result = $adodb->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='$billaddr'");
	$t->set_var('addr1',exapi_dbflds($result,'line1')) ;
	$t->set_var('addr2',exapi_dbflds($result,'line2')) ;
	$t->set_var('addr3',exapi_dbflds($result,'line3')) ;
	$t->set_var('addr4',exapi_dbflds($result,'line4')) ;
	$shipaddr = exapi_lang('shipaddr') ;
	$result = $adodb->query("SELECT * FROM ${pre}address WHERE contactid='$contactid' and addresscode='$shipaddr'");
	$t->set_var('shiptoaddr1',exapi_dbflds($result,'line1')) ;
	$t->set_var('shiptoaddr2',exapi_dbflds($result,'line2')) ;
	$t->set_var('shiptoaddr3',exapi_dbflds($result,'line3')) ;
	$t->set_var('shiptoaddr4',exapi_dbflds($result,'line4')) ;

	$t->set_var('lang_oa',exapi_lang('*** ORDER ACKNOWLEDGEMENT ***'));
	$t->set_var('lang_transdate',exapi_lang('Order Date'));
	$t->set_var('lang_duedate',exapi_lang('Due Date'));
	$t->set_var('lang_sonumber',exapi_lang('Number'));
	$t->set_var('lang_billto',exapi_lang('Bill To:'));
	$t->set_var('lang_shipto',exapi_lang('Ship To:'));
	$t->set_var('lang_itemid',exapi_lang('Item ID'));
	$t->set_var('lang_description',exapi_lang('Description'));
	$t->set_var('lang_qty',exapi_lang('Qty'));
	$t->set_var('lang_price',exapi_lang('Price'));
	$t->set_var('lang_discount',exapi_lang('Discount'));
	$t->set_var('lang_amount',exapi_lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('sonumber',$sonumber) ;

// ---------------------------- Begin list items -----------------------------------------

	$result = $adodb->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id'");
	$total = 0 ;
	While ($rs=$result->fetchRow()) {
		$itemid = $rs['itemid'] ;
		$description = $rs['description'] ;
		$qty = $rs['qty'] ;
		$price = $rs['price'] ;
		$discount = $rs['discount'] ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array('itemid'	=> $itemid,
				'description'	=> $description,
				'qty'		=> $qty,
				'price'		=> $price,
				'discount'	=> $discount ,
				'amount'	=> $amount ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',exapi_lang("Order Total")) ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_term',exapi_lang("Terms Net")." $terms ".exapi_lang("days")) ;
	$t->set_var('lang_currency',exapi_lang("All prices are in")." $currency") ;
	$t->set_var('lang_thank',exapi_lang("Thank you for your valued business!")) ;
	$t->set_var('lang_remark','') ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('email_action',exapi_link("/$app/${tran}ordack.php","id=$id&filter=$filter")) ;
	$t->set_var('lang_email',exapi_lang('Email OA'));
	$t->set_var('done_action',exapi_link("/$app/${tran}list.php","filter=$filter"));
	$t->set_var('lang_done',exapi_lang('Done'));
	if ($email)	{
		$err = "" ; $error=exapi_lang("Error") ; $noemail=exapi_lang("No email sent") ;
		$custmsg = exapi_lang("Customer") ;	$somsg = exapi_lang("SO") ;
		$successmsg = exapi_lang("Email successfully queued for despatch to") ;
		$failuremsg = exapi_lang("Email fails to deliver to") ;

		if (!$custemail)				$err = exapi_lang("Customer email missing") ;
		if ($custemail and strpos($custemail,'@')=='')	$err = exapi_lang("Invalid customer email") ;
		if (!$comemail)					$err = exapi_lang("Company return email missing");
		if ($comemail and strpos($comemail,'@')=='')	$err = exapi_lang("Invalid company return email");
		if ($err) {
			$notes = "$custmsg/$name -- $somsg/$id -- $noemail -- $error: $err" ;
			$t->set_var('lang_notes',$notes) ;
			}
		   else {
			$recipient = "$emailname < $custemail >" ;
			$subject = exapi_lang("SO#: %1 dated %2",$sonumber,$transdate) ;
			$bdmarker = "CK-ERP_".md5(uniqid(time())) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$headers.= "MIME-Version: 1.0\n" ;
			$headers.= "Content-Type: multipart/mixed; boundary=\"$bdmarker\"\n" ;
			$message = "--$bdmarker\n" ;
			$message.= "Content-Type: text/html; charset=$charset\n" ;
			$message.= "Content-Transfer-Encoding: 7bit\n" ;
			$contentid = md5(uniqid(time())) ;
			$htmlpart = str_replace($logourl,"cid:$contentid",$t->parse('out','items','report')) ;
			$message.= str_replace('{done_section}','',$htmlpart) ;
			$message.= "--$bdmarker\n" ;
			$message.= "Content-Type: image/png\n" ;
			$message.= "Content-Transfer-Encoding: base64\n" ;
			$message.= "Content-ID: $contentid\n\n" ;
			$fd = fopen("$logofile","r");
			$message.= chunk_split(base64_encode(fread($fd,filesize($logofile))))."\n";
			$message.= "--$bdmarker--\n" ;
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	$notes = "$custmsg/$name -- $somsg/$id -- $successmsg $custemail" ;
				else	$notes = "$custmsg/$name -- $somsg/$id -- $failuremsg $custemail" ;
			$t->set_var('lang_notes',$notes);
			}
		}
	$t->parse('done_section','done',true);
	$t->pparse('out','items','report');
	exapi_footer() ;

?>
