<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// sqmatchlist.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-so' ;
	$tran = 'sqmatch' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}sqmatch" ,
				'doneexit'	=> "${tran}filter.php"			) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("List of Sales Orders [w and w/o Quotation matched]"),
				'lang_add'	=> exapi_lang("Done")			);
	$ckapi['columns'] = array('transdate'	=> exapi_lang('SO Date') ,
				'name'		=> exapi_lang('Customer') ,
				'sonumber'	=> exapi_lang('SO#') ,
				'isocode'	=> exapi_lang('Currency') ,
				'amount'	=> exapi_lang('Amount') ,
				'id'		=> exapi_lang('Audit ID') 		);
	$ckapi['links']	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'clear'		=> "/$app/${tran}clear.php"	) ;
	$ckapi['lang_links'] = array('lang_view'=> exapi_lang("View") ,
				'lang_edit'	=> exapi_lang("Edit") ,
				'lang_clear'	=> exapi_lang("Clear SO/Quotation Matching") ,
				'lang_log'	=> exapi_lang("Log")				) ;

	$proc1 = newobj('ck-api','process1') ;
	$proc1->process1_list() ;

	if (isset($ckapi['params_sql']['temp1']))	$adodb->query('DROP TABLE '.$ckapi['params_sql']['temp1']);
	if (isset($ckapi['params_sql']['temp2']))	$adodb->query('DROP TABLE '.$ckapi['params_sql']['temp2']);
	exapi_footer() ;

?>
