<?php
//
// CK-ERP  --  Copyright (C) 2004, 2005       Wu Chiu Kay
// ------------------------------------------------------
//  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.
//
// timesheetfilter.php 0.16.1 2005/12/04 C K Wu

	$app = 'ck-sss' ;
	$tran = 'timesheet' ;
	require_once('../ck-api/ckapi.inc.php') ;

	$ckapi['params'] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}timesheet" 		) ;
	$ckapi['phrases'] = array('lang_title'	=> exapi_lang("Search among existing Timesheets :") ,
				'lang_criteria'	=> exapi_lang("Searching Criteria") ,
				'lang_value'	=> exapi_lang("Value") ,
				'lang_note'	=> exapi_lang("Note") ,
				'lang_search'	=> exapi_lang("Start Search") ,
				'lang_add'	=> exapi_lang("Add New Timesheet") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$allopt = "<OPTION value='ALL'></OPTION>" ;
	$nullopt = "<OPTION value=''></OPTION>" ;
	$tsmsg = exapi_lang('Timesheets falling within (from/to) period will be listed.') ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Year') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$allopt.ymwd_selectlist('','','y') ,
				'varname'	=>	'year' ,
				'defval'	=>	'' ,
				'note'		=>	exapi_lang('Search for Timesheets of the target Year'));

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Week From') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.ymwd_selectlist('','','w') ,
				'varname'	=>	'weekfrom' ,
				'defval'	=>	'' ,
				'note'		=>	$tsmsg			) ;

	$ckapi['filter'][] = array('criteria'	=>	exapi_lang('Week To') ,
				'type'		=>	'select' ,
				'selectlist'	=>	$nullopt.ymwd_selectlist('','','w') ,
				'varname'	=>	'weekto' ,
				'defval'	=>	'' ,
				'note'		=>	$tsmsg			) ;

	$proc = newobj('ck-api','process') ;
	$proc->process_filter() ;
	exapi_footer() ;

?>
